'use strict';
var fs = require('fs');
module.exports = function (grunt) {
    // Project configuration.
    grunt.initConfig({
        //css array
		
        //清空build
        clean: {
            build: ['build']
        },
        
        //复制
        copy: {
      
            all_main: {
                files: [
                    {src: 'lib/**', dest: 'build/', expand: true},
                    {src: 'js/**', dest: 'build/', expand: true},
					{src: 'sdk/**', dest: 'build/', expand: true},
					{src: 'encryption/**', dest: 'build/', expand: true},
					{src: 'mos_checkNewVersion.js', dest: 'build/', expand: true}
                ]
            }
        },
       

        //压缩
        uglify: {
                       
            all_min: {
                options: {
                    nameCache: false,
                    screwIE8: true,
                    compress: {
                        drop_console: true,
                        join_vars: false,
                        negate_iife: false,
                        sequences: false,
                        hoist_vars: true,
                        if_return: false
                    },
                    mangle: false,
                    beautify: {
                        quote_keys: true,
                        quote_style: 1
                    }
                },
                files: [
                    {src: ["lib/**/*.js"], dest: "build/", expand: true},
                    {src: ["js/**/*.js"], dest: "build/", expand: true},
					{src: ["sdk/**/*.js"], dest: "build/", expand: true},
					{src: ["encryption/**/*.js"], dest: "build/", expand: true},
					{src: ['mos_checkNewVersion.js'], dest: "build/", expand: true}
                ]
            }
        },

    });
    // These plugins provide necessary tasks.
    grunt.loadNpmTasks('grunt-replace-url');
    grunt.loadNpmTasks('grunt-marsrev');
    grunt.loadNpmTasks('grunt-safety');
    grunt.loadNpmTasks('grunt-contrib-clean');
    grunt.loadNpmTasks('grunt-contrib-copy');
    grunt.loadNpmTasks('grunt-contrib-uglify');
    grunt.loadNpmTasks('grunt-contrib-jshint');
    grunt.loadNpmTasks('grunt-contrib-concat');
    grunt.loadNpmTasks('grunt-replace');
    grunt.loadNpmTasks('grunt-contrib-cssmin');

    var target = grunt.option('target');
    if(!target) {
        target = 'default';
    }

    var model = grunt.option('model');

    grunt.registerTask('package', ['clean:build', 'copy:all_main', 'copy:all_main', 'uglify:all_min']);
			
};