var curLang="en";
var languageJson=zh;
var gui = require("nw.gui");
var CommonUtils = require('./js/common/CommonUtils.js');
var lanpath = gui.App ? gui.App.dataPath.replace("\\User Data\\Default","") + "/" : "/";
var log4js = require('./node_modules/log4js');
global.appDataPath = lanpath;
var langaugeArr = [];//语种配置
var languageData = {};//当前选择语种对应语言数据
var fs = require("fs");
var exePath=process.execPath;
exePath = exePath.replace(/\\/g, "/");
exePath = exePath.substring(0,exePath.lastIndexOf('/')+1);

fs.existsSync(exePath+"log/") || fs.mkdirSync(exePath+"log/");
fs.existsSync(exePath+"log/dblog") || fs.mkdirSync(exePath+"log/dblog");
fs.existsSync(exePath+"history/") || fs.mkdirSync(exePath+"history/");
String.prototype.format = function() {
    var str = this;
    if(arguments) {
        for (var i = 0; i < arguments.length; i++) {
            var reg = new RegExp("\\{" + i + "\\}", "gm");
            str = str.replace(reg, arguments[i]);
        }
    }
    return str;
}
log4js.configure({
    appenders: [
        {
            type:"console",
            category: 'console'
        },
        {
            type: 'file',
            filename: exePath+'/log/obs.log',
            maxLogSize: 10*1048576,
            backups:20,
            category: 'normal',
            layout: {
                type: 'pattern',
                pattern : "%d{ISO8601} %[%p%x{ln}%]%n%m",
                tokens: {
                    ln : function() {
                        // The caller:
                        var stack = (new Error).stack.split("\n")
                        var deep = stack.length;
                        return stack[deep-1]
                    }
                }
            }
        },
        {
            type: 'file',
            filename: exePath+'history/access.log',
            maxLogSize: 10*1048576,
            backups:10,
            category: 'ACCESS'
        },
        {
            type: 'file',
            filename: exePath+'log/dblog/dblog.log',
            maxLogSize: 10*1048576,
            backups:10,
            category: 'database'
        }
    ],
    replaceConsole: true
});

var logger = log4js.getLogger('normal');
log4js.connectLogger(logger,{format:':method:url'});
logger.setLevel('INFO');
global.logger=logger;

global.successLogger = log4js.getLogger('ACCESS');
global.successLogger.setLevel('INFO');

global.dbLogger = log4js.getLogger('database');
global.dbLogger.setLevel('DEBUG');

logger.info('step1:load logger success!');
try{
    var path = require('path');
    var userPath = lanpath;
    var filePath = path.normalize(userPath + "/setting");//setting配置文件
    var filePath1 = path.normalize("C:/obslansetting.ini");//安装时选择的语言配置

    var pkg = require('../package.json');
    var appPath = path.dirname(process.execPath);
    fs.readFile(appPath+'/setting','utf-8',function(err,data){//读取其他语言配置信息
        if(data){
            data = JSON.parse(data);
            if(data.language){
                langaugeArr = data.language;
            }
        }
    });
    var userSurveyPath = path.normalize(appPath + "/userSurvey.ini");//用户体验配置
    var status = fs.existsSync(filePath);
    var UCDVersion = pkg.UCDVersion;//UCD版本
    global.UCDVersion = pkg.UCDVersion;//UCD版本,方便commonUtils。js使用
    global.downloadRate = pkg.downloadRate || 100;//下载发送send请求速度控制
    if(status==="true"){
        var data=fs.readFileSync(filePath, "utf-8");
        if(data.length>0){
            var b = new Base64();
            var dataStr = b.decode(data);
            var configObj1 = JSON.parse(dataStr);
            curLang = configObj1.language;
        }
        logger.info('step2:load setting file success!');
    }else if(fs.existsSync(filePath1)){
        var configObj = { isAutoUpdate: 'Y',
            userExperience: 'N',
            isMultiUpload: true,
            multiUploadNum:5,
            language: 'zh',
            isMultiDownload: true,
            isHttps: 'Y' };
        if(UCDVersion !== 'HEC'&& UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'){
            configObj.language="en";
        }
        var data=fs.readFileSync(filePath1, "utf-8");
        logger.info('step2:load obslansetting file success!');
        data = data.substring(data.length-2,data.length);
        curLang=data;
        try{
            var stat = fs.unlinkSync(filePath1);
            if(stat){
                logger.info('step3:delete obslansetting file failed!');
            }
        }catch(err){
            logger.info('step3:delete obslansetting file failed!');
            logger.error('error:',err);
        }
        configObj.language = data;
        if(fs.existsSync(userSurveyPath)){
            try{
                var stat = fs.unlinkSync(userSurveyPath);
                if(stat){
                    logger.info('step3:delete userSurvey file failed!');
                }
            }catch(err){
                logger.info('step3:delete userSurvey file failed!');
                logger.error('error:',err);
            }
            configObj.userExperience = "Y";
        }
        var b = new Base64();
        var base64Str = b.encode(JSON.stringify(configObj));
        fs.writeFile(userPath + "setting", base64Str,function(err){});
        logger.info('step4:create and write setting info to file!');
    }else{
        logger.info('step2:load def setting!');
        if(UCDVersion !== 'HEC'&& UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'FCS'){
            curLang="en";
        }else{
            curLang="zh";
        }
    }

    //多语言支持
    if(curLang!='en'&&curLang!='zh'){
        logger.info('step:load language File!');
        var languagePath = path.normalize(appPath+'/language/'+curLang+"/language.js");
        if(fs.existsSync(languagePath)){
            try{
                var data1 = fs.readFileSync(appPath+'/language/'+curLang+"/language.js", "utf-8");
                data1 = data1.replace('define([], function () {','').replace('var i18n = ','').replace('return i18n;','').replace('});','').replace('};','}');
                
                languageData = JSON.parse(data1);
                languageData = CommonUtils.mergeDefaultLang(en, languageData);
            }catch(err){
                logger.error('load language file error:',err);
                if(UCDVersion !== 'HEC'&& UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'FCS'){
                    curLang="en";
                }else{
                    curLang="zh";
                }
            }
        }else{
            if(UCDVersion !== 'HEC' && UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'FCS'){
                curLang="en";
            }else{
                curLang="zh";
            }
        }
    }
}catch(err){
    logger.error('err=============',err);
}

logger.info('step5:load I18N!');
var I18NEngine = function (tpl, data) {
    var re = /\${([^%>]+)?}/g;
    while (match = re.exec(tpl)) {
        tpl = tpl.replace(match[0], data[match[1]])
    }
    return tpl;
};

logger.info('step6:load browser desktop!');

//DT及TLF版本去掉中文语言
if(UCDVersion !== 'HEC'&&curLang==='zh'&&UCDVersion !== 'OCB' && UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'FCS'){
    curLang = "en";
}
//CTC只有中文
if(UCDVersion === 'CTC'){
    curLang = "zh";
}
if(UCDVersion === 'HEC'){
    languageJson.obs_term_bucketLifecycle_change2Warm_lable=languageJson.obs_term_bucketLifecycle_change2Infrequent_lable;
    languageJson.obs_term_bucketLifecycle_change2Cold_lable=languageJson.obs_term_bucketLifecycle_change2Archive_lable
}
//渲染页面
if (curLang === "zh") {
    languageData = zh;
    var fileref = document.createElement('link');
    fileref.setAttribute("rel","stylesheet");
    fileref.setAttribute("type","text/css");
    fileref.setAttribute("href","./css/obs_zh.css");
    document.getElementsByTagName("body")[0].appendChild(fileref);

    var tinyStyle = document.createElement('link');
    tinyStyle.setAttribute("rel","stylesheet");
    tinyStyle.setAttribute("type","text/css");
    tinyStyle.setAttribute("href","tinyui/theme-hec/css/tiny.min.css");
    if(UCDVersion === 'OCB'){//FT版本
        fileref.setAttribute("href","./css/obs_ft_en.css");
        tinyStyle.setAttribute("href","tinyui/theme-ocb/css/tiny.min.css");
    }else if(UCDVersion === 'CTC'){//FT版本
        fileref.setAttribute("href","./css/obs_ctc_zh.css");
        tinyStyle.setAttribute("href","tinyui/theme-hec/css/tiny.min.css");
    }else if(UCDVersion === 'CMCC'){
        fileref.setAttribute("href","./css/obs_cmcc_zh.css");
        tinyStyle.setAttribute("href","tinyui/theme-hec/css/tiny.min.css");
    }else if(UCDVersion === 'FCS'){
        fileref.setAttribute("href","./css/obs_fcs_zh.css");
        tinyStyle.setAttribute("href","tinyui/theme-hec/css/tiny.min.css");
    }
    document.getElementsByTagName("body")[0].appendChild(tinyStyle);

    $(".i18n").each(function () {
        this.innerHTML = I18NEngine(this.innerHTML, languageData);
    });
} else {
    if(curLang === "en"){
        languageData = en;
    }
    var fileref = document.createElement('link');
    fileref.setAttribute("rel","stylesheet");
    fileref.setAttribute("type","text/css");

    var tinyStyle = document.createElement('link');
    tinyStyle.setAttribute("rel","stylesheet");
    tinyStyle.setAttribute("type","text/css");

    if(UCDVersion === 'DT'){//DT版本
        fileref.setAttribute("href","./css/obs_dt_en.css");
        tinyStyle.setAttribute("href","tinyui/theme-dt/css/tiny.min.css");
    } else if(UCDVersion === 'OCB'){//FT版本
        fileref.setAttribute("href","./css/obs_ft_en.css");
        tinyStyle.setAttribute("href","tinyui/theme-ocb/css/tiny.min.css");
    } else if(UCDVersion === 'Russia'){//俄罗斯版本
        fileref.setAttribute("href","./css/obs_russia_en.css");
        tinyStyle.setAttribute("href","tinyui/theme-hec/css/tiny.min.css");
    } else if(UCDVersion === 'CTC'){//CTC版本
        fileref.setAttribute("href","./css/obs_ctc_en.css");
        tinyStyle.setAttribute("href","tinyui/theme-hec/css/tiny.min.css");
    } else if(UCDVersion === 'CMCC'){//CMCC版本
        fileref.setAttribute("href","./css/obs_cmcc_en.css");
        tinyStyle.setAttribute("href","tinyui/theme-hec/css/tiny.min.css");
    } else if(UCDVersion === 'FCS'){//FCS版本
        fileref.setAttribute("href","./css/obs_fcs_en.css");
        tinyStyle.setAttribute("href","tinyui/theme-hec/css/tiny.min.css");
    }else{
        fileref.setAttribute("href","./css/obs_en.css");
        tinyStyle.setAttribute("href","tinyui/theme-hec/css/tiny.min.css");
    }
    document.getElementsByTagName("body")[0].appendChild(fileref);
    document.getElementsByTagName("body")[0].appendChild(tinyStyle);

    $(".i18n").each(function () {
        this.innerHTML = I18NEngine(this.innerHTML, languageData);
    });
}



