var IndexAction = require('./sdk/indexAction.js');

var i18n_learnMore = {
    /** 资料的域名，程序初始化后被赋值 */
    docDomainName: "",
    /** console的域名，程序初始化后被赋值 */
    consoleDomainName: "",
    /**
     * 获取真实的link内容
     * @param position 如DT_EN
     * @param key 如ackConfigKnowMore
     * @returns {*}
     */
    getLearnMoreLink: function (position, key) {
        var link = {
            HEC_ZH: {
                ackConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829127.html",
				addNewAccountKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829119.html",
                toIamAddNewAccountKnowMore: "https://console.huaweicloud.com/iam/#/myCredential",
                bucketLoggingKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829130.html",
                policyConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829128.html",
                toAuth:"https://account.huaweicloud.com/usercenter/?locale=zh-cn#/accountindex/realNameAuth",
                lifecycleConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829131.html",
                multipartKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829132.html",
                corsConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829129.html",
                extBucketMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829133.html",
                helpOnline: this.docDomainName + "/obs_dld/index.html"
            },
            CTC_ZH: {
                ackConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829127.html",
                addNewAccountKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829119.html",
                toIamAddNewAccountKnowMore: this.docDomainName + "#/usermanual-obs/zh-cn_topic_0045829113.html",
                bucketLoggingKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829130.html",
                policyConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829128.html",
                lifecycleConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829131.html",
                multipartKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829132.html",
                corsConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829129.html",
                extBucketMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829133.html",
                helpOnline: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829113.html"
            },
            CMCC_ZH: {
                ackConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829127.html",
                addNewAccountKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829119.html",
                toIamAddNewAccountKnowMore: "https://console.huaweicloud.com/iam/#/myCredential",
                bucketLoggingKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829130.html",
                policyConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829128.html",
                lifecycleConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829131.html",
                multipartKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829132.html",
                corsConfigKnowMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829129.html",
                extBucketMore: this.docDomainName + "/usermanual-obs/zh-cn_topic_0045829133.html",
                helpOnline: this.docDomainName + "/obs_dld/index.html"
            },
            HEC_EN: {
                ackConfigKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853509.html",
				addNewAccountKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853477.html",
                toIamAddNewAccountKnowMore: "https://console.huaweicloud.com/iam/#/myCredential",
                bucketLoggingKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853744.html",
                policyConfigKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853707.html",
                toAuth:"https://account.huaweicloud.com/usercenter/?locale=en-us#/accountindex/realNameAuth",
                lifecycleConfigKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853854.html",
                multipartKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853710.html",
                corsConfigKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853860.html",
                extBucketMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853737.html",
                helpOnline: this.docDomainName + "/en-us/obs_dld/index.html"
            },
            CMCC_EN: {
                ackConfigKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853509.html",
                addNewAccountKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853477.html",
                toIamAddNewAccountKnowMore: "https://console.huaweicloud.com/iam/#/myCredential",
                bucketLoggingKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853744.html",
                policyConfigKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853707.html",
                lifecycleConfigKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853854.html",
                multipartKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853710.html",
                corsConfigKnowMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853860.html",
                extBucketMore: this.docDomainName + "/en-us/usermanual-obs/en-us_topic_0045853737.html",
                helpOnline: this.docDomainName + "/en-us/obs_dld/index.html"
            },
            DT_EN: {
                ackConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853509.html",
				addNewAccountKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853477.html",
                toIamAddNewAccountKnowMore: "https://"+this.consoleDomainName+"/iam/#/myCredential",
                bucketLoggingKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853744.html",
                policyConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853707.html",
                lifecycleConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853854.html",
                multipartKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853710.html",
                corsConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853860.html",
                extBucketMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853737.html",
                helpOnline: this.docDomainName + "/usermanual/obs/en-us_topic_0045853713.html"
            },
            TLF_EN: {
                ackConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853509.html",
				addNewAccountKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853477.html",
                toIamAddNewAccountKnowMore: "https://console.vivocloudopen.com.br/iam/#/myCredential",
                bucketLoggingKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853744.html",
                policyConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853707.html",
                lifecycleConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853854.html",
                multipartKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853710.html",
                corsConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853860.html",
                extBucketMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853737.html",
                helpOnline: this.docDomainName + "/usermanual/obs/en-us_topic_0045853713.html"
            },
            OCB_EN: {
                ackConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853509.html",
				addNewAccountKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853477.html",
                toIamAddNewAccountKnowMore: "https://console.prod-cloud-ocb.orange-business.com/iam#/myCredential",
                bucketLoggingKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853744.html",
                policyConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853707.html",
                lifecycleConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853854.html",
                multipartKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853710.html",
                corsConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853860.html",
                extBucketMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853737.html",
                helpOnline: this.docDomainName + "/usermanual/obs/en-us_topic_0045853713.html"
            },
            OCB_ZH: {
                ackConfigKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829127.html",
                addNewAccountKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829119.html",
				toIamAddNewAccountKnowMore: "https://console.prod-cloud-ocb.orange-business.com/iam#/myCredential",
                bucketLoggingKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829130.html",
                policyConfigKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829128.html",
                lifecycleConfigKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829131.html",
                multipartKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829132.html",
                corsConfigKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829129.html",
                extBucketMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829133.html",
                helpOnline: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829113.html"
            },
            FCS_ZH: {
                ackConfigKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829127.html",
                addNewAccountKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829119.html",
                toIamAddNewAccountKnowMore: "",
                bucketLoggingKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829130.html",
                policyConfigKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829128.html",
                lifecycleConfigKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829131.html",
                multipartKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829132.html",
                corsConfigKnowMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829129.html",
                extBucketMore: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829133.html",
                helpOnline: this.docDomainName + "/zh-cn/usermanual/obs/zh-cn_topic_0045829113.html"
            },
            FCS_EN: {
                ackConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853509.html",
                addNewAccountKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853477.html",
                toIamAddNewAccountKnowMore: "",
                bucketLoggingKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853744.html",
                policyConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853707.html",
                lifecycleConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853854.html",
                multipartKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853710.html",
                corsConfigKnowMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853860.html",
                extBucketMore: this.docDomainName + "/usermanual/obs/en-us_topic_0045853737.html",
                helpOnline: this.docDomainName + "/usermanual/obs/en-us_topic_0045853713.html"
            }
        };
        return link[position][key];
    },
    /**
     * 初始化的时候，读取运行目录下面region配置
     */
    initLearnMoreDomainName: function () {
        var indexAction = new IndexAction();
        var self = this;
        console.log(self);
        indexAction.getBucketRegion(null, function (err, data) {
            if (err) {
                global.logger.error("Get region configuration failed.", err);
                return;
            }
            try {
                global.regionCfg = JSON.parse(data);
                global.logger.info("Get region configuration successfully.", regionCfg);
                self.docDomainName = global.regionCfg.docDomainName;
                if(global.regionCfg.docDomainName.indexOf("otctest")>0){//DT测试床
                    self.consoleDomainName = "console.otctest.t-systems.com";
                }else{//DT生产环境
                    self.consoleDomainName = "console.otc.t-systems.com";
                }

            } catch (err) {
                global.logger.error("Region configuration format invalid: " + data, err);
            }
        })
    }
}


module.exports = i18n_learnMore;