var obsError = require('./js/common/ObsError.js')
var commonUtils = require('./js/common/CommonUtils.js');
$(function() {
    $('.mui-icon-property').on('click', function () {
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        if(isHasSelectBucket()){//判断当前桶是否存在，如不存在给出提示
            return false;
        }
        $("#prop_storageClass_id").hide();
        $(".mui-page-full.shown").removeClass('shown');
        var bucket = $('#curBucketName').html();
        var temp = true;
        divDragFunc('bucketProDrag','bucketPro');
        var loading = loadingShow();
        $("#bucketPro").css('z-index', '90');
        async.parallel([
                function(callback){
                    bucketAttributeAction.getBucketLocation(bucket, function (err, data) {
                        callback(err,data);
                    })
                },
                function(callback){
                    bucketAttributeAction.getBucketStorageInfo(bucket, function (err, data) {
                        callback(err,data);
                    })
                },
                function(callback){
                    bucketAttributeAction.getBucketCreateTime(bucket, function (err, data) {
                        callback(err,data);
                    })
                },
                function(callback){
                    bucketAttributeAction.headBucket(bucket, function (err, data) {
                        callback(err,data);
                    })
                }
            ],
            function(err, results){
                if (err) {
                    if((errorConfig[err.code]) && temp){
                        temp = false;
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code,err.message),
                            ok: function () {
                                $("#bucketPropertiesTab tbody tr").each(function () {
                                    $(this).find('td').eq('1').find('span').html('');
                                });
                                $(".refreshCtx").click();
                                return false;
                            }
                        });
                    }
                    loading.close();
                } else {
                    loading.close();
                    $("#bucketPro").addClass('shown');
                    $("#bucketPro").css('z-index', '1000');
                    showOverlay();
                    var url = "";
                    var bName = $("#curBucketName").html();
                    var point = s3.config.endpoint;
                    if (point.indexOf('https') === -1) {
                        point = point.replace('http', 'https');
                    }
                    var data = point.split(':');
                    if (data.length > 2) {
                        point = data[0] + ':' + data[1];
                    }
                    var isIP = data[1].replace("//","");
                    var re =  /^([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/;
                    var AWS = require('./node_modules/hws-sdk');
                    if (userType == 1) {
                        url = AWS.util.uriEscapePath(bName + "." + endpoint);
                    } else {
                        if(re.test(isIP)){
                            url = isIP + "/" + AWS.util.uriEscapePath(bName);
                        }else{
                            url = AWS.util.uriEscapePath(bName) + "." + isIP;
                        }
                    }
                    $("#accessDomain").html(url);
                    $("#bucketEndpoint").html(isIP)
                    var locationData = results[0];
                    var location = '';
                    if(locationData.LocationConstraint){
                        location = locationData.LocationConstraint.toString();
                    }
                    if (location.length === 0) {
                        $("#regionVal").html(languageJson.defualtPath);
                    } else {
                        $("#regionVal").html(encoderForHtml(locationData.LocationConstraint));
                    }
                    var storageInfo = results[1];
                    if(storageInfo && storageInfo.Size){
                        $("#usedStorageVal").html(indexAction.getFileSize(encoderForHtml(storageInfo.Size),"",language));
                    }else{
                        $("#usedStorageVal").html(indexAction.getFileSize(0,"",language));
                    }
                    if(storageInfo && storageInfo.ObjectNumber){
                        $("#totalObjectNumVal").html(indexAction.formatNumber(encoderForHtml(storageInfo.ObjectNumber),language,true));
                    }else{
                        $("#totalObjectNumVal").html(indexAction.formatNumber(0,language,true));
                    }
                    var createTimes = results[2];
                    var createTime = '';
                    for (var index in createTimes.Buckets) {
                        if (createTimes.Buckets[index].Name.toString() === bucket) {
                            createTime = indexAction.gmtDate2LocaleDate(encoderForHtml(createTimes.Buckets[index].CreationDate),language);
                        }
                    }
                    if(createTime){
                        $("#createTimeVal").html(createTime);
                        $("#owerUserNameVal").html(encoderForHtml(createTimes.Owner.DisplayName));
                        $("#ownerUserIDVal").html(encoderForHtml(createTimes.Owner.ID));
                        $("#owerBucketNameVal").html(bucket);
                    }

                    if (pkg.coldline == true) {
                        $("#prop_storageClass_id").show();
                        var headResult = results[3];
                        if (headResult) {
                            $("#storageTypeVal").html(commonUtils.termStorageClass(headResult.StorageType));

                            if(headResult.ObsVersion){
                                $("#bucketVersion").html(headResult.ObsVersion);
                            }else{
                                $("#bucketVersion").html("--");
                            }
                        }
                    } else {
                        $("#prop_storageClass_id").hide();
                    }

                }
            });
        tabFocus("bucketPro");
        return false;
    });
    //桶基本信息 桶名tip提示
    $(function(){
        $(".tips").on("mouseenter", function () {
            if (this.offsetWidth < this.scrollWidth) {
                var text = $(this).text().trim();
                $(this).attr('title', text);
            } else {
                $(this).removeAttr('title');
            }
        });
    });
    $("#bucketLists tbody").delegate('.mui-icon-handel-property','click',function(){
        $(this).parent().parent().click();
        setTimeout(function () {
            $('.mui-icon-property').click();
        },10);
    });

    $('.mui-icon-aclConfig').on('click', function () {
        if(_.isEqual(UCDVersion,"HEC")){
            $("#ackConfigKnowMore").hide();
        }
        if(_.isEqual(UCDVersion,"CTC")){
            $("#ackConfigKnowMore").hide();
        }
        if(_.isEqual(UCDVersion,"CMCC")){
            $("#ackConfigKnowMore").hide();
        }
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        if(isHasSelectBucket()){//判断当前桶是否存在，如不存在给出提示
            return false;
        }
        var inps=$("#aclConfigTab tbody input[disabled]");
        for(i=0;i<inps.length;i++){
            $(inps[i]).css("cursor","auto")
        }
        $(".mui-page-full.shown").removeClass('shown');
        $("#ownerUserName  div").html(encoderForHtml(ownerName));
        if(ownerName.length>20){
            $("#ownerUserName  div").attr("title",ownerName);
        } else{
            $("#ownerUserName  div").removeAttr("title")
        }
        var bucket = $('#curBucketName').html();
        extOwnerId = ownerId;
        extOwnerName = ownerName;
        var loading = loadingShow();
        $("#ACLConfig").css('z-index', '90');
        bucketAttributeAction.getBucketAcl(bucket,function(err,data){
            $("#bucketCustomAcl").text("");
            if (err) {
                logger.error(err);
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message),
                        ok: function () {
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            $(".refreshCtx").click();
                        }
                    });
                }
                loading.close();
                showOverlay();
                $("#ACLConfig").css('z-index', '1000');
            }
            else {
                $("#ACLConfig").addClass('shown');
                divDragFunc('ACLConfigDrag','ACLConfig');
                loading.close();
                $("#ACLConfig").css('z-index', '1000');
                showOverlay();
                if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//当前桶为外部桶
                    extOwnerId = data.Owner.ID;
                    extOwnerName = data.Owner.DisplayName;
                    $("#ownerUserName div").html(encoderForHtml(extOwnerName));
                    if(extOwnerName.length>20){
                        $("#ownerUserName div").attr("title",extOwnerName);
                    } else{
                        $("#ownerUserName div").removeAttr("title");
                    }
                }
                var customGrants = [];
                for (var index in data.Grants) {
                    var obj = data.Grants[index];
                    if (obj.Grantee.URI === "http://acs.amazonaws.com/groups/s3/LogDelivery") {
                        $("[name='loggingUser']").each(function () {
                            if ($(this).val() === obj.Permission) {
                                $(this).click();
                            }
                        })
                    } else if (obj.Grantee.URI === "http://acs.amazonaws.com/groups/global/AllUsers") {
                        $("[name='anonymousUser']").each(function () {
                            if ($(this).val() === obj.Permission) {
                                $(this).click();
                            }
                        })
                    } else if (obj.Grantee.URI === "http://acs.amazonaws.com/groups/global/AuthenticatedUsers") {
                        $("[name='regUser']").each(function () {
                            if ($(this).val() === obj.Permission) {
                                $(this).click();
                            }
                        })
                    }else if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//当前桶为外部桶
                        $("#currentUserName").parent().removeClass("mui-hide");
                        $("#currentUserName").html(encoderForHtml(ownerName))
                        if(ownerName.length>20){
                            $("#currentUserName div").attr("title",ownerName);
                        } else{
                            $("#currentUserName div").removeAttr("title");
                        }
                        if (obj.Grantee.ID && obj.Grantee.ID.toString() === extOwnerId) {
                            $("[name='ownerUser']").each(function () {
                                if ($(this).val() === obj.Permission) {
                                    if ($(this).hasClass('disabled')) {
                                        this.checked = true;
                                    } else {
                                        $(this).click();
                                    }
                                }
                            })
                        } else if(obj.Grantee.ID && obj.Grantee.ID.toString() === ownerId){
                            $("[name='currentUser']").each(function () {
                                if ($(this).val() === obj.Permission) {
                                    $(this).click();
                                    if ($(this).hasClass('disabled')) {
                                        this.checked = true;
                                    }
                                }
                            })
                        }else{
                            customGrants.push(obj);
                        }
                    }else if(obj.Grantee.ID && obj.Grantee.ID.toString() === ownerId) {
                        $("#currentUserName").parent().addClass("mui-hide");
                        $("[name='ownerUser']").each(function () {
                            if ($(this).val() === obj.Permission) {
                                if ($(this).hasClass('disabled')) {
                                    this.checked = true;
                                } else {
                                    $(this).click();
                                }
                            }
                        })
                    } else {
                        customGrants.push(obj);
                    }
                }
                $("#bucketCustomAcl").text(JSON.stringify(customGrants));
            }
        });
        tabFocus("saveAclConfig");
        return false;
    });

    $("#saveAclConfig").on('click', function () {
        var aclObj = {};
        var arr = [];
        $("#aclConfigTab tr:not(:first)").each(function () {
            aclObj.userType = $(this).children('td').eq(1).find('input').attr('name');
            $(this).children('td').each(function () {
                if ($(this).find('input').is(':checked')) {
                    var valueStr = $(this).find('input').val();
                    if (valueStr === 'FULL_CONTROL') {
                        aclObj[valueStr] = valueStr;
                        return false;
                    } else {
                        aclObj[valueStr] = valueStr;
                    }
                }
            });
            arr.push(aclObj);
            aclObj = {};
        });
        var AccessControlList = [];
        var grant = {};
        for (var index in arr) {
            var data = arr[index];
            if (data.userType === "regUser") {
                $.each(data, function (key, value) {
                    if ("regUser" !== value) {
                        grant = {
                            Grantee: {
                                Type: "Group",
                                URI: "http://acs.amazonaws.com/groups/global/AuthenticatedUsers"
                            },
                            Permission: value
                        }
                        AccessControlList.push(grant);
                    }
                });
            } else if (data.userType === "loggingUser") {
                $.each(data, function (key, value) {
                    if ("loggingUser" !== value) {
                        grant = {
                            Grantee: {
                                Type: "Group",
                                URI: "http://acs.amazonaws.com/groups/s3/LogDelivery"
                            },
                            Permission: value
                        }
                        AccessControlList.push(grant);
                    }
                });
            }else if(data.userType==="anonymousUser"){
                $.each(data,function(key,value){
                    if("anonymousUser"!==value){
                        grant = {
                            Grantee:{
                                Type : "Group",
                                URI : "http://acs.amazonaws.com/groups/global/AllUsers"
                            },
                            Permission : value
                        }
                        AccessControlList.push(grant);
                    }
                });
            } else if (data.userType === "ownerUser") {
                if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//当前桶为外部桶
                    $.each(data, function (key, value) {
                        if ("ownerUser" !== value && extOwnerId) {
                            grant = {
                                Grantee: {
                                    Type: "CanonicalUser",
                                    ID: extOwnerId,
                                    DisplayName: extOwnerName
                                },
                                Permission: value
                            }
                            AccessControlList.push(grant);
                        }
                    });
                }else{
                    $.each(data, function (key, value) {
                        if ("ownerUser" !== value) {
                            grant = {
                                Grantee: {
                                    Type: "CanonicalUser",
                                    ID: ownerId,
                                    DisplayName: ownerName
                                },
                                Permission: value
                            }
                            AccessControlList.push(grant);
                        }
                    });
                }
            }else if (data.userType === "currentUser") {
                $.each(data, function (key, value) {
                    if ("currentUser" !== value) {
                        grant = {
                            Grantee: {
                                Type: "CanonicalUser",
                                ID: ownerId,
                                DisplayName: ownerName
                            },
                            Permission: value
                        }
                        AccessControlList.push(grant);
                    }
                });
            }
        }
        var bucketCustomAclTxt = $("#bucketCustomAcl").text();
        if(bucketCustomAclTxt) {
            var bucketCustomAclGrants = JSON.parse(bucketCustomAclTxt);
            if(bucketCustomAclGrants) {
                for(var i=0;i<bucketCustomAclGrants.length;i++) {
                    AccessControlList.push(bucketCustomAclGrants[i]);
                }
            }
        }
        var bucketName = $('#curBucketName').html();
        var AccessControlPolicy = {};
        if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//当前桶为外部桶
            AccessControlPolicy = {
                Owner: {
                    ID: extOwnerId,
                    DisplayName: extOwnerName
                },
                Grants: AccessControlList
            };
        }else{
            AccessControlPolicy = {
                Owner: {
                    ID: ownerId,
                    DisplayName: ownerName
                },
                Grants: AccessControlList
            };
        }
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var loading = loadingShow();
        $("#ACLConfig").css('z-index', '90');
        bucketAttributeAction.putBucketAcl(function (err, data) {
            if (err) {
                logger.error(err);
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message)
                    });
                }
                loading.close();
                $("#ACLConfig").css('z-index', '1000');
                showOverlay();
            }
            else {
                $('.mui-model').showMessage({
                    type:'info',
                    message: languageJson.aclPermissionsSuccess,
                    ok: function () {
                        if(loading){
                            loading.close();
                        }
                        $("#all-refresh-div").click();
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    },
                    title: languageJson.info
                });
                $("#ACLConfig").css('z-index', '1000');
                $("#aclReset").click();
                $("#ACLConfig input[type='checkbox']").each(function () {
                    if (!$(this).hasClass('disabled')) {
                        this.disabled = false;
                    }
                });
                $("#ACLConfig input[type='checkbox']").each(function () {
                    this.checked = false;
                });
                $(".mui-page-full.shown").removeClass('shown');
                showOverlay();
            }
        },bucketName,"",AccessControlPolicy);
        return false;
    });

    $("#aclConfigTab tbody tr:not(.ownerUserName)").find('td:eq(1)').find('input').on('click', function () {
        if ($(this).is(':checked')) {
            $(this).parent().parent().children('td').find('input').not(':first').each(function () {
                this.checked = true;
            });
        } else {
            $(this).parent().parent().children('td').find('input').not(':first').each(function () {
                this.checked = false;
                if($(this).hasClass('disabled')) {
                    this.checked = true;
                }
            });
        }
    });

    $("#aclConfigTab tbody tr.ownerUserName").find('input').eq(0).on('click', function () {
        if ($(this).is(':checked')) {
            $(this).parent().parent().children('td').find('input').not(':first').each(function () {
                this.checked = true;
            });
        } else {
            $(this).parent().parent().children('td').eq(2).find('input').each(function () {
                this.checked = false;
            });
            $(this).parent().parent().children('td').eq(3).find('input').each(function () {
                this.checked = false;
            });
        }
    });

    $("#aclConfigTab tr:not(:first) td:gt(1)").find('input').on('click', function () {
        var temp = true;
        var name = this.name;
        $("input[name='" + name + "']").not(':first').each(function () {
            temp = temp && this.checked;
        });
        if (temp) {
            $("input[name='" + name + "']").eq(0).each(function () {
                if (!this.checked) {
                    this.click();
                }
            });
        }else{
            $("input[name='" + name + "']").eq(0).each(function () {
                this.checked = false;
            });
        }
    });

    $("#cancelAcl").on('click', function () {
        $("#ACLConfig input[type='checkbox']").each(function () {
            this.checked = false;
        });
        $("#ACLConfig input[type='checkbox']").each(function () {
            if (!$(this).hasClass('disabled')) {
                this.disabled = false;
            }
        });
        $(".mui-page-full.shown").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    $("#bucketLists tbody").delegate('.mui-icon-handel-storageType','click',function(){
        if (pkg.coldline == true) {
            $(this).parent().parent().click();
            if ($(this).hasClass('mui-disabled')) {
                return false;
            }
            if (isHasSelectBucket()) {//判断当前桶是否存在，如不存在给出提示
                return false;
            }
            $(".mui-page-full.shown").removeClass('shown');
            var bucket = $('#curBucketName').html();
            //外部桶不存在时给出提示
            bucketAttributeAction.getBucketAcl(bucket,function(err,data){
                $("#bucketCustomAcl").text("");
                if (err) {
                    if(errorConfig[err.code]){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code,err.message),
                            ok: function () {
                                $(".refreshCtx").click();
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                                return false;
                            }
                        });
                    }
                    showOverlay();
                }
            });
            bucketAttributeAction.headBucket(bucket, function (err, data) {
                showOverlay();
                if (err) {//桶不存在时提示
                    if(err.code === "NoSuchBucket"){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code,err.message),
                            ok: function () {
                                $(".refreshCtx").click();
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                                return false;
                            }
                        });
                    }else{//请求桶存储类别错误时直接用默认的标准存储类别
                        $("#changeStorageType").removeClass('mui-hide');
                        $("#changeStorageType").addClass('shown');
                        divDragFunc('changeStorageTypeDrag', 'changeStorageType');
                    }
                } else {
                    var selectIndex = "";
                    if (data) {
                        var inputs = $("#StorageTypedsc").parent().find("input");
                        for (var index in inputs) {
                            if (inputs[index].value == data.StorageType) {
                                selectIndex = index;
                            }
                        }
                    }
                    var appElement = document.getElementById("changeStorageType");
                    var $scope = angular.element(appElement).scope();
                    $scope.bucket.selected.value = $scope.bucket.storageTypeList[selectIndex].key;
                    $scope.bucket.description = $scope.bucket.storageTypeList[selectIndex].desc;
                    $scope.$apply();
                    $("#changeStorageType").removeClass('mui-hide');
                    $("#changeStorageType").addClass('shown');
                    divDragFunc('changeStorageTypeDrag', 'changeStorageType');
                }
            });
        }
        return false;
    });

    $('#saveChange').on('click',function () {
        $(".mui-page-full.shown").removeClass('shown');
        $("#changeStorageType").addClass('mui-hide');
        $("#obejctNotRestoreTip").addClass('mui-hide');
        var bucketName = $('#curBucketName').html();
        var storagePolicy = $("#StorageTypedsc").html();
        storagePolicy = CommonUtils.translateStorageClass(storagePolicy);
        bucketAttributeAction.putBucketStoragePolicy(bucketName,storagePolicy,function(err,data){
            if(err){
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message),
                        ok: function () {
                            $(".refreshCtx").click();
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            return false;
                        }
                    });
                }
            }else{
                $('.mui-model').showMessage({
                    type:"info",
                    message:languageJson.obs_term_changeStorageClass_bucketSuccess_msg.format(bucketName),
                    ok:function(){
                        $(".refreshCtx").click();
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    },
                    title:languageJson.hintInfo
                });
            }
        });
    });

    $('#cancelChange').on('click',function () {
        $("#changeStorageType").removeClass('shown');
        $("#changeStorageType").addClass('mui-hide');
        $("#obejctNotRestoreTip").addClass('mui-hide');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    $('.btnAclPermissions').on('click',function () {
        setTimeout(function () {
            $('.mui-icon-aclConfig').click();
        },10);
    });
    $("#bucketLists tbody").delegate('.mui-icon-handel-acl','click',function(){
        $(this).parent().parent().click();
        setTimeout(function () {
            $('.mui-icon-aclConfig').click();
        },10);
    });
    $("#bucketLists tbody").delegate('.mui-icon-handel-unmount','click',function(){
       $(this).parent().parent().click();
        setTimeout(function () {
            $('.btcBucketUnlink').click();
        },10);
    });
    //调出生命周期管理界面
    $('.btnConfigLifecycle').on('click', function () {
        if(_.isEqual(UCDVersion,"HEC")){
            $("#lifecycleConfigKnowMore").hide();
            languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable = languageJson.obs_term_bucketLifecycle_transitioned2Infrequent_lable;
            languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable = languageJson.obs_term_bucketLifecycle_transitioned2Archive_lable;
        }
        if(!pkg.objectColdline){
            $("#lifecycleConfig").find("h5").find("span").html(languageJson.obs_term_bucketLifecycle_learnMore_info)
        }
        if(isHasSelectBucket()){//判断当前桶是否存在，如不存在给出提示
            return false;
        }
        var bucket = $('#curBucketName').html();
        $(".mui-page-full.shown").removeClass('shown');
        $("#lifecycleConfig").addClass('shown');
        divDragFunc('lifecycleConfigDrag','lifecycleConfig');
        $(this).parent().parent().removeClass('mui-open');
        $("#subAddLifecycle").removeClass('mui-disabled');
        $("#subAddLifecycle").attr('title','');
        $("#editLifecycle").addClass('mui-disabled');
        $("#deleteLifecycle").addClass('mui-disabled');
        var loading = loadingShow();
        $("#lifecycleConfig").css('z-index', '90');
        bucketAttributeAction.getBucketLifecycle(bucket,function (err, data) {
            if (err) {
                logger.error(err);
                $("#lifecycleMessage").addClass('mui-hide');
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message),
                        ok: function () {
                            $(".refreshCtx").click();
                            return false;
                        }
                    });
                }
                loading.close();
                $("#lifecycleConfig").css('z-index', '1000');
                showOverlay();
                //桶不存在时，不显示生命周期界面
                if(err.code === 'NoSuchBucket'){
                    $("#cancelLifecycleConfig").click();
                }
                if(err.code === 'NoSuchLifecycleConfiguration'){
                    $("#lifecycleTab tbody").html('<div class="dialog-table-nodata"><span>' + languageJson.noData + '</span></div>');
                }
            } else {
                $("#lifecycleTab tbody").html('');
                loading.close();
                $("#lifecycleConfig").css('z-index', '1000');
                showOverlay();
                var tbody = $("#lifecycleTab tbody");
                var tr = '';
                $("#lifecycleTab tbody").find('tr').each(function () {
                    $(this).remove();
                });
                var obj = {};
                for (var index in data.Rules) {
                    obj = data.Rules[index];
                    var num=parseInt(index)+1;
                    tr += '<tr>';
                    tr += '<td style="width: 55px;">'+num+'</td>';
                    tr += '<td style="width: 100px"><span class="mui-ellipsis-prototype" style="color: rgba(74, 74, 76, 1)">' + encoderForHtml(obj.ID) + '</span></td>';
                    if (obj.Status === "Enabled") {
                        tr += '<td style="color: rgba(74, 74, 76, 1);width: 75px;"><span class="mui-ellipsis-prototype">' + languageJson.enabled + '</span><input type="text" value="true" hidden="hidden"></td>';
                    } else {
                        tr += '<td style="color: rgba(74, 74, 76, 1);width: 75px;">'+languageJson.stop+'<input type="text" value="false" hidden="hidden"></td>';
                    }
                    if(!obj.Prefix){
                        tr += '<td style="width: 140px;"><span class="mui-ellipsis-prototype" style="color: rgba(74, 74, 76, 1)">' + languageJson.toAllBucket + '</span></td>';
                        $("#subAddLifecycle").addClass('mui-disabled');
                        $("#subAddLifecycle").attr('title',languageJson.lifecycleMessage);
                    }else{
                        tr += '<td style="width: 140px;"><span class="mui-ellipsis-prototype" style="color: rgba(74, 74, 76, 1)">' + languageJson.prefix1+":"+encoderForHtml(obj.Prefix) + '</span></td>';
                    }
                    if(obj.Expiration){
                        if (obj.Transition.length == 2) {
                            tr += '<td class="tdWidth"><span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+obj.Transition[0].Days+ languageJson.day + '<label style="display: none">' + obj.Transition[0].StorageClass + '</label></span><br><span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ obj.Transition[1].Days + languageJson.day + '<label style="display: none">' + obj.Transition[1].StorageClass + '</label></span><br><span class="days2">' + languageJson.dataOutTime +": "+ obj.Expiration.Days + languageJson.day + '</span></td>';
                        }else if(obj.Transition.length == 1 && obj.Transition[0].StorageClass == 'STANDARD_IA'){
                            tr += '<td class="tdWidth"><span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+obj.Transition[0].Days+ languageJson.day + '<label style="display: none">' + obj.Transition[0].StorageClass + '</label></span><br><span class="days2">' + languageJson.dataOutTime +": "+ obj.Expiration.Days + languageJson.day + '</span></td>';
                        }else if(obj.Transition.length == 1 && obj.Transition[0].StorageClass == 'GLACIER'){
                            tr += '<td class="tdWidth"><span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+obj.Transition[0].Days+ languageJson.day + '<label style="display: none">' + obj.Transition[0].StorageClass + '</label></span><br><span class="days2">' + languageJson.dataOutTime +": "+ obj.Expiration.Days + languageJson.day + '</span></td>';
                        }else{
                            tr += '<td class="tdWidth"><span class="days2">' + languageJson.dataOutTime +": "+ obj.Expiration.Days + languageJson.day + '</span></td>';
                        }
                    }else{
                        if(obj.Transition.length == 2){
                            tr += '<td class="tdWidth"><span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+obj.Transition[0].Days+ languageJson.day + '<label style="display: none">' + obj.Transition[0].StorageClass + '</label></span><br><span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ obj.Transition[1].Days + languageJson.day + '<label style="display: none">' + obj.Transition[1].StorageClass + '</label></span></td>';
                        }else if(obj.Transition.length == 1 && obj.Transition[0].StorageClass == 'STANDARD_IA') {
                            tr += '<td class="tdWidth"><span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+obj.Transition[0].Days+ languageJson.day + '<label style="display: none">' + obj.Transition[0].StorageClass + '</label></span></td>';
                        }else if(obj.Transition.length == 1 && obj.Transition[0].StorageClass == 'GLACIER'){
                            tr += '<td class="tdWidth"><span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+obj.Transition[0].Days+ languageJson.day + '<label style="display: none">' + obj.Transition[0].StorageClass + '</label></span></td>';
                        }else{
                            tr += '<td class="tdWidth"><span>--</span></td>';
                        }
                    }
                    if(obj.NoncurrentVersionExpiration){
                        if (obj.NoncurrentVersionTransition.length == 2) {
                            tr += '<td class="tdWidth"><span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+obj.NoncurrentVersionTransition[0].NoncurrentDays+ languageJson.day + '<label style="display: none">' + obj.NoncurrentVersionTransition[0].StorageClass + '</label></span><br><span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ obj.NoncurrentVersionTransition[1].NoncurrentDays + languageJson.day + '<label style="display: none">' + obj.NoncurrentVersionTransition[1].StorageClass + '</label></span><br><span class="days5">' + languageJson.dataOutTime +": "+ obj.NoncurrentVersionExpiration.NoncurrentDays + languageJson.day + '</span></td>';
                        }else if(obj.NoncurrentVersionTransition.length == 1 && obj.NoncurrentVersionTransition[0].StorageClass == 'STANDARD_IA'){
                            tr += '<td class="tdWidth"><span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+obj.NoncurrentVersionTransition[0].NoncurrentDays+ languageJson.day + '<label style="display: none">' + obj.NoncurrentVersionTransition[0].StorageClass + '</label></span><br><span class="days5">' + languageJson.dataOutTime +": "+ obj.NoncurrentVersionExpiration.NoncurrentDays + languageJson.day + '</span></td>';
                        }else if(obj.NoncurrentVersionTransition.length == 1 && obj.NoncurrentVersionTransition[0].StorageClass == 'GLACIER'){
                            tr += '<td class="tdWidth"><span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+obj.NoncurrentVersionTransition[0].NoncurrentDays+ languageJson.day + '<label style="display: none">' + obj.NoncurrentVersionTransition[0].StorageClass + '</label></span><br><span class="days5">' + languageJson.dataOutTime +": "+ obj.NoncurrentVersionExpiration.NoncurrentDays + languageJson.day + '</span></td>';
                        }else{
                            tr += '<td class="tdWidth"><span class="days5">' + languageJson.dataOutTime +": "+ obj.NoncurrentVersionExpiration.NoncurrentDays + languageJson.day + '</span></td>';
                        }
                    }else{
                        if(obj.NoncurrentVersionTransition.length == 2){
                            tr += '<td class="tdWidth"><span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+obj.NoncurrentVersionTransition[0].NoncurrentDays+ languageJson.day + '<label style="display: none">' + obj.NoncurrentVersionTransition[0].StorageClass + '</label></span><br><span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+obj.NoncurrentVersionTransition[1].NoncurrentDays+ languageJson.day + '<label style="display: none">' + obj.NoncurrentVersionTransition[1].StorageClass + '</label></span></td>';
                        }else if(obj.NoncurrentVersionTransition.length == 1 && obj.NoncurrentVersionTransition[0].StorageClass == 'STANDARD_IA'){
                            tr += '<td class="tdWidth"><span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+obj.NoncurrentVersionTransition[0].NoncurrentDays+ languageJson.day + '<label style="display: none">' + obj.NoncurrentVersionTransition[0].StorageClass + '</label></span></td>';
                        }else if(obj.NoncurrentVersionTransition.length == 1 && obj.NoncurrentVersionTransition[0].StorageClass == 'GLACIER') {
                            tr += '<td class="tdWidth"><span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+obj.NoncurrentVersionTransition[0].NoncurrentDays+ languageJson.day + '<label style="display: none">' + obj.NoncurrentVersionTransition[0].StorageClass + '</label></span></td>';
                        }else{
                            tr += '<td class="tdWidth"><span>--</span></td>';
                        }
                    }
                    tr += '<td style="width: 90px;"><span><i class="mui-icon-handel-edit" title="'+ languageJson.edit +'"></i><i class="mui-icon-handel-del" title="'+ languageJson.delete +'"></i></span></td>';
                    tr += '</tr>';
                    tbody.append(tr);
                    tr = "";
                    obj = {};
                }
                var trs = $("#lifecycleTab tbody").find('tr').length;
                if(parseInt(trs)<1){
                    $("#cancelAllLifecycle").addClass('mui-disabled');
                }else{
                    $("#btnConfigLifecycle").removeClass('mui-disabled');
                }
            }
        });
        tabFocus("subLifecycleConfig");
        return false;
    });
    $("#lifecycleTab tbody").delegate('tr','click', function (event) {
        var self = this;
        $(self).parent().children().find('.mui-ellipsis-prototype').removeClass('show-span-active');
        if(event.ctrlKey&&event.button===0)
        {
            checked = true;
            checkedNum = $(self).index();
            $(self).toggleClass('selected-tr-active');
            if($("#lifecycleTab .selected-tr-active").length < 1) {
                //在生命周期列表中.selected-tr-active的个数选中数量，只统计生命周期列表中选中的tr元素
                $("#editLifecycle,#deleteLifecycle").addClass("mui-disabled");
            }
        }else if(event.shiftKey&&event.button===0) {//shift+鼠标左键事件
            $(self).parent().children().removeClass('selected-tr-active');
            if(checked)
            {
                var currCheck = $(self).index();
                var preCheck = checkedNum;
                if(currCheck<preCheck)
                {//大小排序
                    var temp = currCheck+preCheck;
                    currCheck = temp - currCheck;
                    preCheck = temp - preCheck;
                }
                var ul_arr = $("#lifecycleTab tbody tr");
                for(var i = preCheck;i<currCheck+1;i++)
                {
                    $(ul_arr[i]).addClass('selected-tr-active');
                }
            }else{
                checked = true;
                checkedNum = $(self).index();
                $(self).toggleClass('selected-tr-active');
            }
        }else{
            $(self).parent().children().removeClass('selected-tr-active');
            checked = true;
            checkedNum = $(self).index();
            $(self).toggleClass('selected-tr-active');
        }
        var arr = $("#lifecycleTab tbody .selected-tr-active");
        $("#lifecycleTab tbody .selected-tr-active .mui-ellipsis-prototype").addClass('show-span-active');
        if (arr.length === 1) {
            disabledBtn($("#deleteLifecycle,#editLifecycle"));
        } else if(arr.length > 1){
            $("#editLifecycle").addClass('mui-disabled');
            $("#deleteLifecycle").removeClass('mui-disabled');
        }else{
            $("#editLifecycle,#deleteLifecycle").addClass("mui-disabled");
        }
    });
    $("#lifecycleTab tbody").bind('click',function(){
        return false;
    });
    $("#lifecycleTab tbody").bind('contextmenu',function(){
        return false;
    });
    // 生命周期管理界面div 点击左键取消选择
    $("#lifecycleTabDiv").bind('click',function(){
        $("#lifecycleTab tbody tr").removeClass('selected-tr-active');
        $("#lifecycleTab tbody tr").find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $("#editLifecycle,#deleteLifecycle").addClass("mui-disabled");
        return false;
    });
    // 生命周期管理div 点击右键取消选择
    $("#lifecycleTabDiv").bind('contextmenu',function(){
        $("#lifecycleTab tbody tr").removeClass('selected-tr-active');
        $("#lifecycleTab tbody tr").find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $("#editLifecycle,#deleteLifecycle").addClass("mui-disabled");
        return false;
    });

    //生命周期管理界面编辑按钮
    $("#editLifecycle").on('click', function () {
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        $("#lifecycleConfig").css('z-index', '90');
        $("#editLifecycle,#deleteLifecycle").addClass("mui-disabled");
        $("#lifecycleChildDrag .mui-page-full-title").html(languageJson.editLifecycleRule);
        var obj = $("#lifecycleConfig .mui-table .selected-tr-active");
        $("#lifeRulesName").val(encoderForText($(obj).children('td').eq(1).find('span').html()));
        if($("#lifecycleTab tbody").find('tr').length > 1) {
            $('#all').attr('disabled','disabled');
            $('#all').parent().next().find('label').eq(0).attr('title',languageJson.obs_term_bucketLifecycle_configAllBucket_tip);
        }else{
            $('#all').removeAttr('disabled');
            $('#all').parent().next().find('label').eq(0).attr('title','');
        }
        $("[name='lifeRuleType']").on('change', function () {
            if ($("#all").is(":checked")) {
                $(".preAll").css('display','none');
                $("#lifeRulesPath").attr('disabled',true);
                $("#lifecycleType").val('2');
            } else {
                $(".preAll").css('display','block');
                $("#lifeRulesPath").removeAttr('disabled');
                $("#lifecycleType").val('1');
            }
        });
        var rulePath = encoderForText($(obj).children('td').eq(3).find('span').html());
        rulePath = rulePath.replace(languageJson.prefix1 + ":", "");
        rulePath = rulePath.trim();
        rulePath = rulePath.replace(languageJson.toAllBucket, "");
        $("#lifeRulesPath").val(rulePath);
        var trs = $("#lifecycleTab tbody").find('tr').length;
        if ($("#lifeRulesPath").val()) {
            $("#lifecycleType").val("1");
            $("#prefix").each(function () {
                this.checked = true;
            });
            $(".preAll").css('display','block');
            $("#lifeRulesPath").removeAttr('disabled');
            $("#all").each(function () {
                this.checked = false;
            });
        } else {
            $(".preAll").css('display','none');
            $("#lifecycleType").val("2");
            $("#prefix").each(function () {
                this.checked = false;
            });
            $("#all").each(function () {
                this.checked = true;
            });
            $("#lifeRulesPath").attr('disabled',true);
        }
        if($(obj).children('td').eq(2).find('input').val()==='true'){
            $("#lifeEnabled").each(function () {
                this.checked = true;
            });
        }else{
            $("#lifeDisabled").each(function () {
                this.checked = true;
            });
        }
        var Days = $(obj).children('td').eq(4).find('.days');
        var Days1 = $(obj).children('td').eq(4).find('.days1');
        var Days2 = $(obj).children('td').eq(4).find('.days2');
        var Days3 = $(obj).children('td').eq(5).find('.days3');
        var Days4 = $(obj).children('td').eq(5).find('.days4');
        var Days5 = $(obj).children('td').eq(5).find('.days5');
        if ($(obj).children('td').eq(2).find("input").val() === 'true') {
            $("#trueCheck").each(function () {
                this.checked = true;
            });
        } else {
            $("#trueCheck").each(function () {
                this.checked = false;
            });
        }
        if(Days.length !== 0){
            $("#delRadio2").click();
            $("#delDateNumber").val(Days.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio1").click();
        }
        if(Days1.length !== 0){
            $("#delRadio4").click();
            $("#delDateNumber1").val(Days1.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio3").click();
        }
        if(Days2.length !== 0){
            $("#delRadio6").click();
            $("#delDateNumber2").val(Days2.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio5").click();
        }
        if(Days3.length !== 0){
            $("#delRadio8").click();
            $("#delDateNumber3").val(Days3.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio7").click();
        }
        if(Days4.length !== 0){
            $("#delRadio10").click();
            $("#delDateNumber4").val(Days4.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio9").click();
        }
        if(Days5.length !== 0){
            $("#delRadio12").click();
            $("#delDateNumber5").val(Days5.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio11").click();
        }
        $("#lifecycleReset").val(obj.index());
        $("#lifecycleChild").addClass('shown');
        divDragFunc('lifecycleChildDrag','lifecycleChild');
        $(obj).find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $(obj).removeClass("selected-tr-active");
        return false;
    });
    //生命周期管理界面单行编辑按钮
    $("#lifecycleTab tbody").delegate('.mui-icon-handel-edit','click',function () {
        $("#lifecycleConfig").css('z-index', '90');
        $("#lifecycleChildDrag .mui-page-full-title").html(languageJson.editLifecycleRule);
        var obj = $(this).parent().parent().parent();
        $("#lifeRulesName").val(encoderForText($(obj).children('td').eq(1).find('span').html()));
        if($("#lifecycleTab tbody").find('tr').length > 1) {
            $('#all').attr('disabled','disabled');
            $('#all').parent().next().find('label').eq(0).attr('title',languageJson.obs_term_bucketLifecycle_configAllBucket_tip);
        }else{
            $('#all').removeAttr('disabled');
            $('#all').parent().next().find('label').eq(0).attr('title','');
        }
        $("[name='lifeRuleType']").on('change', function () {
            if ($("#all").is(":checked")) {
                $(".preAll").css('display','none');
                $("#lifeRulesPath").attr('disabled',true);
                $("#lifecycleType").val('2');
            } else {
                $(".preAll").css('display','block');
                $("#lifeRulesPath").removeAttr('disabled');
                $("#lifecycleType").val('1');
            }
        });
        var rulePath = encoderForText($(obj).children('td').eq(3).find('span').html());
        rulePath = rulePath.replace(languageJson.prefix1 + ":", "");
        rulePath = rulePath.trim();
        rulePath = rulePath.replace(languageJson.toAllBucket, "");
        $("#lifeRulesPath").val(rulePath);
        var trs = $("#lifecycleTab tbody").find('tr').length;
        if ($("#lifeRulesPath").val()) {
            $("#lifecycleType").val("1");
            $("#prefix").each(function () {
                this.checked = true;
            });
            $(".preAll").css('display','block');
            $("#lifeRulesPath").removeAttr('disabled');
            $("#all").each(function () {
                this.checked = false;
            });
        } else {
            $(".preAll").css('display','none');
            $("#lifecycleType").val("2");
            $("#prefix").each(function () {
                this.checked = false;
            });
            $("#all").each(function () {
                this.checked = true;
            });
            $("#lifeRulesPath").attr('disabled',true);
        }
        if($(obj).children('td').eq(2).find('input').val()==='true'){
            $("#lifeEnabled").each(function () {
                this.checked = true;
            });
        }else{
            $("#lifeDisabled").each(function () {
                this.checked = true;
            });
        }
        var Days = $(obj).children('td').eq(4).find('.days');
        var Days1 = $(obj).children('td').eq(4).find('.days1');
        var Days2 = $(obj).children('td').eq(4).find('.days2');
        var Days3 = $(obj).children('td').eq(5).find('.days3');
        var Days4 = $(obj).children('td').eq(5).find('.days4');
        var Days5 = $(obj).children('td').eq(5).find('.days5');
        if ($(obj).children('td').eq(2).find("input").val() === 'true') {
            $("#trueCheck").each(function () {
                this.checked = true;
            });
        } else {
            $("#trueCheck").each(function () {
                this.checked = false;
            });
        }
        if(Days.length !== 0){
            $("#delRadio2").click();
            $("#delDateNumber").val(Days.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio1").click();
        }
        if(Days1.length !== 0){
            $("#delRadio4").click();
            $("#delDateNumber1").val(Days1.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio3").click();
        }
        if(Days2.length !== 0){
            $("#delRadio6").click();
            $("#delDateNumber2").val(Days2.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio5").click();
        }
        if(Days3.length !== 0){
            $("#delRadio8").click();
            $("#delDateNumber3").val(Days3.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio7").click();
        }
        if(Days4.length !== 0){
            $("#delRadio10").click();
            $("#delDateNumber4").val(Days4.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio9").click();
        }
        if(Days5.length !== 0){
            $("#delRadio12").click();
            $("#delDateNumber5").val(Days5.text().replace(/[^0-9]/ig,""));
        }else{
            $("#delRadio11").click();
        }
        $("#lifecycleReset").val(obj.index());
        $("#lifecycleChild").addClass('shown');
        divDragFunc('lifecycleChildDrag','lifecycleChild');
        $(obj).find('.mui-ellipsis-prototype').removeClass('show-span-active');
        return false;
    });
    $("#lifeRulesPath").on("blur", function () {
        $("#subLifecycleRule").removeClass('mui-disabled');
        var ruleName = $("#lifeRulesPath").val();
        ruleName = ruleName.trim();
        var trNum = $("#lifecycleReset").val();
        if ($("#lifecycleReset") && $("#lifecycleReset") === '1') {
            return false;
        } else {
            $("#lifecycleTab tbody").find('tr').each(function () {
                if (parseInt($(this).index()) !== parseInt(trNum)) {
                    var rulePath = $(this).children('td').eq(2).text();
                    rulePath = rulePath.replace(languageJson.prefix1 + ":", "");
                    rulePath = rulePath.replace(languageJson.toAllBucket, "");
                    if (rulePath && ruleName && (rulePath === ruleName || rulePath.indexOf(ruleName) === 0 || ruleName.indexOf(rulePath) === 0)) {
                        $('.mui-model').showMessage({
                            type: 'warning',
                            message: languageJson.rulePathRepeat,
                            ok: function () {
                                $('#lifeRulesPath').focus();
                                $('#lifeRulesPath').val("");
                            },
                            title: languageJson.warning
                        });
                    }
                }
            });
        }
    });
    //生命周期管理界面删除按钮
    $("#deleteLifecycle").on('click', function () {
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        var length =$("#lifecycleTab .selected-tr-active").length;
        if(length>1){
            var message = languageJson.obs_term_bucketLifecycle_delMultiLifecycle_msg.format(length);
        }else{
            var message = languageJson.sureDeleteLifecycleRule;
        }
        $('.mui-model').showMessage(
            {
                type: "warning",
                message: message,
                isFocus: true,
                ok: function () {
                    $("#editLifecycle,#deleteLifecycle").addClass("mui-disabled");
                    $("#lifecycleConfig .mui-table .selected-tr-active").remove();
                    var trs = $("#lifecycleTab tbody").find('tr').length;
                    if (trs === 0) {
                        $("#subAddLifecycle").removeClass('mui-disabled');
                        $("#subAddLifecycle").attr('title','');
                        $("#lifecycleMessage").addClass('mui-hide');
                        $("#lifecycleTab tbody").html('<div class="dialog-table-nodata"><span>' + languageJson.noData + '</span></div>');
                    }
                    var num = 1;
                    $("#lifecycleTab tbody tr>td:first-child").each(function () {
                        $(this).html(num++);
                    });
                },
                cancel: function () {
                    return false;
                },
                title: languageJson.obs_term_bucketLifecycle_delLifecycleRule_wintitle
            }
        );
        tabFocus("subLifecycleConfig");
        return false;
    });
    //生命周期管理界面单行删除按钮
    $("#lifecycleTab tbody").delegate('.mui-icon-handel-del','click',function () {
        var self = this;
        $('.mui-model').showMessage(
            {
                type: "warning",
                message: languageJson.sureDeleteLifecycleRule,
                isFocus: true,
                ok: function () {
                    $("#editLifecycle,#deleteLifecycle").addClass("mui-disabled");
                    $(self).parent().parent().parent().remove();
                    var trs = $("#lifecycleTab tbody").find('tr').length;
                    if (trs === 0) {
                        $("#subAddLifecycle").removeClass('mui-disabled');
                        $("#subAddLifecycle").attr('title','');
                        $("#lifecycleMessage").addClass('mui-hide');
                        $("#lifecycleTab tbody").html('<div class="dialog-table-nodata"><span>' + languageJson.noData + '</span></div>');
                    }
                    var num = 1;
                    $("#lifecycleTab tbody tr>td:first-child").each(function () {
                        $(this).html(num++);
                    });
                },
                cancel: function () {
                    return false;
                },
                title: languageJson.obs_term_bucketLifecycle_delLifecycleRule_wintitle
            }
        );
        tabFocus("subLifecycleConfig");
        return false;
    });
    //添加生命周期按钮
    $("#subAddLifecycle").on('click', function () {
        if(_.isEqual(UCDVersion,"HEC")){
            $("#transitionWarm").find("p").html(languageJson.obs_term_bucketLifecycle_transition2Infrequent_tip);
            $("#transitionCold").find("p").html(languageJson.obs_term_bucketLifecycle_transition2Archive_tip);
        }
        if(!pkg.objectColdline){
            $(".objectColdline").addClass("mui-hide");
        }
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        if($("#lifecycleTab tbody").find('tr').length > 0) {
            $('#all').attr('disabled','disabled');
            $('#all').parent().next().find('label').eq(0).attr('title',languageJson.obs_term_bucketLifecycle_configAllBucket_tip);
        }else{
            $('#all').removeAttr('disabled');
            $('#all').parent().next().find('label').eq(0).attr('title','');
        }
        if ($("#lifecycleTab tbody").find('tr').length > 99) {
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.lifecycleRuleNotMoreThan100,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        $("#lifecycleChildDrag .mui-page-full-title").html(languageJson.lifecycleRule);
        $("#lifecycleTab tr.selected-tr-active").removeClass('selected-tr-active');
        $("#editLifecycle,#deleteLifecycle").addClass("mui-disabled");
        $("#lifecycleConfig").css('z-index', '90');
        $("#lifecycleChild").addClass('shown');
        divDragFunc('lifecycleChildDrag','lifecycleChild');
        $("#lifeRulesName").val("");
        $("#lifeRulesPath").val("");
        $("#lifecycleReset").val("");
        $("#delRadio1").click();
        $("#delRadio3").click();
        $("#delRadio5").click();
        $("#delRadio7").click();
        $("#delRadio9").click();
        $("#delRadio11").click();
        $("#prefix").each(function () {
            this.checked = true;
        });
        $(".preAll").css('display','block');
        $("#lifeEnabled").each(function () {
            this.checked = true;
        });
        $("#delDataTime").val(GetDateStr(30));
        $("#lifecycleType").val("1");
        $("#lifeRulesPath").removeAttr('disabled');
        $("#delDateNumberSpan").removeClass('mui-hide');
        $("#delDataTimeSpan").addClass('mui-hide');
        $("[name='lifeRuleType']").on('change', function () {
            if ($("#all").is(":checked")) {
                $(".preAll").css('display','none');
                $("#lifeRulesPath").attr('disabled',true);
                $("#lifecycleType").val('2');
            } else {
                $(".preAll").css('display','block');
                $("#lifeRulesPath").removeAttr('disabled');
                $("#lifecycleType").val('1');
            }
        });
        $("#lifeRulesName").focus();
        return false;
    });
    //当前版转换为低频访问存储是否配置
    $("[name='Expiration']").on('change', function () {
        if ($("#delRadio1").is(':checked')) {
            $("#Days").addClass('mui-hide');
            $('#delDateNumber1').attr('min','1');
            if($('#delRadio4').prop('checked') && $('#delRadio6').prop('checked')){
                var value = $('#delDateNumber1').val();
                var newmin = parseInt(value)+1;
                if($('#delDateNumber2').val()>newmin){
                    return false;
                }else{
                    $('#delDateNumber2').val(newmin);
                }
            }else{
                $('#delDateNumber2').attr('min','1');
            }
        } else{
            $("#Days").removeClass('mui-hide');
            $('#delDateNumber').val("30");
            if($('#delRadio4').prop('checked')){
                var value = $('#delDateNumber').val();
                var max = $('#delDateNumber').attr('max');
                var newmin = parseInt(value)+30;
                $('#delDateNumber1').prop('min',newmin);
                if($('#delDateNumber1').val()>newmin){
                    return false;
                }else{
                    $('#delDateNumber1').val(newmin);
                    if($('#delRadio6').prop('checked')){
                        var value = $('#delDateNumber1').val();
                        var newmin = parseInt(value)+1;
                        if($('#delDateNumber2').val()>newmin){
                            return false;
                        }else{
                            $('#delDateNumber2').val(newmin);
                        }
                    }
                }
            }else{
                if($('#delRadio6').prop('checked')){
                    var value = $('#delDateNumber').val();
                    var max = $('#delDateNumber').attr('max');
                    var newmin = parseInt(value)+1;
                    $('#delDateNumber2').prop('min',newmin);
                    if($('#delDateNumber2').val()>newmin){
                        return false;
                    }else{
                        $('#delDateNumber2').val(newmin);
                    }
                }
            }
        }
    });
    //当前版本转换为归档存储是否配置
    $("[name='coldLine']").on('change', function () {
        if ($("#delRadio3").is(':checked')) {
            $("#Days1").addClass('mui-hide');
            if($('#delRadio2').prop('checked') && $('#delRadio6').prop('checked')){
                var value = $('#delDateNumber').val();
                var newmin = parseInt(value) + 1;
                $('#delDateNumber2').prop('min',newmin);
            }else{
                $('#delDateNumber2').prop('min','1');
            }
        } else {
            $("#Days1").removeClass('mui-hide');
            if($('#delRadio2').prop('checked')){
                var value = $('#delDateNumber').val();
                var max = $('#delDateNumber').attr('max');
                var newmin = parseInt(value) + 30;
                $('#delDateNumber1').val(newmin);
                $('#delDateNumber1').prop('min',newmin);
                if($('#delRadio6').prop('checked')){
                    var value = $('#delDateNumber1').val();
                    var newmin = parseInt(value) + 1;
                    $('#delDateNumber2').prop('min',newmin);
                    if($('#delDateNumber2').val()>newmin){
                        return false;
                    }else {
                        $('#delDateNumber2').val(newmin);
                    }
                }
            }else{
                $('#delDateNumber1').val('30');
                $('#delDateNumber1').attr('min','1');
                if($('#delRadio6').prop('checked')){
                    var value = $('#delDateNumber1').val();
                    var max = $('#delDateNumber1').attr('max');
                    var newmin = parseInt(value) + 1;
                    $('#delDateNumber2').attr('min',newmin);
                    if($('#delDateNumber2').val()>newmin){
                        return false;
                    }else{
                        $('#delDateNumber2').val(newmin);
                    }
                }
            }
        }
    });
    //当前版本过期删除是否配置
    $("[name='deledate']").on('change', function () {
        if ($("#delRadio5").is(':checked')) {
            $("#Days2").addClass('mui-hide');
            $(".noteColor").addClass('mui-hide');
        } else {
            $("#Days2").removeClass('mui-hide');
            $(".noteColor").removeClass('mui-hide');
            if($('#delRadio4').prop('checked')){
                var value = $('#delDateNumber1').val();
                var max = $('#delDateNumber1').attr('max');
                var newmin = parseInt(value)+1;
                $('#delDateNumber2').val(newmin);
                $('#delDateNumber2').prop('min',newmin);
            }else{
                if($('#delRadio2').prop('checked')){
                    var value = $('#delDateNumber').val();
                    var max = $('#delDateNumber').attr('max');
                    var newmin = parseInt(value)+1;
                    $('#delDateNumber2').val(newmin);
                    $('#delDateNumber2').prop('min',newmin);
                }else{
                    $('#delDateNumber2').val('30');
                }
            }
        }
    });
    //当前版本第一个天数变化引起后两个变化
    $('#delDateNumber').on('change',function () {
        var value = parseInt($(this).val());
        var min = parseInt($(this).attr('min'));
        var max = parseInt($(this).attr('max'));
        if(value < min){
            $(this).val(min);
            value = min;
        }
        var newmin = parseInt(value) + 30;
        if($("#delRadio4").is(':checked')){
            $('#delDateNumber1').prop('min',newmin);
            if($('#delDateNumber1').val()>newmin){
                return false;
            }else{
                $('#delDateNumber1').val(newmin);
                if($("#delRadio6").is(':checked')){
                    newmin = parseInt(value) + 31;
                    $('#delDateNumber2').prop('min',newmin);
                    if($('#delDateNumber2').val()>newmin){
                        return false
                    }else{
                        $('#delDateNumber2').val(newmin);
                    }
                }
            }
        }else{
            if($("#delRadio6").is(':checked')){
                newmin = parseInt(value) + 1;
                $('#delDateNumber2').prop('min',newmin);
                if($('#delDateNumber2').val()>newmin){
                    return false;
                }else{
                    $('#delDateNumber2').val(newmin);
                }
            }
        }
    });
    //当前版本第二个天数变化引起第三个变化
    $('#delDateNumber1').on('change',function () {
        var value = parseInt($(this).val());
        var min = parseInt($(this).attr('min'));
        var max = parseInt($(this).attr('max'));
        if(value < min){
            $(this).val(min);
            value = min;
        }
        var newmin = value + 1;
        if($("#delRadio6").is(':checked')){
            $('#delDateNumber2').prop('min',newmin);
            if($('#delDateNumber2').val()>newmin){
                return false;
            }else {
                $('#delDateNumber2').val(newmin);
            }
        }
    });
    //当前版本第三个天数变化
    $('#delDateNumber2').on('change',function(){
        var value = parseInt($(this).val());
        var min = parseInt($(this).attr('min'));
        if(value < min){
            $(this).val(min);
            value = min;
        }
    });
    //历史版本转换为低频访问存储是否配置
    $("[name='oldNerline']").on('change', function () {
        if ($("#delRadio7").is(':checked')) {
            $("#Days3").addClass('mui-hide');
            $('#delDateNumber4').attr('min','1');
            if($('#delRadio10').prop('checked') && $('#delRadio12').prop('checked')) {
                var value = $('#delDateNumber4').val();
                var newmin = parseInt(value) + 1;
                if ($('#delDateNumber5').val() > newmin) {
                    return false;
                } else {
                    $('#delDateNumber5').val(newmin);
                }
            }else{
                $('#delDateNumber5').attr('min','1');
            }
        } else {
            $("#Days3").removeClass('mui-hide');
            $('#delDateNumber3').val("30");
            if($('#delRadio10').prop('checked')){
                var value = $('#delDateNumber3').val();
                var max = $('#delDateNumber3').attr('max');
                var newmin = parseInt(value)+30;
                $('#delDateNumber4').prop('min',newmin);
                if($('#delDateNumber4').val()>newmin){
                    return false;
                }else{
                    $('#delDateNumber4').val(newmin);
                    if($('#delRadio12').prop('checked')){
                        var value = $('#delDateNumber4').val();
                        var max = $('#delDateNumber4').attr('max');
                        var newmin = parseInt(value)+1;
                        $('#delDateNumber5').prop('min',newmin);
                        if($('#delDateNumber5').val()>newmin){
                            return false;
                        }else{
                            $('#delDateNumber5').val(newmin);
                        }
                    }
                }
            }else{
                if($('#delRadio12').prop('checked')){
                    var value = $('#delDateNumber3').val();
                    var newmin = parseInt(value)+1;
                    if($('#delDateNumber5').val() > newmin){
                        return false;
                    }else{
                        $('#delDateNumber5').val(newmin);
                    }
                }
            }
        }
    });
    //历史版本转换为归档存储是否配置
    $("[name='oldcoldLine']").on('change', function () {
        if ($("#delRadio9").is(':checked')) {
            $("#Days4").addClass('mui-hide');
            if($('#delRadio8').prop('checked') && $('#delRadio12').prop('checked')){
                var value = $('#delDateNumber3').val();
                var newmin = parseInt(value) + 1;
                $('#delDateNumber5').prop('min',newmin);
            }else{
                $('#delDateNumber5').prop('min','1');
            }
        } else {
            $("#Days4").removeClass('mui-hide');
            if($('#delRadio8').prop('checked')){
                var value = $('#delDateNumber3').val();
                var max = $('#delDateNumber3').attr('max');
                var newmin = parseInt(value) + 30;
                $('#delDateNumber4').val(newmin);
                $('#delDateNumber4').prop('min',newmin);
                if($('#delRadio12').prop('checked')){
                    var value = $('#delDateNumber4').val();
                    var newmin = parseInt(value) + 1;
                    $('#delDateNumber5').prop('min',newmin);
                    if($('#delDateNumber5').val()>newmin){
                        return false;
                    }else {
                        $('#delDateNumber5').val(newmin);
                    }
                }
            }else{
                $('#delDateNumber4').val('30');
                $('#delDateNumber4').attr('min','1');
                if($('#delRadio12').prop('checked')){
                    var value = $('#delDateNumber4').val();
                    var max = $('#delDateNumber4').attr('max');
                    var newmin = parseInt(value) + 1;
                    $('#delDateNumber5').attr('min',newmin);
                    if($('#delDateNumber5').val()>newmin){
                        return false;
                    }else{
                        $('#delDateNumber5').val(newmin);
                    }
                }
            }
        }
    });
    //历史版本过期删除是否配置
    $("[name='deledated']").on('change', function () {
        if ($("#delRadio11").is(':checked')) {
            $("#Days5").addClass('mui-hide');
        } else {
            $("#Days5").removeClass('mui-hide');
            if($('#delRadio10').prop('checked')){
                var value = $('#delDateNumber4').val();
                var max = $('#delDateNumber4').attr('max');
                var newmin = parseInt(value)+1;
                $('#delDateNumber5').val(newmin);
                $('#delDateNumber5').prop('min',newmin);
            }else{
                if($('#delRadio8').prop('checked')){
                    var value = $('#delDateNumber3').val();
                    var max = $('#delDateNumber3').attr('max');
                    var newmin = parseInt(value)+1;
                    $('#delDateNumber5').val(newmin);
                    $('#delDateNumber5').prop('min',newmin);
                }else{
                    $('#delDateNumber5').val('30');
                }
            }
        }
    });
    //历史版本第一个天数变化引起后两个变化
    $('#delDateNumber3').on('change',function () {
        var value = parseInt($(this).val());
        var min = parseInt($(this).attr('min'));
        var max = parseInt($(this).attr('max'));
        if(value < min){
            $(this).val(min);
            value = min;
        }
        var newmin = parseInt(value) + 30;
        if($("#delRadio10").is(':checked')){
            $('#delDateNumber4').prop('min',newmin);
            if($('#delDateNumber4').val()>newmin){
                return false;
            }else{
                $('#delDateNumber4').val(newmin);
                if($("#delRadio12").is(':checked')){
                    newmin = parseInt(value) + 31;
                    $('#delDateNumber5').prop('min',newmin);
                    if($('#delDateNumber5').val()>newmin){
                        return false
                    }else{
                        $('#delDateNumber5').val(newmin);
                    }
                }
            }
        }else{
            if($("#delRadio12").is(':checked')){
                newmin = parseInt(value) + 1;
                $('#delDateNumber5').prop('min',newmin);
                if($('#delDateNumber5').val()>newmin){
                    return false;
                }else{
                    $('#delDateNumber5').val(newmin);
                }
            }
        }
    });
    //历史版本第二个天数变化引起第三个变化
    $('#delDateNumber4').on('change',function () {
        var value = parseInt($(this).val());
        var min = parseInt($(this).attr('min'));
        var max = parseInt($(this).attr('max'));
        if(value < min){
            $(this).val(min);
            value = min;
        }
        var newmin = value + 1;
        if($("#delRadio12").is(':checked')){
            $('#delDateNumber5').prop('min',newmin);
            if($('#delDateNumber5').val()>newmin){
                return false;
            }else {
                $('#delDateNumber5').val(newmin);
            }
        }
    });
    //历史版本第三个天数变化
    $('#delDateNumber5').on('change',function(){
        var value = parseInt($(this).val());
        var min = parseInt($(this).attr('min'));
        if(value < min){
            $(this).val(min);
            value = min;
        }
    });
    //生命周期管理界面保存按钮
    $("#subLifecycleConfig").on('click', function () {
        checked = false;
        checkedNum = -1;
        var arr = [];
        var obj = {};
        var rulePath = '';
        $("#lifecycleTab tbody").find('tr').each(function () {
            obj.status = $(this).children('td').eq(2).find('input').val();
            obj.rulename = $(this).children('td').eq(1).text();
            rulePath = $(this).children('td').eq(3).text();
            rulePath = rulePath.replace(languageJson.prefix1 + ":", "");
            rulePath = rulePath.trim();
            rulePath = rulePath.replace(languageJson.toAllBucket, "");
            obj.rulepath = rulePath;
            obj.days = $(this).children('td').eq(4).find('.days').text();
            obj.daysStorage = $(this).children('td').eq(4).find('.days').find('label').text();
            obj.days1 = $(this).children('td').eq(4).find('.days1').text();
            obj.days1Storage = $(this).children('td').eq(4).find('.days1').find('label').text();
            obj.days2 = $(this).children('td').eq(4).find('.days2').text();
            obj.days3 = $(this).children('td').eq(5).find('.days3').text();
            obj.days3Storage = $(this).children('td').eq(5).find('.days3').find('label').text();
            obj.days4 = $(this).children('td').eq(5).find('.days4').text();
            obj.days4Storage = $(this).children('td').eq(5).find('.days4').find('label').text();
            obj.days5 = $(this).children('td').eq(5).find('.days5').text();
            arr.push(obj);
            obj = {};
        });
        var bucketName = $('#curBucketName').html();
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var loading = loadingShow();
        $("#lifecycleConfig").css('z-index', '90');
        if (arr.length > 0) {
            bucketAttributeAction.putBucketLifecycle(bucketName,arr,function(err,data){
                if (err) {
                    logger.error(err);
                    if(err.code === "InvalidRequest" &&
                        ((err.message.indexOf("overlapping") > -1 && err.message.indexOf("prefixes") > -1) || (err.message.indexOf("same prefix") > -1))) {
                        $('.mui-model').showErrorMessage({
                            obsError: obsError("obs_task_addLifecycleFail_prefixOverlap_msg"),
                            ok: function () {
                                $("#lifecycleConfig").css('z-index', '1000');
                            }
                        });
                    } else if(err.code === "InvalidArgument" && err.message.indexOf("RuleId must be unique") > -1) {
                        $('.mui-model').showErrorMessage({
                            obsError: obsError("lifecycle_duplicate_ruleid"),
                            ok:function () {
                                $("#lifecycleConfig").css('z-index', '1000');
                            }
                        });
                    } else {
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code,err.message),
                            ok:function () {
                                $("#lifecycleConfig").css('z-index', '1000');
                            }
                        });
                    }
                    loading.close();
                    $("#lifecycleConfig").css('z-index', '90');
                    $("#subLifecycleConfig").blur();
                    showOverlay();
                } else {
                    $('.mui-model').showMessage({
                        type:'info',
                        message: languageJson.lifecycleConfigSuccesss,
                        ok: function () {
                            if(loading){
                                loading.close();
                            }
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            return false;
                        },
                        title: languageJson.info
                    });
                    $("#lifecycleConfig").css('z-index', '1000');
                    $("#lifecycleConfig").removeClass('shown');
                    $("#lifecycleTab tbody").find('tr').each(function () {
                        $(this).remove();
                    });
                    showOverlay();
                }
            },languageJson);
        } else {
            bucketAttributeAction.deleteBucketLifecycle(bucketName,function(err,data){
                if (err) {
                    if(errorConfig[err.code]){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code,err.message)
                        });
                    }
                    loading.close();
                    $("#lifecycleConfig").css('z-index', '1000');
                    showOverlay();
                } else {
                    $('.mui-model').showMessage({
                        type:'info',
                        message: languageJson.lifecycleConfigSuccesss,
                        ok: function () {
                            if(loading){
                                loading.close();
                            }
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            return false;
                        },
                        title: languageJson.info
                    });
                    $("#lifecycleConfig").css('z-index', '1000');
                    $("#lifecycleConfig").removeClass('shown');
                    showOverlay();
                }
            });
        }
        return false;
    });
    //生命周期管理界面取消按钮
    $("#cancelLifecycleConfig").on('click', function () {
        checked = false;
        checkedNum = -1;
        $("#lifecycleTab tbody").children('tr').each(function () {
            $(this).remove();
        })
        $("#subAddLifecycle").removeClass('mui-disabled');
        $("#subAddLifecycle").attr('title','');
        $("#lifecycleMessage").addClass('mui-hide');
        $("#lifecycleConfig").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    $('.btnConfigPolicy').on('click', function () {
        if(_.isEqual(UCDVersion,"HEC")){
            $("#policyConfigKnowMore").hide();
        }
        if(_.isEqual(UCDVersion,"CTC")){
            $("#policyConfigKnowMore").hide();
        }
        if(_.isEqual(UCDVersion,"CMCC")){
            $("#policyConfigKnowMore").hide();
        }
        if(isHasSelectBucket()){//判断当前桶是否被选中，如未被选中给出提示
            return false;
        }
        var bucket = $('#curBucketName').html();
        var loading = loadingShow();
        //判断桶是否存在，如不存在给出提示
        bucketAttributeAction.headBucket(bucket, function (err) {
            if(err){
                logger.error(err);
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message),
                        ok: function(){
                            $(".refreshCtx").click();
                            return false
                        }
                    });
                }
                loading.close();
            }else{ //桶存在时，打开桶策略配置页面
                $(".mui-page-full.shown").removeClass('shown');
                $("#policyConfig").addClass('shown');
                divDragFunc('policyConfigDrag','policyConfig');
                $(this).parent().parent().removeClass('mui-open');
                $("#policyData").val("");
                $("#policyConfig").css('z-index', '90');
                //获取桶策略的列表，若获取失败给出提示
                bucketAttributeAction.getBucketPolicy(bucket,function(err,data){
                    if (err) {
                        logger.error(err);
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code,err.message),
                                ok: function(){
                                    $(".refreshCtx").click();
                                    return false
                                }
                            });
                        }
                        loading.close();
                        $("#policyConfig").css('z-index', '1000');
                        showOverlay();
                    } else { //获取桶策略成功，将数据渲染进表格
                        loading.close();
                        $("#policyConfig").css('z-index', '1000');
                        showOverlay();
                        var policy=indexAction.formateJson(encoderForText(data.Policy));
                        $("#policyData").val(policy);
                    }
                });
                tabFocus("policyData");
                return false;
            }
        });
    });

    $("#subpolicyConfig").on('click', function () {
        var bucketName = $('#curBucketName').html();
        var policy = $("#policyData").val();
        if(!commonUtils.checkPolicy(policy)){
            $('.mui-model').showErrorMessage({
                message: errorConfig.MalformedPolicy,
                obsError: obsError("MalformedPolicy"),
                ok: function (){
                    $("#policyConfig").css('z-index', '1000');
                    return false;
                }
            });
            return false;
        }
        showOverlay();
        var loading = loadingShow();
        $("#policyConfig").css('z-index', '90');
        if (policy) {
            bucketAttributeAction.putBucketPolicy(bucketName, policy, function(err,data){
                if (err) {
                    global.logger.error("putBucketPolicy failed.", err)
                    if(errorConfig[err.code]){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code,err.message),
                            ok: function (){
                                $("#policyConfig").css('z-index', '1000');
                                return false;
                            }
                        });
                        $("#policyConfig").css('z-index', '90');
                        if(loading){
                            loading.close();
                        }
                        showOverlay();
                        return false;
                    }
                } else {
                    $('.mui-model').showMessage({
                        type:'info',
                        message: languageJson.policyConfigSuccess,
                        ok: function () {
                            $("#policyConfig").css('z-index', '1000');
                            if(loading){
                                loading.close();
                            }
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            return false;
                        },
                        title: languageJson.info
                    });
                    $("#policyReset").click();
                    $(".mui-page-full.shown").removeClass('shown');
                    $("#policyConfig").css('z-index', '90');
                    showOverlay();
                    return false;
                }
            });
        } else {
            bucketAttributeAction.delBucketPolicy(bucketName,function(err){
                if (err) {
                    if(errorConfig[err.code]){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code,err.message)
                        });
                    }
                    $("#policyConfig").css('z-index', '1000');
                    loading.close();
                    showOverlay();
                    return false;
                } else {
                    $('.mui-model').showMessage({
                        type:'info',
                        message: languageJson.policyConfigSuccess,
                        ok: function () {
                            if(loading){
                                loading.close();
                            }
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            return false;
                        },
                        title: languageJson.info
                    });
                    $("#policyReset").click();
                    $(".mui-page-full.shown").removeClass('shown');
                    $("#policyConfig").css('z-index', '1000');
                    showOverlay();
                    return false;
                }
            });
        }
        return false;
    });
    //添加生命周期界面保存按钮
    $("#subLifecycleRule").on('click', function () {
        var ruleName = $("#lifeRulesName").val();
        var rulePath = $("#lifeRulesPath").val();
        var ruleType = $("#lifecycleType").val();
        var delDateNumber = new Number($("#delDateNumber").val());
        var min = new Number($("#delDateNumber").attr('min'));
        var len = $("input[value='delDateNumber']:checked");
        //规则名判断
        if (!ruleName) {
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.inputRuleID,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        if (ruleName && ruleName.length > 255) {
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.obs_term_bucketLifecycle_rule4_valid,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        if (rulePath && rulePath.length > 1023) {
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.obs_term_bucketLifecycle_prefix_valid,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        //前缀非法字符校验
        if (rulePath) {
            var val = $.trim(rulePath);
            if(/^[/]/.test(val) || /\/[ ]*\//.test(val) || /[\\“”？"<>:|\?\*]/gi.test(val)){
                $('.mui-model').showMessage({
                    type: 'warning',
                    message: languageJson.obs_term_bucketLifecycle_prefixContainsSpecial_valid,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }
        }

        var days,days1,days2,days3,days4,days5 = "";
        var showDays = "";
        if($('#delRadio2').prop('checked')){
            days = $("#delDateNumber").val();
        };
        if($('#delRadio4').prop('checked')){
            days1 = $("#delDateNumber1").val();
        };
        if($('#delRadio6').prop('checked')){
            days2 = $("#delDateNumber2").val();
        };
        if($('#delRadio8').prop('checked')){
            days3 = $("#delDateNumber3").val();
        };
        if($('#delRadio10').prop('checked')){
            days4 = $("#delDateNumber4").val();
        };
        if($('#delRadio12').prop('checked')){
            days5 = $("#delDateNumber5").val();
        };
        if (len.length === 0) {
            var message = '';
            if(pkg.objectColdline){
                message = languageJson.obs_term_bucketLifecycle_noTransitionTime_msg;
            }else{
                message = languageJson.obs_term_bucketLifecycle_noTransitionTime_msg1;
            }
            $('.mui-model').showMessage({
                type: 'warning',
                message: message,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            message = '';
            return false;
        }
        var enabled = $("#lifeEnabled").is(':checked');
        var tbody = $("#lifecycleTab tbody");
        if(tbody.find('tr').length === 0){
            $("#lifecycleTab tbody").html('');
        }
        var trNum = $("#lifecycleReset").val();
        $("#lifecycleConfig").css('z-index', '1000');
        if(_.isEqual(UCDVersion,"HEC")){
            languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable = languageJson.obs_term_bucketLifecycle_transitioned2Infrequent_lable;
            languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable = languageJson.obs_term_bucketLifecycle_transitioned2Archive_lable;
        }
        if (trNum) {
            if (enabled) {
                $(tbody).find('tr').eq(trNum).find('td').eq(2).html('<span class="mui-ellipsis-prototype">' + languageJson.enabled + '</span><input type="text" value="true" hidden="hidden">');
            } else {
                $(tbody).find('tr').eq(trNum).find('td').eq(2).html('<span class="mui-ellipsis-prototype">' + languageJson.stop + '</span><input type="text" value="false" hidden="hidden">');
            }
            if (ruleType === '1' && rulePath) {
                $(tbody).find('tr').eq(trNum).find('td').eq(3).find('span').html(languageJson.prefix1 + ": " + encoderForHtml(rulePath.trim()));
            } else {
                rulePath = "";
                $(tbody).find('tr').eq(trNum).find('td').eq(3).find('span').html(languageJson.toAllBucket);
            }
            if(days && days1 &&days2){
                $(tbody).find('tr').eq(trNum).find('td').eq(4).html('<span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days1) + languageJson.day + '<label style="display: none">GLACIER</label></span><br><span class="days2">' + languageJson.dataOutTime +": "+ encoderForHtml(days2) + languageJson.day + '</span>');
            }else if(days && days1){
                $(tbody).find('tr').eq(trNum).find('td').eq(4).html('<span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days1)+ languageJson.day + '<label style="display: none">GLACIER</label></span>')
            }else if(days && days2){
                $(tbody).find('tr').eq(trNum).find('td').eq(4).html('<span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days2">' + languageJson.dataOutTime +": "+ encoderForHtml(days2) + languageJson.day + '</span>');
            }else if(days1 && days2){
                $(tbody).find('tr').eq(trNum).find('td').eq(4).html('<span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days1) + languageJson.day + '<label style="display: none">GLACIER</label></span><br><span class="days2">' + languageJson.dataOutTime +": "+ encoderForHtml(days2) + languageJson.day + '</span>');
            }else if(days){
                $(tbody).find('tr').eq(trNum).find('td').eq(4).html('<span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span>');
            }else if(days1){
                $(tbody).find('tr').eq(trNum).find('td').eq(4).html('<span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days1) + languageJson.day + '<label style="display: none">GLACIER</label></span>');
            }else if(days2){
                $(tbody).find('tr').eq(trNum).find('td').eq(4).html('<span class="days2">' + languageJson.dataOutTime +": "+ encoderForHtml(days2) + languageJson.day + '</span>');
            }else{
                $(tbody).find('tr').eq(trNum).find('td').eq(4).html('<span>--</span>');
            }
            if(days3 && days4 && days5){
                $(tbody).find('tr').eq(trNum).find('td').eq(5).html('<span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days3)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days4) + languageJson.day + '<label style="display: none">GLACIER</label></span><br><span class="days5">' + languageJson.dataOutTime +": "+ encoderForHtml(days5) + languageJson.day + '</span>');
            }else if(days3 && days4){
                $(tbody).find('tr').eq(trNum).find('td').eq(5).html('<span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days3)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days4) + languageJson.day + '<label style="display: none">GLACIER</label></span>');
            }else if(days3 && days5){
                $(tbody).find('tr').eq(trNum).find('td').eq(5).html('<span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days3)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days5">' + languageJson.dataOutTime +": "+ encoderForHtml(days5) + languageJson.day + '</span>');
            }else if(days4 && days5){
                $(tbody).find('tr').eq(trNum).find('td').eq(5).html('<span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days4) + languageJson.day + '<label style="display: none">GLACIER</label></span><br><span class="days5">' + languageJson.dataOutTime +": "+ encoderForHtml(days5) + languageJson.day + '</span>');
            }else if(days3){
                $(tbody).find('tr').eq(trNum).find('td').eq(5).html('<span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days3)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span>');
            }else if(days4){
                $(tbody).find('tr').eq(trNum).find('td').eq(5).html('<span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days4) + languageJson.day + '<label style="display: none">GLACIER</label></span>');
            }else if(days5){
                $(tbody).find('tr').eq(trNum).find('td').eq(5).html('<span class="days5">' + languageJson.dataOutTime +": "+ encoderForHtml(days5) + languageJson.day + '</span>');
            }else{
                $(tbody).find('tr').eq(trNum).find('td').eq(5).html('<span>--</span>');
            }
            $(tbody).find('tr').eq(trNum).find('td').eq(1).find('span').html(encoderForHtml(ruleName.trim()));
        } else {
            var tr = '<tr>';
            var trs = $("#lifecycleTab tbody").find('tr').length;
            var num = parseInt(trs) + 1;
            tr += '<td style="width: 55px;">' + num + '</td>';
            tr += '<td style="width: 100px;"><span class="mui-ellipsis-prototype">' + encoderForHtml(ruleName.trim()) + '</span></td>';
            if (enabled) {
                tr += '<td style="color: rgba(74, 74, 76, 1);width: 75px;"><span class="mui-ellipsis-prototype">' + languageJson.enabled + '</span><input type="text" value="true" hidden="hidden"></td>';
            } else {
                tr += '<td style="color: rgba(74, 74, 76, 1);width: 75px;">' + languageJson.stop + '<input type="text" value="false" hidden="hidden"></td>';
            }
            if (ruleType === '1' && rulePath) {
                tr += '<td style="width: 140px;"><span class="mui-ellipsis-prototype">' + languageJson.prefix1 + ": " + encoderForHtml(rulePath.trim()) + '</span></td>';
            } else {
                tr += '<td style="width: 140px;"><span class="mui-ellipsis-prototype">' + languageJson.toAllBucket + '</span></td>';
                rulePath = "";
            }
            if(days && days1 && days2){
                tr += '<td class="tdWidth"><span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days1) + languageJson.day + '<label style="display: none">GLACIER</label></span><br><span class="days2">' + languageJson.dataOutTime +": "+ encoderForHtml(days2) + languageJson.day + '</span></td>';
            }else if(days && days1){
                tr += '<td class="tdWidth"><span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days1)+ languageJson.day + '<label style="display: none">GLACIER</label></span></td>';
            }else if(days && days2){
                tr += '<td class="tdWidth"><span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days) + languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days2">' + languageJson.dataOutTime + ": "+ encoderForHtml(days2) + languageJson.day + '</span></td>';
            }else if(days1 && days2){
                tr += '<td class="tdWidth"><span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days1) + languageJson.day + '<label style="display: none">GLACIER</label></span><br><span class="days2">' + languageJson.dataOutTime + ": "+ encoderForHtml(days2) + languageJson.day + '</span></td>';
            }else if(days){
                tr += '<td class="tdWidth"><span class="days">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days) + languageJson.day + '<label style="display: none">STANDARD_IA</label></span></td>';
            }else if(days1){
                tr += '<td class="tdWidth"><span class="days1">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days1) + languageJson.day + '<label style="display: none">GLACIER</label></span></td>';
            }else if(days2){
                tr += '<td class="tdWidth"><span class="days2">' + languageJson.dataOutTime + ": "+ encoderForHtml(days2) + languageJson.day + '</span></td>';
            }else{
                tr += '<td class="tdWidth"><span>--</span></td>';
            }
            if(days3 && days4 && days5){
                tr += '<td class="tdWidth"><span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days3)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days4) + languageJson.day + '<label style="display: none">GLACIER</label></span><br><span class="days5">' + languageJson.dataOutTime +": "+ encoderForHtml(days5) + languageJson.day + '</span></td>';
            }else if(days3 && days4){
                tr += '<td class="tdWidth"><span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days3)+ languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days4)+ languageJson.day + '<label style="display: none">GLACIER</label></span></td>';
            }else if(days3 && days5){
                tr += '<td class="tdWidth"><span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days3) + languageJson.day + '<label style="display: none">STANDARD_IA</label></span><br><span class="days5">' + languageJson.dataOutTime + ": "+ encoderForHtml(days5) + languageJson.day + '</span></td>';
            }else if(days4 && days5){
                tr += '<td class="tdWidth"><span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days4) +  languageJson.day + '<label style="display: none">GLACIER</label></span><br><span class="days5">' + languageJson.dataOutTime + ": "+ encoderForHtml(days5) + languageJson.day + '</span></td>';
            }else if(days3){
                tr += '<td class="tdWidth"><span class="days3">' + languageJson.obs_term_bucketLifecycle_transitioned2Warm_lable +": "+ encoderForHtml(days3) + languageJson.day + '<label style="display: none">STANDARD_IA</label></span></td>';
            }else if(days4){
                tr += '<td class="tdWidth"><span class="days4">' + languageJson.obs_term_bucketLifecycle_transitioned2Cold_lable +": "+ encoderForHtml(days4) + languageJson.day + '<label style="display: none">GLACIER</label></span></td>';
            }else if(days5){
                tr += '<td class="tdWidth"><span class="days5">' + languageJson.dataOutTime + ": "+ encoderForHtml(days5) + languageJson.day + '</span></td>';
            }else{
                tr += '<td class="tdWidth"><span>--</span></td>';
            }
            tr += '<td style="width: 90px;"><span><i class="mui-icon-handel-edit" title="'+ languageJson.edit +'"></i><i class="mui-icon-handel-del" title="'+ languageJson.delete +'"></i></span></td>';
            tr += '</tr>';
            tbody.append(tr);
        }
        $("#trueCheck").attr("checked", true);
        $("#lifecycleReset").click();
        $("#lifecycleChild").removeClass('shown');
        $('#all').parent().next().find('label').eq(0).attr('title','');
        if (rulePath) {
            $("#subAddLifecycle").removeClass('mui-disabled');
            $("#subAddLifecycle").attr('title','');
            $("#lifecycleMessage").addClass('mui-hide');
        } else {
            $("#subAddLifecycle").addClass('mui-disabled');
            $("#subAddLifecycle").attr('title', languageJson.lifecycleMessage);
            $("#lifecycleMessage").removeClass('mui-hide');
        }

        var trs = $("#lifecycleTab tbody").find('tr').length;
        if (parseInt(trs) < 1) {
            $("#cancelAllLifecycle").addClass('mui-disabled');
        } else {
            $("#cancelAllLifecycle").removeClass('mui-disabled');
        }
        tabFocus("subLifecycleConfig");
        return false;
    });


    $("#lifeRulesName").on("blur", function () {
        if($("#lifecycleChild").hasClass('shown')){
            $("#subLifecycleRule").removeClass('mui-disabled');
            var ruleName = $("#lifeRulesName").val();
            ruleName = ruleName.trim();
            var trNum = $("#lifecycleReset").val();
            if ($("#lifecycleReset") && $("#lifecycleReset") === '1') {
                return false;
            } else {
                $("#lifecycleTab tbody").find('tr').each(function () {
                    if (parseInt($(this).index()) !== parseInt(trNum) && $(this).children('td').eq(5).text() === ruleName) {
                        $('.mui-model').showMessage({
                            type: 'warning',
                            message: languageJson.ruleIDRepeat,
                            ok: function () {
                                $('#lifeRulesName').focus();
                                $('#lifeRulesName').val("");
                            },
                            title: languageJson.warning
                        });
                    }
                });
            }
        }
    });

    $('#lifecycleTab tbody').delegate('.mui-icon-account-edit', 'click', function () {
        $("#lifecycleConfig").css('z-index', '90');
        var self = this;
        $(self).parent().parent().parent().children().removeClass("selected-tr-active");
        $(self).parent().parent().parent().children().find('.mui-ellipsis-prototype').removeClass("show-span-active");
        $(self).parent().parent().addClass("selected-tr-active");
        var href = $(self).attr('data-href');
        setTimeout(function () {
            $("#" + href).click();
        },50);
        return false;
    });

    $('#lifecycleTab tbody').delegate('.mui-icon-account-del', 'click', function () {
        var self = this;
        $('.mui-model').showMessage(
            {
                type: "warning",
                message: languageJson.sureDeleteLifecycleRule,
                isFocus: true,
                ok: function () {
                    $(self).parent().parent().remove();
                    var trs = $("#lifecycleTab tbody").find('tr').length;
                    if (trs === 0) {
                        $("#subAddLifecycle").removeClass('mui-disabled');
                        $("#subAddLifecycle").attr('title','');
                        $("#lifecycleMessage").addClass('mui-hide');
                    }

                    $("#deleteLifecycle,#editLifecycle").addClass("mui-disabled");

                    var num = 1;
                    $("#lifecycleTab tbody tr>td:first-child").each(function () {
                        $(this).html(num++);
                    });
                },
                cancel: function () {
                    return false;
                },
                title: languageJson.obs_term_bucketLifecycle_delLifecycleRule_wintitle
            }
        );
        tabFocus("subLifecycleConfig");
        return false;
    });

    $("#cancelLifecycleRule").on('click', function () {
        $("#lifecycleReset").click();
        $("#lifecycleReset").val('');
        $("#subLifecycleRule").removeClass('mui-disabled');
        $("#lifecycleChild").removeClass('shown');
        $("#lifecycleConfig").css('z-index', '1000');
        $('#all').parent().next().find('label').eq(0).attr('title','');
        tabFocus("subLifecycleConfig");
        return false;
    });

    $("#cancelpolicyConfig").on('click', function () {
        $("#policyReset").click();
        $(".mui-page-full.shown").removeClass('shown');
        $("#policyData").html("");
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    $("#showSample").on('click', function () {
        $("#policyHelp").addClass('shown');
        return false;
    });

    $('.btnConfigCors').on('click', function () {
        if(_.isEqual(UCDVersion,"HEC")){
            $("#corsConfigKnowMore").hide();
        }
        if(_.isEqual(UCDVersion,"CTC")){
            $("#corsConfigKnowMore").hide();
        }
        if(_.isEqual(UCDVersion,"CMCC")){
            $("#corsConfigKnowMore").hide();
        }
        if(isHasSelectBucket()){//判断当前桶是否被选中，如未被选中给出提
            return false;
        }
        var bucket = $('#curBucketName').html();
        var loading = loadingShow();
        $("#corsTab tbody").html('');
        //判断桶是否存在，如不存在给出提示
        bucketAttributeAction.headBucket(bucket, function (err) {
            if(err&&err.code === "NoSuchBucket"){
                logger.error("请求的桶不存在",err);
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message),
                        ok: function (){
                            $(".refreshCtx").click();
                            return false;
                        }
                    });
                }
                loading.close();
            }else{ //桶存在时，打开CORS配置页面
                $(".mui-page-full.shown").removeClass('shown');
                $("#corsConfig").addClass('shown');
                divDragFunc('corsConfigDrag','corsConfig');
                $(this).parent().parent().removeClass('mui-open');
                $("#editCors,#deleteCors").addClass('mui-disabled');
                $("#corsConfig").css('z-index', '90');
                //获取CORS配置页面的列表，若获取失败给出提示
                bucketAttributeAction.getBucketCors(bucket,function(err,data){
                    if (err) {
                        logger.error(err);
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code,err.message),
                                ok: function (){
                                    $(".refreshCtx").click();
                                    return false;
                                }
                            });
                        }
                        loading.close();
                        $("#corsConfig").css('z-index', '1000');
                        showOverlay();
                        if(err.code === 'NoSuchCORSConfiguration'){
                            $("#corsTab tbody").html('<div class="dialog-table-nodata"><span>' + languageJson.noData + '</span></div>');
                        }
                    }
                    else { //获取成功，将数据渲染进表格
                        loading.close();
                        $("#corsConfig").css('z-index', '1000');
                        showOverlay();
                        var tr = '';
                        var obj = {};
                        if (data.CORSRules.length > 0) {
                            $("#corsTab tbody").find('tr').each(function () {
                                $(this).remove();
                            });
                            $("#corsTab").css("width",$("#corsTabDiv").css("width"));
                            var tbody = $("#corsTab tbody");
                            for (var index in data.CORSRules) {
                                obj = data.CORSRules[index];
                                var num=parseInt(index)+1;
                                tr = '<tr><td style="width: 50px;">'+num+'</td><td><span class="mui-ellipsis-prototype">' + encoderForHtml(obj.AllowedOrigins.toString().replace(/,/g,"\n").replace(/\n(\n)*( )*(\n)*\n/g,"\n")) + '</span></td>';
                                tr += '<td style="width: 118px;"><span class="mui-ellipsis-prototype-new">' + encoderForHtml(firstWordUpperCase(obj.AllowedMethods.toString().replace(/,/g,", "))) + '</span></td>';
                                if(!obj.AllowedHeaders.toString().replace(/,/g,"\n")){
                                    tr += '<td style="width: 130px;"><span class="mui-ellipsis-prototype isEmpty">--</span></td>';
                                }else{
                                    tr += '<td style="width: 130px;"><span class="mui-ellipsis-prototype">' +encoderForHtml(obj.AllowedHeaders.toString().replace(/,/g,"\n").replace(/\n(\n)*( )*(\n)*\n/g,"\n")) + '</span></td>';
                                }
                                if(!obj.ExposeHeaders.toString().replace(/,/g,"\n")){
                                    tr += '<td style="width: 158px;"><span class="mui-ellipsis-prototype isEmpty">--</span></td>';
                                }else{
                                    tr += '<td style="width: 158px;"><span class="mui-ellipsis-prototype">' + encoderForHtml(obj.ExposeHeaders.toString().replace(/,/g,"\n").replace(/\n(\n)*( )*(\n)*\n/g,"\n")) + '</span></td>';
                                }
                                tr += '<td style="width: 134px;"><span class="mui-ellipsis-prototype" style="text-align: right;margin-right: 4px;">' + indexAction.formatNumber(encoderForHtml(obj.MaxAgeSeconds),language,true) + '</span></td>';
                                tr += '<td style="width: 90px;"><span><i class="mui-icon-handel-edit" title="'+ languageJson.edit +'"></i><i class="mui-icon-handel-del" title="'+ languageJson.delete +'"></i></span></td>';
                                tbody.append(tr);
                                tr = "";
                                obj = {};
                            }
                        }
                        var trs = $("#corsTab tbody").find('tr').length;
                        if(parseInt(trs)<1){
                            $("#cancelAllCors").addClass('mui-disabled');
                        }else{
                            $("#cancelAllCors").removeClass('mui-disabled');
                        }
                    }
                });
                tabFocus("subCorsConfig");
                return false;
            }
        })
    });

    $('#newCorsRule').on('click', function () {
        if($("#corsTab tbody tr").length >= 100){
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.CorsRuleNotMoreThan100,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        $("#editCors,#deleteCors").addClass('mui-disabled');
        $("#corsTab tbody tr").removeClass("selected-tr-active");
        $("#corsTab tbody tr").find('.mui-ellipsis-prototype').removeClass("show-span-active");
        $("#corsTab tbody tr").find('.mui-ellipsis-prototype-new').removeClass("show-span-active");
        $("#corsConfig").css('z-index', '90');
        $("#corsResouce").val('');
        $("#corsAllowedHeader").val('');
        $("#corsExposeHeader").val('');
        $("#saveTime").val('100');
        $("#corsConfigChild").addClass('shown');
        divDragFunc('corsConfigChildDrag','corsConfigChild');
        tabFocus("corsResouce");
        $("#corsConfigChildDrag .mui-page-full-title").html(languageJson.CorsRule);
        return false;
    });

    $('#corsTab tbody').delegate('.mui-icon-account-edit', 'click', function () {
        $("#corsConfig").css('z-index', '90');
        var self = this;
        $(self).parent().parent().parent().children().removeClass("selected-tr-active");
        $(self).parent().parent().parent().children().find('.mui-ellipsis-prototype').removeClass("show-span-active");
        $(self).parent().parent().addClass("selected-tr-active");
        var href = $(self).attr('data-href');
        setTimeout(function () {
            $("#" + href).click();
        },50);
    });

    $('#corsTab tbody').delegate('.mui-icon-account-del', 'click', function () {
        var self = this;
        $('.mui-model').showMessage(
            {
                type: "warning",
                message: languageJson.sureDeleteCorsRule,
                isFocus: true,
                ok: function () {
                    $(self).parent().parent().remove();
                    $("#deleteCors,#editCors").addClass("mui-disabled");
                    var num = 1;
                    $("#corsTab tbody tr>td:first-child").each(function () {
                        $(this).html(num++);
                    });
                    tabFocus("subCorsConfig");
                },
                cancel: function () {
                    return false;
                },
                title: languageJson.obs_term_bucketCors_delCorsRule_wintitle
            }
        );
    });

    $("#corsTab tbody").delegate('tr','click',function(){
        var self = this;
        $(self).parent().children().find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $(self).parent().children().find('.mui-ellipsis-prototype-new').removeClass('show-span-active');
        if(event.ctrlKey&&event.button===0)
        {
            $(self).toggleClass('selected-tr-active');
            checked = true;
            checkedNum = $(self).index();
            if($("#corsTab .selected-tr-active").length < 1) {
                //在CORS列表中.selected-tr-active的个数选中数量，只统计CORS列表中选中的tr元素
                $("#editCors,#deleteCors").addClass("mui-disabled");
            }
        }else if(event.shiftKey&&event.button===0) {//shift+鼠标左键事件
            $(self).parent().children().removeClass('selected-tr-active');
            if(checked)
            {
                var currCheck = $(self).index();
                var preCheck = checkedNum;
                if(currCheck<preCheck)
                {//大小排序
                    var temp = currCheck+preCheck;
                    currCheck = temp - currCheck;
                    preCheck = temp - preCheck;
                }
                var ul_arr = $("#corsTab tbody tr");
                for(var i = preCheck;i<currCheck+1;i++)
                {
                    $(ul_arr[i]).addClass('selected-tr-active');
                }
            }else{
                checked = true;
                checkedNum = $(self).index();
                $(self).toggleClass('selected-tr-active');
            }
        }else{
            $(self).parent().children().removeClass('selected-tr-active');
            checked = true;
            checkedNum = $(self).index();
            $(self).toggleClass('selected-tr-active');
        }
        $("#corsTab tbody .selected-tr-active .mui-ellipsis-prototype").addClass('show-span-active');
        $("#corsTab tbody .selected-tr-active .mui-ellipsis-prototype-new").addClass('show-span-active');
        var arr = $("#corsTab tbody .selected-tr-active");
        if(arr.length>1){
            disabledBtn($("#deleteCors"));
            $("#editCors").addClass("mui-disabled");
        }else if(arr.length===1){
            disabledBtn($("#deleteCors,#editCors"));
        }
    });
    $("#corsTab tbody").bind('click',function(){
        return false;
    });
    $("#corsTab tbody").bind('contextmenu',function(){
        return false;
    });
    // CORS列表div 点击左键取消选择
    $("#corsTabDiv").bind('click',function(){
        $("#corsTab tbody tr").removeClass('selected-tr-active');
        $("#corsTab tbody tr").find(".mui-ellipsis-prototype").removeClass('show-span-active');
        $("#editCors").addClass("mui-disabled");
        $("#deleteCors").addClass("mui-disabled");
        return false;
    });
    // CORS列表div 点击右键取消选择
    $("#corsTabDiv").bind('contextmenu',function(){
        $("#corsTab tbody tr").removeClass('selected-tr-active');
        $("#corsTab tbody tr").find(".mui-ellipsis-prototype").removeClass('show-span-active');
        $("#editCors").addClass("mui-disabled");
        $("#deleteCors").addClass("mui-disabled");
        return false;
    });

    /*
     �༭cors����
     */
    $("#editCors").on('click', function () {
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        $("#corsConfig").css('z-index', '90');
        $("#deleteCors,#editCors").addClass("mui-disabled");
        $("#corsConfigChildDrag .mui-page-full-title").html(languageJson.editCorsRule);
        var obj = $("#corsConfig .mui-table .selected-tr-active");
        $("#corsReset").val(obj.index());
        var corsResouce = $("#corsResouce").val($(obj).children('td').eq(1).find('span').text());
        var corsAllowedHeaderText = $(obj).children('td').eq(3).find('span').text();
        var corsExposeHeaderText = $(obj).children('td').eq(4).find('span').text();
        if($(obj).children('td').eq(3).find('span').hasClass('isEmpty')){
            corsAllowedHeaderText = '';
        }
        if($(obj).children('td').eq(4).find('span').hasClass('isEmpty')){
            corsExposeHeaderText = '';
        }
        var corsAllowedHeader = $("#corsAllowedHeader").val(corsAllowedHeaderText);
        var corsExposeHeader = $("#corsExposeHeader").val(corsExposeHeaderText);
        var saveTime = $("#saveTime").val($(obj).children('td').eq(5).text().replace(/[\,\.]/g,""));
        var method = $(obj).children('td').eq(2).find('span').text();
        if (method.indexOf("Get") > -1) {
            $("#getMethod").prop("checked", true);
        }
        if (method.indexOf("Post") > -1) {
            $("#postMethod").prop("checked", true);
        }
        if (method.indexOf("Put") > -1) {
            $("#putMethod").prop("checked", true);
        }
        if (method.indexOf("Delete") > -1) {
            $("#deleteMethod").prop("checked", true);
        }
        if (method.indexOf("Head") > -1) {
            $("#headMethod").prop("checked", true);
        }
        $("#corsReset").val(obj.index());
        $("#corsConfigChild").addClass('shown');
        divDragFunc('corsConfigChildDrag','corsConfigChild');
        $("#corsTab tbody .selected-tr-active").find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $("#corsTab tbody .selected-tr-active").find('.mui-ellipsis-prototype-new').removeClass('show-span-active');
        $("#corsTab tbody .selected-tr-active").removeClass("selected-tr-active");
        tabFocus("corsResouce");
        return false;
    });

    //单行编辑cors
    $("#corsTab tbody").delegate('.mui-icon-handel-edit','click',function () {
        $("#corsConfig").css('z-index', '90');
        $("#deleteCors,#editCors").addClass("mui-disabled");
        $("#corsConfigChildDrag .mui-page-full-title").html(languageJson.editCorsRule);
        var obj = $(this).parent().parent().parent();
        $("#corsReset").val(obj.index());
        var corsResouce = $("#corsResouce").val($(obj).children('td').eq(1).find('span').text());
        var corsAllowedHeaderText = $(obj).children('td').eq(3).find('span').text();
        var corsExposeHeaderText = $(obj).children('td').eq(4).find('span').text();
        if($(obj).children('td').eq(3).find('span').hasClass('isEmpty')){
            corsAllowedHeaderText = '';
        }
        if($(obj).children('td').eq(4).find('span').hasClass('isEmpty')){
            corsExposeHeaderText = '';
        }
        var corsAllowedHeader = $("#corsAllowedHeader").val(corsAllowedHeaderText);
        var corsExposeHeader = $("#corsExposeHeader").val(corsExposeHeaderText);
        var saveTime = $("#saveTime").val($(obj).children('td').eq(5).text().replace(/[\,\.]/g,""));
        var method = $(obj).children('td').eq(2).find('span').text();
        if (method.indexOf("Get") > -1) {
            $("#getMethod").prop("checked", true);
        }
        if (method.indexOf("Post") > -1) {
            $("#postMethod").prop("checked", true);
        }
        if (method.indexOf("Put") > -1) {
            $("#putMethod").prop("checked", true);
        }
        if (method.indexOf("Delete") > -1) {
            $("#deleteMethod").prop("checked", true);
        }
        if (method.indexOf("Head") > -1) {
            $("#headMethod").prop("checked", true);
        }
        $("#corsReset").val(obj.index());
        $("#corsConfigChild").addClass('shown');
        divDragFunc('corsConfigChildDrag','corsConfigChild');
        $("#corsTab tbody .selected-tr-active").find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $("#corsTab tbody .selected-tr-active").find('.mui-ellipsis-prototype-new').removeClass('show-span-active');
        $("#corsTab tbody .selected-tr-active").removeClass("selected-tr-active");
        tabFocus("corsResouce");
        return false;
    })
    $("#deleteCors").on('click', function () {
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        var length = $("#corsTab .selected-tr-active").length;
        if(length>1){
            var message = languageJson.obs_term_delMultiCorsRule_msg.format(length);
        }else{
            var message = languageJson.sureDeleteCorsRule;
        }
        var self = this;
        $('.mui-model').showMessage(
            {
                type: "warning",
                message: message,
                isFocus: true,
                ok: function () {
                    $("#editCors,#deleteCors").addClass("mui-disabled");
                    $("#corsConfig .mui-table .selected-tr-active").remove();
                    var trs = $("#corsTab tbody").find('tr').length;
                    if (parseInt(trs) < 1) {
                        $("#cancelAllCors").addClass('mui-disabled');
                        $("#corsTab tbody").html('<div class="dialog-table-nodata"><span>' + languageJson.noData + '</span></div>');
                    } else {
                        $("#cancelAllCors").removeClass('mui-disabled');
                    }
                    var num = 1;
                    $("#corsTab tbody tr>td:first-child").each(function () {
                        $(this).html(num++);
                    });
                },
                cancel: function () {
                    return false;
                },
                title: languageJson.obs_term_bucketCors_delCorsRule_wintitle
            }
        );
        tabFocus("subCorsConfig");
        return false;
    });

    //单行删除cors
    $("#corsTab tbody").delegate('.mui-icon-handel-del','click',function () {
        var self = this;
        $('.mui-model').showMessage(
            {
                type: "warning",
                message: languageJson.sureDeleteCorsRule,
                isFocus: true,
                ok: function () {
                    $("#editCors,#deleteCors").addClass("mui-disabled");
                    $(self).parent().parent().parent().remove();
                    var trs = $("#corsTab tbody").find('tr').length;
                    if (parseInt(trs) < 1) {
                        $("#cancelAllCors").addClass('mui-disabled');
                        $("#corsTab tbody").html('<div class="dialog-table-nodata"><span>' + languageJson.noData + '</span></div>');
                    } else {
                        $("#cancelAllCors").removeClass('mui-disabled');
                    }
                    var num = 1;
                    $("#corsTab tbody tr>td:first-child").each(function () {
                        $(this).html(num++);
                    });
                },
                cancel: function () {
                    return false;
                },
                title: languageJson.obs_term_bucketCors_delCorsRule_wintitle
            }
        );
        tabFocus("subCorsConfig");
        return false;
    })

    /*
     保存cors规则
     */
    $("#subCorsConfig").on('click', function () {
        checked = false;
        checkedNum = -1;
        var bucketName = $('#curBucketName').html();
        var arr = [];
        var obj = {};
        $("#corsTab tbody").find('tr').each(function () {
            var method = $(this).children('td').eq(2).text().toUpperCase();
            obj.AllowedMethods = method.split(", ");
            var originstext = $(this).children('td').eq(1).text();
            var origins = originstext.split("\n");
            var allowedOrigins = [];
            for (var o in origins) {
                if (origins[o].length > 0) {
                    allowedOrigins.push(origins[o]);
                }
            }

            var headertext = $(this).children('td').eq(3).text();
            if($(this).children('td').eq(3).find('span').hasClass('isEmpty')){
                headertext = '';
            }
            var headers = headertext.split("\n");
            var allowedHeaders = [];
            for (var o in headers) {
                if (headers[o].length > 0) {
                    allowedHeaders.push(headers[o]);
                }
            }

            var exposeHeadersText = $(this).children('td').eq(4).text();
            if($(this).children('td').eq(4).find('span').hasClass('isEmpty')){
                exposeHeadersText = '';
            }
            var exposes = exposeHeadersText.split("\n");
            var exposeHeaders = [];
            for (var o in exposes) {
                if (exposes[o].length > 0) {
                    exposeHeaders.push(exposes[o]);
                }
            }


            obj.AllowedOrigins = allowedOrigins;
            obj.AllowedHeaders = allowedHeaders;
            obj.MaxAgeSeconds = $(this).children('td').eq(5).find('span').text().replace(/[\,\.]/g,"");
            obj.ExposeHeaders = exposeHeaders;
            arr.push(obj);
            obj = {};
        });
        if (arr.length > 0) {
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            var loading = loadingShow();
            $("#corsConfig").css('z-index', '90');
            bucketAttributeAction.putBucketCors(bucketName,arr,function(err,data){
                if (err) {
                    if(errorConfig[err.code]){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code)
                        });
                    }
                    loading.close();
                    $("#corsConfig").css('z-index', '1000');
                    showOverlay();
                } else {
                    $('.mui-model').showMessage({
                        type:'info',
                        message: languageJson.corsConfigSuccess,
                        ok: function () {
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            return false;
                        },
                        title: languageJson.info
                    });
                    $("#corsTab tbody").children('tr').each(function () {
                        $(this).remove();
                    });
                    $(".mui-page-full.shown").removeClass('shown');
                    if(loading){
                        loading.close();
                    }
                    $("#corsConfig").css('z-index', '1000');
                    showOverlay();
                }
            });
        } else {
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            var loading = loadingShow();
            $("#corsConfig").css('z-index', '90');
            bucketAttributeAction.deleteBucketCors(bucketName,function(err,data){
                if (err) {
                    if(errorConfig[err.code]){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code)
                        });
                    }
                    loading.close();
                    $("#corsConfig").css('z-index', '1000');
                    showOverlay();
                } else {
                    $('.mui-model').showMessage({
                        type: 'info',
                        message: languageJson.corsConfigSuccess,
                        ok: function () {
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            return false;
                        },
                        title: languageJson.info
                    });
                    $(".mui-page-full.shown").removeClass('shown');
                    if(loading){
                        loading.close();
                    }
                    $("#corsConfig").css('z-index', '1000');
                    showOverlay();
                }
            });
        }
    });

    $("#cancelCorsConfig").on('click', function () {
        checked = false;
        checkedNum = -1;
        $("#corsTab tbody").children('tr').each(function () {
            $(this).remove();
        });
        $("#editCors,#deleteCors").addClass("mui-disabled");
        $(".mui-page-full.shown").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    $("#subCorsRule").on('click', function () {
        var corsResouce = $("#corsResouce").val().replace(/\n(\n)*( )*(\n)*\n/g,"\n");
        var corsAllowedHeader = $("#corsAllowedHeader").val().replace(/\n(\n)*( )*(\n)*\n/g,"\n");
        var corsExposeHeader = $("#corsExposeHeader").val().replace(/\n(\n)*( )*(\n)*\n/g,"\n");
        var saveTime = $("#saveTime").val();
        var getMethod = $("#getMethod").is(':checked') ? "Get" : "";
        var postMethod = $("#postMethod").is(':checked') ? "Post" : "";
        var putMethod = $("#putMethod").is(':checked') ? "Put" : "";
        var deleteMethod = $("#deleteMethod").is(':checked') ? "Delete" : "";
        var headerMethod = $("#headMethod").is(':checked') ? "Head" : "";
        var methods = "";
        if (getMethod.length > 0) {
            methods += getMethod + ", ";
        }
        if (postMethod.length > 0) {
            methods += postMethod + ", ";
        }
        if (putMethod.length > 0) {
            methods += putMethod + ", ";
        }
        if (deleteMethod.length > 0) {
            methods += deleteMethod + ", ";
        }
        if (headerMethod.length > 0) {
            methods += headerMethod + ", ";
        }
        //允许来源不能为空
        if (corsResouce == "") {
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.allowNameNotNull,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        if (corsResouce.length > 1024) {
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.allowName_length_valid,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        if (methods.trim().length === 0) {
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.methodNotNull,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        } else {
            methods = methods.substring(0, methods.length - 2)
        }
        if (corsAllowedHeader.length > 1024) {
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.allowedHeader_length_valid,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        if (corsExposeHeader.length > 1024) {
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.exposeHeader_length_valid,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        if (saveTime == "") {
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.cacheTimeNotNull,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }

        if(bucketAttributeAction.checkAllowedOrigin(corsResouce)){
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.allowedAriginError,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        var allowedHeaderReg = new RegExp("([【】，。！？“”《》&……（）：<:]|[\\s]|[\\u4E00-\\u9FA5]|[\\uFE30-\\uFFA0])+");
        if(bucketAttributeAction.checkAllowedAndExposeHeader(corsAllowedHeader,allowedHeaderReg)){
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.allowedHeaderError,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        var exposeHeaderReg = new RegExp("([【】，。！？“”*《》&……（）：<:]|[\\s*]|[\\u4E00-\\u9FA5]|[\\uFE30-\\uFFA0])+");
        if(bucketAttributeAction.checkAllowedAndExposeHeader(corsExposeHeader,exposeHeaderReg)){
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.exposeHeaderError,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        var tbody = $("#corsTab tbody");
        if(tbody.find('tr').length == 0){
            $("#corsTab tbody").html('');
        }
        var trNum = $("#corsReset").val();
        $("#corsReset").val('');
        $("#corsConfig").css('z-index', '1000');
        if (trNum) {
            $(tbody).find('tr').eq(trNum).find('td').eq(1).find('span').html(encoderForHtml(corsResouce));
            $(tbody).find('tr').eq(trNum).find('td').eq(2).find('span').html(encoderForHtml(methods));
            if(!corsAllowedHeader){
                corsAllowedHeader = '--';
                $(tbody).find('tr').eq(trNum).find('td').eq(3).find('span').addClass('isEmpty');
            }else{
                $(tbody).find('tr').eq(trNum).find('td').eq(3).find('span').removeClass('isEmpty');
            }
            $(tbody).find('tr').eq(trNum).find('td').eq(3).find('span').html(encoderForHtml(corsAllowedHeader));
            if(!corsExposeHeader){
                corsExposeHeader = '--';
                $(tbody).find('tr').eq(trNum).find('td').eq(4).find('span').addClass('isEmpty');
            }else{
                $(tbody).find('tr').eq(trNum).find('td').eq(4).find('span').removeClass('isEmpty');
            }
            $(tbody).find('tr').eq(trNum).find('td').eq(4).find('span').html(encoderForHtml(corsExposeHeader));
            $(tbody).find('tr').eq(trNum).find('td').eq(5).find('span').html(indexAction.formatNumber(encoderForHtml(saveTime),language,true));
        } else {
            var tr = '';
            var trs = $("#corsTab tbody").find('tr').length;
            tr = '<tr><td style="width: 50px;">'+0+'</td><td><span class="mui-ellipsis-prototype">' + encoderForHtml(corsResouce) + '</span></td>';
            tr += '<td style="width: 118px;"><span class="mui-ellipsis-prototype-new">' + encoderForHtml(methods) + '</span></td>';
            if(!corsAllowedHeader){
                corsAllowedHeader = '--';
                tr += '<td style="width: 130px;"><span class="mui-ellipsis-prototype isEmpty">' + encoderForHtml(corsAllowedHeader) + '</span></td>';
            }else{
                tr += '<td style="width: 130px;"><span class="mui-ellipsis-prototype">' + encoderForHtml(corsAllowedHeader) + '</span></td>';
            }
            if(!corsExposeHeader){
                corsExposeHeader = '--';
                tr += '<td style="width: 158px;"><span class="mui-ellipsis-prototype isEmpty">' + encoderForHtml(corsExposeHeader) + '</span></td>';
            }else{
                tr += '<td style="width: 158px;"><span class="mui-ellipsis-prototype">' + encoderForHtml(corsExposeHeader) + '</span></td>';
            }
            tr += '<td style="width: 134px;"><span class="mui-ellipsis-prototype" style="text-align: right;margin-right: 4px;">' + indexAction.formatNumber(encoderForHtml(saveTime),language,true) + '</span></td>';
            tr += '<td style="width: 90px;"><span><i class="mui-icon-handel-edit" title="'+ languageJson.edit +'"></i><i class="mui-icon-handel-del" title="'+ languageJson.delete +'"></i></span></td>';
            tbody.prepend(tr);
            $("#corsTab tbody").find('tr').each(function () {
                var num = parseInt($(this).find('td').eq(0).text());
                num++;
                $(this).find('td').eq(0).text(num);
            });
        }
        $("#corsConfigChild input:checkbox").each(function () {
            this.checked = false;
        });
        $("#corsConfigChild").removeClass('shown');
        tabFocus("subCorsConfig");
        return false;
    });

    $("#cancelCorsRule").on('click', function () {
        $("#corsReset").val('');
        $("#corsConfigChild").removeClass('shown');
        $("#corsConfig").css('z-index', '1000');
        $("#corsConfigChild input:checkbox").each(function () {
            this.checked = false;
        });
        tabFocus("subCorsConfig");
        return false;
    });

    $('.btnBucketLogging').on('click', function () {
        if(_.isEqual(UCDVersion,"HEC")){
            $("#bucketLoggingKnowMore").hide();
        }
        if(_.isEqual(UCDVersion,"CTC")){
            $("#bucketLoggingKnowMore").hide();
        }
        if(_.isEqual(UCDVersion,"CMCC")){
            $("#bucketLoggingKnowMore").hide();
        }
        if(isHasSelectBucket()){//判断当前桶是否存在，如不存在给出提示
            return false;
        }
        //初始化日志界面
        $("#loggingTab").addClass("mui-hide");
        $(".Enabletips").addClass("mui-hide");
        $("#LoggingDisabled").click();
        var bucket = $('#curBucketName').html();
        var loading = loadingShow();
        bucketAttributeAction.headBucket(bucket,function (err,data) {
            if(err&&err.code === "NoSuchBucket"){
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message),
                        ok:  function(){
                            $(".refreshCtx").click();
                            return false
                        }
                    });
                    loading.close();
                }
            }else{
                $(this).parent().parent().removeClass('mui-open');
                $("#loggingSelector").val("");
                $("#loggingPath").val("");
                $("#bucketLogging").css('z-index', '90');
                getBucketList(function(err){
                    if(err){
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code,err.message)
                            });
                        }
                        loading.close();
                        $("#bucketLogging").css('z-index', '1000');
                        showOverlay();
                    }else{
                        bucketAttributeAction.getBucketLogging(bucket,function (err, data) {
                            if (err) {
                                logger.error(err);
                                if(errorConfig[err.code]){
                                    $('.mui-model').showErrorMessage({
                                        message: errorConfig[err.code],
                                        obsError: obsError(err.code,err.message),
                                        ok:function () {
                                            if ($("#mui-overlay").size() > 0) {
                                                mui.overlay('off');
                                            }
                                        }
                                    });
                                }
                                loading.close();
                                $("#bucketLogging").css('z-index', '1000');
                                showOverlay();
                            }
                            else {
                                $("#bucketLogging").css('z-index', '1000');
                                if ($(".mui-page-full.shown").size() > 0) {
                                    showOverlay();
                                }
                                if (data.LoggingEnabled) {
                                    var bName = data.LoggingEnabled.TargetBucket;
                                    bucketAttributeAction.headBucket(bName, function (err, results) {
                                        if (err) {
                                            $("#loggingPath").val(bucket+"-log/");
                                            $("#loggingPath").attr('disabled',true);
                                            $("#loggingSelector").selectmenu( "disable" );
                                            $("#LoggingDisabled").click();
                                            //若目标存储桶不存在给出提示
                                            $('.mui-model').showMessage({
                                                type: "warning",
                                                message: languageJson.obs_term_bucketLogging_targetBucketDelErr_msg.format(bName),
                                                ok: function () {//点击确认后显示日志配置界面
                                                    $(".mui-page-full.shown").removeClass('shown');
                                                    $("#bucketLogging").addClass('shown');
                                                    divDragFunc('bucketLoggingDrag','bucketLogging');
                                                    loading.close();
                                                    return false;
                                                },
                                                title: languageJson.warning
                                            });
                                            params = {Bucket: bName,BucketLoggingStatus:{}};
                                            s3.putBucketLogging(params, function (err) {
                                                if(err){
                                                    global.logger.error('putBucketLogging error:',err);
                                                }else{
                                                    global.logger.info("delete logging success");
                                                }
                                            });
                                        } else { //若日志桶存在，则取消禁用。
                                            $("#loggingPath").removeAttr('disabled');
                                            $("#loggingSelector").selectmenu( "enable" );
                                            $("#loggingSelector").val(encoderForHtml(data.LoggingEnabled.TargetBucket));
                                            if($("#loggingSelector").val()){
                                                $("#loggingPath").val(encoderForHtml(data.LoggingEnabled.TargetPrefix));
                                                $("#LoggingEnabled").click();
                                            }
                                            $(".mui-page-full.shown").removeClass('shown');
                                            $("#bucketLogging").addClass('shown');
                                            divDragFunc('bucketLoggingDrag','bucketLogging');
                                        }
                                        $("#loggingSelector").selectmenu( "refresh" );
                                        loading.close();
                                        showOverlay();

                                    });
                                } else {
                                    $("#LoggingDisabled").click();
                                    $("#loggingSelector").val(encoderForHtml(bucket));
                                    $("#loggingPath").val(bucket+"-log/");
                                    $("#loggingPath").attr('disabled',true);
                                    $("#loggingSelector").selectmenu( "disable" );
                                    $(".mui-page-full.shown").removeClass('shown');
                                    $("#bucketLogging").addClass('shown');
                                    divDragFunc('bucketLoggingDrag','bucketLogging');
                                    loading.close();
                                    showOverlay();
                                }
                                $("#loggingSelector").selectmenu( "refresh" );
                            }
                        });
                    }
                });
                return false;
            }
        })

    });
    //是否开启日志
    $("#LoggingEnabled").on('click',function(){
        $("#bucketLogging").css({"width":"910px","left":"calc((100% - 910px)/2)","top":"25%"});
        $("#loggingTab").removeClass("mui-hide");
        $(".Enabletips").removeClass("mui-hide");
        $(".Disabletips").addClass("mui-hide");
    });
    $("#LoggingDisabled").on('click',function(){
        $("#bucketLogging").css({"width":"600px","left":"calc((100% - 600px)/2)","top":"25%"});
        $("#loggingTab").addClass("mui-hide");
        $(".Enabletips").addClass("mui-hide");
        $(".Disabletips").removeClass("mui-hide");
    });
    //刷新日志管理目标桶
    $('#log-refresh-div').on('click',function(){
        $("#bucketLogging").css('z-index', '90');
        var bucket = $("#loggingSelector").val();
        getBucketList(function(err){
            if(err){
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code)
                    });
                }
                $("#bucketLogging").css('z-index', '1000');
            }else{ // 刷新目标桶下拉列表
                $("#bucketLogging").css('z-index', '1000');
                $("#loggingSelector").val(encoderForHtml(bucket));
                $("#loggingSelector").selectmenu( "refresh" );
            }
        });
        return false;
    });
    //取消错误蒙层增加日志管理窗口蒙层
    function LoggingOverlay(){
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var loading = loadingShow();
        loading.close();
        $("#bucketLogging").css('z-index', '1000');
        showOverlay();
    }
    $("#subLoggingBth").on('click', function () {
        var bucketName = $('#curBucketName').html();
        if ($("#LoggingEnabled").is(':checked')) {
            var logName = $("#loggingSelector").val();
            var logPath = $("#loggingPath").val();
            bucketAttributeAction.replaceSpecialCharacterLog(logPath,languageJson, function (errMsg,str) {
                if (errMsg) {
                    $('.mui-model').showMessage({
                        type:'warning',
                        message: errMsg,
                        ok: function () {
                            $("#loggingPath").val(str);
                        },
                        title: languageJson.warning
                    });
                    return false;
                } else {
                    var logPathVal = $.trim(logPath);
                    if(/[\\"<>:|\?\*]/gi.test(logPathVal)) { //特殊字符校验
                        $('.mui-model').showMessage({
                            type: 'warning',
                            message: languageJson.obs_term_bucketLogging_rule2_valid,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.warning
                        });
                        return false;
                    }
                    if (logPath.indexOf('//') !== -1 || logPath.substring(0, 1) === '/') {//双斜杠校验
                        $('.mui-model').showMessage({
                            type: 'warning',
                            message: languageJson.obs_term_bucketLogging_rule3_valid,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.warning
                        });
                        return false;
                    }
                    if(logPathVal) {//句号校验
                        var folders = logPathVal.split("/");
                        var folder = "";
                        for (var i = 0; i < folders.length; i++) {
                            folder = folders[i];
                            var start = folder.substring(0, 1);
                            var end = folder.substring(folder.length - 1, folder.length);
                            if (start === "." || end === ".") {
                                $('.mui-model').showMessage({
                                    type: 'warning',
                                    message: languageJson.obs_term_bucketLogging_rule4_valid,
                                    ok: function () {
                                        return false;
                                    },
                                    title: languageJson.warning
                                });
                                return false;
                            }
                        }
                    }
                    if (logPathVal && logPathVal.length) {//长度校验
                        var length = Buffer.byteLength(logPathVal);
                        if (length > 254) {
                            $('.mui-model').showMessage({
                                type: 'warning',
                                message: languageJson.obs_term_bucketLogging_rule5_valid,
                                ok: function () {
                                    return false;
                                },
                                title: languageJson.warning
                            });
                            return false;
                        }
                    }
                    if (!logName) {
                        $('.mui-model').showMessage({
                            type: 'warning',
                            message: languageJson.bucketNameIsNotNull,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.warning
                        });
                        return false;
                    }
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    var loading = loadingShow();
                    $("#bucketLogging").css('z-index', '90');
                    //获取acl并设置日志投递用户组
                    bucketAttributeAction.getBucketAcl(logName,function(err,data){
                        if(err){
                            logger.error("getBucketAcl err:",err);
                            if(errorConfig[err.code]){
                                $('.mui-model').showErrorMessage({
                                    message: errorConfig[err.code],
                                    obsError: obsError(err.code,err.message)
                                });
                            }
                        }else{
                            var customGrants = [];//配置ACL的权限
                            var logArr = [];//日志投递用户组权限
                            var isFullcontrol = false;//是否是完全控制
                            for (var index in data.Grants) {
                                var obj = data.Grants[index];
                                if (obj.Grantee.URI === "http://acs.amazonaws.com/groups/s3/LogDelivery") {
                                    if(obj.Permission === "FULL_CONTROL"){
                                        customGrants.push(obj);
                                        isFullcontrol =true;
                                    }else{
                                        logArr.push(obj);
                                    }
                                } else if (obj.Grantee.URI === "http://acs.amazonaws.com/groups/global/AllUsers") {
                                    customGrants.push(obj);
                                } else if (obj.Grantee.URI === "http://acs.amazonaws.com/groups/global/AuthenticatedUsers") {
                                    customGrants.push(obj);
                                }else if(obj.Grantee.ID && obj.Grantee.ID.toString() === ownerId) {
                                    customGrants.push(obj);
                                } else {
                                    customGrants.push(obj);
                                }
                            }
                            //如果不是完全控制
                            if(!isFullcontrol){
                                var WRITE = {
                                "Grantee":
                                    {
                                    "URI": "http://acs.amazonaws.com/groups/s3/LogDelivery",
                                    "Type": "Group"
                                    },
                                    "Permission": "WRITE"
                                };
                                customGrants.push(WRITE);//添加写权限
                                var READ_ACP = {
                                    "Grantee":
                                        {
                                            "URI": "http://acs.amazonaws.com/groups/s3/LogDelivery",
                                            "Type": "Group"
                                        },
                                    "Permission": "READ_ACP"
                                };
                                customGrants.push(READ_ACP);//添加ACL编辑权限
                                for (var index in logArr) {
                                    if(logArr[index].Permission === "WRITE_ACP"){
                                        customGrants.push(logArr[index]);
                                    }else if(logArr[index].Permission === "READ"){
                                        customGrants.push(logArr[index]);
                                    }
                                }
                            }
                            var ownerID = data.Owner.ID;
                            var ownerName = data.Owner.DisplayName;
                            var setLogPermission = {
                                Owner: {
                                    ID: ownerID,
                                    DisplayName: ownerName
                                },
                                Grants:customGrants
                            };
                            bucketAttributeAction.putBucketAcl(function (err, data) {
                                if (err) {
                                    logger.error("putBucketAcl err",err);
                                    if(errorConfig[err.code]){
                                        $('.mui-model').showErrorMessage({
                                            message: errorConfig[err.code],
                                            obsError: obsError(err.code,err.message)
                                        });
                                    }
                                }else{
                                    bucketAttributeAction.putBucketLogging(bucketName,logName,logPath,function(err,data){
                                        if (err) {
                                            logger.error(err);
                                            if(err.code==='InvalidTargetBucketForLogging'&&$('#lsBuckets .bucket-item.current').hasClass('ext')){
                                                err.code='InvalidTargetBucketForLogging1';
                                                if(errorConfig[err.code]){
                                                    showOverlay();
                                                    $('.mui-model').showErrorMessage({
                                                        message: errorConfig[err.code],
                                                        obsError: obsError(err.code),
                                                        ok:LoggingOverlay()

                                                    });
                                                }else if(err.statusCode===501){
                                                    showOverlay();
                                                    $('.mui-model').showErrorMessage({
                                                        message: errorConfig['501'],
                                                        obsError: obsError('501'),
                                                        ok:LoggingOverlay()
                                                    });
                                                }
                                            }else  if(err.code==='InvalidTargetBucketForLogging'){
                                                if(err.message.indexOf('region')>0){
                                                    err.code='InvalidTargetBucketForLoggingRegion';
                                                }
                                                if(errorConfig[err.code]){
                                                    showOverlay();
                                                    global.logger.info(obsError, err.code, obsError(err.code))
                                                    $('.mui-model').showErrorMessage({
                                                        message: errorConfig[err.code],
                                                        obsError: obsError(err.code),
                                                        ok:LoggingOverlay()
                                                    });
                                                }
                                            }else{
                                                if(errorConfig[err.code]){
                                                    showOverlay();
                                                    $('.mui-model').showErrorMessage({
                                                        message: errorConfig[err.code],
                                                        obsError: obsError(err.code),
                                                        ok:LoggingOverlay()
                                                    });
                                                }else if(err.statusCode===501){
                                                    showOverlay();
                                                    $('.mui-model').showErrorMessage({
                                                        message: errorConfig['501'],
                                                        obsError: obsError('501'),
                                                        ok:LoggingOverlay()
                                                    });
                                                }
                                                loading.close();
                                                $("#bucketLogging").css('z-index', '1000');
                                                showOverlay();
                                            }
                                        } else {
                                            $('.mui-model').showMessage({
                                                type:'info',
                                                message: languageJson.loggingConfigSuccess,
                                                ok: function () {
                                                    if ($("#mui-overlay").size() > 0) {
                                                        mui.overlay('off');
                                                    }
                                                    return false;
                                                },
                                                title: languageJson.info
                                            });
                                            $("#loggingPath").val('');
                                            $(".mui-page-full.shown").removeClass('shown');
                                            if(loading){
                                                loading.close();
                                            }
                                            $("#bucketLogging").css('z-index', '1000');
                                            showOverlay();
                                        }
                                    },false);
                                }
                            },logName,"",setLogPermission);
                        }
                    });
                }
            });
        } else {
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            var loading = loadingShow();
            $("#bucketLogging").css('z-index', '90');
            bucketAttributeAction.putBucketLogging(bucketName,logName,logPath,function(err,data){
                if (err) {
                    logger.error(err);
                    if(err.code==='InvalidTargetBucketForLogging'&&$('#lsBuckets .bucket-item.current').hasClass('ext')){
                        err.code='InvalidTargetBucketForLogging1';
                    }
                    if(errorConfig[err.code]){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code)
                        });
                    }else if(err.statusCode===501){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig['501'],
                            obsError: obsError('501')
                        });
                    }
                    loading.close();
                    $("#bucketLogging").css('z-index', '1000');
                    showOverlay();
                } else {
                    $('.mui-model').showMessage({
                        type:'info',
                        message: languageJson.obs_term_bucketLog_closeLogManage_msg,
                        ok: function () {
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            return false;
                        },
                        title: languageJson.info
                    });
                    $("#loggingPath").val('');
                    $(".mui-page-full.shown").removeClass('shown');
                    if(loading){
                        loading.close();
                    }
                    $("#bucketLogging").css('z-index', '1000');
                    showOverlay();
                }
            },true);
        }
        return false;
    });

    $("#LoggingEnabled").on('change', function () {
        if($(this).is(':checked')){
            $("#loggingPath").removeAttr('disabled');
            $("#loggingSelector").selectmenu( "enable" );
        }else{
            $("#loggingPath").attr('disabled',true);
            $("#loggingSelector").selectmenu( "disable" );
        }
    });

    $("#cancelLogging").on('click', function () {
        $(".mui-page-full.shown").removeClass('shown');
        $("#loggingPath").val('');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    /**
     * 禁止时间控件键盘输入事件
     */
    $("#delDataTime").on('keydown', function () {
        return false;
    });

    function getBucketList(callback) {
        s3.listBuckets(function (err, data) {
            if (err) {
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code)
                    });
                }
                if (callback) {
                    callback(err);
                }
            } else {
                if(!pkg.objectColdline){
                    var buckets = [];
                    async.eachLimit(data.Buckets, 10, function(item, callback) {
                        bucketAttributeAction.headBucket(item.Name, function (err, data) {
                            if(data && data.StorageType === 'Standard'){
                                buckets.push(item);
                            }
                            callback();
                        })
                    }, function(err) {
                        if (err) {
                            if(errorConfig[err.code]){
                                $('.mui-model').showErrorMessage({
                                    message: errorConfig[err.code],
                                    obsError: obsError(err.code)
                                });
                            }
                            if (callback) {
                                callback(err);
                            }
                        }else{
                            getBucketListHandle(buckets,callback)
                        }
                    });
                }else{
                    getBucketListHandle(data.Buckets,callback)
                }
            }
        });
    }

    function getBucketListHandle(data,callback){
        var selectBody = $("#loggingSelector");
        selectBody.html('');
        var str = "";
        for (var index in data) {
            var bucket = data[index];
            str += '<option value="' + encoderForHtml(bucket.Name) + '">' + encoderForHtml(bucket.Name) + '</option>';
        }
        selectBody.append(str);
        if (callback) {
            callback();
        }
    }

    /*
     ����Ͱ��Logging
     */
    function putBucketLogging(bucketName, log, path,callback) {
        getBucketAclLog(bucketName, function (err, data) {
            if (err) {
                logger.error(err);
                if(callback){
                    callback(err);
                }
            } else {
                var params;
                if(log){
                    params = {
                        Bucket: bucketName,
                        BucketLoggingStatus: {
                            LoggingEnabled: {
                                TargetBucket: log,
                                TargetPrefix: path,
                                TargetGrants: [{
                                    Grantee: {
                                        Type: "CanonicalUser",
                                        ID: data.Owner.ID,
                                        DisplayName: data.Owner.DisplayName
                                    },
                                    Permission: "FULL_CONTROL"
                                }]
                            }
                        }
                    };
                }else{
                    params = {Bucket: bucketName,BucketLoggingStatus:{}}
                }
                s3.putBucketLogging(params, function (err) {
                    if (err) {
                        logger.error(err);
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code)
                            });
                        }
                        if(callback){
                            callback(err);
                        }
                    } else {
                        $('.mui-model').showMessage({
                            type:'info',
                            message: languageJson.loggingConfigSuccess,
                            ok: function () {
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                                return false;
                            },
                            title: languageJson.info
                        });
                        $("#loggingPath").val('');
                        $(".mui-page-full.shown").removeClass('shown');
                        showOverlay();
                        if(callback){
                            callback();
                        }
                    }
                });
            }
        });
    }

    /*
     ��ȡͰ��Acl
     */
    function getBucketAclLog(bucketName, callback) {

        var params = {
            Bucket: bucketName
        };
        s3.getBucketAcl(params, function (err, data) {
            if (callback) {
                callback(err, data);
            }
        });
    };

    function tabFocus(id){
        $("#"+id).focus();
    }

    /*
     取当前日期的加N天的日期
     */
    function GetDateStr(AddDayCount)
    {
        var dd = new Date();
        dd.setDate(dd.getDate()+AddDayCount);//获取AddDayCount天后的日期
        var y = dd.getFullYear();
        var m = (dd.getMonth()+1)<10?"0"+(dd.getMonth()+1):(dd.getMonth()+1);//获取当前月份的日期，不足10补0
        var d = dd.getDate()<10?"0"+dd.getDate():dd.getDate(); //获取当前几号，不足10补0
        return y+"-"+m+"-"+d;
    }
});


function isHasSelectBucket(){
    var curBucket = $('#curBucketName').html();
    if(!curBucket){
        var htmlStr = languageJson.selectBucket;
        $('.mui-model').showMessage({
            type: "warning",
            message: htmlStr,
            ok: function () {
                return false;
            },
            title: languageJson.warning
        });
        return true;
    }else{
        return false;
    }
}