var obsError = require('./js/common/ObsError.js')
var i18n_learnMore = require('./js/i18n_learnMore.js')
var commonUtils = require('./js/common/CommonUtils.js');
var async = require('./node_modules/async');
var TaskControlAction = require('./js/sdk/taskControlAction.js');
var taskControlAction = new TaskControlAction();
//左侧通列表
function listBucketUI(err, data, loading, currentName) {
    var arr = [];
    if(data){
        for (var i in ExtBucket) {
            if (ExtBucket[i].id === currentUserId) {
                for (var index in data.Buckets) {
                    var bucket = data.Buckets[index];
                    // 如果桶列表里存在与外部桶名相同的桶，则去重外部桶
                    if (bucket.Name === ExtBucket[i].bucketArr[0]) {
                        ExtBucket.splice(i,1);
                        break;
                    }
                }
            }
        }
    }
    listBucketBodyUI(err, data);
    $("#downloadFileName").val("");
    pageContext = {};//重置分页对象
    pageContext.nowPage = 1;
    $("#isSearch").val("");
    if(!$("#prefixSearch").val()){//没有前缀搜索时刷新才隐藏图标
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#clearBucketSearchInput").addClass("mui-hide");
    }
    $("#path").html('');
    $('#curBucketName').html("");
    $('#lsBuckets').html('');
    $('#objLists tr').each(function (i, item) {
        $(item).remove();
    });
    if (err) {
        $('.btnUserInfo').removeClass('userLogin');
        allButtonChange('1');
        logger.error("Error:", err);
        if (err.code == "BadRequest"){
            err.code = "TooManyWrongSignature"
        }
        if(err.code === "Unauthorized"){
            $(".mui-page-full.shown").removeClass('shown');
            $("#auth").removeClass('mui-hide');
            $("#auth").addClass('shown');
            divDragFunc('authDrag','auth');
        }
        if (errorConfig[err.code]&& err.code != "AccessDenied") {
            $('.mui-model').showErrorMessage({
                message: errorConfig[err.code],
                obsError: obsError(err.code,err.message)
            });
        }
        if (loading) {
            loading.close();
        }
        if(err.code==="AccessDenied"){
            var arr = [];
            for (var i in ExtBucket) {
                if (ExtBucket[i].id === currentUserId) {
                    arr = ExtBucket[i].bucketArr;
                    if(arr.length != 0){
                        $("#overlay").addClass('mui-hide');
                    }
                    break;
                }
            }

            var extBucketNameList = []
            for (var i in arr) {
                var bucketItem = {
                    bucketName: encoderForHtml(arr[i])
                }
                if (arr[i] === currentName) {
                    bucketItem.current = true
                } else {
                    bucketItem.current = false
                }
                extBucketNameList.push(bucketItem)
            }
            $("#lsBuckets").append(renderSync("lsExtBucketsTemplate", extBucketNameList));
            if(pkg.coldline){
                for (var index in extBucketTableList) {
                    bucketAttributeAction.headBucket(extBucketTableList[index].showKey, function (err, data, bucketName) {
                        if (err) {
                            global.logger.error("query StorageType failed. bucket=" + bucketName, err);
                            $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html("--");
                            return;
                        }
                        $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html(commonUtils.termStorageClass(data.StorageType));
                    })
                }
            }
            $("#lsBuckets").append(renderSync("tableNoDataLeft", {queryNothing: global.langData.noRecords}));
            $("#lsBuckets").append(renderSync("tableQueryNothingLeft", {queryNothing: global.langData.noRecords}));
            $("#leftNoData").hide();
            $("#leftQueryNothing").hide();
        };

    } else {
        isLoaded = true;
        $('.btnUserInfo').addClass('userLogin');
        ownerId = data.Owner.ID;
        ownerName = data.Owner.DisplayName;
        allButtonChange('2');
        var bucket;

        var bucketNameList = []
        for (var index in data.Buckets) {
            bucket = data.Buckets[index];
            var bucketItem = {
                bucketName: encoderForHtml(bucket.Name)
            }
            if (bucket.Name === currentName) {
                bucketItem.current = true
            } else {
                bucketItem.current = false
            }
            bucketNameList.push(bucketItem)
        }
        $("#lsBuckets").html(renderSync("lsBucketsTemplate", bucketNameList));

        var arr = [];
        for (var i in ExtBucket) {
            if (ExtBucket[i].id === currentUserId) {
                arr = ExtBucket[i].bucketArr;
                break;
            }
        }

        var extBucketNameList = []
        for (var i in arr) {
            var bucketItem = {
                bucketName: encoderForHtml(arr[i])
            }
            if (arr[i] === currentName) {
                bucketItem.current = true
            } else {
                bucketItem.current = false
            }
            extBucketNameList.push(bucketItem)
        }
        $("#lsBuckets").append(renderSync("lsExtBucketsTemplate", extBucketNameList))
        $("#lsBuckets").append(renderSync("tableNoDataLeft", {queryNothing: global.langData.noData}));
        $("#lsBuckets").append(renderSync("tableQueryNothingLeft", {queryNothing: global.langData.noRecords}));
        $("#leftQueryNothing").hide();
        $("#leftNoData").hide();
        if (data.Buckets.length === 0 && arr.length === 0) {
            if (loading) {
                loading.close();
            }
            $("#leftNoData").show();
            return false;
        }
        $(".btnBucketSearch").click();
        $(".btnSearch").click();
        if (currentName) {
            $('#curBucketName').html(encoderForHtml(currentName));
            objectOrBucketRetrun(currentName);//切换到对象列表
        } else if (loading) {
            loading.close();
        } else {
            global.logger.warn("listBucketUI failed, currentName=" + currentName + "; loading=" + loading)
        }
    }
}

//主区域桶列表
function listBucketBodyUI(err, data, loading, currentName) {
    $('#bucketLists tr').each(function (i, item) {
        $(item).remove();
    });
    $("#BucketCreated").removeClass("lastUpdateTh");
    $(".bucket-delete,.mui-icon-aclConfig,.mui-icon-more,.mui-icon-property").addClass('mui-disabled');
    $('#bucketCreateNum').html('');
    $('#bucketRestNum').html('');
    if (err) {
        allButtonChange('1');
        if(err.code === "Unauthorized"){
            $(".mui-page-full.shown").removeClass('shown');
            $("#auth").removeClass('mui-hide');
            $("#auth").addClass('shown');
            divDragFunc('authDrag','auth');
            return false;
        }
        if(err.code === "AccessDenied"){
            isLoaded = true;
            $('.btnUserInfo').addClass('userLogin');
            var arr = [];
            var tbody = $("#bucketLists tbody");
            for (var i in ExtBucket) {
                if (ExtBucket[i].id === currentUserId) {
                    arr = ExtBucket[i].bucketArr;
                    break;
                }
            }
            if(arr.length != 0){
                $("#overlay").addClass('mui-hide');
            }else{
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message),
                    ok:function(){
                        $("#overlay").addClass('mui-hide');
                    }
                });
            }
            var extBucketTableList = [];
            for (var i in arr) {
                //处理多个连续空格显示问题
                var showKey = (encoderForHtml(arr[i]).replace(new RegExp(' ', 'gm'), '&nbsp;'));
                extBucketTableList.push({
                    showKey: showKey,
                    bucketName: arr[i],
                    aclConfig: languageJson.aclPermissions,
                    multipart: languageJson.multipart,
                    delete: languageJson.delete,
                    obs_term_unlinkBucket_button: languageJson.obs_term_unlinkBucket_button,
                    coldline : pkg.coldline
                })
            }
            tbody.append(renderSync("lsExtBucketsTableTemplate", extBucketTableList));
            if(pkg.coldline){
                for (var index in extBucketTableList) {
                    bucketAttributeAction.headBucket(extBucketTableList[index].showKey, function (err, data, bucketName) {
                        if (err) {
                            global.logger.error("query StorageType failed. bucket=" + bucketName, err);
                            $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html("--");
                            return;
                        }
                        $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html(commonUtils.termStorageClass(data.StorageType));
                    })
                }
            }
        }else if (err.code !== "AccessDenied") {
            var _message = errorConfig[err.code] || err.statusCode;
            if(_message){
                if(err.code === "NetworkingError" && userType === "1"){//用户未配置其他存储时使用另一个提示
                    err.code = "NetworkingError2";
                }
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message,err.statusCode)
                });
            }
        }
        logger.error("Error:", err);
        if (loading) {
            loading.close();
        }
    } else {
        var bucket;
        var tbody = $("#bucketLists tbody");
        var bucketTableList = [];
        for (var index in data.Buckets) {
            bucket = data.Buckets[index];
            //处理多个连续空格显示问题
            var showKey = (encoderForHtml(bucket.Name).replace(new RegExp(' ', 'gm'), '&nbsp;'));
            var localDate = indexAction.gmtDate2LocaleDate(bucket.CreationDate, language);

            bucketTableList.push({
                showKey: showKey,
                localDate: localDate,
                bucketName: bucket.Name,
                property: languageJson.bucketProperty,
                common_term_changeStorageClass_button: languageJson.common_term_changeStorageClass_button,
                delete: languageJson.delete,
                more: languageJson.more,
                coldline : pkg.coldline,
                objectColdline : pkg.objectColdline
            })
        }
        tbody.html(renderSync("lsBucketsTableTemplate", bucketTableList));
        async.eachLimit(bucketTableList, 5, function (item, callback) {
            bucketAttributeAction.getBucketLocation(item.showKey, function (err, data, bucketName) {
                if (err) {
                    global.logger.error("query location failed. bucket=" + bucketName, err);
                    $("#" + bucketName.replace(/\./g, "\\.") + "_bucket_region").html("--");
                } else {
                    $("#" + bucketName.replace(/\./g, "\\.") + "_bucket_region").html(data.LocationConstraint);
                }
                callback();
            })
        }, function (err) {
            if (err) {
                global.logger.error('get location eachSeries error.', err);
            } else {
                global.logger.info('get location eachSeries done.');
            }
        });
        if(pkg.coldline){
            async.eachLimit(bucketTableList, 5, function (item, callback) {
                bucketAttributeAction.headBucket(item.showKey, function (err, data, bucketName) {
                    if (err) {
                        global.logger.error("query StorageType failed. bucket=" + bucketName, err);
                        $("#" + bucketName.replace(/\./g, "\\.") + "_bucket_storageType").html("--");
                    } else {
                        $("#" + bucketName.replace(/\./g, "\\.") + "_bucket_storageType").html(commonUtils.termStorageClass(data.StorageType));
                    }
                    callback();
                })
            }, function (err) {
                if (err) {
                    global.logger.error('head bucket eachSeries error.', err);
                } else {
                    global.logger.info('head bucket eachSeries done.');
                }
            });
        }
        var arr = [];
        for (var i in ExtBucket) {
            if (ExtBucket[i].id === currentUserId) {
                arr = ExtBucket[i].bucketArr;
                break;
            }
        }
        var extBucketTableList = [];
        for (var i in arr) {
            //处理多个连续空格显示问题
            var showKey = (encoderForHtml(arr[i]).replace(new RegExp(' ', 'gm'), '&nbsp;'));
            extBucketTableList.push({
                showKey: showKey,
                bucketName: arr[i],
                aclConfig: languageJson.aclPermissions,
                multipart: languageJson.multipart,
                delete: languageJson.delete,
                obs_term_unlinkBucket_button: languageJson.obs_term_unlinkBucket_button,
                coldline : pkg.coldline
            })
        }
        tbody.append(renderSync("lsExtBucketsTableTemplate", extBucketTableList));
        if(pkg.coldline){
            for (var index in extBucketTableList) {
                bucketAttributeAction.headBucket(extBucketTableList[index].showKey, function (err, data, bucketName) {
                    if (err) {
                        global.logger.error("query StorageType failed. bucket=" + bucketName, err);
                        $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html("--");
                        return;
                    }
                    $("#" + bucketName.replace(/\./g, "\\.") + "_extBucket_storageType").html(commonUtils.termStorageClass(data.StorageType));
                })
            }
        }
        tbody.append(renderSync("tableNoData", {queryNothing: global.langData.noData}));
        $("#bucketLists tbody").append(renderSync("tableQueryNothing", {queryNothing: global.langData.noRecords}));
        $("#tableBodyNoData").hide();
        $("#tableBodyQueryNothing").hide();
        // 设置桶数量信息
        var bucketCreateNum;
        var extBucketNum;
        if(data.Buckets){
            bucketCreateNum = bucketTableList.length;
        }else{
            bucketCreateNum = '';
            extBucketNum = '';
        }
        if(ExtBucket){
            extBucketNum = extBucketTableList.length;
        }else{
            extBucketNum = '';
        }
        $('#bucketCreateNum').html(bucketCreateNum);
        $('#extBucketNum').html(extBucketNum);
        if (loading) {
            loading.close();
        }
        if (data.Buckets.length === 0 && arr.length === 0) {
            $("#tableBodyNoData").show();
            return false;
        }
    }
}

/**
 * 搜索table区域的bucket
 * @param keyVal
 * @returns {boolean}
 */
function searchBucketTable(keyVal) {
    var mui_hide = $("#bucketArea").attr("class");
    //这里表明是在查桶列表，与查询对象列表区分开
    //查询忽略大小写
    keyVal = keyVal.toLowerCase();
    if (mui_hide != "mui-hide") {
        $("#bucketLists tbody").children().show();
        var bucketLs = $("#bucketLists tbody").children();
        var queryNothing = true;
        for (var i = 0; i < bucketLs.length; i++) {
            var bucketName = $(bucketLs[i]).find("span[name='bucketBodyItem']").attr("data-href");
            if (!bucketName) {
                continue;
            } else if (bucketName.indexOf(keyVal) == -1) {
                $(bucketLs[i]).hide();
            } else {
                queryNothing = false;
            }
        }
        if (queryNothing) {
            $("#tableBodyQueryNothing").show();
            $("#tableBodyNoData").hide();
        } else {
            $("#tableBodyQueryNothing").hide();
            $("#tableBodyNoData").hide();
        }
        return true;
    }
}

$(".btnBucketSearch").on('click', function (event) {
    var keyval = $('#bucketSearch').val().trim();
    keyval = keyval.toLowerCase();
    $("#lsBuckets").children().show();
    var bucketLs = $("#lsBuckets").children();
    var queryNothing = true;
    for (var i = 0; i < bucketLs.length; i++) {
        var bucketName = $(bucketLs[i]).attr("data-href")
        if (!bucketName) {
            continue;
        } else if (bucketName.indexOf(keyval) == -1) {
            $(bucketLs[i]).hide();
        } else {
            queryNothing = false;
        }
    }
    if (queryNothing) {
        $("#leftQueryNothing").show();
        $("#leftNoData").hide();
    } else {
        $("#leftNoData").hide();
        $("#leftQueryNothing").hide();
    }
});

//筛选桶时输入回车按钮执行查询功能
$("#bucketSearch").on('keyup', function (event) {
    var keyCode = event.keyCode;
    if (keyCode === 13) {
        $(".btnBucketSearch").click();
    }
});

//获取当前路径
function getCurrPath() {
    var parentPath = '';
    $('#path a span').each(function (i, a) {
        if (i > 0) {
            parentPath = JSON.parse($(a).text()).name
        }
    });
    return parentPath;
}

//获取元素绝对位置
function getNodeLocation(id) {
    var x = $("#" + id).offset().left;
    var y = $("#" + id).offset().top;
    var location = {
        popX: x,
        popY: y
    }
    return location;
}

//对象列表和桶列表切换
function objectOrBucketRetrun(currentName) {
    var loading = loadingShow();
    if ($("#objectArea").hasClass('mui-hide')) {
        $("#objectArea").removeClass('mui-hide');//桶列表和对象列表切换
        $("#bucketArea").addClass('mui-hide');
        $("#objectBtnDiv").removeClass('mui-hide');
        $("#bucketBtnDiv").addClass('mui-hide');
        $("#prefixSearch").val("");
        $("#all-back-div").addClass('all-back-btn');//修改后退按钮样式
        $("#all-back-div").removeClass('all-back-btn-disabled');
        $(".mui-font-color-gray").removeClass('mui-hide');//显示下方属性栏
        $("#prefixSearch").attr('placeholder', languageJson.prefixSearchInfo);
    }
    bucketAttributeAction.headBucket(currentName, function (err, data) {
        if (err) {
            if (!err.code) {
                err.code = "InternalError"
                global.logger.error("Get into bucket by click...", err);
            }
            if (err.code == "Forbidden") {
                $('.mui-model').showErrorMessage({
                    message: errorConfig["AccessDenied"],
                    obsError: obsError("AccessDenied")
                });
            } else {
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message)
                });
            }

            $("#bread-path-box-bucket").click();
            loading.close();
            return false;
        }
        currBucketStorage = (data && data.StorageType) || false;
        if (pkg.objectColdline || currBucketStorage === 'Coldline') {
            $("#recoverBtn").removeClass('mui-hide');
        } else {
            $("#recoverBtn").addClass('mui-hide');
        }
        bucketAndObjectAction.listObject(currentName, 'true', '', function (err, data) {
            loading.close();
            listObjectUI(err, data, currentName);
        });
        var str = {
            name: currentName
        };
        var htmStr = renderSync("head-navi-item", {
            currPath: JSON.stringify(str),
            folderName: currentName
        });
        $(".mui-body .mui-content .path").html(htmStr);
        $("#path a").each(function(){
            var pathNodeName = $(this).attr("folderName");
            if(pathNodeName.length > 12) {
                $(this).attr("title", pathNodeName);
            }
        })
    });
}

/**
 * 实现弹出框拖拽功能
 * @param target
 * @param root
 */
function divDragFunc(target, root) {
    //偏移量，避免拖动到边界时将界面边框挡住了
    var offset = 2;
    //header的高度
    var top = 60;
    var offset2 = 0; //有的窗口太高，再设置一个垂直方向的偏移量，避免拖动之后窗口组件显示不全
    if(target == "bucketProDrag"){
        offset2 = 38;
    }else if(target == "changeStorageClassDrag"){
        offset2 = -58;
    }
    $.drag({
        target: document.getElementById(target),
        root: document.getElementById(root),
        min: {x: offset, y: top},
        max: {
            x: document.body.clientWidth - document.getElementById(root).clientWidth - offset,
            y: document.body.clientHeight - offset - offset2 - document.getElementById(root).scrollHeight
        }
    });
}

/**
 * 打开learnMore 链接
 */
$(".mui-page h5 a,#helpOnline").on('click', function () {
    var gui = require('nw.gui');
    var id = $(this).attr('id');
    var href = '';
    if (UCDVersion === 'DT') {//DT版本
        href = i18n_learnMore.getLearnMoreLink("DT_EN", id);
    } else if (UCDVersion === 'TLF') {//TLF版本
        href = i18n_learnMore.getLearnMoreLink("TLF_EN", id);
    } else if (UCDVersion === 'OCB' && language === 'en') {//OCB英文版本
        href = i18n_learnMore.getLearnMoreLink("OCB_EN", id);
    } else if (UCDVersion === 'OCB' && language === 'zh') {//OCB中文版本
        href = i18n_learnMore.getLearnMoreLink("OCB_ZH", id);
    } else if (UCDVersion === 'HEC' && language === 'zh') {//HEC中文版本
        href = i18n_learnMore.getLearnMoreLink("HEC_ZH", id);
    } else if (UCDVersion === 'CTC' && language === 'zh') {//CTC中文版本
        href = i18n_learnMore.getLearnMoreLink("CTC_ZH", id);
    }  else if (UCDVersion === 'CTC' && language === 'en') {//CTC英文版本
        href = i18n_learnMore.getLearnMoreLink("CTC_EN", id);
    }else if (UCDVersion === 'CMCC' && language === 'zh') {//CMCC中文版本
        href = i18n_learnMore.getLearnMoreLink("CMCC_ZH", id);
    }else if (UCDVersion === 'CMCC' && language === 'en') {//CMCC英文版本
        href = i18n_learnMore.getLearnMoreLink("CMCC_EN", id);
    }else if (UCDVersion === 'FCS' && language === 'zh') {//FCS中文版本
        href = i18n_learnMore.getLearnMoreLink("FCS_ZH", id);
    }else if (UCDVersion === 'FCS' && language === 'en') {//FCS英文版本
        href = i18n_learnMore.getLearnMoreLink("FCS_EN", id);
    }else {//HEC英文版本
        href = i18n_learnMore.getLearnMoreLink("HEC_EN", id);
    }
    gui.Shell.openExternal(href);
    return false;
})

/**
 * 控制前缀查询输入域清除按钮显示与隐藏
 */
$("#prefixSearch").on('keyup', function () {
    var value = $(this).val();
    if (value.length > 0) {
        $("#clearPrefixSearchInput").removeClass("mui-hide");
    } else {
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#isSearch").val("");
    }
});

/**
 * 清空前缀查询输入域
 */
$("#clearPrefixSearchInput").on('click', function () {
    $("#prefixSearch").val("");
    $("#isSearch").val("");
    $(".btnSearch").click();
    $(this).addClass('mui-hide');
});

/**
 * 控制桶搜索输入域清除按钮显示与隐藏
 */
$("#bucketSearch").on('keyup', function () {
    var value = $(this).val();
    if (value.length > 0) {
        $("#clearBucketSearchInput").removeClass("mui-hide");
    } else {
        $("#clearBucketSearchInput").addClass("mui-hide");
    }
});

/**
 * 清空桶搜索输入域
 */
$("#clearBucketSearchInput").on('click', function () {
    $("#bucketSearch").val("");
    $(".btnBucketSearch").click();
    $(this).addClass('mui-hide');
});

/**
 * 检查每页对象列表配置数量
 * @param configObj
 * @returns {boolean}
 */
function chekcObjPageSize(configObj) {
    var objSize = new Number($("#objPerPageSize").val());
    var objSizeMin = new Number($("#objPerPageSize").attr("min"));
    var objSizeMax = new Number($("#objPerPageSize").attr("max"));
    if (objSize < objSizeMin) {
        $('.mui-model').showMessage({
            type: "warning",
            message: languageJson.objListPerPageMin,
            ok: function () {
                return false;
            },
            title: languageJson.warning
        });
        return false;
    }
    if (objSize > objSizeMax) {
        $('.mui-model').showMessage({
            type: "warning",
            message: languageJson.objListPerPageMax,
            ok: function () {
                return false;
            },
            title: languageJson.warning
        });
        return false;
    }
    global.objPerPageSize = $("#objPerPageSize").val();
    configObj.objPerPageSize = $("#objPerPageSize").val();
    return true;
}



/**
 * disabled 状态的按钮添加tips效果,在生命周期和cors界面上通过mui-disabled样式筛选不生效
 */
$(".mui-disabled").on('mouseover mouseout', function (event) {
    if ($(this).hasClass('mui-disabled')) {
        if (event.type === "mouseover") {
            var data = $(this).attr("data-title");
            $(this).attr("title", data);
        } else {
            $(this).removeAttr("title");
        }
    }
});

/**
 * 生命周期和cors列表中disabled状态的按钮添加tips效果
 */
$(".mui-icon-edit-16,.mui-icon-del-16").on('mouseover mouseout', function (event) {
    if ($(this).hasClass('mui-disabled')) {
        if (event.type === "mouseover") {
            var data = $(this).attr("data-title");
            $(this).attr("title", data);
        } else {
            $(this).removeAttr("title");
        }
    }
});

/**
 * 启用按钮，去掉disabled效果
 * @param $btnObj
 */
function disabledBtn($btnObj) {
    $btnObj.removeClass('mui-disabled');
    $btnObj.removeAttr('title');
    $btnObj.removeAttr('disabled');
}




function createAccountCtrl() {
    requirejs([], function () {
        var module = angular.module('createAccountModule', ['tiny']);

        module.controller('createAccountCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            if(_.isEqual(UCDVersion,"HEC")){
                $("#addNewAccountKnowMore").parent().hide();
            }
            if(_.isEqual(UCDVersion,"CTC")){
                $("#addNewAccountKnowMore").parent().hide();
            }
            $scope.createAccount = {
                placeholder : global.langData.accountNamePlaceHolder,
                accountValidate: {
                    "validator": [{
                        rule: function (value) {
                            return value.length <= 50;
                        },
                        errorMsg: global.langData.inputAccountNameIsLong
                    }, {
                        rule: function (value) {
                            return value.trim().length > 0;
                        },
                        errorMsg: global.langData.common_term_emptyEnter_msg
                    }, {
                        rule: function (value) {
                            var userId = $("#userId").val();
                            if (global.accountObj && global.accountObj.Accounts && global.accountObj.Accounts.Account) {
                                for (var i = 0; i < global.accountObj.Accounts.Account.length; i++) {
                                    var item = global.accountObj.Accounts.Account[i];
                                    if (item && item.ID[0] != userId && item.Name.toString() == value.trim()) {
                                        return false;
                                    }
                                }
                            }
                            return true;
                        },
                        errorMsg: global.langData.inputAccountNameIsRepet
                    }]
                },
                accountAkValidate: {
                    "validator": [{
                        rule: function (value) {
                            return value.trim().length > 0;
                        },
                        errorMsg: global.langData.inputAccessKey
                    },{
                        rule: function (value) {
                            return value.trim().length <= 256;
                        },
                        errorMsg: global.langData.inputAccessKeyIsLong
                    }]
                },
                accountSkValidate: {
                    "validator": [{
                        rule: function (value) {
                            return value.trim().length > 0;
                        },
                        errorMsg: global.langData.inputSecretKey
                    },{
                        rule: function (value) {
                            return value.trim().length <= 256;
                        },
                        errorMsg: global.langData.inputSecretKeyIsLong
                    }]
                },
                accountEndpointValidate: {
                    "validator": [{
                        rule: function (value) {
                            return value.length > 0;
                        },
                        errorMsg: global.langData.IPNotNull
                    }, {
                        rule: function (value) {
                            // 端口校验
                            var regPort = /:([0-9]|[1-9]\d|[1-9]\d{2}|[1-9]\d{3}|[1-5]\d{4}|6[0-4]\d{3}|65[0-4]\d{2}|655[0-2]\d|6553[0-5])$/;
                            if (!regPort.test(value)) {
                                return false;
                            }
                            return true;
                        },
                        errorMsg: global.langData.PortIsNotNull
                    }, {
                        rule: function (value) {
                            // 如果只有数字则进行IP校验
                            var regIsNum = /^[0-9]*$/;
                            var isNum = regIsNum.test(value.split(':')[0].split('.').join(''));
                            if(isNum){
                                // IP校验
                                var regIP = /^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5]):/;
                                if (!regIP.test(value)) {
                                    return false;
                                }
                            }else{
                                // 域名校验
                                var regAddress = /^(?=^.{3,255}$)[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+:/;
                                if (!regAddress.test(value)) {
                                    return false;
                                }
                            }
                            return true;
                        },
                        errorMsg: global.langData.obs_term_proxyAddress_valid1
                    }]
                },
                cleanInvalidate: function () {
                    tiValid.clearInValid($("#name"));
                    tiValid.clearInValid($("#accessKey"));
                    tiValid.clearInValid($("#secretKey"));
                    tiValid.clearInValid($("#endpoint"));
                }
            };
        }]);

        angular.bootstrap($('#tiny-accountConfig'), ['createAccountModule']);
    });
}

function createBucketCtrl() {
    requirejs([], function () {
        var module = angular.module('createBucketModule', ['tiny']);

        module.controller('createBucketCtrl', ['$scope', function ($scope) {
            if(_.isEqual(UCDVersion,"HEC")){
                $("#extBucketMore").hide();
            }
            if(_.isEqual(UCDVersion,"CTC")){
                $("#extBucketMore").hide();
            }
            $("#createExtBuceketTab").hide();
            $("#createBucketTab").show();
            $scope.coldlineSwitch = pkg.coldline;
            $scope.createType = {
                createTypeList: [
                    {
                        key: "bucket",
                        value: global.langData.obs_task_createBucket_radio
                    },
                    {
                        key: "extBucket",
                        value: global.langData.obs_task_createAddExternalBucket_radio
                    }
                ]
            }
            $scope.createType.selected = {
                value: $scope.createType.createTypeList[0].value
            }
            $scope.createType.changeCreate = function () {
                $("#createExtBuceketTab").hide();
                $("#createBucketTab").hide();
                if ($scope.createType.selected.value === $scope.createType.createTypeList[0].value) {
                    $("#createBucketTab").show();
                }
                if ($scope.createType.selected.value === $scope.createType.createTypeList[1].value) {
                    $("#createExtBuceketTab").show();
                }
            }
            $scope.bucket = {
                storageTypeList: [
                    {
                        key: "Standard",
                        value: global.langData.obs_term_standard_lable,
                        desc: global.langData.obs_term_standard_tip,
                        disable: false
                    }, {
                        key: "Nearline",
                        value: commonUtils.termStorageClass("Nearline"),
                        desc: global.langData.obs_term_nearline_tip,
                        disable: false
                    }, {
                        key: "Coldline",
                        value: commonUtils.termStorageClass("Coldline"),
                        desc: global.langData.obs_term_coldline_tip,
                        disable: false
                    }
                ]
            }
            $scope.bucket.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.bucket.storageTypeList[0].key
            }
            $scope.bucket.description = $scope.bucket.storageTypeList[0].desc;
            $scope.bucket.changeType = function () {
                for (var index in $scope.bucket.storageTypeList) {
                    if ($scope.bucket.storageTypeList[index].key == $scope.bucket.selected.value) {
                        $scope.bucket.description = $scope.bucket.storageTypeList[index].desc
                    }
                }
            }
            $scope.resetCreateBucket = function () {
                // 点击取消还原默认值
                $scope.createType.selected = {
                    value: $scope.createType.createTypeList[0].value
                };
                $scope.createType.changeCreate();
                $scope.bucket.selected = {
                    value: $scope.bucket.storageTypeList[0].key
                };
            }
        }]);
        angular.bootstrap($('#createBucketPage'), ['createBucketModule']);
        angular.bootstrap($('#lifecycleChild'), ['createBucketModule']);
    });
}
//桶存储类别
function changeStorageCtrl() {
    requirejs([], function () {
        var module = angular.module('changeStorageModule', ['tiny']);

        module.controller('changeStorageCtrl', ['$scope', function ($scope) {
            $scope.coldlineSwitch = pkg.coldline;
            $scope.bucket = {
                storageTypeList: [
                    {
                        key: "Standard",
                        value: global.langData.obs_term_standard_lable,
                        desc: global.langData.obs_term_standard_tip,
                        disable: false
                    }, {
                        key: "Nearline",
                        value: commonUtils.termStorageClass("Nearline"),
                        desc: global.langData.obs_term_nearline_tip,
                        disable: false
                    }, {
                        key: "Coldline",
                        value: commonUtils.termStorageClass("Coldline"),
                        desc: global.langData.obs_term_coldline_tip,
                        disable: false
                    }
                ]
            }
            $scope.bucket.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.bucket.storageTypeList[0].value
            }
            $scope.bucket.description = $scope.bucket.storageTypeList[0].desc;
            $scope.bucketLogging = {
                enable:global.langData.startUse,
                disable:global.langData.stopUse
            }
            $scope.bucket.changeType = function () {
                for (var index in $scope.bucket.storageTypeList) {
                    if ($scope.bucket.storageTypeList[index].key == $scope.bucket.selected.value) {
                        $scope.bucket.description = $scope.bucket.storageTypeList[index].desc
                    }
                }
            }
        }]);
        angular.bootstrap($('#changeStorageType'), ['changeStorageModule']);
        angular.bootstrap($('#bucketLogging'), ['changeStorageModule']);
    });
}
//对象存储类别
function changeObjectStorageCtrl() {
    requirejs([], function () {
        var module = angular.module('changeObjectStorageModule', ['tiny']);

        module.controller('changeObjectStorageCtrl', ['$scope', function ($scope) {
            $scope.coldlineSwitch = pkg.objectColdline;
            $scope.object = {
                storageTypeList: [
                    {
                        key: "Standard",
                        value: global.langData.obs_term_standard_lable,
                        desc: global.langData.obs_term_standard_tip,
                        disable: false
                    }, {
                        key: "Nearline",
                        value: commonUtils.termStorageClass("Nearline"),
                        desc: global.langData.obs_term_nearline_tip,
                        disable: false
                    }, {
                        key: "Coldline",
                        value: commonUtils.termStorageClass("Coldline"),
                        desc: global.langData.obs_term_coldline_tip,
                        disable: false
                    }
                ]
            }
            $scope.object.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.object.storageTypeList[0].value
            }
            $scope.object.description = $scope.object.storageTypeList[0].desc;
            $scope.object.changeType = function () {
                for (var index in $scope.object.storageTypeList) {
                    if ($scope.object.storageTypeList[index].key == $scope.object.selected.value) {
                        $scope.object.description = $scope.object.storageTypeList[index].desc
                    }
                }
            }
            // 初始化上传对象的project option
            $scope.selectProjectModel = {
                selectedProjectId: [],
                disable: true,
                placeholder: "select a project",
                options: []
            }
            // 选中的project
            $scope.projectSelected = {value: undefined};
            // 初始化KMS key option
            $scope.selectKeyModel = {
                selectedKeyId: [],
                disable: true,
                placeholder: "select a key",
                options: []
            }
            // 选中的project
            $scope.keySelected = {value: undefined};
        }]);
        angular.bootstrap($('#uploadFileDialog'), ['changeObjectStorageModule']);
        angular.bootstrap($('#uploadFolderDialog'), ['changeObjectStorageModule']);
        angular.bootstrap($('#changeStorageClass'), ['changeObjectStorageModule']);
    });
}
//日历选择
function DateCtrl() {
        requirejs([], function () {
            var module = angular.module("DateCtrlModule", ["tiny"]);

            module.controller('DateCtrl', function ($scope) {
                $scope.dateOptions = {
                    format : "yyyy.MM.dd",
                    value : {
                        begin : new Date(2011, 5, 6),
                        end: null
                    },
                    elementId: 'date_range_test',
                    minValue : null,
                    maxValue : new Date(2019, 8, 27),
                    disable : false
                };

                $scope.changeValue = function() {
                    $scope.dateOptions.value = {
                        begin : new Date(2012, 7, 8),
                        end: new Date(2012, 7, 8)
                    };
                };

                $scope.getValue = function() {
                    $scope.currentValue = "cuurent value.begin is: " + $scope.dateOptions.value.begin;
                    $scope.currentValue1 = "cuurent value.end is: " + $scope.dateOptions.value.end;
                }
            });

            angular.bootstrap($("#exportData"), ["DateCtrlModule"]);
        })
}
/**
 * 菜单控制
 */
function ctxMenuCtrl() {
    requirejs([], function () {
        var module = angular.module('ctxMenuModule', ['ngAnimate', 'tiny']);

        module.controller('ctxMenuCtrl', function ($scope, tiModal) {
            //點擊刪除按鈕時，触发次方法
            $scope.openDelConfirm = function () {
                //获取通列表选中的tr元素里面的桶信息
                var name = $("#bucketLists .selected-tr-active [name='bucketBodyItem']").text();
                var region = $("#bucketLists .selected-tr-active [name='region']").text();
                var storageClass = $("#bucketLists .selected-tr-active [name='storageClass']").text();
                //构造modal内置table的header
                var head = [
                    [global.langData.bucketNameInTable, "50%"],
                ];
                //构造modal内置table的body，为了使html模板能通用，这里必须定义为二维数组
                var body = [
                    [
                        [name, "50%"]
                    ]
                ];
                //如果是温冷存储开启，则添加温冷类型信息
                if(pkg.coldline) {
                    head.push([global.langData.obs_term_storageClass_lable, "25%"]);
                    head.push([global.langData.obs_term_region_column, "25%"]);
                    //bucket不能批量删除，所以只有一组数据
                    body[0].push([storageClass, "25%"]);
                    body[0].push([region, "25%"]);
                } else {
                    head.push([global.langData.obs_term_region_column, "50%"]);
                    body[0].push([region, "50%"]);
                }
                //打开modal窗口，参考tinyui2：http://tinyui.huawei.com/tinyui2/index.html#/api/modal
                var modalInstance = tiModal.open({
                    templateUrl: 'html_template/deleteBucket.html',
                    controller: 'modalInstanceCtrl',
                    modalClass: "obs-ti-modal-class",
                    closeOnEsc: false,
                    draggable: false,
                    //参数传递
                    resolve: {
                        items: {
                            message: global.langData.isSureDeleteBucket,
                            title: global.langData.deleteBucket,
                            head: head,
                            body: body,
                            tip:global.langData.obs_term_deleteWarn_msg,
                            tip1:global.langData.obs_term_delBucket_warn_msg,
                            OK: function () {
                                var bName = $("#curBucketName").html();
                                deleteBucketOK(bName);
                            }
                        }
                    }
                });
            };
            $scope.openBucketUnlink = function () {
                //获取通列表选中的tr元素里面的桶信息
                var name = $("#bucketLists .selected-tr-active [name='bucketBodyItem']").text();
                var region = $("#bucketLists .selected-tr-active [name='region']").text();
                var storageClass = $("#bucketLists .selected-tr-active [name='storageClass']").text();
                //构造modal内置table的header
                var head = [
                    [global.langData.bucketNameInTable, "50%"],
                ];
                //构造modal内置table的body，为了使html模板能通用，这里必须定义为二维数组
                var body = [
                    [
                        [name, "50%"]
                    ]
                ];
                //如果是温冷存储开启，则添加温冷类型信息
                if(pkg.coldline) {
                    head.push([global.langData.obs_term_storageClass_lable, "25%"]);
                    head.push([global.langData.obs_term_region_column, "25%"]);
                    //bucket不能批量删除，所以只有一组数据
                    body[0].push([storageClass, "25%"]);
                    body[0].push([region, "25%"]);
                } else {
                    head.push([global.langData.obs_term_region_column, "50%"]);
                    body[0].push([region, "50%"]);
                }
                //打开modal窗口，参考tinyui2：http://tinyui.huawei.com/tinyui2/index.html#/api/modal
                var modalInstance = tiModal.open({
                    templateUrl: 'html_template/deleteDetail.html',
                    controller: 'modalInstanceCtrl',
                    modalClass: "obs-ti-modal-class",
                    closeOnEsc: false,
                    draggable: false,
                    //参数传递
                    resolve: {
                        items: {
                            message: global.langData.obs_term_unlinkBucket_msg,
                            title: global.langData.obs_term_unlinkBucket_Wintitle,
                            head: head,
                            body: body,
                            tip1:global.langData.obs_term_unlinkBucket_warn_msg,
                            tip:global.langData.obs_term_unlinkBucket_warn_msg,
                            OK: function () {
                                var bName = $("#curBucketName").html();
                                deleteBucketOK(bName);
                            }
                        }
                    }
                });
            };
        });
        /**
         * 删除桶弹出框控制器
         */
        module.controller('modalInstanceCtrl', function ($scope, tiModalInstance, items) {
            $scope.OK = global.langData.yes;
            $scope.Cancel = global.langData.no;
            $scope.warnMessage = items.message;
            $scope.title = items.title;
            $scope.tableItems = items.body;
            $scope.tableHeads = items.head;
            $scope.tip1 = items.tip1;
            $scope.tip = items.tip;
            $scope.ok = function () {
                tiModalInstance.close();
                items.OK();
            };
            $scope.cancel = function () {
                tiModalInstance.dismiss('cancel');
            };
        });

        angular.bootstrap($("#bucketCtxMenuId"), ["ctxMenuModule"]);
    })
}

function checkObjectRestore(key, cb) {
    var bucket = $("#curBucketName").html();
    bucketAndObjectAction.headObject(bucket, key, function (err, data) {
        if (data && data.Restore && data.Restore.indexOf('ongoing-request="true"') > -1) {
            $("#recoverBtn").addClass('mui-disabled');
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreUnavailable_tip);
            updateRestoreStatCache(key,languageJson.obs_term_restoring_lable);
        } else {
            disabledBtn($("#recoverBtn"));
        }
        var objectStorage = getChoseObjType();
        if (objectStorage === 'Coldline' || objectStorage === "GLACIER"){
            if (data && data.Restore && data.Restore.indexOf('ongoing-request="false"') > -1) {
                disabledBtn($("#downloadbtn"));
                $("#PropertyInMore").removeClass("mui-hide");
                $(".downloadCtx").removeClass('mui-disabled-task');
                $(".downloadCtx").parent().removeAttr('title');
                updateRestoreStatCache(key,languageJson.obs_term_restored_lable);
            }else{
                $("#downloadbtn").addClass('mui-disabled');
                $(".downloadCtx").addClass('mui-disabled-task');
                $("#PropertyInMore").addClass("mui-hide");
                $(".downloadCtx").parent().attr('title', languageJson.obs_task_downloadUnavailable_tip);
                $("#downloadbtn").attr('data-title', languageJson.obs_task_downloadUnavailable_tip);
            }
        }else{
            disabledBtn($("#downloadbtn"));
            $("#recoverBtn").addClass('mui-disabled');
        }
    });
}

function checkAddTitle($id, data) {
    $("#tempWidthDiv").html(data);
    if (!($("#tempWidthDiv").width() < $id.width())) {
        $id.attr('title', data);
    } else {
        $id.attr('title', "");
    }
}