/**
 * Created on 5/18/2017.
 */
var TaskEnum = require("./js/common/TaskEnum.js");
var CopyMoveComponent = require("./js/component/CopyMoveComponent.js");

global.glbClipboard = {
    bucket: "",
    key: "",
    size: "",
    objName: "",
    action: "",
    location:"",
    empty: true,
    isFolder: false,
    modifyTime: new Date(),
    add: function (bucket, key, size, objName, isFolder, location, action) {
        this.bucket = bucket;
        this.objName = objName;
        this.isFolder = isFolder;
        this.key = key;
        this.size = size;
        this.action = action;
        this.empty = false;
        this.location = location;
        this.modifyTime = new Date();
    },
    clean: function () {
        this.bucket = "";
        this.objName = "";
        this.key = "";
        this.size = "";
        this.location = location;
        this.action = "";
        this.empty = true;
        this.isFolder = false;
        this.modifyTime = new Date();
    }
}

function doAction(action) {
    "use strict";
    var objKey = getChoseObjKey();
    var objSize = getChoseObSize();
    var bucket = $("#curBucketName").html();
    var objName = getChoseObjName();
    var isFolder = activeIsFolder();
    var curPath = getCurrPath();
    global.glbClipboard.add(bucket, objKey, objSize, objName, isFolder, curPath, action);
}

$(".copyCtx").click(function () {
    "use strict";
    doAction(TaskEnum.TASK_TYPE.copy.value);
})

$(".moveCtx").click(function () {
    "use strict";
    doAction(TaskEnum.TASK_TYPE.move.value);
})

$(".pasteCtx").click(function () {
    "use strict";
    function paste() {
        var showAnimate = true;
        setTimeout(function(){
            if(showAnimate) {
                showCreateTasksAnimation();
            }
        }, 1500)
        var targetBucket = $("#curBucketName").html();
        var targetPath = getCurrPath();
        var copyMoveComponent = new CopyMoveComponent(taskControlAction, taskManager, targetBucket, targetPath);
        taskManager.setAbortAll(false);
        taskManager.setPauseAll(false);
        copyMoveComponent.doPaste(function (err) {
            if(err) {
                showAnimate = false;
                $(".mui-model").showMessage({
                    type: "warning",
                    message: obsError(err.code).description,
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return;
                    },
                    title: global.langData.warning
                });
                showOverlay();
            }
            if (global.glbClipboard.action === TaskEnum.TASK_TYPE.move.value) {
                global.glbClipboard.clean();
            }
        });
    }

    if(global.glbClipboard.action === TaskEnum.TASK_TYPE.move.value) {
        $(".mui-model").showMessage({
            type: "warning",
            message: global.langData.obs_term_moveObject_msg,
            ok: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                paste();
            },
            cancel: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                return false;
            },
            title: global.langData.warning
        });
        showOverlay();
    } else {
        paste();
    }
})
