/**
 * Created on 2017/3/23.
 */
function objButtonCtrl() {
    requirejs([], function () {
        var module = angular.module('objButtonModule', ['tiny']);
        /**
         * 上传对象按钮显示tips
         */
        module.controller('objButtonCtrl', function ($scope, tiModal, tiValid) {
            $scope.uploadButton = {
                content: global.langData.uploadOverwriteTip,
                position: "top-left",
                value: global.langData.upload,
                hideEffect: {
                    duration: 100
                },
                showEffect: {
                    duration: 100
                }
            };
            //点击删除object时触发的动作，包括顶部按钮和右侧删除图标
            $scope.openObjDelConfirm = function () {
                if ($("#btnDeleteObjects").hasClass('mui-disabled')) {
                    return false;
                }
                var bucketName = $('#curBucketName').html();
                var parentPath = getCurrPath();
                //删除对象从选择列表中获取
                var filename = "";
                var lis = $("#objLists tr.selected-tr-active>td:last-child");
                /**
                 *
                 * 如果是文件，则获取到dom对应的text是这样{"name":"94K_23","size":"94.00 KB","dataSize":96256,"modifyTime":" 12/30/2016 17:39:46 GMT+08:00"}
                 * 如果是文件夹，则是：{"name":"test10/测试数据/10000小对象1k-100k/"}
                 */
                var nameSize = {};
                async.forEachSeries(lis, function (li, callback) {
                    var obj = JSON.parse($(li).text());
                    if (obj.size) {
                        //有size属性则说明是文件
                        nameSize[parentPath + obj.name] = obj.dataSize;
                        filename = filename + parentPath + obj.name + "|";
                    } else {
                        filename = filename + obj.name + "|";
                    }
                    callback();
                }, function (err) {
                    if (err) {
                        logger.error('err: ' + err);
                    }
                });
                //校验所选文件夹或文件下是否有未完成的任务
                deletedCheck(filename, bucketName, function (result) {
                    if (result) {
                        //存在未完成的任务，禁止删除
                        $('.mui-model').showMessage({
                            type: "warning",
                            message: global.langData.selectDeleteObject1,
                            ok: function () {
                                return false;
                            },
                            title: global.langData.warning
                        });
                        return false;
                    } else {
                        //没有任务执行，开始处理删除逻辑
                        if (!filename) {
                            $('.mui-model').showMessage({
                                type: "warning",
                                message: global.langData.selectDeleteObject,
                                ok: function () {
                                    return false;
                                },
                                title: global.langData.warning
                            });
                            return false;
                        }
                        showOverlay();
                        var delBody = [];
                        var typeArr = [];
                        //获取选中对象的信息
                        $("#objLists .selected-tr-active").each(function (index, obj) {
                            var showKey = $(obj).find("[name='showKey']").text();
                            var fileType = $(obj).find("[name='fileType']").text();
                            var date = $(obj).find("[name='date']").text();
                            var type = $(obj).attr('data-type');
                            var storageClass = $(obj).find('td').eq(1).children('span').text();
                            var fileSize = $(obj).find('td').eq(3).children('span').text();
                            var line = [
                                [showKey.trim(), "50%"],
                                [storageClass.trim(), "20%"],
                                [fileSize.trim(), "30%"]
                            ];
                            delBody.push(line);
                            typeArr.push(type);
                        })
                        var msg;
                        var titleName;
                        var tip1 = global.langData.obs_term_delObject_disableVersion_tip;
                        var tip2 = global.langData.obs_term_delObject_enableVersion_tip;
                        if (delBody.length > 1){
                            if(typeArr.indexOf('file')==-1){
                                msg = CommonUtils.format(global.langData.obs_term_objectManage_delMultiFolder_msg, delBody.length);
                                titleName =global.langData.obs_term_delFolder_wintitle;
                                tip1 = global.langData.obs_term_delFolder_disableVersion_tip;
                                tip2 = global.langData.obs_term_delFolder_enableVersion_tip;
                            }else{
                                msg = CommonUtils.format(global.langData.obs_term_objectManage_delMultiObject_msg, delBody.length);
                                titleName = global.langData.obs_task_deleteObject_wintitle;
                            }

                        } else {
                            //判断选中的是文件还是文件夹
                            var thisTrType = $("#objLists .selected-tr-active").attr('data-type');
                            if(thisTrType == "folder"){
                                msg = global.langData.isSureDeleteFolder;
                                titleName =global.langData.obs_term_delFolder_wintitle;
                                tip1 = global.langData.obs_term_delFolder_disableVersion_tip;
                                tip2 = global.langData.obs_term_delFolder_enableVersion_tip;
                            }else {
                                msg = global.langData.isSureDeleteObjcet;
                                titleName = global.langData.obs_task_deleteObject_wintitle;
                            }

                        }

                        //打开modal窗口，参考tinyui2：http://tinyui.huawei.com/tinyui2/index.html#/api/modal
                        var modalInstance = tiModal.open({
                            templateUrl: 'html_template/deleteDetail.html',
                            controller: 'modalInstanceCtrl',
                            modalClass: "obs-ti-modal-class",
                            closeOnEsc: false,
                            draggable: false,
                            resolve: {
                                items: {
                                    message: msg,
                                    title:titleName,
                                    tip1:tip1,
                                    tip2:tip2,
                                    head: [
                                        [global.langData.object, "50%"],
                                        [global.langData.obs_term_storageClass_lable, "20%"],
                                        [global.langData.size, "30%"]
                                    ],
                                    body: delBody,
                                    OK: function () {
                                        deleteObjectOK(bucketName, filename, parentPath, nameSize);
                                    }
                                }
                            }
                        });
                    }
                });
                taskControlAction.checkDBData();
            };
            $scope.openObjResConfirm = function () {
                if ($("#recoverBtn").hasClass('mui-disabled')) {
                    return false;
                }
                var bucketName = $('#curBucketName').html();
                var parentPath = getCurrPath();
                //删除对象从选择列表中获取
                var filename = "";
                var lis = $("#objLists tr.selected-tr-active>td:last-child");
                var nameSize = {};
                async.forEachSeries(lis, function (li, callback) {
                    var obj = JSON.parse($(li).text());
                    if (obj.size) {
                        //有size属性则说明是文件
                        nameSize[parentPath + obj.name] = obj.dataSize;
                        filename = filename + parentPath + obj.name + "|";
                    } else {
                        filename = filename + obj.name + "|";
                    }
                    callback();
                }, function (err) {
                    if (err) {
                        logger.error('err: ' + err);
                    }
                });
                var delBody = [];
                var typeArr = [];
                //获取选中对象的信息
                $("#objLists .selected-tr-active").each(function (index, obj) {
                    var showKey = $(obj).find("[name='showKey']").text();
                    var fileType = $(obj).find("[name='fileType']").text();
                    var date = $(obj).find("[name='date']").text();
                    var type = $(obj).attr('data-type');
                    var storageClass = $(obj).find('td').eq(1).children('span').text();
                    var fileSize = $(obj).find('td').eq(3).children('span').text();
                    var line = [
                        [showKey.trim(), "50%"],
                        [storageClass.trim(), "20%"],
                        [fileSize.trim(), "30%"]
                    ];
                    delBody.push(line);
                    typeArr.push(type);
                })
                var  msg = global.langData.isSureDeleteFolder;
                var titleName =global.langData.obs_task_restoreObject_wintitle;
                var titleTip = global.langData.obs_term_recover_msg.format(lis.length);
                if(lis.length === 1 && $("#objLists tr.selected-tr-active").attr("data-type") === "file"){
                    var currObj = $('#objLists .selected-tr-active').find('.hiddenObjData').text();
                    var objName = JSON.parse(currObj).name;
                    var loading = loadingShow();
                    bucketAndObjectAction.headObject(bucketName,parentPath+objName,function (err,data) {
                        //如果对象正在恢复，则不能继续做恢复操作
                        loading.close();
                        if(data && data.Restore && data.Restore.indexOf('ongoing-request="true"') > -1){
                            $('.mui-model').showMessage({
                                type: "warning",
                                message: obsError('RestoreAlreadyInProgress').description,
                                ok: function () {
                                    return false;
                                },
                                title: languageJson.warning
                            });
                        }else{
                            //打开modal窗口，参考tinyui2：http://tinyui.huawei.com/tinyui2/index.html#/api/modal
                            var modalInstance = tiModal.open({
                                templateUrl: 'html_template/restoreDetail.html',
                                controller: 'modalInstanceCtrl',
                                modalClass: "obs-ti-modal-class",
                                closeOnEsc: false,
                                draggable: false,
                                resolve: {
                                    items: {
                                        message: msg,
                                        title:titleName,
                                        tip:titleTip,
                                        head: [
                                            [global.langData.object, "50%"],
                                            [global.langData.obs_term_storageClass_lable, "20%"],
                                            [global.langData.size, "30%"]
                                        ],
                                        body: delBody,
                                        OK: function () {

                                        }
                                    }
                                }
                            });
                        }
                    });
                }else{
                    //打开modal窗口，参考tinyui2：http://tinyui.huawei.com/tinyui2/index.html#/api/modal
                    var modalInstance = tiModal.open({
                        templateUrl: 'html_template/restoreDetail.html',
                        controller: 'modalInstanceCtrl',
                        modalClass: "obs-ti-modal-class",
                        closeOnEsc: false,
                        draggable: false,
                        resolve: {
                            items: {
                                message: msg,
                                title:titleName,
                                tip:titleTip,
                                head: [
                                    [global.langData.object, "50%"],
                                    [global.langData.obs_term_storageClass_lable, "20%"],
                                    [global.langData.size, "30%"]
                                ],
                                body: delBody,
                                OK: function () {

                                }
                            }
                        }
                    });
                }
                /**
                 *
                 * 如果是文件，则获取到dom对应的text是这样{"name":"94K_23","size":"94.00 KB","dataSize":96256,"modifyTime":" 12/30/2016 17:39:46 GMT+08:00"}
                 * 如果是文件夹，则是：{"name":"test10/测试数据/10000小对象1k-100k/"}
                 */
            };
            $scope.cleanInvalidate = function () {
                tiValid.clearInValid($("#floderName"));
            }
        });
        /**
         * 删除桶弹出框控制器
         */
        module.controller('modalInstanceCtrl', function ($scope, tiModalInstance, items) {
            $scope.OK = global.langData.yes;
            $scope.Cancel = global.langData.no;
            $scope.warnMessage = items.message;
            $scope.title = items.title;
            $scope.titleTip = items.tip;
            $scope.tableItems = items.body;
            $scope.tableHeads = items.head;
            $scope.tip1 = items.tip1;
            $scope.tip2 = items.tip2;
            $scope.days = global.langData.day;
            $scope.show = global.langData.obs_task_restoreObjectValidityPeriod_lable;
            $scope.speed = global.langData.obs_task_restoreObjectSpeed_lable;
            $scope.recoverTips = global.langData.obs_term_restoreObject_validityPeriod_tip
            var getRecoverSpeedList = function () {
                if (_.isEqual(UCDVersion, "HEC")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                } else if (_.isEqual(UCDVersion, "CTC")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                } else if (_.isEqual(UCDVersion, "CMCC")) {
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }
                    ]
                } else{
                    return [
                        {
                            key: "Expedited",
                            value: global.langData.obs_task_restoreObjectExpedited_radio,
                            desc: global.langData.obs_task_restoreObjectExpedited_tip,
                            disable: false
                        }, {
                            key: "Standard",
                            value: global.langData.obs_task_restoreObjectStandard_radio,
                            desc: global.langData.obs_task_restoreObjectStandard_tip,
                            disable: false
                        }, {
                            key: "Bulk",
                            value: global.langData.obs_task_restoreObjectBulk_radio,
                            desc: global.langData.obs_task_restoreObjectBulk_tip,
                            disable: false
                        }
                    ]
                }
            };
            $scope.recover = {
                recoverSpeedList: getRecoverSpeedList()
            };
            $scope.recover.selected = {
                // 设置默认选中值，后续$scope.selected.value会根据用户的选择而动态改变
                value: $scope.recover.recoverSpeedList[1].key
            };
            $scope.recover.description = $scope.recover.recoverSpeedList[1].desc;
            $scope.recover.changeType = function () {
                for (var index in $scope.recover.recoverSpeedList) {
                    if ($scope.recover.recoverSpeedList[index].key == $scope.recover.selected.value) {
                        $scope.recover.description = $scope.recover.recoverSpeedList[index].desc
                    }
                }
            }

            $scope.numberOptions = {
                value: 30,
                focused: false,
                disable: true,
                focus: function () {
                },
                blur: function () {
                },
                change: function () {
                    var value = parseInt($("#recoverDays").val());
                    if(value < 1){
                        $scope.numberOptions.value = 1;
                    }else if(value > 30){
                        $scope.numberOptions.value = 30;
                    }
                }
            };
            //批量恢复
            function handleMuilObject(days, tier) {
                var bucket = $("#curBucketName").html();
                var path = getCurrPath();
                var lis = $("#objLists tr.selected-tr-active>td:last-child");
                //批量恢复
                var showMsgTemp = true;
                /**
                 * 与forEach相似，但不是并行执行。而是一个个按顺序执行。
                 */
                async.forEachSeries(lis, function (li, callback) {
                    var obj = JSON.parse($(li).text());
                    var name = obj.name;
                    if (name.charAt(name.length - 1) === '/') {
                        listRestoreObjects(bucket, path, name, '', 0, function (err) {
                            if (err && showMsgTemp) {
                                showMsgTemp = false;
                                $('.mui-model').showErrorMessage({
                                    message: languageJson.someObjectDownErr,
                                    obsError: obsError("someObjectDownErr")
                                });
                            }
                            callback();
                        }, days, tier);
                    } else {
                        var size = obj.dataSize;
                        handleSingleObject(path + name, bucket, days, tier, function (err) {
                            if (err) {
                                taskControlAction.recoverObject(bucket, path + name, size, "FAILED", err.code, days, tier);
                            } else {
                                taskControlAction.recoverObject(bucket, path + name, size, "RESTORING", "", days, tier);
                            }
                            callback();
                        });
                    }
                }, function () {
                    global.logger.info('HandleMuilObject scuuess!');
                });
            }

            /**
             * 批量恢复任务
             * @param bucket 桶名
             * @param parentPath 当前文件夹路径
             * @param marker
             * @param path 本地文件夹路径
             * @param retryNnum 重试次数
             * @param cb 回调方法
             */
            function listRestoreObjects(bucket, parentPath, prefix, marker, retryNnum, cb, days, tier) {
                var self = this;
                if (!self.taskManager.abortAll) {
                    var params = {Bucket: bucket, Marker: marker, Prefix: prefix, MaxKeys: 100};
                    s3.listObjects(params, function (err, data) {
                        if (err) {
                            //最多重试3次
                            if (retryNnum < 4) {
                                retryNnum++;
                                //每次重试间隔时间按重试次数递增
                                setTimeout(function () {
                                    listRestoreObjects(bucket, parentPath, prefix, marker, retryNnum, cb, days, tier);
                                    global.logger.error('this is listRestoreObjects function error = ', retryNnum);
                                }, retryNnum * 60000);
                            } else {
                                if (cb) {
                                    cb(err);
                                }
                            }
                            global.logger.error(err);
                        }
                        else {
                            retryNnum = 0;
                            //处理列举出来的结果集
                            restoreListObjectData(data, days, tier, function () {
                                if (data.IsTruncated) {
                                    listRestoreObjects(bucket, parentPath, prefix, data.NextMarker, retryNnum, cb, days, tier);
                                } else {
                                    cb();
                                }
                            });
                        }
                    });
                } else {
                    cb()
                }
            };

            /**
             * 处理每次调用listObjects返回的结果数据
             * @param data 需要处理的数据
             */
            function restoreListObjectData(data, days, tier, call) {
                //同步处理结果集，每次处理20条记录，避免和UDS交互并发太大
                var bucket = data.Name;
                async.eachLimit(data.Contents, 20, function (item, callback) {
                    var key = item.Key;
                    var size = item.Size;
                    handleSingleObject(key, bucket, days, tier, function (err) {
                        if (key.charAt(key.length - 1) != '/'  && item.StorageClass === "GLACIER") {//folders and not clod will not be restored
                            if (err) {
                                taskControlAction.recoverObject(bucket, key, size, "FAILED", err.code, days, tier);
                            } else {
                                taskControlAction.recoverObject(bucket, key, size, "RESTORING", "", days, tier);
                            }
                        }
                        callback();
                    });
                }, function () {
                    if (call) {
                        call();
                    }
                });
            };
            $scope.recoverObject = {
                daysValidate: {
                    "validator": [{
                        rule: function (value) {
                            if (value > 0 && value < 31) {
                                $scope.validateResult = true;
                                return true;
                            } else {
                                $scope.validateResult = false;
                                return false;
                            }
                        },
                        errorMsg: global.langData.obs_task_restoreDaysBeyond_tip
                    }, {
                        rule: function (value) {
                            var oldExpires = $("#recoverObjectExpires").text();
                            if (commonUtils.compareExpiresDays(value, oldExpires)) {
                                $scope.validateExpiresResult = true;
                                return true;
                            } else {
                                $scope.validateExpiresResult = false;
                                return false;
                            }
                        },
                        errorMsg: global.langData.obs_task_restoreValidityPeriodFault_info
                    }]
                },
                cleanInvalidate: function () {
                    tiValid.clearInValid($("#recoverDays"));
                },
            };
            $scope.ok = function () {
                taskManager.setAbortAll(false);
                var days = $scope.numberOptions.value;
                var tier = $scope.recover.selected.value;
                //不知道这个为什么要加，暂时删掉
                //handleMuilObject(days, tier);
                showCreateTasksAnimation();
                $("#all-refresh-div").click();
                tiModalInstance.close();
                items.OK();
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            };
            $scope.cancel = function () {
                tiModalInstance.dismiss('cancel');
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            };
        });

        angular.bootstrap($('#objectBtnDiv'), ['objButtonModule']);
    });
}
//创建文件夹验证
function createFloderCtrl() {
    requirejs([], function () {
        var module = angular.module('createFloderModule', ['tiny']);

        module.controller('createFloderCtrl', ['$scope', 'tiValid', function ($scope, tiValid) {
            $scope.createFloder = {
                floderNameValidate: {

                    "validator": [{
                        "rule": function notEmptyFn(value) {
                            var val = $.trim(value);
                            return val.length > 0;
                        },
                        "errorMsg": global.langData.InputFolderName
                    }, {
                        "rule": function characterFn(value) {
                            var val = $.trim(value);
                            return !/[\\“”？"<>:|\?\*／＼＂＜＞：｜＊]/gi.test(val);
                        },
                        "errorMsg": global.langData.obs_term_createFolder_ruler2_valid
                    }, {
                        "rule": function followFn(value) {
                            var val = $.trim(value);

                            if (val === "." || val === "..") {
                                return false;
                            }
                            //带有多层文件夹的目录不能以.开头和结尾
                            return !/(\/\.)|(\.\/)/gi.test(val);
                        },
                        "errorMsg": global.langData.obs_term_createFolder_ruler3_valid
                    }, {
                        "rule": function startFn(value) {
                            var val = $.trim(value);
                            var start = val.substring(0, 1);
                            var end = val.substring(val.length - 1, val.length);
                            if (start === "." || end === "." || start === "．" || end === "．" || start === "/" || end === "/") {
                                return false;
                            }
                            return true;
                        },
                        "errorMsg": global.langData.obs_term_createFolder_ruler3_valid
                    }, {
                        "rule": function lengthFn(value) {
                            var path = getCurrPath();
                            var folderNameChar=new Buffer(path+value.trim());
                            var folderNameLength=folderNameChar.length;
                            if(folderNameLength>1023){
                                return false;
                            }
                            return true;
                        },
                        "errorMsg": global.langData.obs_term_createFolder_ruler1_valid
                    },{
                        "rule": function followFn(value) {
                            var val = $.trim(value);
                            return val.indexOf("//") === -1;
                        },
                        "errorMsg": global.langData.obs_term_createFolder_ruler2_valid
                    }]

                    // "validator": [{
                    //     rule: function (value) {
                    //         return value.trim().length > 0;
                    //     },
                    //     errorMsg: global.langData.InputFolderName
                    // }, {
                    //     rule: function (value) {
                    //         var parrent = /[<>?:*\\|\"]/g;
                    //         if (parrent.test(value)) {
                    //             return false;
                    //         }
                    //         return true;
                    //     },
                    //     errorMsg: global.langData.inputVerification
                    // }, {
                    //     rule: function (value) {
                    //         var value = $.trim(value);
                    //         if(value.indexOf('.')===0||value.substring(value.length-1,value.length)==='.'||value.indexOf('/')===0 ||value.substring(value.length-1,value.length)==='/' ){
                    //             return false;
                    //         }
                    //         return true;
                    //     },
                    //     errorMsg: global.langData.describe_object_ruleThree
                    // }, {
                    //     rule: function (value) {
                    //         return value.indexOf("//") === -1;
                    //     },
                    //     errorMsg: global.langData.inputVerification3
                    // }, {
                    //     rule: function (value) {
                    //         var path = getCurrPath();
                    //         var folderNameChar=new Buffer(path+value.trim());
                    //         var folderNameLength=folderNameChar.length;
                    //         if(folderNameLength>1023){
                    //             return false;
                    //         }
                    //         return true;
                    //     },
                    //     errorMsg: global.langData.folderNameTooLarge
                    // }]
                }
            };
        }]);

        angular.bootstrap($('#createFolderPage'), ['createFloderModule']);
    });
}
function deleteObjectOK(bucketName, filename, parentPath, nameSize) {
    if ($("#mui-overlay").size() > 0) {
        mui.overlay('off');
    }
    if (bucketName && filename) {
        var prefixSearch = $('#prefixSearch').val();
        var arr = filename.split("|");
        $("#downloadFileName").val('');
        $("#objLists tr.selected-tr-active>td:first-child").find('span').removeClass('show-span-active');
        $("#downloadbtn,#btnDeleteObjects,#recoverBtn").addClass('mui-disabled');
        $("#downloadbtn").attr('data-title', languageJson.selectFileOrFolder);
        if (UCDVersion === "HEC") {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
        }else {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
        }
        $("#objLists tr.selected-tr-active").removeClass('selected-tr-active');
        if (taskManager) {
            taskManager.setPauseAll(false);
            taskManager.abortAll = false;
        }
        showCreateTasksAnimation();//加载新增任务动画效果
        var showMsgTemp = true;
        for (var i in arr) {
            if (arr[i].charAt(arr[i].length - 1) === '/') {
                taskControlAction.deletePath(bucketName, arr[i], '', 0, function (err) {
                    if (err && showMsgTemp) {
                        showMsgTemp = false;
                        $('.mui-model').showErrorMessage({
                            message: languageJson.someObjectDelErr,
                            obsError: obsError("someObjectDelErr")
                        });
                    }
                });
            } else if (arr[i]) {
                taskControlAction.deleteObject(bucketName, arr[i], nameSize[arr[i]]);
            }
        }
    } else {
        $('.mui-model').showMessage({
            type: "info",
            message: languageJson.oneOrMoreDeleteObjcet,
            ok: function () {
                return false;
            },
            title: languageJson.hint
        });
    }
}