﻿var macAdr = require('./js/encryption/getmac');
var needle = require('./node_modules/needle');
var imgPath;
var cok;
var setting = {};

function userCommentLogin(AK,SK)
{
    indexAction.loadSetting(function (configObj) {
        if(configObj) 
        {
        	setting = configObj;
        	if(setting.userExperience == "Y")
            {
            	loginWithMac(AK,SK);
            }
        }
    });
}

function loginWithMac(AK,SK)
{
	macAdr.getMac(function (err, macAddress) {
        if (err)
        {
        	throw err;
        }	
        else 
        {
        	var ip = getLocalIPAddr();
        	
        	var data = {
        			AK: AK,
        	        clientIP: ip,
        	        clientType: "1",
        	        clientMAC: macAddress,
        	        enableMultiUpload : setting.isMultiUpload,
        	        enableMultiDownload : setting.isMultiDownload,
        	        multiUploadNum : setting.multiUploadNum,
        	        multiDownloadNum : setting.multiDownloadNum
        			};

        	var options = {
        		timeout: 50000,
        		rejectUnauthorized:false,
        		headers: {
        			'Content-Type': 'application/json'
        			}
        	};

        	needle.post('https://storage.huaweicloud.com/obsusersurvey/login',data, options, function(err, resp, body){
        		if(resp && resp.cookies){
                    cok = resp.cookies.JSESSIONID;
                }
        		if(err)
        		{
        			logger.error(err);
        		}
        	});
        }
    });
}

function loginWithoutMac(AK,SK)
{
	var data = {
			AK: AK,
	        clientType: "1",
	        enableMultiUpload : setting.isMultiUpload,
	        enableMultiDownload : setting.isMultiDownload,
	        multiUploadNum : setting.multiUploadNum,
	        multiDownloadNum : setting.multiDownloadNum
			};

	var options = {
		timeout: 50000,
		rejectUnauthorized:false,
		headers: {
			'Content-Type': 'application/json'
			}
	};

	needle.post('https://storage.huaweicloud.com/obsusersurvey/login',data, options, function(err, resp, body){
		if(resp && resp.cookies){
            cok = resp.cookies.JSESSIONID;
        }
		if(err)
		{
			logger.error(err);
		}	
	});
}

function getLocalIPAddr()
{ 
    var oSetting = null; 
    var ip = ""; 
    try{ 
        oSetting = new ActiveXObject("rcbdyctl.Setting");
        ip = oSetting.GetIPAddress; 
       if (ip.length == 0){ 
           return ""; 
        } 
        oSetting = null;
       }catch(e){ 
       return ip; 
      } 
      return ip; 
} 

// 显示用户反馈窗口
function showUserCommentWind()
{
	indexAction.loadSetting(function (configObj) {
		
        $("#userCommentDiv").addClass('shown');
        $("#commentContent").val("");
        return false;
    });
	
	$("#userCommentDiv").addClass('shown');
	mui.overlay('on',{"static":true});
	tabFocus("subSysConfig");
}

// 监听上传附件输入框状态
function changeFile(this_)
{
	// 判断图片大小
	var filepath = $('#fileupload').val();
	imgPath = filepath;
	
	if("" != filepath)
	{
		var file_size = 0;
	    file_size = this_.files[0].size;
	    var size = file_size / 1024;
	    if (size > 2 * 1024) 
	    {
	    	$('.mui-model').showMessage({
	    		type:"warning",
	    		message: languageJson.uploadSizeMsg,
	    		ok:function(){
	    			$("#photoCover").val("");
	    	    	$("#fileupload").val("");
	    		},
	    		title:languageJson.warning
	    	});
	    }
	    else
	    {
	    	var filepath = filepath.split("\\");
	        var fileName = filepath[filepath.length - 1];
	        $('#photoCover').val(fileName);
	    }	
	}
}

// 提交用户反馈意见
function saveUserComment()
{
    var commentContent = $("#commentContent").val();
    if("" === commentContent || commentContent.length > 200)
    {
    	$('.mui-model').showMessage({
    		type:"warning",
    		message:languageJson.inputFeedbackMsg,
    		ok:function(){
    		return false;
    		},
    		title:languageJson.warning
    		});
        return false;
    }
    var emailAddress = $("#emailAddress").val();
    var regEmail = /^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/
    var regMobile = /^0?1[3|4|5|7|8][0-9]\d{8}$/;
    var regTel = /^0[\d]{2,3}-[\d]{7,8}$/;
    
    if("" === emailAddress || !regEmail.test(emailAddress))
    {
    	$('.mui-model').showMessage({
    		type:"warning",
    		message:languageJson.emailFormatIsNotRight,
    		ok:function(){
    		return false;
    		},
    		title:languageJson.warning
    		});
        return false;
    }
    var phoneNum = $("#phoneNum").val();

    if("" === phoneNum || (!regMobile.test(phoneNum) && !regTel.test(phoneNum)))
    {
    	$('.mui-model').showMessage({
    		type:"warning",
    		message:languageJson.phoneNumFormatIsNotRight,
    		ok:function(){
    		return false;
    		},
    		title:languageJson.warning
    		});
        return false;
    }
    
    var comment = {
            content : commentContent,
            email : emailAddress,
            phoneNumber : phoneNum
        };
    
    // 判断图片类型
    var filepath = $("#fileupload").val();
    if("" != filepath)
    {
    	var extStart = filepath.lastIndexOf(".");
        var ext = filepath.substring(extStart, filepath.length).toUpperCase();
        if((ext != ".BMP") && (ext != ".PNG") && (ext != ".GIF") && (ext != ".JPG") && (ext != ".JPEG")) 
        {
        	$('.mui-model').showMessage({
        		type:"warning",
        		message: languageJson.uploadTypeMsg,
        		ok:function(){
        			$("#photoCover").val("");
        	    	$("#fileupload").val("");
        		},
        		title:languageJson.warning
        		});
        	return;
        }
    }	
    
	var data = {
	  		  content: encodeURI(commentContent),////needle传输中文有问题，必须先编码后解码
	  		  email: emailAddress,
	  	      phoneNumber : phoneNum,
	  		  image: { file: imgPath, content_type: 'image/png' }
	  		}

	  		var options = {
	  		  multipart: true,
	  		  timeout: 50000,
	  		  rejectUnauthorized:false,
	  		  headers: {
				'Cookie': "JSESSIONID=" + cok
				}
	  		}
	
    document.getElementById("userCommentDiv").style.zIndex = "90";
    
    $('#userCommentDivLoading').show();

    var loading= loadingShow();

	needle.post('https://storage.huaweicloud.com/obsusersurvey/feedback', data, options, function(err, resp, body)
	{
		document.getElementById("userCommentDiv").style.zIndex = "101";
		$('#userCommentDivLoading').hide();
		
		if(loading){
            loading.close();
        }
		
    	cancelUserSurvey();
		
		$('.mui-model').showMessage({
    		type:"info",
    		message:languageJson.submitFeedbackSuccess,
    		ok:function(){
    		},
    		title:languageJson.hintInfo
    		});
		
		if(err)
		{
			logger.error(err);
		}
	});
}

// 用户退出登录
function userCommentLogout(callback)
{
	if(pkg.UCDVersion !== "HEC") {
		callback();
		return;
	}
	var loading= loadingShow();
	
	var data = {
			};

	var options = {
		timeout: 3000,
		rejectUnauthorized:false,
		headers: {
			'Cookie': "JSESSIONID=" + cok
			}
	};

	needle.post('https://storage.huaweicloud.com/obsusersurvey/logout', data, options, function(err, resp, body){
		cok = null;
		callback();
		if(loading){
            loading.close();
        }
		
		if(err)
		{
			logger.error(err);
		}
	});
}

// 关闭用户反馈信息窗口
function cancelUserSurvey()
{
	$("#commentContent").val("");
	$("#emailAddress").val("");
	$("#phoneNum").val("");
	$("#photoCover").val("");
	$("#fileupload").val("");
    $("#userCommentDiv").removeClass('shown');
    mui.overlay('off');
    return false;
}

// 显示用户体验改进计划申明
function userSurveyStatement()
{
    $(".mui-dropdown-menu").removeClass('mui-open');
    $("#userSurveyStatement").addClass('shown');
    mui.overlay('on',{"static":true});
    return false;
}