var AWS = require('../core');
var inherit = AWS.util.inherit;

/**
 * @api private
 */
AWS.Signers.RequestSigner = inherit({
  constructor: function RequestSigner(request) {
    this.request = request;
  }
});

AWS.Signers.RequestSigner.getVersion = function getVersion(version) {
  switch (version) {
    case 'v4': return AWS.Signers.V4;
    case 's3': return AWS.Signers.S3;
  }
  throw new Error('Unknown signing version ' + version);
};

require('./v4');
require('./s3');
require('./presign');
