var IndexAction = require('./js/sdk/indexAction.js');
var BucketAndObjectAction = require('./js/sdk/bucketAndObjectAction.js');
var BucketAttributeAction = require('./js/sdk/bucketAttributeAction.js');
var accountService = require('./js/encryption/accountService.js');
var TaskControlAction = require('./js/sdk/taskControlAction.js');
var invokeTool=require("./js/obsUtils.js").invokeTool;
var accessConnector = require("./js/access/iam/IAMConnector.js");
var Const = require('./js/common/constants.js');
var fs = require('fs');
var async = require('./node_modules/async');
var os = require('os');
var AESTools = require('./js/AESTools');
var TaskManager = require("./js/TaskManager");
var exec = require('child_process').exec;
var pkg = require('../package.json');
var obsError = require('./js/common/ObsError.js');
var i18n_learnMore = require('./js/i18n_learnMore.js');
var commonUtils = require('./js/common/CommonUtils.js');
var gui = require("nw.gui");
var AWS = require('./node_modules/hws-sdk');
//碎片数量
var multipartNum;
//任务完成标识
var isTaskDone = false;
//基本信息配置接口对象
var indexAction = new IndexAction();
//桶和对象操作接口对象
var bucketAndObjectAction;
//桶属性接口对象
var bucketAttributeAction;
//任务管理接口对象
var taskControlAction;

//AWS.S3
var s3;
//任务管理器
var taskManager;
//上一次访问的桶
var lastBucket;
//桶名
var bucketName;
//错误信息配置
var errorConfig = {};
//对象列表分页信息
var pageContext = {};
//碎片管理分页信息
var pageMultipartContext = {};
//对象列表默认页码
pageContext.nowPage = 1;
//碎片管理默认页码
pageMultipartContext.nowPage = 1;
//对象列表默认显示方式
var objectShowWay = "list";
//当前登陆用户ID
var currentUserId;
//当前登陆用户名
global.currentUserName;
//domainID
var ownerId;
//domainName
var ownerName;
//是否启用Https 'Y' or 'N'
var isHttps = 'Y';
//是否启用MD5校验 'Y' or 'N'
global.isMD5check = 'N';
//是否启用证书校验 'Y' or 'N'
var isSSL = 'N';
//是否自动检查升级 'Y' or 'N'
var isAutoUpdate = "Y";
//多段上传配置
var uploadConfig = { maxUploadTasks: 20,
    isMultiUpload: true,
    multiUploadNum: '5',
    maxTps: 15 };
//多段下载配置
var downloadConfig = { maxTaskNum: 20,
    isMultiDownload: true,
    multiDownloadNum: '5'};
//是否多段下载
global.isMultiDownload = true;
//当前语言
var language;
//当前语言配置文件
var languageJson=zh;
//域名信息
var domainName;
//当前选择任务列表
var selected="uploadTaskDiv";
var selectedTable = false;
//当前选择任务状态
var nowstat="";
//单次允许上传对象数量
var uploadFileNumber=500;
//用户类型
var userType ;
//IP端口
var endpoint ;
//默认region
var defaultRegion ;
//签名版本
var signatureVersion ;
//是否登陆成功
var isLoaded = false;
//升级服务器地址
var updateServer;
//是否显示清理垃圾错误信息
var isShowDelRubErrMsg = true;
//是否显示下载文件错误信息
var isShowDownErrMsg = true;
//操作系统类型
var winType = "";
//碎片显示时间
var rubbishDays = 0;
//任务队列
var taskArr = [];
//是否刷新对象列表
var isRefreshObj = false;
//上次刷新对象列表时间
var lastRefresh = false;
//外部桶
var ExtBucket = new Array();
//文件夹列表
var folderList = [];
//排序方式
var objSort = false;
//桶列表排序
var BucketSort = true;
//代理信息
var proxy = {};
//是否登陆UDS成功
var isLoaderUser = false;
//服务端加密标志
global.serverEncryption = false;
//服务端加密KMS秘钥ID
global.serverEncryptionKeyId = "";

//是否开启服务端加密功能
var isShowServerEncryption = false;
//数据加密传输
global.isChunk = false;
//当前桶存储类型
var currBucketStorage = false;

var checkRecoverInterval = false;


//加密模块初始化
global.Tools = new AESTools(lanpath);
//数据库密码
global.newMongoPwd = false;

//account对象列表
global.accountObj = {};

//临时账户信息
var tempAccount = false;

var pwdPlaceHolder="************";

//每页对象列表数量
global.objPerPageSize = 100;
//任务列表显示数量
global.taskShowSize = 100;

//通过fs.createReadStream打开的句柄数
global.filesNum = 0 ;

global.langData = {};

//域名信息
global.domainName;
//当前账号的domainId和名称
global.curOnwerId = "";
global.curDisplayName = "";
global.curRegion = "";

$(function(){
    window.ondragover = function(e) {
        e.stopPropagation();
        e.preventDefault();
        return false
    };
    window.ondrop = function(e) {
        e.stopPropagation();
        e.preventDefault();
        return false
    };
    window.ondragenter = function(e) {
        e.stopPropagation();
        e.preventDefault();
        return false
    };
    selectedTable = $("#"+selected+" table");



    //弹出页面关闭按钮统一处理方法
    $(".mui-page-close1").on('click',function(){
        var href = $(this).attr('data-href');
        if(href){
            $("#"+href).click();
        }else{
            $(this).parent().removeClass('shown');
        }
        return false;
    });

    //对象列表和任务列表切换
    $('.mui-left .item .head').on('click',function(){
        $("#objDiv").toggleClass('current');
        $("#objPanel").toggleClass('current');
        $("#taskDiv").toggleClass('current');
        $("#taskPanel").toggleClass('current');
        if($("#taskPanel").hasClass('mui-active')){
            reloadTasks(true);
        }
        return false;
    });

    //切换桶 左边
    $('.bucketLeftDiv .bucketList .item').delegate('.bucket-item','click',function(){

        $(this).parent().find('.current').removeClass('current');
        $(this).parent().find('li').find('span').removeClass('show-span-active');
        $(this).addClass('current');
        $(this).find('span').addClass('show-span-active');
        var bucketName =$(this).attr('data-href').trim();
        $("#downloadFileName").val("");
        $('#curBucketName').html(bucketName);
        $('#curBucketName').attr('isExt',$(this).find("span").hasClass("mui-icon-ext-bucket"));
        pageContext = {};//重置分页对象
        pageContext.nowPage = 1;
        $("#isSearch").val("");
        $("#prefixSearch").val('');
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#objectNum").html('');
        $("#storageSize").html('');
        $('#objLists tr').each(function(i,item){
            $(item).remove();
        });
        objectOrBucketRetrun(bucketName);//切换到对象列表
    });

    //切换桶 table
    $('#bucketLists tbody').delegate('.list-objs-1','click',function(){

        $("#lsBuckets").find('.current').removeClass('current');
        $("#lsBuckets").find('li').find('span').removeClass('show-span-active');
        var bucketName =$(this).attr('data-href').trim();
        $("#lsBuckets").find('li').each(function () {
            if($(this).attr('data-href').trim() == bucketName){
                $(this).addClass('current');
                $(this).find('span').addClass('show-span-active');
            }
        });
        $("#downloadFileName").val("");
        $('#curBucketName').html(bucketName);
        $('#curBucketName').attr('isExt',$(this).hasClass("mui-icon-extBucket"));
        pageContext = {};//重置分页对象
        pageContext.nowPage = 1;
        $('#objLists-table-section').addClass('mui-hide');
        $("#isSearch").val("");
        $("#prefixSearch").val('');
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#objectNum").html('');
        $("#storageSize").html('');
        $('#objLists tr').each(function(i,item){
            $(item).remove();
        });
        objectOrBucketRetrun(bucketName);//切换到对象列表
    });
    //切换任务列表
    $('.taskLeftDiv .taskTypes').on('click',function(){
        if(!$(this).hasClass('current')){
            $(this).parent().find('.current').removeClass('current');
            $(this).addClass('current');
            taskChecked = false;
            taskCheckedNum = -1;
            selected = $(this).find('span').attr('data-href');
            selectedTable = $("#"+selected+" table");
            $('#'+selected+' tbody').html('');//清空列表

            $("#uploadTaskDiv").addClass('mui-hide');
            $("#downloadTaskDiv").addClass('mui-hide');
            $("#deleteTaskDiv").addClass('mui-hide');
            $("#recoverTaskDiv").addClass('mui-hide');
            $("#uploadTaskDiv tbody").html('');
            $("#downloadTaskDiv tbody").html('');
            $("#deleteTaskDiv tbody").html('');
            $("#recoverTaskDiv tbody").html('');
            $("#"+selected).removeClass('mui-hide');
            reloadTasks(true);
        }
    });
    //桶属性界面展示功能
    $('.mui-icon-more').on('mouseup',function(e){
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        var show = $('#bucketHandle').hasClass('mui-active');
        if(show) {
            $('#bucketHandle').removeClass('mui-active')
        } else {
            hideOtherPop();
            handleExtbucket();//外部桶桶属性按钮隐藏
            $('#bucketHandle').addClass('mui-active').css({
                left: $(this).offset().left,
                top: $(this).offset().top - 29
            });
        }
        return false;
    });
    //用户管理界面展示功能
    $('.btnUserInfo').on('mouseup',function(){
        var userInfoShow = $('.more-user-btns').hasClass('mui-active');
        if(userInfoShow) {
            $('.more-user-btns').removeClass('mui-active');
            $('.btn-account').removeClass('btn-account-unfold');
        } else {
            hideOtherPop();
            hideTaskPop();
            $("#userSearch").focus();
            $('.more-user-btns').addClass('mui-active');
            $('.btn-account').addClass('btn-account-unfold');
        }
        return false;
    });
    //帮助页面、桶属性页面关闭功能实现
    $('#bucketProSure,#helpSure,#helpDtSure').on('click',function(){
        $("#bucketPropertiesTab tbody tr").each(function () {
            $(this).find('td').eq('1').find('span').html('');
        });
        $(".mui-page-full.shown").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    //前缀查询输入回车按钮时执行查询功能
    $("#prefixSearch").on('keyup', function (event) {
        var keyCode = event.keyCode;
        if(keyCode === 13) {
            $(".btnSearch").click();
        }
    });

    //创建桶
    $('.bucket-create').on('click',function(){
        $(".mui-page-full.shown").removeClass('shown');
        $('#btnExBucket').removeAttr('disabled');
        $("#createBucketPage").css('z-index', '1000');
        showOverlay();
        if (userType === '1') {
            $("#bucketRegionDiv").addClass('mui-hide');
            $("#bucketRegionInputDiv").removeClass('mui-hide');
        } else{
            $("#bucketRegionDiv").removeClass('mui-hide');
            $("#bucketRegionInputDiv").addClass('mui-hide');
        }
        $("#createBucketPage").addClass('shown');
        divDragFunc('createBucketPageDrag','createBucketPage');
        // 这里取消创桶输入框的焦点
        return false;
    });

    //新建文件夹界面展示
    $('.mui-icon-newFolder').on('click',function(){
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#createFolderPage").addClass('shown');
        divDragFunc('createFolderPageDrag','createFolderPage');
        $('.more-btns').removeClass('mui-active');
        tabFocus('floderName');
        return false;
    });

    //关于界面展示
    $('#about').on('click',function(){
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#help").addClass('shown');
        //CTC显示ctc网址，隐藏hec网址，隐藏copyright
        if(_.isEqual(UCDVersion,"CTC")){
            $("#ctccloudsWeb").removeClass('mui-hide');
            $("#hwcloudsWeb").addClass('mui-hide');
            $("#versionOwer").html(languageJson.copyright_CTC);
        }
        //CMCC隐藏copyright，有的时候再更换显示
        if(_.isEqual(UCDVersion,"CMCC")){
            $("#versionOwer").addClass('mui-hide');
        }
        //FCS只显示版本
        if(_.isEqual(UCDVersion,"FCS")){
            $("#versionOwer").addClass('mui-hide');
            $("#websiteTr").addClass('mui-hide');
            $("#versionWarning").addClass('mui-hide');
        }
        divDragFunc('helpDrag','help');
        $('.more-btns').removeClass('mui-active');
        return false;
    });

    //海外版本关于界面展示
    $('#aboutDt').on('click',function(){
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#helpDt").addClass('shown');
        divDragFunc('helpDtDrag','helpDt');
        $('.more-btns').removeClass('mui-active');
        return false;
    });
    //系统配置界面展示
    $('#btnSetting').on('mouseup',function(){
        var moreHelpShow = $('.more-help-btns').hasClass('mui-active');
        if(moreHelpShow) {
            $('.more-help-btns').removeClass('mui-active');
        } else {
            hideOtherPop();
            hideTaskPop();
            $('.more-help-btns').addClass('mui-active');
        }
        if(_.isEqual(UCDVersion,"CTC")){
            $("#btnUserSurvey").hide();
            $("#userExperienceDiv").hide();
        }
        if(_.isEqual(UCDVersion,"CMCC")){
            $("#btnUserSurvey").hide();
        }
        if(_.isEqual(UCDVersion,"FCS")){
            $("#btnUserSurvey").hide();
            $("#checkUpdate").hide();
            $("#isAutoUpdate").parent().hide();
            $("#userExperienceDiv").hide();
        }
        return false;
    });

    //调整几个浮动界面位置。
    $(window).on('mouseup',function(){
        if(!$("#userSearch").is(":focus")&&!$("#userSearch").val()){
            hideOtherPop();
        }
    });
    $("#userSearch").on('keyup', function (ev) {//控制输入时清除按钮的显示隐藏
        var value = $(this).val();
        if (value.length > 0) {
            $("#clearAccountInput").removeClass("mui-hide");
        } else {
            $("#clearAccountInput").addClass("mui-hide");
        }
        if(ev.keyCode === 13){
            $(".searchAccount").click();
        }
    });
    $("#clearAccountInput").on("click",function () {//清除搜索值
        $("#userSearch").val("");
        $(".NoAccount").addClass('mui-hide');
        $("#clearAccountInput").addClass("mui-hide");
        $("#userList").find("ul").children().show()
    });
    $(".searchAccount").on("click",function () {//搜索
        $("#userList").find("ul").children().show();
        var queryNothing = true;
        var keyVal = $("#userSearch").val().trim().toLowerCase();
        var userList = $("#userList").find("ul").children();
        for (var i = 0; i < userList.length; i++) {
            var accountName = $(userList[i]).find("a.user").attr("data-href").toLowerCase();
            if (!accountName) {
                continue;
            } else if (accountName.indexOf(keyVal) == -1) {
                $(userList[i]).hide();
            } else {
                queryNothing = false;
            }
        }
        if (queryNothing) {
            $(".NoAccount").removeClass("mui-hide");
        } else {
            $(".NoAccount").addClass("mui-hide");
        }

    });
    function hideTaskPop() {
        $("#taskPanel").removeClass('mui-active');
        $("#taskDivHead").removeClass('triangle-up');
        $("#taskOverlay").addClass('mui-hide');
    }
    $("#userSearch").on('focus', function () {
        $(".userSearchLi").addClass('dtColor');
    });
    $("#userSearch").on('blur', function () {
        $(".userSearchLi").removeClass('dtColor');
    });
    function hideOtherPop() {
        $('.more-btns,.more-user-btns,.more-help-btns,.task-status-check').removeClass('mui-active').removeClass('mui-active-object');
        $('.btn-account').removeClass('btn-account-unfold');
        $('.help-tips').removeClass('active');
        $('.help-tips').html('');
        $('.help-tips').css('top','-650px');
        $('.task-status-check').css('top','-1440px');
    }

    //鼠标移入note图标后显示提示信息界面
    $('.mui-icon-note1').on('mouseover',function(e){
        var hf = $(this).attr('data-href');
        if(hf && $(hf).size() === 1){
            $('.help-tips').html($(hf).html());
        }
        $('.help-tips').addClass('active');
        var bodyW = $('body').width();
        var bodyH = $('body').height();
        var tipsW = $('.help-tips').width();
        var tipsH = $('.help-tips').height();
        var pageX = e.pageX;
        var pageY = e.pageY;
        if(bodyW-pageX<tipsW&&bodyH-pageY<tipsH+20){
            $('.help-tips').css({left:bodyW-tipsW-10,top:bodyH-tipsH-20});
        }else if(bodyW-pageX<tipsW&&bodyH-pageY>tipsH+20){
            $('.help-tips').css({left:bodyW-tipsW-10,top:(pageY+15)});
        }else if(bodyW-pageX>tipsW&&bodyH-pageY<tipsH+20){
            $('.help-tips').css({left:pageX,top:bodyH-tipsH-20});
        }else{
            $('.help-tips').css({left:pageX,top:(pageY+15)});
        }
        $('.more-user-btns').removeClass('mui-active');
        $('.task-status-check').removeClass('mui-active').css('top','-1440px');
        return false;
    });
    $('.mui-icon-note').on('mouseover',function(e){
        var hf = $(this).attr('data-href');
        if(hf && $(hf).size() === 1){
            $('.help-tips').html($(hf).html());
        }
        $('.help-tips').addClass('active');
        var bodyW = $('body').width();
        var bodyH = $('body').height();
        var tipsW = $('.help-tips').width();
        var tipsH = $('.help-tips').height();
        var pageX = e.pageX;
        var pageY = e.pageY;
        if(bodyW-pageX<tipsW&&bodyH-pageY<tipsH+20){
            $('.help-tips').css({left:bodyW-tipsW-10,top:bodyH-tipsH-20});
        }else if(bodyW-pageX<tipsW&&bodyH-pageY>tipsH+20){
            $('.help-tips').css({left:bodyW-tipsW-10,top:(pageY+15)});
        }else if(bodyW-pageX>tipsW&&bodyH-pageY<tipsH+20){
            $('.help-tips').css({left:pageX,top:bodyH-tipsH-20});
        }else{
            $('.help-tips').css({left:pageX,top:(pageY+15)});
        }
        $('.more-user-btns').removeClass('mui-active');
        $('.task-status-check').removeClass('mui-active').css('top','-1440px');
        return false;
    });

    //鼠标移出note图标后显示提示信息界面
    $('.mui-icon-note').on('mouseout',function(e){
        $('.help-tips').removeClass('active');
        $('.help-tips').css('top','-650px');
    });
    $('.mui-icon-note1').on('mouseout',function(e){
        $('.help-tips').removeClass('active');
        $('.help-tips').css('top','-650px');
    });

    var move2task = function(){
        var m= $('.move');
        m.css({opacity:1});
        setTimeout(function(){
            m.css({left:'120px',bottom:'5px'});
        },100);
        setTimeout(function(){
            m.css({opacity:0});
        },900);
    };
    $('.move-task').on('mouseup',function(e){
        var m= $('.move');
        m.css({left: (e.pageX-10)+'px',bottom: (window.innerHeight - e.pageY-15)+'px'});
        setTimeout(move2task,900);
    });
    //外部桶碎片管理
    $("#bucketLists tbody").delegate('.mui-icon-handel-multipart','click',function(){
        $(this).parent().parent().click();
        setTimeout(function () {
            $('.btnListMultipart').click();
        },10);
    });
    //碎片管理界面展示
    $(".btnListMultipart").on('click', function () {
        if(_.isEqual(UCDVersion,"HEC")){
            $("#multipartKnowMore").hide();
        }
        if(_.isEqual(UCDVersion,"CTC")){
            $("#multipartKnowMore").hide();
        }
        if(_.isEqual(UCDVersion,"CMCC")){
            $("#multipartKnowMore").hide();
        }
        if(isHasSelectBucket()){//判断是否选择桶
            return false;
        }
        var bucket = $('#curBucketName').html();
        //请求桶，报错则提示，点击OK刷新，请求正常则显示碎片管理界面
        bucketAttributeAction.headBucket(bucket, function (err, results) {
            if (err&&err.code === "NoSuchBucket") {
                showOverlay();
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message),
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        $("#all-refresh-div").click();
                        return false;
                    }
                });
            } else {
                $(".mui-page-full.shown").removeClass('shown');
                $("#multipartPage").addClass('shown');
                divDragFunc('multipartPageDrag','multipartPage');
                $("#multipartTab tbody").html("");
                pageMultipartContext.nowPage = 1;
                var data = {};
                data.pageMultipartContext = pageMultipartContext;
                data.arr = [];
                data.rubbishDays = rubbishDays;
                var loading = loadingShow();
                $("#multipartPage").css('z-index', '90');

                //获取桶碎片信息
                bucketAndObjectAction.listMultipartUploads($('#curBucketName').html(),'','','','', function (err,data) {
                    if(err){
                        $("#deleteMultipart").addClass('mui-hide');//获取不到时隐藏清除碎片按钮
                    };
                    loading.close();
                    $("#multipartPage").css('z-index', '1000');
                    showOverlay();
                    listMultiparUploadsUI(err,data,$('#curBucketName').html());
                },data);
                return false;
            }
        });
    });

    //碎片下拉刷新
    $("#multipartDiv").scroll(function(){
        var viewH =$(this).height();//可见高度
        var contentH =$(this).get(0).scrollHeight;//内容高度
        var scrollTop =$(this).scrollTop();//滚动高度

        if(contentH - viewH ===  scrollTop) {
            if(pageMultipartContext.refresh){
                var data = {};
                data.pageMultipartContext = pageMultipartContext;
                data.arr = [];
                data.rubbishDays = rubbishDays;
                pageMultipartContext.refresh = false;
                bucketAndObjectAction.listMultipartUploads($('#curBucketName').html(),'',pageMultipartContext.NextKeyMarker,pageMultipartContext.NextUploadIdMarker,pageMultipartContext.nowPage, function (err,data) {
                    listMultiparUploadsUI(err,data,$('#curBucketName').html());
                },data);
            }
        }
    });

    //删除单个碎片功能
    $("#multipartTab tbody").delegate('.mui-icon-account-clear', 'click', function () {
        var curBucket = $('#curBucketName').html();
        var id = $(this).attr("data-id");
        var key = $(this).attr("data-key");
        $('.mui-model').showMessage({
            type: "warning",
            message: languageJson.isDeleteMultipart,
            isFocus: true,
            ok: function () {
                //删除选择的碎片
                bucketAndObjectAction.abortMultipartUpload(curBucket, id, key,false,function (err,data){
                    if(err){
                        logger.error(err);
                        $("#multipartTab tbody").html('');
                        pageMultipartContext.nowPage = 1;
                        var data = {};
                        data.pageMultipartContext = pageMultipartContext;
                        data.arr = [];
                        data.rubbishDays = rubbishDays;
                        $("#deleteMultipart").addClass('mui-hide');
                        bucketAndObjectAction.listMultipartUploads(curBucket,'','','','', function (err,data) {
                            listMultiparUploadsUI(err,data,curBucket);
                        },data);
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code,err.message)
                            });
                        }
                    }else{
                        $('.mui-model').showMessage({
                            type:"info",
                            message:CommonUtils.format(languageJson.obs_term_bucketFragment_delFragmentSuccess_msg, CommonUtils.encodeForHTML(CommonUtils.substr32(key))),
                            ok:function(){
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                                return false;
                            },
                            title:languageJson.hintInfo
                        });
                        $("#multipartTab tbody").html('');
                        pageMultipartContext.nowPage = 1;
                        $("#deleteMultipart").addClass('mui-hide');
                        var data = {};
                        data.pageMultipartContext = pageMultipartContext;
                        data.arr = [];
                        data.rubbishDays = rubbishDays;
                        $("#deleteMultipart").addClass('mui-hide');

                        //删除完成后刷新碎片管理界面
                        bucketAndObjectAction.listMultipartUploads(curBucket,'','','','', function (err,data) {
                            listMultiparUploadsUI(err,data,curBucket);
                        },data);
                        showOverlay();
                    }
                });
            },
            cancel: function () {
                return false;
            },
            title: languageJson.obs_term_bucketFragment_delFragment_wintitle
        });
    });

    //清理所有碎片功能
    $("#deleteMultipart").on('click', function () {
        $('.mui-model').showMessage({
            type: "warning",
            message: languageJson.isDeleteAllMultipart,
            isFocus: true,
            ok: function () {
                isShowDelRubErrMsg = true;
                pageMultipartContext.nowPage = 1;
                $("#multipartPage").css('z-index', '90');
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                var option = {};
                option.timeout = 300000;
                var loading = loadingShow();

                //调用删除所有碎片接口
                bucketAndObjectAction.deleteAllMultipartUploads($('#curBucketName').html(), '', '', '', function (err,data) {
                    $("#multipartPage").css('z-index', '1000');
                    loading.close();
                    if(err){
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: languageJson.deleteAllMultipartErr + ' ' + ( obsError(err.code,err.message) ? obsError(err.code).description : errorConfig[err.code] ),
                                ok: function () {
                                    return false;
                                }
                            });
                        }
                    } else {
                        $('.mui-model').showMessage({
                            type: "info",
                            message: languageJson.obs_term_bucketFragment_delAllFragmentSuccess_msg,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.hintInfo
                        });
                        pageMultipartContext.nowPage = 1;
                        $("#multipartTab tbody").html('<div class="dialog-table-nodata"><span>' + languageJson.noData + '</span></div>');
                        $("#deleteMultipart").addClass('mui-hide');
                    }
                    showOverlay();
                },'',rubbishDays);
            },
            cancel: function () {
                return false;
            },
            title: languageJson.obs_term_bucketFragment_delFragment_wintitle
        });
    });

    //选择某一行碎片
    $("#multipartTab tbody").delegate('tr', 'click', function () {
        $("#multipartTab tbody tr td span").removeClass('show-span-active');
        var self = this;
        $(self).parent().children().removeClass("selected-tr-active");
        $(self).addClass("selected-tr-active");
        $(self).find('td').find('.mui-ellipsis-multipart').toggleClass('show-span-active');
    });
    $("#multipartTab tbody").bind('click',function(){
        return false;
    });
    $("#multipartTab tbody").bind('contextmenu',function(){
        return false;
    });
    // 碎片列表div 点击左键取消选择
    $("#multipartDiv").bind('click',function(){
        $("#multipartTab tbody tr").removeClass('selected-tr-active');
        $("#multipartTab tbody tr").find(".mui-ellipsis-multipart").removeClass('show-span-active');
        return false;
    });
    // 碎片列表div 点击右键取消选择
    $("#multipartDiv").bind('contextmenu',function(){
        $("#multipartTab tbody tr").removeClass('selected-tr-active');
        $("#multipartTab tbody tr").find(".mui-ellipsis-multipart").removeClass('show-span-active');
        return false;
    });

    //刷新碎片管理界面
    $("#refreshMultipart").on('click', function () {
        pageMultipartContext.nowPage = 1;
        $("#multipartTab tbody").html("");
        $("#deleteMultipart").addClass('mui-hide');
        var data = {};
        data.pageMultipartContext = pageMultipartContext;
        data.arr = [];
        data.rubbishDays = rubbishDays;
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var loading = loadingShow();
        $("#multipartPage").css('z-index', '90');
        bucketAndObjectAction.listMultipartUploads($('#curBucketName').html(),'','','','', function (err,data) {
            loading.close();
            $("#multipartPage").css('z-index', '1000');
            showOverlay();
            listMultiparUploadsUI(err,data,$('#curBucketName').html());
        },data);
    });


    //关闭碎片列表
    $("#cancelMultipart").on('click', function () {
        $("#multipartPage").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
    });

    //刷新桶
    $('.btnRefresh').on('click', function () {
        var bucket = $('#curBucketName').html();
        if (window.require) {
            var loading = loadingShow();
            bucketAndObjectAction.listBucket(function (err, data) {
                listBucketUI(err, data,loading,bucket)
            });
        }
        return false;
    });

    $("#all-refresh-div").on('click', function () {
        if (window.require) {
            var loading = loadingShow();
            bucketAndObjectAction.listBucket(function (err, data) {
                if($("#objectArea").hasClass('mui-hide')){//界面停留在桶列表，则只刷新桶
                    listBucketUI(err, data,loading);
                }else{
                    var bucketName = $('#curBucketName').text().trim();
                    var curPath = getCurrPath();
                    if(bucketName===curPath){
                        curPath = '';
                    }
                    // 如果是搜索过的对象列表，只刷新搜索的列表
                    if ($("#isSearch").val()) {
                        var prefix = $("#prefixSearch").val();
                        prefix = curPath + prefix;
                        bucketAndObjectAction.listObject(bucketName, 'true', prefix, function (err, data) {
                            listObjectUI(err, data, bucketName);
                            loading.close();
                        },pageContext['page'+pageContext.nowPage]);
                    } else {
                        bucketAndObjectAction.listObject(bucketName, 'true', curPath, function (err, data) {
                            listObjectUI(err, data, bucketName);
                            loading.close();
                        },pageContext['page'+pageContext.nowPage]);
                    }
                }
            });
        }
        return false;
    });

    //打开账户列表管理界面
    $("#userList").delegate('li a.manager','click',function(){
        $("#clearAccountInput").click();
        hideOtherPop();
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#accountList").addClass('shown');
        //FCS局点隐藏下面的链接
        if(_.isEqual(UCDVersion,"FCS")){
            $("#FCS").parent().addClass('mui-hide');
        }
        divDragFunc('accountListDrag','accountList');
    });

    //编辑账户信息
    $('#accountList').delegate('.mui-icon-account-edit','click',function(){
        var self=this;
        var accId = $(self).attr('data-id');
        $("#createAccount .mui-page-full-title").html(languageJson.editAccount);
        $("#createAccount").find("h5").first().addClass("mui-hide");
        //获取需要编辑的账户信息
        accountService.getAccountInfo(accId, function (result) {
            var href= $(self).attr('data-href');
            $("#accountList").css('z-index','90');
            $("#createAccountTab").removeClass('mui-hide');
            $("#"+href).addClass('shown');
            if(!result){
                $('.mui-model').showErrorMessage({
                    type:'error',
                    message: languageJson.getConfigInfoErr,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.errorMessage
                });
                return false;
            }
            $("#name").val(result.name);
            $("#accessKey").val(result.accessKey);
            $("#selType").val(result.type);
            $("#selType").selectmenu('refresh', true);
            if(result.type.toString().trim()==='1'){
                $("#endpointDiv").addClass('mui-hide');
            }else{
                $("#endpointDiv").removeClass('mui-hide');
                $("#endpoint").val(result.endpoint);
            }
            if(result.secretKey){
                $("#secretKey").val(result.secretKey);
                $("#secretKey").next().val(pwdPlaceHolder);
                $("#isSaveSK").get(0).checked = true;
            }else{
                $("#isSaveSK").get(0).checked = false;
            }
            $("#userId").val(result.userID);
        });
        divDragFunc('createAccountDrag','createAccount');
        return false;
    });



    $("input[type='number']").bind('input propertychange', function() {
        var self = this;
        var max = new Number($(self).attr('max'));
        var min = new Number($(self).attr('min'));
        var val = new Number($(self).val());
        $(self).val(val);
        if(val >= max) {
            $(self).val(max)
        }
    });

    /*
     限制number只能输入数字
     */
    $("input[type='number']").on('keypress', function (event) {
        var keyCode = event.keyCode;
        if (keyCode <= 47 || keyCode >= 58) {
            return false;
        }
    });
    /*
     限制number不能小于最小值
     */
    $("input[type='number']").on('blur', function (event) {
        if($(this).val() == '') {
            if($(this).attr('min')) {
                $(this).val($(this).attr('min'));
            } else {
                $(this).val('');
            }
        }else {
            if($(this).attr('min') && +$(this).val() < +$(this).attr('min')) {
                $(this).val($(this).attr('min'));
            }
        }
    });
    /*
     限制前缀查询不能输入/
     */

    //删除账户信息
    $('#accountList').delegate('.mui-icon-account-del', 'click', function () {
        var self = this;
        var accId = $(self).attr('data-id');
        var formHtml = '';
        formHtml += languageJson.isDeleteAccount;
        $('.mui-model').showMessage({
            type: "warning",
            message: formHtml,
            isFocus: true,
            ok: function (model) {
                accountService.deleteAccountInfo(accId, function (result) {
                    if(result==='clear'){
                        $('.btnUserInfo').addClass('userNoLogin');//删除账户,置灰图标
                        allButtonChange('1');
                        clearBucketLists();
                    }
                    getAccountListInfo(function (Id) {
                        if(result==='nextUser'){
                            currentUserId = Id;
                            isLoaderUser = true;
                            $("#objLists tbody").find('tr').each(function () {//清空对象列表（列表方式）
                                $(this).remove();
                            });
                            $("#lsBuckets").html('');
                            $("#isSearch").val("");
                            $("#prefixSearch").val('');
                            $("#clearPrefixSearchInput").addClass("mui-hide");
                            $("#objectNum").html('');
                            $("#storageSize").html('');
                            $("#downloadFileName").val("");
                            selectedTable.find('tbody').html('');
                            $('#taskNum').html(0);
                            $("#path").html('');
                            $("#taskNumberShowDiv").removeClass('taskNumShow');
                            clearBucketLists();
                        }
                    });
                },'',currentUserId);
                return false;
            },
            cancel: function () {
                return false;
            },
            title: languageJson.deleteAccount
        });
    });

    //是否开启https功能判断
    $("#isHttps").on("click",function(){
        if($("#isHttps").is(":checked")) {
            if(isHttps==="N"&&userType!=='1'){
                $('.mui-model').showMessage({
                    type:"warning",
                    message:languageJson.isSureUseHttps,
                    ok:function(model){
                        return false;
                    },
                    title:languageJson.warning
                });
            }
            $("#isSSL").attr("disabled",false);
            $("#isSSL").next().removeClass("ti-text-muted");
            $("#serverEncryption").attr("disabled",false);
            $("#serverEncryption").next().removeClass("ti-text-muted");
        }else{
            $("#serverEncryption").removeAttr('checked');
            $("#serverEncryption").next().addClass("ti-text-muted");
            $("#serverEncryption").attr("disabled",true);
            $("#isSSL").removeAttr('checked');
            $("#isSSL").next().addClass("ti-text-muted");
            $("#isSSL").attr("disabled",true);
            if(isHttps==="Y"){
                $('.mui-model').showMessage({
                    type:"warning",
                    message:userType==='2'?languageJson.isSureUseHttp1:languageJson.isSureUseHttp,
                    ok:function(model){
                        return false;
                    },
                    title:languageJson.warning
                });
            }
        }
    });
    //关闭账户列表
    $("#saveAccount,#cancelAccount").on('click', function () {
        $("#accountList").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        setTimeout(function () {
            if(isLoaderUser){
                isLoaderUser = false;
                getAccountListInfo(function (Id) {
                    var trs = $("#accountTab tbody").find('tr').length;
                    if(taskControlAction){
                        taskControlAction.abortAllTasks(function () {
                            if(taskManager){
                                taskControlAction.closeInterval();
                            }
                            if(trs===2){
                                loaderUser(Id,true,tempAccount);
                                tempAccount = false;
                            }else{
                                loaderUser(Id);
                            }
                        });
                    }else{
                        if(trs===2){
                            loaderUser(Id,true,tempAccount);
                            tempAccount = false;
                        }else{
                            loaderUser(Id);
                        }
                    }
                });
            }
        },50);
    });
    $('#btnAddAccount').on('click',function(){
        $("#createAccount .mui-page-full-title").html(languageJson.addAccount);
        $("#createAccount").find("h5").first().removeClass("mui-hide");
        var trs = $("#accountTab tbody").find('tr').length;
        if(trs===1){
            //标注关闭用户管理界面后是否重新登陆用户
            isLoaderUser = true;
        }
        $("#selType").val('1');
        $("#selType").selectmenu('refresh', true);
        $("#endpointDiv").addClass('mui-hide');
        if(trs>50){
            $('.mui-model').showMessage({
                type:"warning",
                message:languageJson.notMoreThan50Account,
                ok:function(){
                    return false;
                },
                title:languageJson.warning
            });
            return false;
        }
        var self=this;
        var href= $(self).attr('data-href');
        $("#accountList").css('z-index','90');
        $("#createAccountTab").removeClass('mui-hide');
        $("#"+href).addClass('shown');
        divDragFunc('createAccountDrag','createAccount');
        tabFocus("name");
        return false;
    });

    $("#selType").on('change', function () {
        if ('1' === $(this).val()) {
            $("#endpointDiv").addClass('mui-hide');
        } else {
            $("#endpointDiv").removeClass('mui-hide');
        }
    });


    /*
     新增/修改用户信息
     */
    $('#saveAccountBtn').on('click', function () {
        var name = $("#name").val();
        var accessKey = $("#accessKey").val();
        var selType = $("#selType").val();
        var secretKey=$("#secretKey").next().val();
        if (secretKey === pwdPlaceHolder) {
            secretKey = $("#secretKey").val();
        }
        var userId = $("#userId").val();
        var endpoint = $("#endpoint").val();
        var jsonObj = {};
        endpoint = endpoint.replace(/\s/g, "");
        name = name.replace(/\\/g, "/");
        accessKey = accessKey.replace(/\\/g, "/");
        secretKey = secretKey.replace(/\\/g, "/");
        endpoint = endpoint.trim();
        endpoint = endpoint.replace(/\\/g, "/");
        jsonObj.name = name;
        jsonObj.accessKey = accessKey.trim();
        jsonObj.secretKey = secretKey.trim();
        jsonObj.type = selType;
        endpoint = endpoint.replace(/[:]{2,}/g,":");
        if (selType === "2") {
            jsonObj.endpoint = endpoint;
        }else{
            jsonObj.endpoint = domainName;
        }
        indexAction.saveOrModifyAccountCheck(jsonObj,languageJson, userId, function(err){
            if(err){
                $('.mui-model').showMessage({
                    type:"warning",
                    message:err,
                    ok:function(model){
                        return false;
                    },
                    title:languageJson.warning
                });
            }else{
                if(!$("#isSaveSK").is(":checked")){
                    jsonObj.isSaveSK = false;
                }else{
                    jsonObj.isSaveSK = true;
                }
                jsonObj.name = name.trim();
                var trs = $("#accountTab tbody").find('tr').length;
                if(trs==1&& !jsonObj.isSaveSK){
                    tempAccount = jsonObj;
                }
                indexAction.createOrModifyUser(accountService,userId, jsonObj, function (err) {
                    if(err){
                        global.logger.info('create account error');
                    }else{
                        if(userId==currentUserId){
                            global.currentUserName = name.trim();
                            // 登录过，刷新当前列表
                            $("#clearAccountInput").click();
                            var href = name.trim();
                            if(hasRunning() || $('.mui-header .controls a.btnTaskManage').hasClass('running')){
                                var msg = languageJson.changeAccountWithTask;
                                hasMovingTask(function(err, data){
                                    if(data > 0){
                                        msg = languageJson.obs_switchUser_check_move_task_confirm;
                                    }
                                    $('.mui-model').showMessage({
                                        type: "warning",
                                        message: msg,
                                        ok: function () {
                                            isLoaded = false;
                                            $('.btnUserInfo').addClass('userNoLogin');
                                            var showName = encoderForHtml(href).length>20?encoderForHtml(href).substring(0,20)+"...":encoderForHtml(href);
                                            var str = '<span title="'+ encoderForHtml(href) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                                            $(".btnUserInfo").html(str);
                                            if(taskControlAction){
                                                taskControlAction.pauseAllTasks(function(){
                                                    if(taskManager){
                                                        taskControlAction.closeInterval();
                                                    }
                                                    taskControlAction.updateIteratorsObject(false);
                                                    changeUserUI(userId);
                                                });
                                            }else{
                                                changeUserUI(userId);
                                            }
                                            if ($("#mui-overlay").size() > 0) {
                                                mui.overlay('off');
                                            }
                                        },
                                        cancel: function () {
                                            if ($("#mui-overlay").size() > 0) {
                                                mui.overlay('off');
                                            }
                                            return false;
                                        },
                                        title: languageJson.warning
                                    });
                                    showOverlay();
                                })

                            }else{
                                if(taskControlAction){
                                    taskControlAction.updateIteratorsObject(false);
                                }
                                isLoaded = false;
                                $('.btnUserInfo').addClass('userNoLogin');
                                var showName = encoderForHtml(href).length>20?encoderForHtml(href).substring(0,20)+"...":encoderForHtml(href);
                                var str = '<span title="'+ encoderForHtml(href) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                                $(".btnUserInfo").html(str);
                                if(taskControlAction){
                                    taskControlAction.pauseAllTasks(function(){
                                        if(taskManager){
                                            taskControlAction.closeInterval();
                                        }
                                        changeUserUI(userId);
                                    });
                                }else{
                                    changeUserUI(userId);
                                }
                            }
                        }
                    }
                    $('#createAccount input').each(function () {
                        $(this).val('');
                    });
                    $("#accountList").css('z-index','1000');
                    $("#createAccount").removeClass('shown');
                    $("#createAccountTab").addClass('mui-hide');
                    var self = $('#saveAccountBtn');
                    var edit = $(self).attr('data-edit');
                    if('true' === edit){
                        currentUserId = userId;
                    }
                    getAccountListInfo(function(e){
                        var href = $(self).attr('data-href');
                        var init = $(self).attr('data-init');
                        if ('true' === init) {
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            loaderUser('',true,jsonObj);
                            $(self).removeAttr('data-init');
                        }else if ('true' === edit) {
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            loaderUser(userId,true,jsonObj);
                            $(self).removeAttr('data-edit');
                        }
                        $("#isSaveSK").get(0).checked = true;
                    },true);
                });
                return false;
            }
        });

    });

    //进入子目录
    $("#objLists tbody").delegate('.folder .list-objs-1','click',function(event){
        if(event.ctrlKey || event.shiftKey){
            return true;
        }
        $(".mui-dropdown-menu").removeClass('mui-open');
        var self=this;
        checked = false;
        pageContext = {};//重置分页对象
        pageContext.nowPage = 1;

        var bucketName = $('#curBucketName').html();

        var parentPath = getCurrPath();
        var folderName =JSON.parse($(self).parent().parent().find('.hiddenObjData').text()).name;//取第五列的数据
        folderName = folderName.substring(parentPath.length,folderName.length-1);//去掉folderName最后的/
        var currPath = parentPath+folderName+'/';

        $("#isSearch").val("");
        $("#prefixSearch").val('');
        $("#clearPrefixSearchInput").addClass("mui-hide");
        var loading = loadingShow();
        bucketAndObjectAction.listObject(bucketName,'true',currPath, function (err,data) {
            loading.close();
            if(!err && data && (data.Contents.length > 0 || data.CommonPrefixes.length > 0 )){
                var htmStrObj = {
                    currPath: encoderForHtml($(self).parent().parent().find('.hiddenObjData').text()),
                    folderName: encoderForHtml(folderName)
                }
                var htmStr = '<a class="mui-ellipsis-1" data-value="'+ htmStrObj.currPath +'" folderName="'+ htmStrObj.folderName +'">'+ htmStrObj.folderName +'<span style="display:none">'+ htmStrObj.currPath +'</span></a>';
                var divPath = $("#path");
                if($("#path a").length> Const("NAVI_COUNT")){
                    $("#path a").each(function () {

                    });
                }
                divPath.append(htmStr);
                var arr = $("#path").children();
                var leng = arr.length;
                if(arr.length>Const("NAVI_COUNT"))
                {
                    for(var i=0;i<arr.length-Const("NAVI_COUNT");i++) {
                        $(arr[i]).addClass('mui-hide');
                    }
                    $(arr[leng - Const("NAVI_COUNT")]).addClass('content');
                }
            } else {
                $("#all-refresh-div").click();
                loading.close();
                return;
            }
            listObjectUI(err,data,bucketName);
            loading.close();
        });
        return false;
    });

    //回退按钮
    $("#all-back-div").on('click',function(){
        var index = $("#path").children().length - 2;
        if(index == -1) {
            //返回桶列表
            $("#bread-path-box-bucket").click();
        } else if(index == -2) {
            global.logger.info("Reach root, disable back")
        } else {
            $($("#path").children()[index]).click()
        }
    })
    //上一页
    $('#objLists-previous').on('click',function(){
        if(pageContext.upRefresh){
            pageContext.upRefresh = false;
            pageContext.nowPage = pageContext.nowPage-1;
            listMoreObjects(pageContext);
        }
        $(this).blur();
    });
    //下一页
    $('#objLists-next').on('click',function(){
        if(pageContext.refresh){
            pageContext.refresh = false;
            pageContext.upRefresh = false;
            pageContext.nowPage = pageContext.nowPage+1;
            listMoreObjects(pageContext);
        }
        $(this).blur();
    });
    function listMoreObjects(pageContext) {
        var marker = pageContext["page"+pageContext.nowPage];
        var bucketName = $('#curBucketName').html();
        var isSearch = $('#isSearch').val();
        var path = getCurrPath();
        var prefixPath = isSearch ? path + $("#prefixSearch").val() : path;
        var loading = loadingShow();
        bucketAndObjectAction.listObject(bucketName, 'true', prefixPath, function (err, data) {
            setTimeout(function () {
                var isLastPage = false;
                if(!data.IsTruncated) {//如果没有下一页，则将数据追加在当前页的后面
                    isLastPage = true;
                }
                listObjectUI(err, data, bucketName, false, isLastPage);
                loading.close();
                $("#listObjBodyDiv").scrollTop(10);
            }, 1500)
        }, marker);
    }

    //在线帮助
    $('#hwcloudsWeb').on('click', function (e) {
        $(".mui-dropdown-menu").removeClass('mui-open');
        var gui = require('nw.gui');
        if(language==='zh'){
            gui.Shell.openExternal($(this).attr('href'));
        }else{
            gui.Shell.openExternal($(this).attr('data-href'));
        }
        return false;
    });

    //在线帮助
    $('#dtloudsWeb').on('click', function (e) {
        $(".mui-dropdown-menu").removeClass('mui-open');
        var gui = require('nw.gui');
        if(language==='zh'){
            gui.Shell.openExternal($(this).attr('href'));
        }else{
            gui.Shell.openExternal($(this).attr('data-href'));
        }
        return false;
    });

    //隐私政策
    $('.privacyPlicy').on('click', function (e) {
        $(".mui-dropdown-menu").removeClass('mui-open');
        var gui = require('nw.gui');
        gui.Shell.openExternal($(this).attr('href'));
        return false;
    });

    //点击路径
    $("#path").delegate('a','click',function() {
        var self = this;
        if($(self).index() === $("#path").find('a').length - 1){
            return;
        }
        var bucketName = $('#curBucketName').text().trim();
        var curPath = JSON.parse($(self).children().text()).name || '';
        var isNext = false;
        //删除后面的节点
        $(self).parent().find('a').each(function () {
            $(this).removeClass('mui-hide').removeClass('content');
            if (!isNext && JSON.parse($(this).children().text()).name === curPath) {
                isNext = true;
            }
            else if (isNext) {
                $(this).remove();
            }
        });
        if(bucketName===curPath){
            curPath = '';
        }
        var arr = $("#path").children();
        var leng = arr.length;
        if(arr.length>Const("NAVI_COUNT"))
        {
            for(var i=0;i<arr.length-Const("NAVI_COUNT");i++) {
                $(arr[i]).addClass('mui-hide');
            }
            $(arr[leng-Const("NAVI_COUNT")]).addClass('content');
        }
        $("#isSearch").val("");
        $("#prefixSearch").val('');
        $("#clearPrefixSearchInput").addClass("mui-hide");
        var loading = loadingShow();
        pageContext = {};//重置分页对象
        pageContext.nowPage = 1;
        bucketAndObjectAction.listObject(bucketName,'true',curPath, function (err,data) {
            listObjectUI(err, data,bucketName);
            loading.close();
        });
        return false;
    });

    function initProjectListPage() {
        var bucket = $('#curBucketName').html();
        var bucketLocation = "";
        var obsVersion = "not support muti-project";
        bucketAttributeAction.headBucket(bucket, function (err, results) {
            if (err) {
                global.logger.warn("init projects headbucket err",err)
            } else {
                // 非3.0的桶，支持多project
                bucketLocation = results.LocationConstraint;
                global.curRegion = bucketLocation;
                if(results.ObsVersion){
                    // 暂不支持多project 需要注释掉以下代码
                    //obsVersion = results.ObsVersion;
                    global.logger.info("The bucket version is "+results.ObsVersion);
                }else {
                    global.logger.info("The bucket version is not 3.0.")
                }
                accessConnector.projectCache = []; //project 列表
                accessConnector.keyCache = [];   // key 列表
                var appElement = document.getElementById("project_select_kms_checkbox");
                var $scope = angular.element(appElement).scope();
                $("#project_select_kms_checkbox").on('change',function(){
                    var kms =  $scope.keySelected.value;
                    if($("#project_select_kms_checkbox").is(":checked")){
                        $("#tr_key_tiselect").removeClass("mui-hide");
                        if(!obsVersion){
                            $("#tr_project_tiselect").removeClass("mui-hide");
                        }
                        $("#UploadFileBtn").addClass("mui-disabled");
                        $("#UploadFileBtn").attr('title','select a key before you upload.');
                        $scope.selectProjectModel.disable = false;
                        $scope.selectKeyModel.disable = false;
                        if(kms != undefined){
                            $("#UploadFileBtn").removeClass("mui-disabled");
                            $("#UploadFileBtn").attr('title',"");
                        }
                    }else{
                        $scope.selectProjectModel.disable = true;
                        $scope.selectKeyModel.disable = true;
                        $("#tr_project_tiselect").addClass("mui-hide");
                        $("#tr_key_tiselect").addClass("mui-hide");
                        $("#UploadFileBtn").removeClass("mui-disabled");
                        $("#UploadFileBtn").attr('title',"");
                    }
                });
                var project_id = "";
                accessConnector.queryProjects(bucketLocation, function(err,data){
                    data = JSON.parse(data);
                    if(data.error){
                        global.logger.warn("queryProjects err",err);
                    }else {
                        var options = [];
                        if(data.projects){
                            var projectArr = data.projects;
                            projectArr.forEach(function (value, index, array) {
                                if(value.name.startsWith(bucketLocation)){ // 过滤出当前region的project
                                    options.push({label: value.name, id: value.id, "data": value});
                                }
                                if(value.name === bucketLocation){ //查出当前region的project id
                                    project_id = value.id;
                                }
                            });
                        }
                        $scope.selectProjectModel.options = options;
                        $scope.$digest();
                    }
                    // 非3.0桶支持多project
                    if(!obsVersion){
                        $scope.selectProjectModel.change = function (option) {
                            $("#UploadFileBtn").addClass("mui-disabled");
                            $("#UploadFileBtn").attr('title','select a key before you upload.');
                            $scope.selectKeyModel.options = [];
                            $scope.selectKeyModel.selectedKeyId = [];
                            $scope.keySelected = {value: undefined};
                            if(accessConnector.keyCache[option.id]){
                                $scope.selectKeyModel.options = accessConnector.keyCache[option.id];
                                $scope.selectKeyModel.placeholder = "select a key.";
                                $scope.$digest();
                            }else {
                                accessConnector.queryKmsList(bucketLocation, option.id,function (err, data) {
                                    global.logger.info("queryKmsList:");
                                    global.logger.info(data);
                                    data = JSON.parse(data);
                                    var options = [];
                                    if(data.error){
                                        console.log("queryKmsList err!");
                                        console.log(err);
                                        if(option.label === bucketLocation){ // 当前region下的project给个默认kms
                                            options.push({label: "obs/default", id: "default_kms_obs/default"});
                                            $scope.selectKeyModel.placeholder = "select a key.";
                                        }else{
                                            $scope.selectKeyModel.placeholder = "Create a kms in console.";
                                            $scope.keySelected = {value: undefined};
                                        }
                                    }else{
                                        if(data.key_details){
                                            var keyDetails = data.key_details;
                                            for (var i = 0; i < keyDetails.length; i++) {
                                                // 过滤出启用状态和默认的kms
                                                if ((keyDetails[i].key_state != "2") || ((keyDetails[i].default_key_flag == "1") && (keyDetails[i].key_alias != 'obs/default'))) {
                                                    continue;
                                                }
                                                options.push({label: keyDetails[i].key_alias, id: keyDetails[i].key_id, "data": keyDetails[i]});
                                            }
                                            accessConnector.keyCache[option.id] =  options;
                                            $scope.selectKeyModel.options = options;
                                            $scope.$digest();
                                        }
                                    }

                                });
                            }
                            global.logger.info(accessConnector.keyCache);


                        };
                    }else {
                        if(accessConnector.keyCache[project_id]){
                            $scope.selectKeyModel.options = accessConnector.keyCache[project_id];
                            $scope.selectKeyModel.placeholder = "select a key.";
                            $scope.$digest();
                        }else {
                            accessConnector.queryKmsList(bucketLocation, project_id,function (err, data) {
                                var options = [];
                                data = JSON.parse(data);
                                if(data.error){
                                    console.log("queryKmsList err!");
                                    console.log(err);
                                    options.push({label: "obs/default", id: "default_kms_obs/default"});
                                    $scope.keySelected = {value: "obs/default"};
                                    $scope.selectKeyModel.selectedKeyId = ["default_kms_obs/default"];
                                    $scope.selectKeyModel.placeholder = "select a key.";
                                }else{
                                    if(data.key_details){
                                        var keyDetails = data.key_details;
                                        for (var i = 0; i < keyDetails.length; i++) {
                                            // 过滤出启用状态和默认的kms
                                            if ((keyDetails[i].key_state != "2") || ((keyDetails[i].default_key_flag == "1") && (keyDetails[i].key_alias != 'obs/default'))) {
                                                continue;
                                            }
                                            options.push({label: keyDetails[i].key_alias, id: keyDetails[i].key_id, "data": keyDetails[i]});
                                        }
                                    }
                                }
                                $scope.selectKeyModel.options = options;
                                accessConnector.keyCache[project_id] =  options;
                                $scope.$digest();
                            });
                        }
                    }
                    $scope.selectKeyModel.change = function (option) {
                        $("#UploadFileBtn").removeClass("mui-disabled");
                        $("#UploadFileBtn").attr('title',"");
                        $scope.keySelected = {value: option.label};
                        global.serverEncryptionKeyId = option.id;
                    };
                });

            }
        });

    }
    function initProjectListPage2() {
        var bucket = $('#curBucketName').html();
        var bucketLocation = "";
        var obsVersion = "not support muti-project";
        bucketAttributeAction.headBucket(bucket, function (err, results) {
            if (err) {
                global.logger.warn("init projects headbucket err",err)
            } else {
                // 非3.0的桶，支持多project
                bucketLocation = results.LocationConstraint;
                global.curRegion = bucketLocation;
                if(results.ObsVersion){
                    // 暂不支持多project 需要注释掉以下代码
                    //obsVersion = results.ObsVersion;
                    global.logger.info("The bucket version is "+results.ObsVersion);
                }else {
                    global.logger.info("The bucket version is not 3.0.")
                }
                accessConnector.keyCache = [];   // key 列表
                var appElement = document.getElementById("project_select_kms_checkbox2");
                var $scope = angular.element(appElement).scope();
                $("#project_select_kms_checkbox2").on('change',function(){
                    var kms =  $scope.keySelected.value;
                    if($("#project_select_kms_checkbox2").is(":checked")){
                        $("#tr_key_tiselect2").removeClass("mui-hide");
                        if(!obsVersion){
                            $("#tr_project_tiselect2").removeClass("mui-hide");
                        }
                        $("#uploadFolderBtn").addClass("mui-disabled");
                        $("#uploadFolderBtn").attr("title", 'select a key before you upload.');
                        $scope.selectProjectModel.disable = false;
                        $scope.selectKeyModel.disable = false;
                        if(kms != undefined){
                            $("#uploadFolderBtn").removeClass("mui-disabled");
                            $("#uploadFolderBtn").attr('title',"");
                        }
                    }else{
                        $scope.selectProjectModel.disable = true;
                        $scope.selectKeyModel.disable = true;
                        $("#tr_project_tiselect2").addClass("mui-hide");
                        $("#tr_key_tiselect2").addClass("mui-hide");
                        $("#uploadFolderBtn").removeClass("mui-disabled");
                        $("#uploadFolderBtn").attr('title',"");
                    }
                });
                var project_id = "";
                accessConnector.queryProjects(bucketLocation, function(err,data){
                    data = JSON.parse(data);
                    console.log(data);
                    if(data.error){
                        global.logger.warn("queryProjects err",err);
                    }else {
                        var options = [];
                        if(data.projects){
                            var projectArr = data.projects;
                            projectArr.forEach(function (value, index, array) {
                                if(value.name.startsWith(bucketLocation)){ // 过滤出当前region的project
                                    options.push({label: value.name, id: value.id, "data": value});
                                }
                                if(value.name === bucketLocation){ //查出当前region的project id
                                    project_id = value.id;
                                }
                            });
                        }
                        $scope.selectProjectModel.options = options;
                        $scope.$digest();
                    }
                    // 非3.0桶支持多project
                    if(!obsVersion){
                        $scope.selectProjectModel.change = function (option) {
                            $("#uploadFolderBtn").addClass("mui-disabled");
                            $("#uploadFolderBtn").attr('title','select a key before you upload.');
                            $scope.selectKeyModel.options = [];
                            $scope.selectKeyModel.selectedKeyId = [];
                            $scope.keySelected = {value: undefined};
                            if(accessConnector.keyCache[option.id]){
                                $scope.selectKeyModel.options = accessConnector.keyCache[option.id];
                                $scope.selectKeyModel.placeholder = "select a key.";
                                $scope.$digest();
                            }else {
                                accessConnector.queryKmsList(bucketLocation, option.id,function (err, data) {
                                    global.logger.info("queryKmsList:");
                                    global.logger.info(data);
                                    data = JSON.parse(data);
                                    var options = [];
                                    if(data.error){
                                        console.log("queryKmsList err!");
                                        console.log(err);
                                        if(option.label === bucketLocation){ // 当前region下的project给个默认kms
                                            options.push({label: "obs/default", id: "default_kms_obs/default"});
                                            $scope.selectKeyModel.placeholder = "select a key.";
                                        }else{
                                            $scope.selectKeyModel.placeholder = "Create a kms in console.";
                                            $scope.keySelected = {value: undefined};
                                        }
                                    }else{
                                        if(data.key_details){
                                            var keyDetails = data.key_details;
                                            for (var i = 0; i < keyDetails.length; i++) {
                                                // 过滤出启用状态和默认的kms
                                                if ((keyDetails[i].key_state != "2") || ((keyDetails[i].default_key_flag == "1") && (keyDetails[i].key_alias != 'obs/default'))) {
                                                    continue;
                                                }
                                                options.push({label: keyDetails[i].key_alias, id: keyDetails[i].key_id, "data": keyDetails[i]});
                                            }
                                            accessConnector.keyCache[option.id] =  options;
                                            $scope.selectKeyModel.options = options;
                                            $scope.$digest();
                                        }
                                    }

                                });
                            }
                            global.logger.info(accessConnector.keyCache);
                        };
                    }else {
                        if(accessConnector.keyCache[project_id]){
                            $scope.selectKeyModel.options = accessConnector.keyCache[project_id];
                            $scope.selectKeyModel.placeholder = "select a key.";
                            $scope.$digest();
                        }else {
                            accessConnector.queryKmsList(bucketLocation, project_id,function (err, data) {
                                var options = [];
                                data = JSON.parse(data);
                                if(data.error){
                                    console.log("queryKmsList err!");
                                    console.log(err);
                                    options.push({label: "obs/default", id: "default_kms_obs/default"});
                                    $scope.keySelected = {value: "obs/default"};
                                    $scope.selectKeyModel.selectedKeyId = ["default_kms_obs/default"];
                                    $scope.selectKeyModel.placeholder = "select a key.";
                                }else{
                                    if(data.key_details){
                                        var keyDetails = data.key_details;
                                        for (var i = 0; i < keyDetails.length; i++) {
                                            // 过滤出启用状态和默认的kms
                                            if ((keyDetails[i].key_state != "2") || ((keyDetails[i].default_key_flag == "1") && (keyDetails[i].key_alias != 'obs/default'))) {
                                                continue;
                                            }
                                            options.push({label: keyDetails[i].key_alias, id: keyDetails[i].key_id, "data": keyDetails[i]});
                                        }
                                    }
                                }
                                $scope.selectKeyModel.options = options;
                                accessConnector.keyCache[project_id] =  options;
                                $scope.$digest();
                            });
                        }
                    }
                    $scope.selectKeyModel.change = function (option) {
                        $("#uploadFolderBtn").removeClass("mui-disabled");
                        $("#uploadFolderBtn").attr('title',"");
                        $scope.keySelected = {value: option.label};
                        global.serverEncryptionKeyId = option.id;
                    };
                });

            }
        });

    }

    //显示上传文件面板
    $("#uploadFiles").on('click',function(){
        $("#project_select_kms_checkbox").attr('title',languageJson.obs_term_uploadObject_addFile_tip);
        if (pkg.objectColdline == true) {//是否支持温冷
            var bucket = $('#curBucketName').html();
            bucketAttributeAction.headBucket(bucket, function (err, results) {
                if (err) {
                   global.logger.warn("upload file headbucket err",err)
                } else {
                    showOverlay();
                    var selectIndex = 0;
                    if (results) {
                        var inputs = $("#uploadObjectStorageType").parent().find("input");
                        for (var index in inputs) {
                            if (inputs[index].value == results.StorageType) {
                                selectIndex = index;
                            }
                        }
                        var appElement = document.getElementById("uploadObjectStorageType");
                        var $scope = angular.element(appElement).scope();
                        $scope.object.selected.value = $scope.object.storageTypeList[selectIndex].key;
                        $scope.object.description = $scope.object.storageTypeList[selectIndex].desc;
                        $scope.$apply();
                    }
                }
            });
        }
        // 加载projects 下拉选项
        initProjectListPage();
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#uploadFileDialog").addClass('shown');
        divDragFunc('uploadFileDrag','uploadFileDialog');
        $("#removeAll").addClass("mui-disabled");
        $("#UploadFileBtn").addClass("mui-disabled");
        $("#UploadFileBtn").attr('title',languageJson.obs_term_uploadObject_addFile_tip);
        $(".mui-dropdown-menu").removeClass('mui-open');
        // 初始化加密CheckBox的状态
        $("#project_select_kms_checkbox").attr("disabled", "disabled");
        $("#project_select_kms_checkbox").addClass("mui-disabled");
        $("#project_select_kms_checkbox").attr("checked", false);
        $("#project_select_kms_checkbox").attr('title',languageJson.obs_term_uploadObject_addFile_tip);
        $("#tr_project_tiselect").addClass("mui-hide");
        $("#tr_key_tiselect").addClass("mui-hide");
        return false;
    });

    //点击【+ 选择文件】显示选择文件对话框
    $('#uploadFileDialog .choiceFileBtn').on('click',function () {
        var uploadFileLength = $('#uploadFileDialog .upoadFileListTitle .fileNum span').text();
        if(uploadFileLength>=uploadFileNumber){
            $('.mui-model').showMessage({
                type:"warning",
                message:languageJson.obs_task_uploadObject_limit_msg,
                ok:function(){},
                title:languageJson.warning
            });
            return false;
        }else{
            $('#uploadFileDialog .choiceFileInput').trigger('click');
        }
    });

    //choiceFileInput改变获取选择的文件并添加到待上传文件列表
    $('#uploadFileDialog .choiceFileInput').on('change', function () {
        var uploadFileLength = $('#uploadFileDialog .upoadFileListTitle .fileNum span').text();
        //统计
        var totalUploadFileSize = 0;
        //要上传的文件对象
        var uploadFileObjectArray = [];
        var files = $(this).get(0).files;
        $("#removeAll").removeClass("mui-disabled");
        for (var i = 0; i < files.length; ++i) {
            if(i<uploadFileNumber-uploadFileLength){
                var fileName = files[i].name;
                var filePath = files[i].path;
                filePath = filePath.replace(/\\/g, "/");
                var fileSize = files[i].size;

                //排除重复的对象
                var exist = false;
                var lis = $('#uploadFileDialog ul.fileLists li.file');
                $.each(lis, function(index, item) {
                    var path = $(item).data('path');
                    if(path == filePath) {
                        exist = true;
                        return;
                    }
                });
                if(!exist) {
                    totalUploadFileSize += fileSize;
                    filePath = filePath.replace(/\\/g, "/");
                    uploadFileObjectArray.push({
                        name : fileName,
                        nameShow : fileName.replace(new RegExp(' ','gm'),'&nbsp;'),
                        path : filePath,
                        pathShow: filePath.replace(new RegExp(' ','gm'),'&nbsp;'),
                        size : indexAction.getFileSize(fileSize),
                        originalSize : fileSize,
                        delete : global.langData.obs_browser_removeFile
                    });
                }
            }
        }
        var appElement = document.getElementById("project_select_kms_checkbox");
        var $scope = angular.element(appElement).scope();
        var kms = $scope.keySelected.value;
        var needKms = $("#project_select_kms_checkbox").is(":checked");
        var enableSubmit = (!needKms) || (needKms && kms != undefined);
        if(uploadFileObjectArray.length > 0) {
            $("#project_select_kms_checkbox").removeAttr("disabled");
            $("#project_select_kms_checkbox").removeClass("mui-disabled");
            $("#project_select_kms_checkbox").attr('title',"");
            if(enableSubmit){
                $("#UploadFileBtn").removeClass("mui-disabled");
                $("#UploadFileBtn").attr('title',"");
            }else{
                $("#UploadFileBtn").addClass("mui-disabled");
                $("#UploadFileBtn").attr('title',"select a key before you upload.");
            }
            $('#uploadFileDialog ul.fileLists').append(renderSync("listUploadObjectsItemTemplate", uploadFileObjectArray));
            $('#uploadFileDialog .choiceFileInput').val("");
            setTimeout(function(){
                //文件数
                $('#uploadFileDialog .upoadFileListTitle .fileNum span').text($('#uploadFileDialog ul.fileLists li').length);
                //文件总大小
                $('#uploadFileDialog .upoadFileListTitle .fileSize span').text(indexAction.getFileSize(culTotalUploadFileSize()));
            },500);
        }
    });

    var getFileListLength = function () {
        var list = $('#uploadFileDialog ul.fileLists li');
        return list.length;
    }
    //移除所有文件
    $("#removeAll").on("click",function () {
        var self = this;
        if($(self).hasClass("mui-disabled")){
            return false;
        }
        $('.mui-model').showMessage({
            type: 'warning',
            message: languageJson.obs_browser_removeAllFile_msg,
            ok: function () {
                $("#removeAll").addClass("mui-disabled");
                $("#UploadFileBtn").addClass("mui-disabled");
                $("#UploadFileBtn").attr('title',languageJson.obs_term_uploadObject_addFile_tip);
                $("#uploadFileDialog ul.fileLists").html("");
                $('#uploadFileDialog .upoadFileListTitle .fileNum span').text(0);
                $('#uploadFileDialog .upoadFileListTitle .fileSize span').text(0);
                return false;
            },
            cancel: function () {
                return false;
            },
            title: languageJson.warning
        });
    })

    //删除上传列表中的文件
    $("#uploadFileDialog ul.fileLists").delegate('.fileDelete','click',function(){
        $(this).parent().remove();
        //文件数
        $('#uploadFileDialog .upoadFileListTitle .fileNum span').text($('#uploadFileDialog ul.fileLists li').length);
        //清空隐藏input值
        $('#uploadFileDialog .choiceFileInput').val("");
        if($("#uploadFileDialog ul.fileLists>li").length ===0){
            $("#removeAll").addClass("mui-disabled");
            $("#UploadFileBtn").addClass("mui-disabled");
            $("#UploadFileBtn").attr('title',languageJson.obs_term_uploadObject_addFile_tip);
            $("#project_select_kms_checkbox").attr("disabled", "disabled");
            $("#project_select_kms_checkbox").addClass("mui-disabled");
            $("#project_select_kms_checkbox").attr("checked", false);
            $("#project_select_kms_checkbox").attr('title',languageJson.obs_term_uploadObject_addFile_tip);
            $("#tr_project_tiselect").addClass("mui-hide");
            $("#tr_key_tiselect").addClass("mui-hide");
        }
        //文件总大小
        $('#uploadFileDialog .upoadFileListTitle .fileSize span').text(indexAction.getFileSize(culTotalUploadFileSize()));
    });

    // 计算要上传文件的总大小
    var culTotalUploadFileSize = function() {
        var totalSize = 0;
        var lis = $('#uploadFileDialog ul.fileLists li');
        $.each(lis, function(index, item) {
            var size = $(item).data('originalsize');
            totalSize += parseInt(size);
        });
        return totalSize;
    }

    //上传文件确定按钮
    $('#UploadFileBtn').on('click',function(){
        var self = this;
        if($(self).hasClass("mui-disabled")){
            return false;
        }
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var lis = $('#uploadFileDialog ul.fileLists li');
        if (lis.length === 0) {
            var htmlStr = languageJson.obs_term_uploadObject_addFile_tip;
            $('.mui-model').showMessage({
                type: "warning",
                message: htmlStr,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        var bucketName = $('#curBucketName').html();
        if(!bucketName){
            var htmlStr = languageJson.selectBucket;
            $('.mui-model').showMessage({
                type: "warning",
                message: htmlStr,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        var parentPath = getCurrPath();
        if(taskManager){
            taskManager.abortAll=false;
            taskManager.setPauseAll(false);
        }
        indexAction.loadSetting(function (configObj) {
          if(configObj) {
              global.isMD5check = configObj.isMD5check;
          }
        })
        //获取选择的存储类型
        var storageType = $('#uploadObjectStorageType').html();
        storageType = CommonUtils.translateStorageClass(storageType);
        // 获取加密上传的key
        var filelis = $('#uploadFileDialog ul.fileLists li.file');
        var temp = true;
        $.each(filelis, function(index, item) {
            var filePath = $(item).data('path');
            if(!fs.existsSync(filePath)){
                temp = false;
                $(item).addClass("RedColor");
            }else{
                $(item).removeClass("RedColor");
            }
        });
        var folderlis = $('#uploadFileDialog ul.fileLists li.folder');
        $.each(folderlis, function(index, item) {
            var path = $(item).data('path');
            path = path.replace(/\\/g, "/");
            if(!path.endsWith('/')) {
                path = path + '/';
            }
            if(!fs.existsSync(path)){
                temp = false;
                $(item).addClass("RedColor");
            }else{
                $(item).removeClass("RedColor");
            }
        });
        if(!temp){//文件不存在
            $('.mui-model').showMessage({
                type: 'warning',
                message: languageJson.obs_term_uploadObject_localNotExist_msg,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        $.each(filelis, function(index, item) {
            var fileName = $(item).data('name');
            var filePath = $(item).data('path');
            taskControlAction.uploadFile(bucketName, parentPath + fileName, filePath, storageType);
        });
        $.each(folderlis, function(index, item) {
            var path = $(item).data('path');
            path = path.replace(/\\/g, "/");
            if(!path.endsWith('/')) {
                path = path + '/';
            }
            taskControlAction.uploadPath(bucketName, parentPath, path, storageType);
        });
        $(".mui-page-full.shown").removeClass('shown');
        showCreateTasksAnimation();//加载新增任务动画效果
        taskControlAction.checkDBData();
        $('#uploadFileDialog ul.fileLists li').remove();
        //清除隐藏input的值
        $('#uploadFileDialog .choiceFileInput').val("");
        $('#uploadFileDialog .choiceFolderInput').val("");
        //文件数
        $('#uploadFileDialog .upoadFileListTitle .fileNum span').text(0);
        //文件总大小
        $('#uploadFileDialog .upoadFileListTitle .fileSize span').text(0);
        // 当前region
        global.curRegion = global.curRegion ? global.curRegion : defaultRegion;
        return false;
    });

    //上传文件取消按钮
    $('#cancelUploadFile').on('click',function(){
        //清除上传列表里面的文件
        $('#uploadFileDialog ul.fileLists li').remove();
        //清除隐藏input的值
        $('#uploadFileDialog .choiceFileInput').val("");
        //文件数
        $('#uploadFileDialog .upoadFileListTitle .fileNum span').text(0);
        //文件总大小
        $('#uploadFileDialog .upoadFileListTitle .fileSize span').text(0);
        $(".mui-page-full.shown").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        $("#project_select_kms_checkbox").attr("disabled", "disabled");
        $("#project_select_kms_checkbox").addClass("mui-disabled");
        $("#project_select_kms_checkbox").attr("checked", false);
        $("#project_select_kms_checkbox").attr('title',languageJson.obs_term_uploadObject_addFile_tip);
        $("#tr_project_tiselect").addClass("mui-hide");
        $("#tr_key_tiselect").addClass("mui-hide");
        return false;
    });

    //显示上传文件夹dialog
    $("#uploadFolders").on('click',function(){
        if (pkg.objectColdline == true) {//是否支持温冷
            var bucket = $('#curBucketName').html();
            bucketAttributeAction.headBucket(bucket, function (err, results) {
                if (err) {
                    global.logger.warn("upload folder headbucket err ",err);
                } else {
                    showOverlay();
                    var selectIndex = 0;
                    if (results) {
                        var inputs = $("#uploadFolderObjectStorageType").parent().find("input");
                        for (var index in inputs) {
                            if (inputs[index].value == results.StorageType) {
                                selectIndex = index;
                            }
                        }
                        var appElement = document.getElementById("uploadFolderObjectStorageType");
                        var $scope = angular.element(appElement).scope();
                        $scope.object.selected.value = $scope.object.storageTypeList[selectIndex].key;
                        $scope.object.description = $scope.object.storageTypeList[selectIndex].desc;
                        $scope.$apply();
                    }
                }
            });
        }
        // 加载projects 下拉选项
        initProjectListPage2();
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#uploadFolderDialog").addClass('shown');
        divDragFunc('uploadFolderDrag','uploadFolderDialog');
        $("#uploadFolderBtn").addClass("mui-disabled");
        $("#uploadFolderBtn").attr("title",languageJson.obs_term_uploadObject_addFolder_tip);
        $(".mui-dropdown-menu").removeClass('mui-open');
        // 初始化加密CheckBox的状态
        $("#project_select_kms_checkbox2").attr("disabled", "disabled");
        $("#project_select_kms_checkbox2").addClass("mui-disabled");
        $("#project_select_kms_checkbox2").attr("checked", false);
        $("#project_select_kms_checkbox2").attr('title',languageJson.obs_term_uploadObject_addFolder_tip);
        $("#tr_project_tiselect2").addClass("mui-hide");
        $("#tr_key_tiselect2").addClass("mui-hide");
        return false;
    });

    //点击上传文件夹添加按钮
    $('#addFolder').on('click',function () {
        $('#choiceFolderInput').trigger('click');
    });

    //input显示上传文件夹名称
    $('#choiceFolderInput').on('change', function () {
        var path = $('#choiceFolderInput').val();
        path = path.replace(/\\/g, "/");
        $('#FolderName').val(path);
        var appElement = document.getElementById("project_select_kms_checkbox2");
        var $scope = angular.element(appElement).scope();
        var kms = $scope.keySelected.value;
        var needKms = $("#project_select_kms_checkbox2").is(":checked");
        var enableSubmit = (!needKms) || (needKms && kms != undefined);
        $("#project_select_kms_checkbox2").removeAttr("disabled");
        $("#project_select_kms_checkbox2").removeClass("mui-disabled");
        $("#project_select_kms_checkbox2").attr('title',"");
        if(enableSubmit){
            $("#uploadFolderBtn").removeClass("mui-disabled");
            $("#uploadFolderBtn").attr('title',"");
        }else{
            $("#uploadFolderBtn").addClass("mui-disabled");
            $("#uploadFolderBtn").attr('title',"select a key before you upload.");
        }
    });

    //上传文件夹确定按钮
    $('#uploadFolderBtn').on('click',function(){
        var self = this ;
        if($(self).hasClass("mui-disabled")){
            return false;
        }
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        $(".mui-page-full.shown").removeClass('shown');
        var parentPath = getCurrPath();
        var path = $('#choiceFolderInput').val();
        path = path.replace(/\\/g, "/");
        if (path === '') {
            var htmlStr = languageJson.obs_term_uploadObject_addFolder_tip;
            $('.mui-model').showMessage({
                type: "warning",
                message: htmlStr,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        var bucket = $('#curBucketName').html();
        if (bucket) {
            isRefreshObj = true;
            if(taskManager){
                taskManager.pauseAll = false;
                taskManager.abortAll = false;
            }
            if(!path.endsWith('/')) {
                path = path + '/';
            }
            //获取选择的存储类型
            var storageType = CommonUtils.translateStorageClass($('#uploadFolderObjectStorageType').html());
            taskControlAction.uploadPath(bucket, parentPath, path, storageType);
            showCreateTasksAnimation();//加载新增任务动画效果
        } else {
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.selectBucket,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        $('#choiceFolderInput').val('');
        $('#FolderName').val('');
        taskControlAction.checkDBData();
        // 当前region
        global.curRegion = global.curRegion ? global.curRegion : defaultRegion;
        global.serverEncryption = $("#project_select_kms_checkbox2").is(":checked") ? true : false;
    });

    //点击选择文件夹
    $("#folders").on("click",function () {
        var uploadFileLength = $('#uploadFileDialog .upoadFileListTitle .fileNum span').text();
        if(uploadFileLength>=uploadFileNumber){
            $('.mui-model').showMessage({
                type:"warning",
                message:languageJson.obs_task_uploadObject_limit_msg,
                ok:function(){},
                title:languageJson.warning
            });
            return false;
        }else{
            $('#uploadFileDialog .choiceFolderInput').trigger('click');
        }
    })
    $(".choiceFolderInput").on("change",function () {
        var FolderPath = $(".choiceFolderInput").val();
        var index = FolderPath.lastIndexOf('\\');
        var FolderName = FolderPath.substring(index+1)
        if(!FolderName){
            FolderName = FolderPath.substring(0,index-1) + "$"
        }
        $("#removeAll").removeClass("mui-disabled");
        var lis = $('#uploadFileDialog ul.fileLists li.folder');
        var exist = false;
        if(lis.length>0){
            $.each(lis, function(index, item) {
                var path = $(item).data('path');
                if(path == FolderPath) {
                    exist = true;
                    $(".choiceFolderInput").val("");
                    return;
                }
            });
        }
        if(!exist && FolderPath){
            var appElement = document.getElementById("project_select_kms_checkbox");
            var $scope = angular.element(appElement).scope();
            var kms = $scope.keySelected.value;
            var needKms = $("#project_select_kms_checkbox").is(":checked");
            var enableSubmit = (!needKms) || (needKms && kms != undefined);
            $("#project_select_kms_checkbox").removeAttr("disabled");
            $("#project_select_kms_checkbox").removeClass("mui-disabled");
            $("#project_select_kms_checkbox").attr('title',"");
            if(enableSubmit){
                $("#UploadFileBtn").removeClass("mui-disabled");
                $("#UploadFileBtn").attr('title',"");
            }else{
                $("#UploadFileBtn").addClass("mui-disabled");
                $("#UploadFileBtn").attr('title',"select a key before you upload.");
            }
            $("#UploadFileBtn").removeClass("mui-disabled");
            $("#UploadFileBtn").attr('title',"");
            var uploadFolder = {
                name:FolderName,
                nameShow: FolderName.replace(new RegExp(' ','gm'),'&nbsp;'),
                path : FolderPath,
                pathShow: FolderPath.replace(new RegExp(' ','gm'),'&nbsp;'),
                delete : global.langData.obs_browser_removeFile
            }
            $(".choiceFolderInput").val("");
            $('#uploadFileDialog ul.fileLists').append(renderSync("listUploadFoldersItemTemplate", uploadFolder));
            setTimeout(function(){
                //文件数
                $('#uploadFileDialog .upoadFileListTitle .fileNum span').text($('#uploadFileDialog ul.fileLists li').length);
            },500);
        }
    })
    //上传文件名tips
    $(function () {
        $(".fileLists").delegate(".fileName","mouseenter", function () {
            if (this.offsetWidth < this.scrollWidth) {
                var text = $(this).text().trim();
                $(this).attr('title', text);
            } else {
                $(this).removeAttr('title');
            }
        });
    })
    //上传文件夹取消按钮
    $('#cancelUploadFolder').on('click',function(){
        $('#choiceFolderInput').val('');
        $('#FolderName').val('');
        $(".mui-page-full.shown").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        $("#project_select_kms_checkbox2").addClass("mui-disabled");
        $("#project_select_kms_checkbox2").attr("disabled", "disabled");
        $("#project_select_kms_checkbox2").attr("checked", false);
        $("#project_select_kms_checkbox2").attr('title',languageJson.obs_term_uploadObject_addFolder_tip);
        $("#tr_project_tiselect2").addClass("mui-hide");
        $("#tr_key_tiselect2").addClass("mui-hide");
        global.serverEncryption = false;
        return false;
    });

    $("#listObjBodyDiv").on('click',function(){
        $("#objLists tr.selected-tr-active>td:first-child").find('span').removeClass('show-span-active');
        $("#downloadbtn,#btnDeleteObjects,#recoverBtn").addClass('mui-disabled');
        $("#downloadbtn").attr('data-title',languageJson.selectFileOrFolder);
        if (UCDVersion === "HEC") {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
        }else {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
        }
        $("#objLists tr.selected-tr-active").removeClass('selected-tr-active');
        $("#downloadFileName").val('');
    });

    $("#taskConcole").on('click',function(){
        $("#"+selected+" table tbody .selected-tr-active").each(function(){
            var id = $(this).attr('id');
            var task = taskManager.runningMap[id];
            if(task){
                task.active = false;
            }
        });
        $("#taskConcole tr.selected-tr-active>td").each(function () {
            $(this).find('span').removeClass('show-span-active');
        });
        $("#taskConcole tr.selected-tr-active").removeClass('selected-tr-active');
    });

    $("#objLists tbody").delegate('.mui-icon-handel-download','click',function(event){
        $(this).parent().parent().click();
        setTimeout(function () {
            $('#downloadbtn').click();
        },50);
    });

    $("#objLists tbody").delegate('.mui-icon-handel-del','click',function(){
        $(this).parent().parent().click();
        setTimeout(function () {
            $('#btnDeleteObjects').click();
        },50);
    });

    //显示下载文件框
    $('#downloadbtn').on('click', function () {
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        var name = $("#downloadFileName").val();
        $("#downloadDialog").nwsaveas = name;
        if (!name) {
            var htmlStr = languageJson.checkDownObject;
            $('.mui-model').showMessage({
                type: "warning",
                message: htmlStr,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        $('#downloadDialog').trigger('click');
        return false;
    });

    $("body").on("dragstart",function(){
        return false;
    });

    //下载文件
    $('#downloadDialog').on('change', function (e) {
        var bucket = $('#curBucketName').html();
        var prefixSearch = $('#prefixSearch').val();
        var parentPath = getCurrPath();
        var path = $(this).val();
        path = path.replace(/\\/g, "/");
        $(this).val("");
        taskControlAction.pathCheck(path, function (exist) {
            if (exist) {
                //被选中的列表
                var lis = $("#objLists tr.selected-tr-active>td:last-child");
                //超过2个大文件不走多段下载
                if(lis.length>2){
                    global.isMultiDownload = false;
                }else{
                    global.isMultiDownload = true;
                }
                $("#objLists tr.selected-tr-active>td:first-child").find('span').removeClass('show-span-active');
                $("#downloadbtn,#btnDeleteObjects,#recoverBtn").addClass('mui-disabled');
                $("#downloadbtn").attr('data-title',languageJson.selectFileOrFolder);
                if (global.UCDVersion === "HEC") {
                    $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
                }else {
                    $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
                }
                $("#objLists tr.selected-tr-active").removeClass('selected-tr-active');
                if (bucket && lis && path) {
                    isShowDownErrMsg = true;
                    if(taskManager){
                        taskManager.setPauseAll(false);
                        taskManager.abortAll=false;
                    }

                    /**
                     * 与forEach相似，但不是并行执行。而是一个个按顺序执行。
                     */
                    //控制错误信息只弹出一次
                    var showMsgTemp = true;
                    //控制任务加载动画只执行一次
                    var showCreateTasks = true;
                    async.forEachSeries(lis, function(li,callback) {
                        var obj=JSON.parse($(li).text());
                        var name = obj.name;
                        if(name.charAt(name.length-1)==='/'){
                            if(showCreateTasks){
                                showCreateTasksAnimation();//加载新增任务动画效果
                                showCreateTasks = false;
                            }
                            taskControlAction.downloadPath(bucket,parentPath,name,'',path,0, function (err) {
                                if(err){
                                    //下载失败，则创建一个失败的下载任务
                                    if(err&&showMsgTemp) {
                                        showMsgTemp = false;
                                        //超时信息错误码特殊处理
                                        var errCode = err.code === 'NetworkingError' ? "someObjectDownErr" : err.code;
                                        //为了避免加载任务动画效果和错误信息同时出现，错误信息延迟2秒显示
                                        setTimeout(function () {
                                            $('.mui-model').showErrorMessage({
                                                message: languageJson[errCode],
                                                obsError: obsError(errCode,err.message)
                                            });
                                        },2000)

                                    }
                                }
                            });
                        }else{
                            if(fs.existsSync(path+'/'+name)){
                                showOverlay();
                                $(".mui-page-full.shown").removeClass('shown');
                                $("#renameNotice").removeClass('mui-hide');
                                $("#renameNotice").addClass('shown');
                                divDragFunc('renameNoticeDrag','renameNotice');
                                var self = name;
                                var thisPath = parentPath;
                                //均保存
                                $('#rename').on('click',function () {
                                    $(".mui-page-full.shown").removeClass('shown');
                                    $("#renameNotice").addClass('mui-hide');
                                    if ($("#mui-overlay").size() > 0) {
                                        mui.overlay('off');
                                    }
                                    var j = 0;
                                    for(var i=1;i<1000;i++){
                                        j++;
                                       var newname = self.substring(0,self.lastIndexOf('.'))+'('+j+')'+self.substring(self.lastIndexOf('.'));
                                        if(!fs.existsSync(path+'/'+newname)){
                                            break;
                                        }
                                    }
                                    if(showCreateTasks){
                                        showCreateTasksAnimation();//加载新增任务动画效果
                                        showCreateTasks = false;
                                    }
                                    taskControlAction.downloadFile(bucket,thisPath+self,path+'/'+newname,obj.dataSize,obj.etag);
                                    self = "";
                                    thisPath = "";
                                });
                                //覆盖
                                $('#cover').on('click',function () {
                                    $("#renameNotice").removeClass('shown');
                                    $("#renameNotice").addClass('mui-hide');
                                    if ($("#mui-overlay").size() > 0) {
                                        mui.overlay('off');
                                    }
                                    fs.unlink(path+'/'+self,function (err) {//先删除原有的，避免无法写入进去
                                        if(err){
                                            global.logger.info("unlink error ====",err);
                                        }
                                        if(showCreateTasks){
                                            showCreateTasksAnimation();//加载新增任务动画效果
                                            showCreateTasks = false;
                                        }
                                        taskControlAction.downloadFile(bucket,thisPath+self,path+'/'+self,obj.dataSize,obj.etag);
                                        self = "";
                                        thisPath = "";
                                        return false;
                                    });
                                });
                                $('#cancelDownload').on('click',function(){
                                    $("#renameNotice").removeClass('shown');
                                    $("#renameNotice").addClass('mui-hide');
                                    if ($("#mui-overlay").size() > 0) {
                                        mui.overlay('off');
                                    }
                                    return false;
                                });
                            }else{
                                if(showCreateTasks){
                                    showCreateTasksAnimation();//加载新增任务动画效果
                                    showCreateTasks = false;
                                }
                                taskControlAction.downloadFile(bucket,parentPath+name,path+'/'+name,obj.dataSize,obj.etag);
                            }
                        }
                        callback();
                    }, function(err) {
                        if(err){
                            logger.error('err: ' + err);
                        }
                    });
                } else {
                    $('.mui-model').showMessage({
                        type: "warning",
                        message: languageJson.selectObjcet,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.warning
                    });
                }
            } else {
                $('.mui-model').showMessage({
                    type: "info",
                    message: languageJson.pathNotExist,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.hint
                });
            }
        });
        taskControlAction.checkDBData();
    });

    //按住ctrl键多选对象(列表显示)
    $("#objLists tbody").delegate('tr','click',function(event){
        $("#objLists tr.selected-tr-active>td:first-child").find('span').removeClass('show-span-active');
        $("#objLists tr.selected-tr-active td").find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $("#downloadbtn,#btnDeleteObjects").addClass('mui-disabled');
        if (global.UCDVersion === "HEC") {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
        }else {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
        }
        $("#downloadbtn").attr('data-title',languageJson.obs_task_downloadUnavailable_tip);
        var self=this;
        if(event.ctrlKey&&event.button===0)
        {//ctrl+鼠标左键事件
            checked = true;
            checkedNum = $(self).index();

            $(self).toggleClass('selected-tr-active');
            $("#downloadbtn,#btnDeleteObjects").toggleClass('mui-disabled');
            if($("#objLists .selected-tr-active").length < 1) {
                //在对象列表中.selected-tr-active的个数选中数量，只统计对象列表中选中的tr元素
                $("#downloadbtn,#btnDeleteObjects").addClass('mui-disabled');
            }
            if (global.UCDVersion === "HEC") {
                $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
            }else {
                $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
            }
            $("#downloadbtn").attr('data-title',languageJson.obs_task_downloadUnavailable_tip);
        }else if(event.shiftKey&&event.button===0){//shift+鼠标左键事件
            $(self).parent().children().removeClass('selected-tr-active');
            $("#downloadFileName").val("");
            if(checked)
            {
                var currCheck = $(self).index();
                var preCheck = checkedNum;
                if(currCheck<preCheck)
                {//大小排序
                    var temp = currCheck+preCheck;
                    currCheck = temp - currCheck;
                    preCheck = temp - preCheck;
                }
                var ul_arr = $("#objLists tbody tr");

                for(var i = preCheck;i<currCheck+1;i++)
                {
                    $(ul_arr[i]).addClass('selected-tr-active');
                    disabledBtn($("#downloadbtn,#btnDeleteObjects"))
                }
            } else {
                checked = true;
                checkedNum = $(self).index();
                $(self).addClass('selected-tr-active');
                disabledBtn($("#downloadbtn,#btnDeleteObjects"))
            }
        }else{
            checked = true;
            checkedNum = $(self).index();
            $(self).parent().children().removeClass('selected-tr-active');
            $("#downloadFileName").val("");
            $(self).addClass('selected-tr-active');
            disabledBtn($("#downloadbtn,#btnDeleteObjects"));
        }
        var fileNames = "";
        $("#objLists tr.selected-tr-active").each(function () {
            if($(this).children('td').eq(0).children('span').children('i').hasClass("mui-icon-object-folder"))
            {
                fileNames = fileNames + JSON.parse($(this).find('.hiddenObjData').text()).name + "|";
            }else
            {
                fileNames = fileNames + JSON.parse($(this).find('.hiddenObjData').text()).name + "|";
            }
        });
        if(pkg.objectColdline || currBucketStorage == 'Coldline'){
            if($("#objLists tr.selected-tr-active").length == 1 && $("#objLists tr.selected-tr-active").attr("data-type") == "file") {
                //冷对象时判断对象是否已经恢复
                var objectStorage = getChoseObjType();
                if (objectStorage === 'Coldline' || objectStorage === "GLACIER"){
                    var restoreState = $("#objLists tr.selected-tr-active").find('.restore_stat').text();
                    if(restoreState){//如果有恢复状态数据才根据页面判断
                        if (_.isEqual($("#objLists tr.selected-tr-active").find('.restore_stat').text(), languageJson.obs_term_restored_lable)){//先根据页面判断该对象是否为未恢复对象
                            disabledBtn($("#downloadbtn"));
                        }else{//先根据页面判断该对象是否为未恢复对象
                            $("#downloadbtn").addClass('mui-disabled');
                        }
                    }
                    var path = getCurrPath();
                    checkObjectRestore(path + JSON.parse($(this).find('.hiddenObjData').text()).name);
                }else{
                    disabledBtn($("#downloadbtn"));
                }
                var path = getCurrPath();
                checkObjectRestore(path + JSON.parse($(this).find('.hiddenObjData').text()).name);
            } else if($("#objLists tr.selected-tr-active").length == 0){
                $("#recoverBtn").addClass('mui-disabled');
            } else {
                var objData = $("#objLists tr.selected-tr-active>.hiddenObjData");
                //冷对象数量
                var glacierNum = 0;
                for(var i = 0; i < objData.length; i++) {
                    var json = JSON.parse($(objData[i]).text());
                    if (json.StorageClass != 'STANDARD_IA'&& json.StorageClass != 'STANDARD') {
                        glacierNum++;
                    }
                }
                //如果只有冷对象时，显示恢复按钮
                if (glacierNum == objData.length) {
                    disabledBtn($("#recoverBtn"));
                }else {
                    $("#recoverBtn").addClass('mui-disabled');
                }
                var restoreState = $("#objLists tr.selected-tr-active").find('.restore_stat');
                var NoRestoreObjNum = 0;
                var RestoringObjNum = 0;
                for(var j = 0; j < restoreState.length; j++) {
                    if(_.isEqual($(restoreState[j]).text(), languageJson.obs_term_notRestored_lable)){
                        NoRestoreObjNum++;
                        break;
                    }
                    if(_.isEqual($(restoreState[j]).text(), languageJson.obs_term_restoring_lable)){
                        RestoringObjNum++;
                        break;
                    }
                }
                //如果有未恢复对象，置灰下载按钮
                if(NoRestoreObjNum > 0 || RestoringObjNum>0){
                    $("#downloadbtn").addClass('mui-disabled');
                }else{
                   disabledBtn($("#downloadbtn"));
                }
            }
        }

        $("#objLists tr.selected-tr-active>td:first-child").find('span').addClass('show-span-active');
        $("#objLists tr.selected-tr-active td").find('.mui-ellipsis-prototype').addClass('show-span-active');
        $("#objLists tr.selected-tr-active>td:first-child").find('span').width($("#objLists tr.selected-tr-active>td:first-child").width() - 10);
        $("#downloadFileName").val(fileNames);
        return false;
    });

    $('.mui-icon-task-statusCheck').on('click',function(){
        $('.task-status-check').addClass('mui-active').css({top:$(this).get(0).offsetTop+$(this).get(0).offsetHeight,left:$(this).get(0).offsetLeft,width:$(this).get(0).offsetWidth});
        return false;
    });

    //根据任务状态筛选任务
    $('.task-status-check li a').on('click', function () {
        var href = $(this).attr('data-href');
        var test = $(this).html();
        $('.mui-icon-task-statusCheck').html(test);

        nowstat=href;//当前选择任务状态
        if(nowstat==='FAILED'){
            $("#taskTabHead thead").find('th').eq('5').addClass('mui-hide');
            $("#taskTabHead thead").find('th').eq('6').addClass('mui-hide');
            $("#taskTabHead thead").find('th').eq('7').removeClass('mui-hide');
        }else{
            $("#taskTabHead thead").find('th').eq('5').removeClass('mui-hide');
            $("#taskTabHead thead").find('th').eq('6').removeClass('mui-hide');
            $("#taskTabHead thead").find('th').eq('7').addClass('mui-hide');
        }
        $('.task-status-check').css('top','-1440px');
        reloadTasks(true);
    });

    //多选任务
    $("#taskConcole .body tbody").delegate('tr', 'click', function () {

        $("#"+selected+" table tbody tr.selected-tr-active>td").find('.mui-ellipsis-4').removeClass('show-span-active');
        $("#"+selected+" table tbody tr.selected-tr-active td").find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $("#"+selected+" table tbody tr.selected-tr-active td").find('.mui-ellipsis-failedTask').removeClass('show-span-active');
        for(var i in taskManager.runningMap){
            taskManager.runningMap[i].active = false;
        }
        var self=this;
        if(event.ctrlKey&&event.button===0)
        {//ctrl+鼠标左键事件
            taskChecked = true;
            taskCheckedNum = $(self).index();
            $(self).toggleClass('selected-tr-active');
        }else if(event.shiftKey&&event.button===0){//shift+鼠标左键事件
            $(self).parent().children().removeClass('selected-tr-active');
            if(taskChecked)
            {
                var currCheck = $(self).index();
                var preCheck = taskCheckedNum;
                if(currCheck<preCheck)
                {//大小排序
                    var temp = currCheck+preCheck;
                    currCheck = temp - currCheck;
                    preCheck = temp - preCheck;
                }
                var ul_arr = $("#"+selected+" tbody tr");
                for(var i = preCheck;i<currCheck+1;i++)
                {
                    $(ul_arr[i]).addClass('selected-tr-active');
                }
            }else
            {
                taskChecked = true;
                taskCheckedNum = $(self).index();
                $(self).addClass('selected-tr-active');
            }
        }else{
            taskChecked = true;
            taskCheckedNum = $(self).index();
            $(self).parent().children().removeClass('selected-tr-active');
            $(self).addClass('selected-tr-active');
        }
        $("#"+selected+" table tbody tr.selected-tr-active>td").find('.mui-ellipsis-4').addClass('show-span-active');
        $("#"+selected+" table tbody tr.selected-tr-active td").find('.mui-ellipsis-prototype').addClass('show-span-active');
        $("#"+selected+" table tbody tr.selected-tr-active td").find('.mui-ellipsis-failedTask').addClass('show-span-active');
        $("#"+selected+" table tbody .selected-tr-active").each(function(){
            var id = $(this).attr('id');
            var task = taskManager.runningMap[id];
            if(task){
                task.active = true;
            }
        });
        return false;
    });


    //暂停任务
    $("#pauseTask").on('click', function () {
        var arr = $("#"+selected+" table tbody tr.selected-tr-active");
        if(arr.length === 0){
            $('.mui-model').showMessage({
                type:"warning",
                message:languageJson.selectTaskToPaused,
                ok:function(){
                    return false;
                },
                title:languageJson.warning
            });
        }
        arr.each(function (i,obj) {
            var id = $(obj).attr('id');
            $(obj).attr('status','paused');
            taskControlAction.pauseTask(id);
        });
        return false;
    });
    function runTask () {
        var arr = $("#" + selected + " table tbody tr.selected-tr-active");
        if (arr.length === 0) {
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.selectTaskToRestart,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
        }
        arr.each(function (i, obj) {
            var id = $(obj).attr('id');
            taskControlAction.startTask(id);
        });
        return false;
    }
    //运行任务
    $("#runTask").on('click', function(){
        runTask();
    });

    //运行所有任务
    $("#runAllTask").on('click', function () {
        $("#runAllTask").addClass('mui-disabled-task');
        var queryString={"$or" : [ { stat:"PAUSE"} , { stat:"FAILED"}]};
        taskManager.countTasks(queryString, function (err,data) {
            if(data === 0 && hasRunning()){
                $('.mui-model').showMessage({
                    type:"info",
                    message:languageJson.obs_task_runAllTask_tip,
                    ok:function(){
                    },
                    title:languageJson.info
                });
            }
        });
        async.parallel([
            function(cb) {
                taskControlAction.startAllTasks(function(){
                    reloadTasks(true);
                    cb();
                });
            },
            function(cb) {
                restoreAllFailedTask(function () {
                    cb();
                });
            }
        ], function (err, results) {
            $("#runAllTask").removeClass('mui-disabled-task');
        });
        return false;
    });

    //暂停所有任务
    $("#pauseAllTask").on('click', function () {
        taskControlAction.pauseAllTasks(function(){
            reloadTasks(true);
        });
        return false;
    });

    //取消所有任务
    $("#cancelAllTask").on('click', function () {
        if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
            showOverlay();
        }
        var message = languageJson.isSureCancelAll;
        if(hasRunning()){
            message = languageJson.cancelRunningTasksMsg;
        }
        $('.mui-model').showMessage({
            type:"warning",
            message:message,
            ok:function(){
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                taskControlAction.abortAllTasks(function(){
                    reloadTasks(true);
                    refreshTaskNum();//刷新所有任务个数
                });
            },
            cancel:function(){
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                return false;
            },
            title:languageJson.warning
        });
        return false;
    });

    //取消任务
    $("#cancelTask").on('click', function () {
        var arr = $("#"+selected+" table tbody tr.selected-tr-active");
        if(arr.length === 0){
            $('.mui-model').showMessage({
                type:"warning",
                message:languageJson.selectTaskToCancel,
                ok:function(){
                    return false;
                },
                title:languageJson.warning
            });
        }else{
            if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
                showOverlay();
            }
            var message = languageJson.isSureCancel;
            $("#"+selected+" table tbody tr.selected-tr-active").each(function () {
                if($(this).find('td').eq(4).find('span').text()===languageJson.running){
                    if($("#"+selected+" table tbody tr.selected-tr-active").length>1){
                        message = languageJson.cancelRunningTasksMsg;
                    }else{
                        message = languageJson.cancelRunningTaskMsg;
                    }
                }
            });
            $('.mui-model').showMessage({
                type:"warning",
                message:message,
                ok:function(){
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    arr.each(function (i,obj) {
                        var id = $(obj).attr('id');
                        taskControlAction.abortTask(id);
                    });
                },
                cancel:function(){
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    return false;
                },
                title:languageJson.warning
            });
        }
        return false;
    });

    //暂停任务
    $("#taskPanel tbody").delegate('tr .mui-icon-task-pause','click', function () {
        var self = this;
        $(self).parent().parent().parent().children().removeClass("selected-tr-active");
        $(self).parent().parent().addClass("selected-tr-active");
        setTimeout(function () {
            $("#pauseTask").click();
        },50);
    });

    //运行任务
    $("#taskPanel tbody").delegate('tr .mui-icon-task-run1','click', function () {
        var self = this;
        var id = $(self).parent().parent().attr('id');
        var bucket = $(self).parent().parent().find('td:eq(1) span').text();
        taskControlAction.resumeTask(bucket, id);
        return false;
    });

    //取消任务
    $("#taskPanel tbody").delegate('tr .mui-icon-task-cancel1','click', function () {
        var self = this;
        $(self).parent().parent().parent().children().removeClass("selected-tr-active");
        $(self).parent().parent().addClass("selected-tr-active");
        setTimeout(function () {
            $("#cancelTask").click();
        },50);
    });

    //切换用户
    $("#userList").delegate('li a.user',"click", function () {
        $("#clearAccountInput").click();
        hideOtherPop();
        var self = this;
        var id = $(self).attr('data-id');
        /**
         * $('.mui-header .controls a.btnTaskManage').hasClass('running') 加入这个判断的原因是hasRunning判断有时间间隔，当上传文件一点击完成就立马切换用户，会出现任务还没开始运行，就不会提示用户执行中的任务会被暂停
         * 为了方便快捷，影响小所以通过判断界面上右上角那个执行任务的图标来做辅助判断，因为只要有即将启动的任务这个图标就会改变成running状态，这个不会出现延迟
         */
        if(hasRunning() || $('.mui-header .controls a.btnTaskManage').hasClass('running')){
            var msg = languageJson.changeAccountWithTask;
            hasMovingTask(function(err, data){
                if(data > 0){
                    msg = languageJson.obs_switchUser_check_move_task_confirm;
                }
                $('.mui-model').showMessage({
                    type: "warning",
                    message: msg,
                    ok: function () {
                        isLoaded = false;
                        $('.btnUserInfo').addClass('userNoLogin');
                        var href = $(self).attr('data-href');
                        var showName = encoderForHtml(href).length>20?encoderForHtml(href).substring(0,20)+"...":encoderForHtml(href);
                        var str = '<span title="'+ encoderForHtml(href) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                        $(".btnUserInfo").html(str);
                        if(taskControlAction){
                            taskControlAction.pauseAllTasks(function(){
                                if(taskManager){
                                    taskControlAction.closeInterval();
                                }
                                taskControlAction.updateIteratorsObject(false);
                                changeUserUI(id);
                            });
                        }else{
                            changeUserUI(id);
                        }
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                    },
                    cancel: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    },
                    title: languageJson.warning
                });
                showOverlay();
            })

        }else{
            if(taskControlAction){
                taskControlAction.updateIteratorsObject(false);
            }
            isLoaded = false;
            $('.btnUserInfo').addClass('userNoLogin');
            var id = $(self).attr('data-id');
            var href = $(self).attr('data-href');
            var showName = encoderForHtml(href).length>20?encoderForHtml(href).substring(0,20)+"...":encoderForHtml(href);
            var str = '<span title="'+ encoderForHtml(href) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
            $(".btnUserInfo").html(str);
            if(taskControlAction){
                taskControlAction.pauseAllTasks(function(){
                    if(taskManager){
                        taskControlAction.closeInterval();
                    }
                    changeUserUI(id);
                });
            }else{
                changeUserUI(id);
            }
        }
    });

    //创建桶
    $("#btnCreateBucket").on('click',function(e){
        var bName=$('#bucketName').val();
        var region = '';
        if(userType==='1'){
            if(!$("#regionSelect").hasClass('mui-hide')){
                region = $("#regionSelect").val();
            }else{
                region = $("#regionStr1").html();
            }
        }else{
            region = $("#regionStr").val();
            if(region && region.length > 1024) {
                $('.mui-model').showMessage({
                    type:'warning',
                    message: languageJson.obs_term_characterLimit_info.format(languageJson.obs_term_region_column, 1024),
                    ok: function () {
                       return;
                    },
                    title: languageJson.warning
                });
                return;
            }
        }
        var str = bucketAndObjectAction.bucketNameCheck(bName,languageJson);
        var bNameIsExist = false;
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var loading = loadingShow();
        $("#createBucketPage").css('z-index', '90');
        bucketAndObjectAction.listBucket(function(err,data){
            if(err){
                logger.error(err);
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message)
                    });
                }
                loading.close();
                $("#createBucketPage").css('z-index', '1000');
                showOverlay();
            }else{
                for (var index in data.Buckets) {
                    var bucketName = data.Buckets[index].Name;
                    if(bucketName === bName.trim()){
                        bNameIsExist = true;
                        $('.mui-model').showMessage({
                            type:'warning',
                            message: languageJson.bucketNameRepeat,
                            ok: function () {
                                $("#bucketName").focus();
                                $("#bucketName").val('');
                                $("#createBucketPage").css('z-index', '1000');
                            },
                            title: languageJson.warning
                        });
                        $("#createBucketPage").css('z-index', '90');
                        $("#btnCreateBucket").blur();
                        return false;
                    }
                }
                if(!bNameIsExist){
                    if(str.trim().length===0){
                        var start = new Date().getTime();
                        var storageType = $("#chosedStorageType").html();
                        bucketAndObjectAction.createBucket(storageType,bName,region,function(err,data){
                            var end = new Date().getTime();
                            logger.info('createBucket time =====',end-start);
                            if (err) {
                                if(err.code === "Unauthorized"){//创建桶未实名
                                    $(".mui-page-full.shown").removeClass('shown');
                                    $("#auth").removeClass('mui-hide');
                                    $("#auth").addClass('shown');
                                    divDragFunc('authDrag','auth');
                                }
                                logger.error("create bucket err",err);
                                if(errorConfig[err.code]){
                                    $('.mui-model').showErrorMessage({
                                        message: errorConfig[err.code],
                                        obsError: obsError(err.code,err.message),
                                        ok:function () {
                                            $("#createBucketPage").css('z-index', '1000');
                                        }
                                    });
                                }
                                loading.close();
                                $("#createBucketPage").css('z-index', '90');
                                showOverlay();
                            }
                            else {
                                $("#createBucketPage").removeClass('shown');
                                $("#createBucketPage").css('z-index', '1000');
                                $('#bucketName').val('');
                                $("#regionStr").val('');
                                $('#btnCeacelCreateBucket').click();
                                var msg = CommonUtils.format(languageJson.createBucketSuccess, CommonUtils.encodeForHTML(bName));
                                $('.mui-model').showMessage({
                                    message: msg,
                                    ok: function () {
                                        $("#createBucketPage input").each(function () {
                                            $(this).val('');
                                        });
                                        if ($("#mui-overlay").size() > 0) {
                                            mui.overlay('off');
                                        }
                                        return false;
                                    },
                                    title: languageJson.info
                                });
                                $("#lastUpdateTh").addClass("lastUpdateThNodata");
                                $("#objLists tbody").html('<div class="table-nodata"><span>' + languageJson.noData + '</span></div>');
                                $("#objLists-table-section").addClass("mui-hide");
                                bucketAndObjectAction.listBucket(function(err,data){
                                    listBucketUI(err,data,loading,bName)
                                });
                                showOverlay();
                            }
                            return false;
                        });
                    }
                    else{
                        loading.close();
                        showOverlay();
                        $("#createBucketPage").css('z-index', '1000');
                        $('.mui-model').showMessage({
                            type:"warning",
                            message:str,
                            ok:function(){
                                $('#bucketName').focus();
                            },
                            title:languageJson.warning
                        });
                        return false;
                    }
                }else{
                    loading.close();
                    $("#createBucketPage").css('z-index', '1000');
                    showOverlay();
                }
            }
        });
        return false;
    });

    $("#btnCeacelCreateBucket").on('click', function () {
        $("#createBucketPage").removeClass('shown');
        $('#bucketName').val('');
        $("#regionStr").val('');
        $('#ExBucketName').val('');
        $('.help-tips').html('');
        $('.help-tips').css('top','-650px');
        $('.help-tips').removeClass('active');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
    });

    //新建文件夹
    $("#btnCreateFolder").on('click', function () {
        var path = getCurrPath();
        var bucketName = $('#curBucketName').html();
        var folderName = $("#floderName").val();
        bucketAndObjectAction.folderNameCharacter(folderName,languageJson, function (errMsg,folderName,errKey) {
            if(errMsg){
                if(errKey === "folderNameTooLarge"){
                    $('.mui-model').showErrorMessage({
                        message: languageJson.folderNameTooLarge,
                        obsError: obsError("folderNameTooLarge")
                    });
                    return false;
                }
                $("#floderName").val(folderName);
                $('.mui-model').showMessage({
                    type:'warning',
                    message: errMsg,
                    ok: function () {
                        $("#floderName").focus();
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                if(bucketName) {
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    var loading = loadingShow();
                    $("#createFolderPage").css('z-index', '90');

                    //检查文件夹是否存在
                    bucketAndObjectAction.listObject(bucketName,"true",path+folderName.trim()+"/",function(err,data){
                        if(err){
                            loading.close();
                            if(errorConfig[err.code]){
                                $('.mui-model').showErrorMessage({
                                    message: errorConfig[err.code],
                                    obsError: obsError(err.code,err.message),
                                    ok: function () {
                                        $("#createFolderPage").css('z-index', '1000');
                                        return false;
                                    },
                                });
                                showOverlay();
                            }
                        } else if (data.Contents.length >0 || data.CommonPrefixes.length >0){
                            loading.close();
                            $('.mui-model').showMessage({
                                type:'warning',
                                message: languageJson.FolderAlreadyExists,
                                ok: function () {
                                    $("#createFolderPage").css('z-index', '1000');
                                    return false;
                                },
                                title: languageJson.warning
                            });
                            showOverlay();
                        } else{
                            bucketAndObjectAction.createFolder(bucketName,path+folderName.trim()+"/",function(err,data){
                                if (err) {
                                    logger.error(err);
                                    if(errorConfig[err.code]){
                                        $('.mui-model').showErrorMessage({
                                            message: errorConfig[err.code],
                                            obsError: obsError(err.code,err.message)
                                        });
                                    }
                                    loading.close();
                                    $("#createFolderPage").css('z-index', '1000');
                                    showOverlay();
                                }
                                else {
                                    $(".mui-page-full.shown").removeClass('shown');
                                    $("#floderName").val('');
                                    loading.close();
                                    $("#createFolderPage").css('z-index', '1000');
                                    $('.mui-model').showMessage({
                                        message:CommonUtils.format(languageJson.createFolderSuccess, CommonUtils.encodeForHTML(CommonUtils.substr32(folderName)+"/")),
                                        ok: function () {
                                            if ($("#mui-overlay").size() > 0) {
                                                mui.overlay('off');
                                            }
                                            return false;
                                        },
                                        title: languageJson.info
                                    });
                                    pageContext = {};//重置分页对象
                                    pageContext.nowPage = 1;
                                    $("#prefixSearch").val('');
                                    $("#clearPrefixSearchInput").addClass("mui-hide");
                                    bucketAndObjectAction.listObject(bucketName,'true',path,function(err,data){
                                        listObjectUI(err,data,bucketName);
                                    });
                                    $("#downloadFileName").val('');
                                    showOverlay();
                                }
                                return false;
                            });
                        }
                    });
                }else
                {
                    $('.mui-model').showMessage({
                        type:"warning",
                        message:languageJson.selectBucket,
                        ok:function(){
                            return false;
                        },
                        title:languageJson.warning
                    });
                }
            }
        },path);
    });

    //关闭新建文件夹页面
    $("#btnCeacelCreateFolder").on('click', function () {
        $("#createFolderPage").removeClass('shown');
        $('#floderName').val('');
        $('.help-tips').html('');
        $('.help-tips').css('top','-650px');
        $('.help-tips').removeClass('active');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
    });

    //检查更新
    $("#checkUpdate").on('click', function () {
        //升级功能
        mosUpdate(true);
    });

    $("#createBucketPageDrag,#createFolderPageDrag,#ExBucketPageDrag").on('mousedown',function(){
        $('.help-tips').html('');
        $('.help-tips').css('top','-650px');
        $('.help-tips').removeClass('active');
    });
    //关闭系统配置页面
    $("#cancelSysConfig").on('click', function () {
        $("#config").removeClass('shown');
        $("#systemConfig").addClass('mui-hide');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
    });

    //关闭账户配置页面
    $("#cancelAccountBth").on('click', function () {
        $('#createAccount input').each(function () {
            $(this).val('');
        });
        $("#isSaveSK").get(0).checked = true;
        $("#accountList").css('z-index','1000');
        if($("#saveAccountBtn").attr('data-init')==='true'){
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            $("#saveAccountBtn").removeAttr('data-init');
        }
        if($("#saveAccountBtn").attr('data-edit')==='true'){
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            $("#saveAccountBtn").removeAttr('data-edit');
        }
        $("#createAccount").removeClass('shown');
        $("#createAccountTab").addClass('mui-hide');
    });

    //读取系统配置信息
    $('#sysSetting').on('click', function () {
        if(UCDVersion == 'HEC'){
            $("#MD5check").parent().removeClass('mui-hide');
        }
        indexAction.loadSetting(function (configObj) {
            if (configObj) {
                $("#isAutoUpdate").get(0).checked = ("Y" === configObj.isAutoUpdate);
                $("#userExperience").get(0).checked = ("Y" === configObj.userExperience);
                $("#isHttps").get(0).checked = ("Y" === configObj.isHttps);
                $("#isSSL").get(0).checked = ("Y" === configObj.isSSL);
                $("#MD5check").get(0).checked = ("Y" === configObj.isMD5check);
                if(configObj.isHttps === "Y"){
                    $("#isSSL").attr("disabled",false);
                    $("#isSSL").next().removeClass("ti-text-muted");
                    $("#serverEncryption").attr("disabled",false);
                    $("#serverEncryption").next().removeClass("ti-text-muted");
;                }
                //服务端加密显示
                if(isShowServerEncryption){
                    $("#serverEncryption").get(0).checked = (true == configObj.isServerEncryption);
                }
                if (configObj && configObj.uploadTaskNum) {
                    uploadTaskNum = parseInt(configObj.uploadTaskNum);
                    $("#uploadTaskNum").val(uploadTaskNum);
                }
                if (configObj && configObj.downloadTaskNum) {
                    downloadTaskNum = parseInt(configObj.downloadTaskNum);
                    $("#downloadTaskNum").val(downloadTaskNum);
                }
                if(configObj.language){
                    $("#language").val(configObj.language);
                    $("#language").selectmenu('refresh', true);
                    //如果语言配置文件不存在，则显示默认语言
                    if(!$("#language").val()){
                        $("#language").val(curLang);
                        $("#language").selectmenu('refresh', true);
                    }
                    //如果当前语言为中文并且版本为DT版本，修改语言配置
                    if($("#language").val()=='zh'&& UCDVersion !== 'HEC' && UCDVersion !== 'TLF'&& UCDVersion !== 'OCB'&& UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'FCS'){
                        $("#language").val('en');
                        $("#language").selectmenu('refresh', true);
                    }
                }
                if(configObj.multiUploadNum){
                    $("#multiUploadNum").val(configObj.multiUploadNum);
                    $("#multiUploadNum").removeAttr('disabled');
                }

                if(configObj.proxy){
                    $("#isProxy").get(0).checked = (configObj.proxy.isProxy);
                    if(configObj.proxy.isProxy){
                        $("#proxyAddress").val(configObj.proxy.proxyIP).removeAttr('disabled');
                        $("#proxyPort").val(configObj.proxy.proxyPort).removeAttr('disabled');
                        $("#isAuthentication").removeAttr('disabled');
                        $("#proxyAuth,#proxyInfo").removeClass('mui-hide');
                    }else{
                        $("#proxyAuth,#proxyInfo").addClass('mui-hide');
                        $("#proxyAddress").val('').attr('disabled',true);
                        $("#proxyPort").attr('disabled',true);
                        $("#proxyPort").val('8080');
                        $("#isAuthentication").attr('disabled',true);
                    }
                    $("#isAuthentication").get(0).checked = (configObj.proxy.isAuthentication);
                    if(configObj.proxy.isAuthentication){
                        $("#proxyusname").val(configObj.proxy.proxyUserName).removeAttr('disabled');
                        $("#proxypswd").next().val(pwdPlaceHolder).removeAttr('disabled');
                        $("#proxypswd").val(configObj.proxy.proxyPwd);   //隐藏的控件保存原值
                        $("#realpwd").val(configObj.proxy.proxyPwd);
                        $("#proxydomain").val(configObj.proxy.proxyDomain).removeAttr('disabled');
                    }else{
                        $("#proxyusname").val('').attr('disabled',true);
                        $("#proxypswd").next().val('').attr('disabled',true);
                        $("#proxydomain").val('').attr('disabled',true);
                    }
                }

                if(configObj.objPerPageSize) {
                    $("#objPerPageSize").val(configObj.objPerPageSize);
                }
            }else if(language){
                $("#language").val(language);
                $("#language").selectmenu('refresh', true);
                if($("#language").val()=='zh'&&UCDVersion !== 'HEC'&& UCDVersion !== 'OCB'&& UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'FCS'){
                    $("#language").val('en');
                    $("#language").selectmenu('refresh', true);
                }
            }

            //DT版本只有英文版，去掉语言选择配置项
            if(UCDVersion==='DT'){
                $("#language").val('en');
                $("#language").selectmenu('refresh', true);
                $("#languageDiv").addClass('mui-hide');
            } else if(UCDVersion === 'CTC') {//CTC版本只有中文版，去掉语言选择配置项
                $("#language").val('zh');
                $("#language").selectmenu('refresh', true);
                $("#languageDiv").addClass('mui-hide');
            }
            $("#systemConfig").removeClass('mui-hide');
            $("#config").addClass('shown');
            return false;
        });
        $("#general").click();
        divDragFunc('configDrag','config');
        showOverlay();
        tabFocus("subSysConfig");
    });

    $('#objLists').delegate('.mui-icon-handel-download','mouseenter', function (e) {
        $(this).attr('title',languageJson.down);
    });

    $('#objLists').delegate('.mui-icon-handel-del','mouseenter', function (e) {
        $(this).attr('title',languageJson.delete);
    });

    $('#objLists').delegate('.mui-icon-handel-share','mouseenter', function (e) {
        $(this).attr('title',languageJson.objectAttr);
    });
    //实名认证确定按钮
    $("#sureAuth").on("click",function () {
        $(".mui-page-full.shown").removeClass('shown');
        $("#auth").addClass('mui-hide');
        if ($("#mui-overlay").size() > 0) {//取消蒙层
            mui.overlay('off');
        }
        $("#createBucketPage input").each(function () {//清空创建桶页面input值
            $(this).val('');
        });
    })

    $(".mui-model .mui-model-close").on('click', function () {
        $(this).parent().removeClass('mui-active').removeClass('mui-model-mini');
        $('.mui-btn.cancel').click();
        $('.mui-btn.ok').click();
        $(this).parent().find('.mui-btn.ok,.mui-btn.cancel').unbind();
        return false;
    });

    $("#serverEncryption").on("change", function(){
        var checked = $("#serverEncryption").is(":checked");
        if(checked) {
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.defaultKMSKeyInit,
                ok: function () {
                    return false;
                },
                cancel: function () {
                    $("#serverEncryption").get(0).checked = false;
                    return false;
                },
                title: languageJson.warning
            });
        }
    })
    //保存系统配置信息
    $("#subSysConfig").click(function () {
        var configObj = {};
        isAutoUpdate = $("#isAutoUpdate").is(":checked") ? 'Y' : 'N';
        configObj.isAutoUpdate = isAutoUpdate;
        userExperience = $("#userExperience").is(":checked") ? 'Y' : 'N';
        configObj.isMD5check = $("#MD5check").is(":checked") ? "Y" : "N";
        if(UCDVersion !== 'HEC'){
            configObj.isMD5check = 'N';
        }
        global.isMD5check = configObj.isMD5check;
        configObj.userExperience = userExperience;
        language = $("#language").val();
        configObj.mongoAuthPwd = global.newMongoPwd;
        //服务端加密信息保存
        var isServerEncryption = $("#serverEncryption").is(":checked") ? true : false;

        if(isServerEncryption){
            if(!$("#isHttps").is(":checked")){
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.isUsedHttps,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }
        }

        global.serverEncryption = isServerEncryption;
        configObj.isServerEncryption = isServerEncryption;

        //读取系统语言
        configObj.language = language;
        var valUpload= $("#uploadTaskNum").val().trim();
        var valDown=$("#downloadTaskNum").val().trim();

        var multiUploadNum = parseInt($("#multiUploadNum").val().trim() || 0);
        if (multiUploadNum >= 5 && multiUploadNum <= 5120) {
            configObj.multiUploadNum = $("#multiUploadNum").val();
            uploadConfig.multiUploadNum = $("#multiUploadNum").val();
        }
        else {
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.notMoreThan5GB,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }

        var uploadTaskNumber = parseInt(valUpload || 0);
        var downloadTaskNumber = parseInt(valDown || 0);
        var min=parseInt($("#uploadTaskNum").attr('min'));
        var max=parseInt($("#uploadTaskNum").attr('max'));
        if(uploadTaskNumber<min || uploadTaskNumber>max){
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.maxUploadTaskNumWarn,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }else{
            uploadTaskNum = uploadTaskNumber;
            configObj.uploadTaskNum = uploadTaskNum;
            uploadConfig.maxUploadTasks = uploadTaskNum;
        }
        min=parseInt($("#downloadTaskNum").attr('min'));
        max=parseInt($("#downloadTaskNum").attr('max'));
        if(downloadTaskNumber < min || downloadTaskNumber > max){
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.maxDownloadTaskNumWarn,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }else{
            downloadTaskNum = downloadTaskNumber;
            configObj.downloadTaskNum = downloadTaskNum;
            downloadConfig.maxTaskNum = downloadTaskNum;
        }

        //添加网络代理配置
        var proxys = {};
        proxys.isProxy = $("#isProxy").is(":checked") ? true : false;
        if(proxys.isProxy){
            var proxyIP = $("#proxyAddress").val().trim();
            var proxyPort = $("#proxyPort").val();
            var regAdress = /^(?=^.{3,255}$)[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+$/;
            var regIP = /^(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)$/i;
            if(!(proxyIP)){
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.ProxyIPNotNull,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else if(proxyIP.length>255){
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.obs_term_proxyAddressLength_valid,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                var regIsNum = /^[0-9]*$/;
                var isNum = regIsNum.test(proxyIP.split('.').join(''));
                if(isNum){
                    if (!regIP.test(proxyIP)) {
                        $(".config-left li[data-href=\"#networkSetting\"]").click();
                        $('.mui-model').showMessage({
                            type: "warning",
                            message:  languageJson.obs_term_proxyAddress_valid,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.warning
                        });
                        return false;
                    }
                }else{
                    if (!regAdress.test(proxyIP)) {
                        $(".config-left li[data-href=\"#networkSetting\"]").click();
                        $('.mui-model').showMessage({
                            type: "warning",
                            message:  languageJson.obs_term_proxyAddress_valid,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.warning
                        });
                        return false;
                    }
                }
            }
            if (proxyPort>65535){
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.ProxyPortErr,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                proxys.proxyIP = proxyIP;
                proxys.proxyPort = proxyPort;
            }
            proxys.isAuthentication = $("#isAuthentication").is(":checked") ? true : false;
            if(proxys.isAuthentication){
                var proxyUserName = $("#proxyusname").val().trim();
                var proxyPwd = $("#proxypswd").next().val();
                if(proxyPwd===pwdPlaceHolder){
                    //未修改，取原值
                    proxyPwd = $("#proxypswd").val();
                }
                var proxyDomain = $("#proxydomain").val();
                if(!proxyUserName){
                    $('.mui-model').showMessage({
                        type: "warning",
                        message: languageJson.userOrPwdIsNull,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.warning
                    });
                    return false;
                }else if(proxyUserName.length>255){
                    $('.mui-model').showMessage({
                        type: "warning",
                        message: languageJson.obs_term_proxyUserLength_valid,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.warning
                    });
                    return false;
                }else{
                    proxys.proxyUserName = proxyUserName;
                    proxys.proxyPwd = proxyPwd;
                    proxys.proxyDomain = proxyDomain;
                }
            }
        }
        configObj.proxy = proxys;
        proxy = JSON.parse(JSON.stringify(proxys));
        if(taskManager){
            taskManager.setUploadConfig(uploadConfig);
            taskManager.setDownloadConfig(downloadConfig);
        }
        var https = $("#isHttps").is(":checked") ? "Y" : "N";

        if(!chekcObjPageSize(configObj)) {
            return false;
        }

        if (isHttps !== https) {
            if ("N" === https) {
                configObj.isHttps = https;
                isHttps = https;
                configObj.isSSL = "N";
                isSSL = configObj.isSSL;
                indexAction.writeSysConfig(configObj);
                $("#config").removeClass('shown');
                isLoaded = false;
                $('.btnUserInfo').addClass('userNoLogin');
                $("#lsBuckets").html('');//清空桶列表
                $("#objContainer").html('');//清空对象列表
                $("#objLists tbody").html('');
                if(taskControlAction){
                    taskControlAction.pauseAllTasks(function(){
                        if(taskManager){
                            taskControlAction.closeInterval();
                        }
                        changeUserUI(currentUserId);
                    });
                }else{
                    changeUserUI(currentUserId);
                }
                $("#multiDownloadNum").val(5);
                $("#multiUploadNum").val(5);
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            } else if ("Y" === https && userType === '2') {
                configObj.isHttps = https;
                isHttps = https;
                $("input[name='res']").click();
                configObj.isSSL = $("#isSSL").is(":checked") ? "Y" : "N";
                isSSL = configObj.isSSL;
                indexAction.writeSysConfig(configObj);
                $("#config").removeClass('shown');
                isLoaded = false;
                $('.btnUserInfo').addClass('userNoLogin');
                $("#lsBuckets").html('');//清空桶列表
                $("#objContainer").html('');//清空对象列表
                $("#objLists tbody").html('');
                if(taskControlAction){
                    taskControlAction.pauseAllTasks(function(){
                        if(taskManager){
                            taskControlAction.closeInterval();
                        }
                        changeUserUI(currentUserId);
                    });
                }else{
                    changeUserUI(currentUserId);
                }
                $("#multiDownloadNum").val(5);
                $("#multiUploadNum").val(5);
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            } else {
                configObj.isHttps = https;
                isHttps = https;
                $("input[name='res']").click();
                configObj.isSSL = $("#isSSL").is(":checked") ? "Y" : "N";
                isSSL = configObj.isSSL;
                indexAction.writeSysConfig(configObj);
                $("#config").removeClass('shown');
                isLoaded = false;
                $('.btnUserInfo').addClass('userNoLogin');
                $("#lsBuckets").html('');//清空桶列表
                $("#objContainer").html('');//清空对象列表
                $("#objLists tbody").html('');
                if(taskControlAction){
                    taskControlAction.pauseAllTasks(function(){
                        if(taskManager){
                            taskControlAction.closeInterval();
                        }
                        changeUserUI(currentUserId);
                    });
                }else{
                    changeUserUI(currentUserId);
                }
                $("#multiDownloadNum").val(5);
                $("#multiUploadNum").val(5);
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            }
        } else {
            configObj.isHttps = https;
            isHttps = https;
            if("Y" === https){
                configObj.isSSL = $("#isSSL").is(":checked") ? "Y" : "N";
            }else{
                configObj.isSSL = "N";
            }
            isSSL = configObj.isSSL;
            $("input[name='res']").click();
            indexAction.writeSysConfig(configObj);
            $("#config").removeClass('shown');
            $("#multiDownloadNum").val(5);
            $("#multiUploadNum").val(5);
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
        }
        $("#systemConfig").addClass('mui-hide');
        s3 = indexAction.updateS3(s3,configObj);


    });

    //用户意见反馈
    $('#btnUserSurvey').on('click', function () {
        showUserCommentWind();
        divDragFunc('userCommentDivDrag','userCommentDiv');
    });

    $("#config input[type='checkbox']").change(function () {
        var self = this;
        var href = $(self).attr('data-href');
        if ($(self).is(':checked')) {
            $("#" + href).attr("disabled", false);
        } else {
            $("#" + href).attr("disabled", true);
        }
    });
    //桶列表排序
    $("#BucketCreated").on('click',function(){
        var $trs = $('#bucketLists tbody .mui-icon-bucket').parent().parent();//外部桶无创建时间不排序
        $trs.sort(function(a,b){
            var t1 = $(a).find('span[name="localDate"]').text();
            var t2 = $(b).find('span[name="localDate"]').text();
            var x = new   Date(Date.parse(t1.replace(/-/g,   "/")));
            var y = new   Date(Date.parse(t2.replace(/-/g,   "/")));
            if(BucketSort){
                if(parseInt(x.getTime()) < parseInt(y.getTime())) return 1;
                else return -1;
            }else {
                if(parseInt(x.getTime()) < parseInt(y.getTime())) return -1;
                else return 1;
            }
        });
        $("#BucketCreated").toggleClass("lastUpdateTh");
        if(BucketSort){
            BucketSort = false;
            $trs.detach().appendTo('#bucketLists tbody');
        }else {
            BucketSort = true;
            $trs.detach().prependTo('#bucketLists tbody');
        }
    });
    //对象列表排序
    $("#lastUpdateTh").on('click',function(){
        var $trs = $('#objLists tbody tr[data-type="file"]');
        $trs.sort(function(a,b){
            var t1 = $(a).find('td:eq(5)').text();
            var t2 = $(b).find('td:eq(5)').text();
            var x = new   Date(Date.parse(t1.replace(/-/g,   "/")));
            var y = new   Date(Date.parse(t2.replace(/-/g,   "/")));
            if(objSort){
                if(parseInt(x.getTime()) < parseInt(y.getTime())) return 1;
                else return -1;
            }else {
                if(parseInt(x.getTime()) < parseInt(y.getTime())) return -1;
                else return 1;
            }
        });
        $("#lastUpdateTh").toggleClass("lastUpdateTh");
        if(objSort){
            objSort = false;
            $trs.detach().appendTo('#objLists tbody');
        }else {
            objSort = true;
            $trs.detach().prependTo('#objLists tbody');
        }
    });
    //前缀查询输入框获取焦点增加颜色
    $("#prefixSearch").on('focus',function () {
        $("#PrefixIput").addClass("dtColor")
    });
    //前缀查询输入框失去焦点取消颜色
    $("#prefixSearch").on('blur',function () {
        $("#PrefixIput").removeClass("dtColor")
    });
    //桶左侧输入框获取焦点增加颜色
    $("#bucketSearch").on('focus',function () {
        $("#BucketIput").addClass("dtColor")
    });
    //桶左侧输入框失去焦点取消颜色
    $("#bucketSearch").on('blur',function () {
        $("#BucketIput").removeClass("dtColor")
    });
    //前缀查询
    $(".btnSearch").on('click', function () {
        var prefix = $("#prefixSearch").val().trim();
        if(searchBucketTable(prefix)) {
            return;
        }
        var mui_hide = $("#bucketArea").attr("class");
        //有这个hide样式，则是object列表，否则是bucket列表
        if(!mui_hide && mui_hide != "mui_hide") {
            return
        }
        var bucketName = $('#curBucketName').html();
        if(prefix.length > 0){
            $("#isSearch").val("true");
        }else{
            $("#isSearch").val("");
        }
        var path = getCurrPath();
        prefix = path + prefix;
        if(bucketName)
        {
            var loading=loadingShow();
            pageContext = {};//重置分页对象
            pageContext.nowPage = 1;
            bucketAndObjectAction.listObject(bucketName,"true",prefix,function(err,data){
                if(err && err.message && err.message.indexOf("prefix") > -1 && err.message.indexOf("too") > -1) {
                    global.logger.error("searchPrefixTooLong!", err);
                    err.code = "searchPrefixTooLong";
                }
               if(data&&(data.Contents.length >0||data.CommonPrefixes.length>0)){//能够搜索到文件或文件夹
                   var prefix = data.Prefix;
                   var arr = prefix.split("/");
                   var str = {
                       name: bucketName
                   };
                   var htmStr = renderSync("head-navi-item", {
                       currPath: JSON.stringify(str),
                       folderName: bucketName
                   });
                   $(".mui-body .mui-content .path").html(htmStr);
                   var length = 0;
                   for(var i=0;i<arr.length-1;i++){
                       length+=arr[i].length+1;
                       var str = {
                           name: prefix.slice(0,length)
                       }
                       var htmStr = renderSync("head-navi-item", {
                           currPath: JSON.stringify(str),
                           folderName: arr[i]
                       });
                       $(".mui-body .mui-content .path").append(htmStr);
                   }
               }
                listObjectUI(err,data,bucketName);
                loading.close();
            });
        }else{
            $('.mui-model').showMessage({
                type:"warning",
                message:languageJson.selectBucket,
                ok:function(){
                    return false;
                },
                title:languageJson.warning
            });
        }
    });

    //全选功能
    $('#listObjBodyDiv,#uploadTaskDiv,#downloadTaskDiv,#deleteTaskDiv,#recoverTaskDiv,#lifecycleTabDiv,#multipartDiv,#corsTabDiv').on('mouseover',function(){
        if(!$(this).hasClass('onMouseOver')){
            $('#listObjBodyDiv,#uploadTaskDiv,#downloadTaskDiv,#deleteTaskDiv,#recoverTaskDiv,#lifecycleTab,#multipartTab,#corsTab').removeClass('onMouseOver');
            $(this).addClass('onMouseOver');
        }
    });

    $('body').on('keypress', function (event) {
        if (event.keyCode === 13)
        {
            if($("textarea").is(':focus')){
                return true;
            }else{
                return false;
            }
        }
    });
    //禁用tab
    $('body').on('keydown', function (event) {
        if (event.keyCode === 9) {
            return false;
        }
    });

    //挂载外部桶
    $('.btnExBucket').on('click', function () {
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#ExBucketPage").addClass('shown');
        divDragFunc('ExBucketPageDrag','ExBucketPage');
        tabFocus('ExBucketName');
        return false;
    });

    window.onresize = function(){
        $("#objLists").css("width",$("#objListsHead").css("width"));
        $("#" + selected + " table").css("width",$("#taskTabHead").css("width"));
        $("#corsTab").css("width",$("#corsTabDiv").css("width"));
        $("#multipartTab").css("width",$("#multipartPageTab").css("width"));
    };


    //挂载外部桶
    $('#btnCeacelExBucket').on('click', function () {
        $("#createBucketPage").removeClass('shown');
        $('#ExBucketName').val('');
        $('#regionStr').val('');
        $('#bucketName').val('');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });
    /**
     * 添加外部桶前检查是否coldline
     * @param err
     * @param data
     * @returns {boolean}
     */
    function checkColdlineBucket(err, data) {
        var currBucketStorage = (data && data.StorageType) || false;
        if(currBucketStorage === 'Coldline'){
            $('.mui-model').showErrorMessage({
                message: languageJson.obs_task_createAddColdlineExternalBucket_info,
                ok:function(){
                    $('#ExBucketName').focus();
                }
            });
            return false
        }
        return currBucketStorage;
    }
    //保存外部桶
    $('#btnExBucket').on('click',function(){
        var bName=$('#ExBucketName').val().trim();
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        $('#btnExBucket').attr('disabled','disabled');
        var loading = loadingShow();
        $("#createBucketPage").css('z-index', '90');
        //桶名为空警告
        if(!bName){
            $('.mui-model').showMessage({
                type:"warning",
                message: languageJson.bucketNameNotNull,
                ok:function(){
                    $('#ExBucketName').focus();
                    showCreateBucket();
                    return false;
                },
                title:languageJson.warning
            });
            showOverlay();
            $("#createBucketPage").css('z-index', '1000');
            return false;
        };
        bucketAttributeAction.headBucket(bName, function(err, results){
            var str = bucketAndObjectAction.bucketNameCheck(bName,languageJson);
            //桶名符合校验规范情况
            if(str.trim().length===0){
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                //外部桶名是否重复
                var isExtNameRepeat = false;
                $('#bucketLists .mui-icon-extBucket').each(function () {
                    //判断外部桶是否已经挂载
                    if($(this).text() === bName){
                        isExtNameRepeat = true;
                    }
                });
                $("#createBucketPage").css('z-index', '90');
                bucketAndObjectAction.extBucketNameCheck(bName,languageJson, function (err,data) {
                    if(err && err.code !== "AccessDenied"){
                        $('.mui-model').showErrorMessage({
                            message:languageJson.InternalError,
                            obsError: obsError("InternalError"),
                            ok:function(){
                                $('#ExBucketName').focus();
                                showCreateBucket();
                            }
                        });
                        if(loading){
                            loading.close();
                        }
                        $("#createBucketPage").css('z-index', '90');
                        showOverlay();
                    } else if((data||err.code === "AccessDenied" )&& !isExtNameRepeat){
                        bucketAndObjectAction.listObject(bName, 'true','', function (err,data) {
                            if(!err){
                                $("#createBucketPage").removeClass('shown');
                                $('#ExBucketName').val('');
                                $('#btnCeacelExBucket').click();
                                var temp = true;
                                if(ExtBucket&&ExtBucket.length!==0){//外部桶持久化文件存在
                                    for(var i in ExtBucket){
                                        if(ExtBucket[i].id===currentUserId){
                                            ExtBucket[i].bucketArr.push(bName);
                                            temp = false;
                                            break;
                                        }
                                    }
                                    if(temp){
                                        var obj = {};
                                        obj.id = currentUserId;
                                        obj.bucketArr = [bName];
                                        ExtBucket.push(obj);
                                    }
                                }else{
                                    ExtBucket = [];
                                    var obj = {};
                                    obj.id = currentUserId;
                                    obj.bucketArr = [bName];
                                    ExtBucket.push(obj);
                                }
                                indexAction.writeExBucket(ExtBucket);
                                $('.mui-model').showMessage({
                                    type:"info",
                                    message:CommonUtils.format(languageJson.exBucketSuccess, CommonUtils.encodeForHTML(bName)),
                                    ok:function(){
                                        if ($("#mui-overlay").size() > 0) {
                                            mui.overlay('off');
                                        }
                                        $('#all-refresh-div').click();
                                        $('#btnExBucket').removeAttr('disabled');
                                        return false;
                                    },
                                    title:languageJson.info
                                });
                                var lsHtml = '<li data-href="' + bName +'"';
                                lsHtml += 'class="bucket-item ext">';
                                lsHtml += '<span class="mui-icon-ext-bucket mui-ellipsis-tips tooltips">'+encoderForHtml(bName) + '</span></li>';
                                $("#lsBuckets").append(lsHtml);

                                var tbody = $("#bucketLists tbody");
                                var extBucketTableList = [];
                                var showKey=(encoderForHtml(bName).replace(new RegExp(' ','gm'),'&nbsp;'));
                                var SNCMap = {};
                                if(_.isEqual(UCDVersion,"HEC")){
                                    SNCMap = {
                                        Nearline: languageJson.obs_term_nearline_lable_HEC,
                                        Coldline: languageJson.obs_term_coldline_lable_HEC,
                                        Standard: languageJson.obs_term_standard_lable
                                    }
                                }else{
                                    SNCMap = {
                                        Nearline: languageJson.obs_term_nearline_lable,
                                        Coldline: languageJson.obs_term_coldline_lable,
                                        Standard: languageJson.obs_term_standard_lable
                                    }
                                }
                                extBucketTableList.push({
                                    showKey: showKey,
                                    bucketName: bName,
                                    aclConfig: languageJson.aclPermissions,
                                    multipart: languageJson.multipart,
                                    delete: languageJson.delete,
                                    obs_term_unlinkBucket_button: languageJson.obs_term_unlinkBucket_button,
                                    storageType: SNCMap[results.StorageType],
                                    coldline: pkg.coldline,
                                    objectColdline: pkg.objectColdline,
                                })
                                $("#tableBodyNoData").hide();
                                $("#tableBodyQueryNothing").hide();
                                $("#leftNoData").hide();
                                $("#leftQueryNothing").hide();
                                tbody.append(renderSync("lsExtBucketsTableTemplate", extBucketTableList));
                                if(loading){
                                    loading.close();
                                }
                                $("#createBucketPage").css('z-index', '1000');
                                showOverlay();
                            }else{
                                global.logger.error('exBucket error:',err);
                                if(errorConfig[err.code]){
                                    $('.mui-model').showErrorMessage({
                                        message: errorConfig[err.code],
                                        obsError: obsError(err.code,err.message),
                                        ok: function () {
                                            $('#ExBucketName').focus();
                                            showCreateBucket();
                                        }
                                    });
                                    if(loading){
                                        loading.close();
                                    }
                                    showOverlay();
                                    $("#createBucketPage").css('z-index', '90');
                                }else{
                                    $('.mui-model').showErrorMessage({
                                        message:languageJson.InternalError,
                                        obsError: obsError("InternalError"),
                                        ok:function(){
                                            $('#ExBucketName').focus();
                                            showCreateBucket();
                                        }
                                    });
                                    if(loading){
                                        loading.close();
                                    }
                                    showOverlay();
                                    $("#createBucketPage").css('z-index', '90');
                                }
                            }
                        });
                    }else{
                        $('.mui-model').showErrorMessage({
                            message:languageJson.bucketNameRepeat,
                            obsError: obsError("bucketNameRepeat"),
                            ok:function(){
                                $('#ExBucketName').focus();
                                showCreateBucket();
                            }
                        });
                        if(loading){
                            loading.close();
                        }
                        showOverlay();
                        $("#createBucketPage").css('z-index', '90');
                    }
                });
                return false;
            }
            //桶名不符合校验报错
            else{
                var loading = loadingShow();
                $('.mui-model').showMessage({
                    type:"warning",
                    message:str,
                    ok:function(){
                        $('#bucketName').focus();
                        showCreateBucket();
                    },
                    title:languageJson.warning
                });
                loading.close();
                showOverlay();
                $("#createBucketPage").css('z-index', '90');
                return false;
            }
            if(err) {
                global.logger.error("Add ExtBucket, Head Bucket failed", err)
                var errMsg = obsError(err.code,err.message) ? obsError(err.code).description : languageJson.ERR_CODE_InternalError;
                var loading = loadingShow();
                $('.mui-model').showErrorMessage({
                    message: errMsg,
                    ok:function(){
                        $('#ExBucketName').focus();
                        showCreateBucket();
                    }
                });
                loading.close();
                showOverlay();
                $("#createBucketPage").css('z-index', '90');
                return false;
            }
            return false;
        })
    });
    //创建桶报错提示框确定
    function showCreateBucket (){
        $('#btnExBucket').removeAttr('disabled');
        $("#createBucketPage").css('z-index', '1000');
    }
    //分享对象URL
    function showProperty(bName, href) {
        var url = false;
        var parentPath = getCurrPath();
        var point = s3.config.endpoint;
        if (point.indexOf('https') === -1) {
            point = point.replace('http', 'https');
        }
        var data = point.split(':');
        if (data.length > 2) {
            point = data[0] + ':' + data[1];
        }

        var AWS = require('./node_modules/hws-sdk');
        if (userType == 1) {
            url = point.replace(endpoint, '') + AWS.util.uriEscapePath(bName + "." + endpoint + '/' + parentPath + href);
        } else {
            url = point + "/" + AWS.util.uriEscapePath(bName + "/" + parentPath + href);
        }

        //开启对象温冷才显示取回状态
        if(pkg.objectColdline == true){
            $("#recoverTr").removeAttr('hidden');
            $("#recoverExpiresTr").show();
        }else{
            $("#recoverTr").attr('hidden',true);
            $("#recoverExpiresTr").hide();
        }
        if (isShowServerEncryption || pkg.objectColdline == true) {
            var loading = loadingShow();
            if(isShowServerEncryption){
                $("#encryptionTr").removeAttr('hidden');
            }
            bucketAndObjectAction.headObject(bName, parentPath + href, function (err, data) {
                loading.close();
                if(err && err.code === 'NotFound'){
                    global.logger.error('copyObject error:',err);
                    $('.mui-model').showErrorMessage({
                        message: languageJson.NoSuchKey
                    });
                    return false;
                }
                if (data && data.SSEKMSKeyId) {
                    $("#objectEncryption").text(languageJson.EncryptionYes);
                    $("#btnServerEncryption").attr('hidden', 'hidden');
                } else if(data) {
                    $("#objectEncryption").text(languageJson.EncryptionNo);
                    $("#btnServerEncryption").removeAttr('hidden');
                } else {
                    $("#objectEncryption").text("--");
                    $("#btnServerEncryption").removeAttr('hidden');
                }
                if (pkg.objectColdline == true || currBucketStorage == 'Coldline') {
                    $("#recoverTr").show();
                    $("#recoverExpiresTr").show();
                    var objId = AWS.util.crypto.sha256(parentPath + href, 'hex');
                    var dataKey = objId + Const("RESTORE_STATUS_SUFFIX");
                    var storageType = JSON.parse($("#" + dataKey).parent().parent().find(".hiddenObjData").text()).StorageClass;
                    global.restoreCache.putCache(data, dataKey);
                    //根据head结果判断对象取回状态
                    $("#objectRecover").text("--");
                    $("#objectRecoverExpires").text("--");
                    if (data && data.Restore && data.Restore.indexOf('ongoing-request="false"') > -1) {
                        $("#objectRecover").text(languageJson.obs_term_restored_lable);
                        $("#" + dataKey).html(languageJson.obs_term_restored_lable);
                        var result = data.Restore.split('=');
                        if (result[2]) {
                            $("#recoverExpiresTr").removeAttr('hidden');
                            $("#objectRecoverExpires").text(indexAction.gmtDate2LocaleDate(result[2], language));
                        }
                    } else if (data && data.Restore && data.Restore.indexOf('ongoing-request="true"') > -1) {
                        $("#objectRecover").text(languageJson.obs_term_restoring_lable);
                        $("#" + dataKey).html(languageJson.obs_term_restoring_lable);
                    } else if (data && storageType == "GLACIER") {
                        $("#objectRecover").text(languageJson.obs_term_notRestored_lable);
                        $("#" + dataKey).html(languageJson.obs_term_notRestored_lable);
                    } else if (data && storageType == "STANDARD"){
                        $("#recoverTr").attr('hidden',true);
                        $("#recoverExpiresTr").hide();
                    } else if (data && storageType == "STANDARD_IA"){
                        $("#recoverTr").attr('hidden',true);
                        $("#recoverExpiresTr").hide();
                    } else {
                        $("#objectRecover").text("--");
                        $("#" + dataKey).html("--");
                    }
                } else {
                    $("#recoverTr").hide();
                    $("#recoverExpiresTr").hide();
                }
                if(err && err.code === 'Forbidden'){
                    $("#objectEncryption").text('--');
                    $("#objectEncryption").attr('title',languageJson.obs_task_viewEncryptionDeny_tip);
                }else{
                    $("#objectEncryption").removeAttr('title');
                }
                $(".mui-page-full.shown").removeClass('shown');
                $("#objectURLPage").addClass('shown');
                setTimeout(function () {
                    mui.overlay('on', {"static": true, keyboard: false});
                }, 50);
                $("#objectUrlName").val(href);
                $("#UrlAdress").val(url);
                divDragFunc('objectURLPageDrag','objectURLPage');
            });
        } else {
            $(".mui-page-full.shown").removeClass('shown');
            $("#objectURLPage").addClass('shown');
            mui.overlay('on', {"static": true, keyboard: false});
            $("#objectUrlName").val(href);
            $("#UrlAdress").val(url);
            divDragFunc('objectURLPageDrag','objectURLPage');
        }
    }

    /**
     * 显示properties对话框
     * @param href
     */
    function checkAndShowProp(href) {
        var bName = $("#curBucketName").html();
        bucketAndObjectAction.headObject(bName, getCurrPath() + href, function (err, data) {
            if (err && err.hasOwnProperty("code") && errorConfig[err.code]) {
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message),
                    ok:function () {
                        bucketAndObjectAction.listObject(bName, 'true', '', function (err, data) {
                            listObjectUI(err, data, bName, true);
                        });
                    }
                });
            } else {
                showProperty(bName, href);
            }
            ;
        });
    }
    //目前主要是提供邮件菜单的properties功能
    $("#propBtn").on("click", function(){
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        var href = JSON.parse($("#objLists .selected-tr-active .hiddenObjData").text()).name;
        checkAndShowProp(href);
    })
    //点击操作列中的properties图标
    $("#objLists tbody").delegate('.mui-icon-handel-share','click',function(){
        $(this).parent().parent().click();
        var href = JSON.parse($(this).parent().next().text()).name;
        checkAndShowProp(href);
    });
    //点击更多里的properties
    $("#PropertyInMore").on("click",function(){
        var objName = getChoseObjName();
        checkAndShowProp(objName);
    });

    $("#copyUrl").on('click', function () {
        $("#UrlAdress").attr("title","");
        var Url2=document.getElementById("UrlAdress");
        Url2.select(); // 选择象
        document.execCommand("Copy");
        $('.mui-model').showMessage({//增加复制成功提示信息
            type:"info",
            message:languageJson.copySuccess,
            ok:function(){
                return false;
            },
            title:languageJson.info
        });
    });

    $('#closeUrlPage').on('click', function () {
        $("#objectURLPage").removeClass('shown');
        $('#objectUrlName').val('');
        $('#UrlAdress').val('');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    $("#language").on('change', function () {
        var lang = $("#language").val();
        if(lang!==language){
            $('.mui-model').showMessage({
                type:"info",
                message:languageJson.restartToLanguageEffect,
                ok:function(){
                    $('#bucketName').focus();
                },
                title:languageJson.info
            });
        }
        return false;
    });

    $("#UrlAdress,#objectUrlName").on('mouseover', function (e) {
        if(this.offsetWidth<this.scrollWidth){
            $(this).attr('title',$(this).val());
        } else {
            $(this).attr('title','');
        }
    });
    //=============================================弹出框可拖拽功能============================================================

    //界面尺寸变更，重新加载弹出框拖拽方法
    $(window).resize(function() {
        $(".mui-page").each(function () {
            $(this).css({left:($('body').width()-$(this).width())/2,top:'20%'});
        });
        $("#lifecycleChild").css({left:($('body').width()-$("#lifecycleChild").width())/2,top:'10%'});
        $("#model").css({left:($('body').width()-$("#model").width())/2,top:'20%'});//系统对话框位置重置
        divDragFunc('createBucketPageDrag','createBucketPage');
        divDragFunc('createFolderPageDrag','createFolderPage');
        divDragFunc('helpDrag','help');
        divDragFunc('multipartPageDrag','multipartPage');
        divDragFunc('accountListDrag','accountList');
        divDragFunc('createAccountDrag','createAccount');
        divDragFunc('configDrag','config');
        divDragFunc('exportDataDrag','exportData');
        divDragFunc('userCommentDivDrag','userCommentDiv');
        divDragFunc('bucketProDrag','bucketPro');
        divDragFunc('helpDtDrag','helpDt');
        divDragFunc('ACLConfigDrag','ACLConfig');
        divDragFunc('changeStorageTypeDrag','changeStorageType');
        divDragFunc('renameNoticeDrag','renameNotice');
        divDragFunc('authDrag','auth');
        divDragFunc('changeStorageClassDrag','changeStorageClass');
        divDragFunc('uploadFileDrag','uploadFileDialog');
        divDragFunc('uploadFolderDrag','uploadFolderDialog');
        divDragFunc('lifecycleConfigDrag','lifecycleConfig');
        divDragFunc('lifecycleChildDrag','lifecycleChild');
        divDragFunc('policyConfigDrag','policyConfig');
        divDragFunc('corsConfigDrag','corsConfig');
        divDragFunc('corsConfigChildDrag','corsConfigChild');
        divDragFunc('bucketLoggingDrag','bucketLogging');
        divDragFunc('objectURLPageDrag','objectURLPage');
        divDragFunc('modelDrag','model');

        var location = getNodeLocation("btnTaskManage");
        $("#taskDivHead").css({left:location.popX - 7,top:location.popY + 23});
    });

    $(".config-left li").on('click', function () {
        $(this).parent().find('li').each(function () {
            $(this).removeClass('curr');
        });
        $(this).addClass('curr');
        var href = $(this).attr('data-href');
        $("#GeneralSetting,#networkSetting,#otherSetting").addClass('mui-hide');
        $(href).removeClass('mui-hide');
    });

    $("#isProxy").on('change',function(){
        if($("#isProxy").is(':checked')){
            $("#proxyAddress,#proxyPort,#isAuthentication").removeAttr('disabled');
            $("#proxyAuth,#proxyInfo").removeClass('mui-hide');
        }else{
            $("#proxyAuth,#proxyInfo").addClass('mui-hide');
            if($("#isAuthentication").is(':checked')){
                $("#isAuthentication").click();
            }
            $("#proxyAddress,#proxyPort,#isAuthentication").attr('disabled',true);
        }
    });

    $("#isAuthentication").on('change',function(){
        if($("#isAuthentication").is(':checked')){
            $("#proxyusname,#proxydomain").removeAttr('disabled');
            $("#proxypswd").next().removeAttr("disabled");
        }else{
            $("#proxyusname,#proxydomain").attr('disabled', true);
            $("#proxypswd").next().attr("disabled", true);
        }
    });

    //选中对象服务端加密
    $('#btnServerEncryption').on('click', function () {
        var bucketName = $('#curBucketName').html();
        var parentPath = getCurrPath();
        var filename = $("#downloadFileName").val();

        if (!filename) {
            var htmlStr = languageJson.selectDeleteObject;
            $('.mui-model').showMessage({
                type: "warning",
                message: htmlStr,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        mui.overlay('on', {"static": true});
        $('.mui-model').showMessage({
            type: "warning",
            message: languageJson.isSureEncryption,
            ok: function (model) {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                if (bucketName && filename) {
                    var loading = loadingShow();
                    $("#objectURLPage").css('z-index', '90');
                    bucketAndObjectAction.copyObject(bucketName, parentPath+$("#objectUrlName").val(), function (err,data) {
                        loading.close();
                        $("#objectURLPage").css('z-index', '1000');
                        if(err){
                            global.logger.error('copyObject error:',err);
                            if(errorConfig[err.code]){
                                $('.mui-model').showErrorMessage({
                                    message: errorConfig[err.code],
                                    obsError: obsError(err.code,err.message)
                                });
                            }
                        }else{
                            $('.mui-model').showMessage({
                                type:'info',
                                message: languageJson.EncryptionSuccess,
                                ok: function () {
                                    bucketAndObjectAction.headObject(bucketName,parentPath+$("#objectUrlName").val(),function(err,data) {
                                        if (data&&data.SSEKMSKeyId) {
                                            $("#objectEncryption").text(languageJson.EncryptionYes);
                                            $("#btnServerEncryption").attr('hidden', 'hidden');
                                        } else {
                                            $("#objectEncryption").text(languageJson.EncryptionNo);
                                            $("#btnServerEncryption").removeAttr('hidden');
                                        }
                                    });
                                    return false;
                                },
                                title: languageJson.info
                            });
                        }
                    });
                } else {
                    $('.mui-model').showMessage({
                        type: "info",
                        message: languageJson.oneOrMoreDeleteObjcet,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.hint
                    });
                }

            },
            cancel: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                return false;
            },
            title: languageJson.warning
        });
    });

    //控制左边桶列表显示与隐藏
    $("#showOrHideBucket").on('click',function () {
        $(".bucketLeftDiv").toggleClass("mui-hide");
        $(".mui-body .mui-content .area").toggleClass("show");
        $("#showOrHideBucket").toggleClass('showBucket');
        $("#showOrHideBucket").toggleClass('hideBucket');
        $("#objLists").resize();
    });


    //返回到桶列表
    $("#bread-path-box-bucket").on('click',function () {
        if($("#bucketArea").hasClass('mui-hide')){
            $("#bucketArea").removeClass('mui-hide');//桶列表和对象列表切换
            $("#objectArea").addClass('mui-hide');
            $("#objectBtnDiv").addClass('mui-hide');
            $("#bucketBtnDiv").removeClass('mui-hide');
            $("#all-back-div").addClass('all-back-btn-disabled');//后退按钮样式修改
            $("#all-back-div").removeClass('all-back-btn');
            $("#objectProDiv").addClass('mui-hide');//隐藏对象属性栏
            $("#bucketProDiv").removeClass('mui-hide');//显示桶属性栏
            $("#prefixSearch").attr('placeholder',languageJson.bucketSearchInfo);
        }
        $(".mui-icon-more").css('display','block');
        $(".mui-icon-fragment").css('display','none');
        $("#bucketSearch").val('');//清空查询条件
        $("#prefixSearch").val('');//清空查询条件
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#clearBucketSearchInput").addClass("mui-hide");
        $(".bucket-delete,.mui-icon-property,.mui-icon-aclConfig,.mui-icon-more").addClass('mui-disabled');
        var loading = loadingShow();
        lastBucket = '';
        $("#curBucketName").html('');
        $("#objectNum").html('');
        $("#storageSize").html('');
        bucketAndObjectAction.listBucket(function (err, data) {
            $("#path p").children().each(function () {
                $(this).remove();
            });
            listBucketUI(err,data,loading);
        });
    });

    //选择桶列表的行
    $("#bucketLists tbody").delegate('tr','click',function(event){
        $("#bucketLists tr.selected-tr-active>td:first-child").find('span').removeClass('show-span-active');
        $("#bucketLists tr.selected-tr-active td").find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $("#bucketLists tr.selected-tr-active").removeClass('selected-tr-active');
        $(this).addClass('selected-tr-active');
        $(this).find('td').eq(0).find('span').addClass('show-span-active');
        disabledBtn($(".bucket-delete,.mui-icon-aclConfig,.mui-icon-more"));
        if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//如果是外部桶，则不显示基本信息按钮
            $(".mui-icon-property").addClass('mui-disabled');//置灰基本信息按钮
            $(".mui-icon-more").css('display','none');
            $(".mui-icon-fragment").css('display','block');
        }else{
            disabledBtn($(".mui-icon-property"));
            $(".mui-icon-more").css('display','block');
            $(".mui-icon-fragment").css('display','none');
        }
        $("#curBucketName").html($(this).find('td').eq(0).find('span').attr('data-href'));
        return false;
    });

    //点击操作区删除桶按钮
    $("#bucketLists tbody").delegate('.mui-icon-handel-delBucket','click',function(){
        $(this).parent().parent().click();
        setTimeout(function () {
            $('.bucket-delete').click();
        },10);
    });

    //点击操作区more按钮
    $("#bucketLists tbody").delegate('.mui-icon-handel-more','mouseup',function(ev){
        var show = $('#bucketHandle2').hasClass('mui-active');
        if(show) {
            $('#bucketHandle2').removeClass('mui-active');
        } else {
            hideOtherPop();
            $(this).parent().parent().click();
            handleExtbucket();//外部桶桶属性按钮隐藏
            $('#bucketHandle2').addClass('mui-active');

            //计算弹出窗口位置
            //计算位置时偏移两个像素，避免弹出框的边界和Browser边框重合
            var border = 2;
            //header高度
            var headerHeight = 60;
            var dx = $(window).width() - ev.originalEvent.x;
            var dy = $(window).height() - ev.originalEvent.y;
            var menuWidth = $('#bucketHandle2 li').width()+border;
            var menuHeight = $('#bucketHandle2').height()+border;
            var popX = dx < menuWidth ? $(window).width() - menuWidth : ev.originalEvent.x;
            var popY = dy < menuHeight ? $(window).height() - menuHeight : ev.originalEvent.y;

            $('#bucketHandle2').css({left: popX, top: popY - headerHeight});
        }
        return false;
    });

    //点击对象列表操作区more按钮
    $("#objLists tbody").delegate('.mui-icon-handel-more','mouseup',function(ev){
        var show = $('#objectMoreOperate').hasClass('mui-active-object');
        var restoreState = $(this).parent().parent().find(".restore_stat").text();
        if(restoreState){
            if (_.isEqual($(this).parent().parent().find(".restore_stat").text(), languageJson.obs_term_restored_lable)) {//对象为已恢复对象
                $("#PropertyInMore").removeClass("mui-hide");
            }else{
                $("#PropertyInMore").addClass("mui-hide");
            }
            if(restoreState == languageJson.obs_term_notRestored_lable || restoreState == languageJson.obs_term_restoring_lable){
                $('#changeStorageTypeInMore').addClass("mui-disabled-task");
                $('#changeStorageTypeInMore').parent().attr('title',languageJson.obs_task_changeStorageClassUnavailable_tip);
            }else{
                $('#changeStorageTypeInMore').removeClass("mui-disabled-task");
                $('#changeStorageTypeInMore').parent().attr('title','');
            }
        }else{
            $("#PropertyInMore").addClass("mui-hide");
        }
        var path = getCurrPath();
        checkObjectRestore(path + JSON.parse($(this).parent().parent().find('.hiddenObjData').text()).name);
        if(show) {
            $('#objectMoreOperate').removeClass('mui-active-object');
        } else {
            hideOtherPop();
            $(this).parent().parent().click();
            var StorageType = $(this).parent().parent().find('td').eq(1).find('span').text();
            if(pkg.objectColdline){
                if(StorageType == languageJson.obs_term_standard_lable){
                    StorageType = 'Standard';
                }else if(StorageType == languageJson.obs_term_nearline_lable || StorageType == languageJson.obs_term_nearline_lable_HEC){
                    StorageType = 'Nearline';
                }else{
                    StorageType = 'Coldline'
                };
                var a = "";
                var inputs = $("#StorageClassdsc").parent().find("input");
                for (var index in inputs){
                    if (inputs[index].value == StorageType){
                        a = index;
                    }
                };
                var appElements = document.getElementById("changeStorageClass");
                var $scope = angular.element(appElements).scope();
                $scope.object.selected.value = $scope.object.storageTypeList[a].key;
                $scope.object.description = $scope.object.storageTypeList[a].desc;
                $scope.$apply();
                var fileType = $(this).parent().parent().data('type');
                if(fileType == 'folder') {
                    $('#changeStorageTypeInMore').parent().hide();
                }else{
                    $('#changeStorageTypeInMore').parent().show();
                }
            }else{
                $('#changeStorageTypeInMore').parent().hide();
            }
            handleExtbucket();//外部桶桶属性按钮隐藏
            $('#objectMoreOperate').addClass('mui-active-object');
            if (_.isEqual($(this).parent().parent().find('.restore_stat').text(), languageJson.obs_term_restored_lable)) {
                $("#downloadInMore").removeClass('mui-disabled-task');
                $("#downloadInMore").parent().removeAttr('title');
            } else {
                $("#downloadInMore").addClass('mui-disabled-task');
                $("#downloadInMore").parent().attr('title',languageJson.ERR_CODE_InvalidObjectState);
            }
            //控制拷贝和移动的显示隐藏
            copyMoveOptionDisplay();
            //计算弹出窗口位置
            //计算位置时偏移两个像素，避免弹出框的边界和Browser边框重合
            var border = 2;
            //header高度
            var headerHeight = 60;
            var dx = $(window).width() - ev.originalEvent.x;
            var dy = $(window).height() - ev.originalEvent.y;
            var menuWidth = $('#objectMoreOperate li').width()+border;
            var menuHeight = $('#objectMoreOperate').height()+border;
            var popX = dx < menuWidth ? $(window).width() - menuWidth : ev.originalEvent.x;
            var popY = dy < menuHeight ? $(window).height() - menuHeight : ev.originalEvent.y;

            $('#objectMoreOperate').css({left: popX, top: popY - headerHeight});
        }
        return false;
    });
    //导出报表确定按钮
    $('#SureExport').on('click',function () {
        $("#exportData").add('mui-hide');
        $("#exportData").removeClass('shown');
    });
    //取消导出
    $('#CancelExport').on('click',function () {
        $("#exportData").add('mui-hide');
        $("#exportData").removeClass('shown');
    });
    //选择日期
    $('#pickDateBtn').on('click', function() {
        console.log(1111)
        var options ={
            'type':'date',
            'beginYear':'2017',
            'endYear':'2020'
        }
        var picker = new mui.Datepicker(options);
        picker.show(function(rs){
            picker.innerText = rs.text;
            picker.dispose()
        })
    });
    //对象修改存储类别
    $("#changeStorageTypeInMore").on('click',function(){
        var href = getChoseObjName();
        var bName = $("#curBucketName").html();
        //先判断对象存在与否，报错弹出提示，确定刷新列表
        bucketAndObjectAction.headObject(bName, getCurrPath() + href, function (err, data) {
            if (err && err.hasOwnProperty("code") && errorConfig[err.code]) {
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message),
                    ok:function () {
                        bucketAndObjectAction.listObject(bName, 'true', '', function (err, data) {
                            listObjectUI(err, data, bName);
                        });
                    }
                });
            }else{
                showOverlay();
                $(".mui-page-full.shown").removeClass('shown');
                $("#changeStorageClass").removeClass('mui-hide');
                $("#changeStorageClass").addClass('shown');
                divDragFunc('changeStorageClassDrag','changeStorageClass');
            }
        });
    });
    $("#deleteInMore").on('click',function(){
        $('#btnDeleteObjects').click();
    });
    //取消蒙层并刷新
    function refresh (){
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        $(".refreshCtx").click();
        return false;
    }
    //确定保存
    $('#saveChanges').on('click',function () {
        $(".mui-page-full.shown").removeClass('shown');
        $("#changeStorageClass").addClass('mui-hide');
        var bName = $("#curBucketName").html();
        var href = getChoseObjName();
        var Objkey = getChoseObjKey();
        var storagePolicy = $('#StorageClassdsc').html();
        storagePolicy = CommonUtils.translateStorageClass(storagePolicy);
        //关闭蒙层显示加载图标
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var loading = loadingShow();
        async.parallel([
            function(callback) {
                bucketAndObjectAction.headObject(bName,Objkey,function (err,data) {
                    callback(err,data)
                });
            },
            function(callback) {
                var params = {
                    Bucket : bName,
                    Key : Objkey
                };
                s3.getObjectAcl(params,function (err,data) {
                    callback(err,data)
                })
            }
        ], function (err, results) {
            if(err){
                global.logger.info("head object or getobejctacl err",err)
                loading.close();
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message),
                        ok: function () {
                            refresh();
                        }
                    });
                }
            }else{
                var data = results[0];
                var isKMS;//对象是否为KMS加密
                var sseKMSKeyId; /// 加密keyid
                if(data && data.SSEKMSKeyId){
                    isKMS = true;
                    sseKMSKeyId = data.SSEKMSKeyId;
                }else{
                    isKMS = false;
                }
                var acl = results[1];
                var putAclParams = {
                    Bucket: bName,
                    Key: Objkey,
                    AccessControlPolicy: {
                        Grants: acl.Grants,
                        Owner: acl.Owner
                    }
                };
                bucketAndObjectAction.copyObject(bName,storagePolicy,Objkey,isKMS, sseKMSKeyId, function (err,data) {
                    //关闭加载图标，增加蒙层
                    loading.close();
                    showOverlay();
                    if(err){
                        global.logger.info("copyobject err",err)
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code,err.message),
                                ok: function () {
                                    refresh();
                                }
                            });
                        }
                    }else{
                        s3.putObjectAcl(putAclParams,function () {
                            if(err){
                                global.logger.info("putobejctacl err",err)
                                if(errorConfig[err.code]){
                                    $('.mui-model').showErrorMessage({
                                        message: errorConfig[err.code],
                                        obsError: obsError(err.code,err.message),
                                        ok: function () {
                                            refresh();
                                        }
                                    });
                                }
                            }else{
                                $('.mui-model').showMessage({
                                    type:"info",
                                    message:languageJson.obs_term_changeStorageClass_objectSuccess_msg.format(href),
                                    ok:function(){
                                        refresh();
                                    },
                                    title:languageJson.hintInfo
                                });
                            }
                        })
                    }
                });
            }
        });
    });
    //取消
    $('#cancelChanges').on('click',function () {
        $("#changeStorageClass").removeClass('shown');
        $("#changeStorageClass").addClass('mui-hide');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });
    //打开任务管理
    $(".btnTaskManage").on('click',function () {
        showTips();
        if(!$("#overlay").hasClass('mui-hide')){
                return false;
        }
        $("#taskOverlay").toggleClass('mui-hide');
        $("#taskPanel").toggleClass('mui-active');
        $("#taskDivHead").toggleClass('triangle-up');
        var location = getNodeLocation("btnTaskManage");
        $("#taskDivHead").css({left:location.popX - 7,top:location.popY + 23});
        $("[tab-for='processingTaskPanel']").click();
        reloadTasks(true);
    });
    //点击运行列表重新注册tips
    $("[tab-for='processingTaskPanel']").on("click",function () {
        setTimeout(function () {
            showTips();
        },0)
    });
    //图标hover显示tips
    function showTips() {
        $('.mui-icon-note').on('mouseover',function(e){
            var hf = $(this).attr('data-href');
            if(hf && $(hf).size() === 1){
                $('.help-tips').html($(hf).html());
            }
            $('.help-tips').addClass('active');
            var bodyW = $('body').width();
            var bodyH = $('body').height();
            var tipsW = $('.help-tips').width();
            var tipsH = $('.help-tips').height();
            var pageX = e.pageX;
            var pageY = e.pageY;
            if(bodyW-pageX<tipsW&&bodyH-pageY<tipsH+20){
                $('.help-tips').css({left:bodyW-tipsW-10,top:bodyH-tipsH-20});
            }else if(bodyW-pageX<tipsW&&bodyH-pageY>tipsH+20){
                $('.help-tips').css({left:bodyW-tipsW-10,top:(pageY+15)});
            }else if(bodyW-pageX>tipsW&&bodyH-pageY<tipsH+20){
                $('.help-tips').css({left:pageX,top:bodyH-tipsH-20});
            }else{
                $('.help-tips').css({left:pageX,top:(pageY+15)});
            }
            $('.more-user-btns').removeClass('mui-active');
            $('.task-status-check').removeClass('mui-active').css('top','-1440px');
            return false;
        });
        $('.mui-icon-note').on('mouseout',function(e){
            $('.help-tips').removeClass('active');
        });
    }
    //关闭任务管理
    $(".mui-task-close").on('click',function () {
        $("#taskPanel").toggleClass('mui-active');
        $("#taskDivHead").toggleClass('triangle-up');
        $("#taskOverlay").addClass('mui-hide');
    });


    $("#objLists tbody").delegate('.mui-icon-handel-recover','click',function(){
        $(this).parent().parent().click();
        disabledBtn($("#recoverBtn"));
        $("#recoverBtn").click();
    });
});

(function ($, w) {

    w.loadingShow = function (option) {
        //判断是否显示loading框
        if ($("#mui-overlay").size() > 0) {
            return false;
        }
        var startTime = $("#mui-overlay").attr('startTime');
        var nowTime = new Date();
        //如果请求时间超过400ms就显示loading
        if (startTime && (nowTime.getTime() - startTime) < 400) {
            return false;
        }
        var loading = mui.overlay('on', {"static": true,keyboard:false});
        $(loading).attr('startTime', nowTime.getTime());
        if(UCDVersion !== 'HEC'&& UCDVersion !== 'CTC'&&  UCDVersion !== 'CMCC'&&  UCDVersion !== 'FCS'){
            loading.innerHTML = '<div class="loading-dt"></div>';
        }else{
            loading.innerHTML = '<div class="loading"></div>';
        }

        if (!option) {
            option = {};
        }
        if (!option.timeout) {
            option.timeout = 100000;
        }

        setTimeout(function () {
            if (loading) {
                loading.innerHTML = '';
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            }
        }, option.timeout);

        this.close = function () {

            if (loading) {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            }
            loading = false;
        };

        return this;
    };

    /**
     * 弹出错误提示框，如果obsError存在，则使用obsError.description作为message
     * 默认选项：
     * title:Error
     * type:error
     * ok:function () {
                return false;
            }
     * @param option
     */
    $.fn.showErrorMessage = function (option) {
        if(option.obsError) {
            option.message = option.obsError.description;
            if(option.showDetail == true) {
                option.obsError.detailTitle = "Detail"
                option.obsError.codeTitle = "Code"
                option.obsError.nameTitle = "Name"
                option.obsError.suggestionTitle = "Suggestion"
                //错误详情渲染
                $("#err_detail_pad").html(renderSync("errDetailPadTemplate", option.obsError));
                $("#err_detail_content").hide();
                $("#err_detail_title").click(function () {
                    if ($("#err_detail_content").is(":hidden")) {
                        $("#err_detail_content").show();
                    } else {
                        $("#err_detail_content").hide();
                    }
                })
            }
        }
        option.type = "error";
        option.ok = option.ok ? option.ok : function () {
                return false;
            }
        option.title = option.title ? option.title : global.langData.error
        $(this).showMessage(option)
    }
    //加载消息提示框
    $.fn.showMessage = function (option) {
        if ($(".mui-model.mui-model-mini").hasClass('shown')) {
            return false;
        }
        $(".mui-page.shown").each(function () {
            var self = this;
            var zIndex = $(self).css('z-index');
            if(zIndex>100){
                $(self).css('z-index','99');
            }
        });
        return this.each(function () {
            var $model = $(this);
            $model.find('.mui-model-content').find('p').html(option.message);
            $model.find('.mui-model-content').find('p').addClass("mui-text-info");
            if ('error' === option.type) {
                $model.find('.mui-model-content').find('img').attr("src", "images/dialog_error2.png");
            }
            else if ('warning' === option.type) {
                $model.find('.mui-model-content').find('img').attr("src", "images/alarm-big.svg");
                $model.find('.mui-model-content').find('img').addClass("war-size");
            }else if('tips' === option.type){
                $model.find('.mui-model-content').find('img').attr("src", "images/prompt-big.png");
            }
            else {
                $model.find('.mui-model-content').find('img').attr("src", "images/dialog_sucess.png");
            }

            if (option.title) {
                $model.find('.mui-model-title').html(option.title);
            }
            if (option.ok) {
                $model.find('.mui-model-content>button.ok').removeClass('mui-hide');
                $model.find('.mui-model-content>button.ok').one('click', function () {
                    option.ok($model);
                    $model.removeClass('mui-model-mini');
                    $model.find('.mui-model-content>button.cancel').unbind();
                    $(".mui-page.shown").each(function () {
                        var zIndex = $(this).css('z-index');
                        if(zIndex==99){
                            $(this).css('z-index','1000');
                        }
                    });
                });
                if(option.isFocus){
                    $model.find('.mui-model-content').find('.cancel').addClass('mui-btn-default');
                    $model.find('.mui-model-content').find('.ok').removeClass('mui-btn-default');
                }else{
                    $model.find('.mui-model-content').find('.cancel').removeClass('mui-btn-default');
                    $model.find('.mui-model-content').find('.ok').addClass('mui-btn-default');
                }
            }
            else {
                $model.find('.mui-model-content>button.ok').addClass('mui-hide');
            }

            if (option.okHide) {
                $model.find('.mui-model-content>button.ok').addClass('mui-hide');
            }

            if (option.noClose) {
                $model.find('.mui-model-close').addClass('mui-hide');
            }

            if (option.cancel) {
                $model.find('.mui-model-content>button.ok').text(languageJson.yes);
                $model.find('.mui-model-content>button.cancel').removeClass('mui-hide');
                $model.find('.mui-model-content>button.cancel').one('click', function () {
                    option.cancel();
                    $model.removeClass('mui-model-mini');
                    $model.find('.mui-model-content>button.ok').unbind();
                    $(".mui-page.shown").each(function () {
                        var zIndex = $(this).css('z-index');
                        if(zIndex==99){
                            $(this).css('z-index','1000');
                        }
                    });
                });
            }
            else {
                $model.find('.mui-model-content>button.cancel').addClass('mui-hide');
                $model.find('.mui-model-content>button.ok').text(languageJson.close);
            }
            if (option.cancelHide) {
                $model.find('.mui-model-content>button.cancel').addClass('mui-hide');
            }
            $model.addClass('mui-model-mini');
            divDragFunc('modelDrag','model');
        });
    };

})(jQuery, window);

function copyUninsFiles(upd) {
    var copyFiles = ['/unins000.exe', '/unins000.dat'];
    for (var n = 0; n < copyFiles.length; n++) {
        var fileName = copyFiles[n];
        var exists = fs.existsSync(upd.getAppPath().replace(/\\/g, "/") + fileName);
        upd['newAppPath'] = upd['newAppPath'].replace(/\\/g, "/");
        if (exists) {
            var tempPath = upd['newAppPath'].substring(0, upd['newAppPath'].lastIndexOf("/"));
            var readable = fs.createReadStream(upd.getAppPath().replace(/\\/g, "/") + fileName);
            var writable = fs.createWriteStream(tempPath + fileName);
            readable.pipe(writable);
        }

    }
}

function saveAccountAndKillDB(upd, currentBucket) {

    accountService.saveCurrentAccount(currentUserId, currentBucket, function () {
        if (!taskControlAction) {
            taskControlAction = new TaskControlAction();
        }
        taskControlAction.pauseAllTasks(function () {//暂停正在运行的任务
            if (window.mongod) {
                window.mongod.kill(0);
            }
            exec('taskkill /f /im obsdb.exe', {}, function (err) {
                if (err) {
                    logger.error(err);
                }
            });
            setTimeout(function () {
                upd.runInstaller(upd['newAppPath'], [upd.getAppPath(), upd.getAppExec()], {});
                logger.info("runInstaller......" + upd.getAppPath() + "======" + upd.getAppExec());
                gui.Window.get().close(true);
            }, 2000);
        });
    });
}
function closeAlert(currentBucket) {
    var msg = languageJson.sureQuitClint;

    if (hasRunning()) {
        msg = languageJson.quitWithTask;
    }
    hasMovingTask(function(err, data) {
        if(data > 0){
            msg = languageJson.obs_quit_check_move_task_confirm;
        }
        $('.mui-model').showMessage({
            type: "warning",
            message: msg,
            isFocus: true,
            ok: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                userCommentLogout(function () {
                    accountService.saveCurrentAccount(currentUserId, currentBucket, function () {
                        if (!taskControlAction) {
                            taskControlAction = new TaskControlAction();
                        }
                        taskControlAction.pauseAllTasks(function () {
                            exec('taskkill /f /im obsdb.exe', {}, function (err) {
                                if (err) {
                                    global.logger.error("kill obsdb error", err);
                                }
                            });

                            //判断是否需要更新密钥
                            if (global.Tools.checkPwd()) {
                                gui.Window.get().close(true);
                            } else {
                                updatePwd(function () {
                                    gui.Window.get().close(true);
                                })
                            }
                        });
                    });
                });
            },
            cancel: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                return false;
            },
            title: languageJson.warning
        });
        showOverlay();
    });
}
$(document).ready(function(){
    $(document).tooltip();
    $('#delDataTime').datepicker({
        minDate: 1,
        dateFormat:'yy-mm-dd'
    });
    $('#selType').selectmenu({
        change: function( event, ui ) {
            if ('1' === $(this).val()) {
                $("#endpointDiv").addClass('mui-hide');
            } else {
                $("#endpointDiv").removeClass('mui-hide');
            }
        }
    }).selectmenu( "menuWidget" ).addClass("obs-connect-type");
    $('#language').selectmenu({
        change: function(event, ui){
            var lang = $("#language").val();
            if(lang!==language){
                $('.mui-model').showMessage({
                    type:"info",
                    message:languageJson.restartToLanguageEffect,
                    ok:function(){
                        $('#bucketName').focus();
                    },
                    title:languageJson.info
                });
            }
            return false;
        }
    }).selectmenu( "menuWidget" ).addClass("obs-connect-type");

    $("#loggingSelector").selectmenu();

    i18n_learnMore.initLearnMoreDomainName();


});
window.addEventListener('load', function () {

    if (window.require) {
        window.path = gui.App.dataPath.replace("\\User Data\\Default","") + "/";
        var curWin = gui.Window.get();
        document.getElementById('btnClose').addEventListener('click', function () {
            gui.Window.get().close();
        });
        document.getElementById('btnMinisize').addEventListener('click', function () {
            gui.Window.get().minimize();
        });
        document.getElementById('btnMaxsize').addEventListener('click', function () {
            if($("#btnMaxsize").hasClass('btnMax')){//切换全屏模式
                gui.Window.get().maximize();
            }else{
                gui.Window.get().unmaximize();
                $("#btnMaxsize").removeClass('btnMaxReturn');
                $("#btnMaxsize").addClass('btnMax');
            }
        });
        gui.Window.get().on('maximize', function () {
            $("#btnMaxsize").removeClass('btnMax');
            $("#btnMaxsize").addClass('btnMaxReturn');
        });
        gui.Window.get().on('unmaximize', function () {
            $("#btnMaxsize").addClass('btnMax');
            $("#btnMaxsize").removeClass('btnMaxReturn');
        });
        gui.Window.get().on('close', function () {
            curWin.show();//显示browser界面
            curWin.focus();//界面获取焦点
            var currentBucket = $('#curBucketName').html();
            var upd = window.upd;
            if (upd && upd['newAppPath']) {
                copyUninsFiles(upd);
                saveAccountAndKillDB(upd, currentBucket);
                return;
            }
            closeAlert(currentBucket);
        });

        //将数据库文件保存在用户数据目录
        var dbpath = global.appDataPath+"/data";
        if(pkg.dbpath) {
            dbpath = pkg.dbpath;
        }
        if(!fs.existsSync(dbpath)){
            createLocalFolder(dbpath);
        }
        var startDB = function(){
            var path = require('path');
            var spawn = require('child_process').spawn;
            window.mongod = spawn(path.dirname(process.execPath)+'/obsdb.exe', ['--dbpath', dbpath ,'--bind_ip' ,'127.0.0.1','--port' ,27117,'--auth']);

            window.mongod.stdout.on('data', function (data) {
                global.dbLogger.debug(data.toString());
            });

            window.mongod.stderr.on('data', function (data) {
                logger.error(data.toString());
            });

            window.mongod.on('close', function (code) {
                logger.info(code);
            });
        };


        fs.exists(dbpath+'/mongod.lock', function (exists) {
            if(exists){
                fs.unlink(dbpath+'/mongod.lock',function(err){
                    if(err){
                        logger.info(err);
                    }
                    startDB();
                });
            }
            else{
                startDB();
            }
        });
        var option = {
            key: 'Ctrl+F5',
            active: function () {
                var keyCode = this.key;
                if (keyCode === 'Ctrl+A') {
                    if($("textarea").is(':focus')||$("input").is(':focus')){
                        return false;
                    }
                    if ($("#mui-overlay").size() > 0) {
                        $('#listObjBodyDiv,#uploadTaskDiv,#downloadTaskDiv,#deleteTaskDiv,#recoverTaskDiv').removeClass('onMouseOver');
                    }
                    $(".onMouseOver tbody tr").addClass('selected-tr-active');
                    if($(".onMouseOver tbody .selected-tr-active").length==1){
                        disabledBtn($("#editCors,#deleteCors,#editLifecycle,#deleteLifecycle"));
                        disabledBtn($(".mui-page .shown .mui-icon-del-16"));
                    }else if($(".onMouseOver tbody .selected-tr-active").length>1){
                        $("#editCors,#editLifecycle").addClass('mui-disabled');
                        disabledBtn($("#deleteCors,#deleteLifecycle"));
                    }
                    $(".onMouseOver tbody tr td").find('.mui-ellipsis-6').addClass('show-span-active');
                    $(".onMouseOver tbody tr td").find('.mui-ellipsis-4').addClass('show-span-active');
                    $(".onMouseOver tbody tr td").find('.mui-ellipsis-prototype').addClass('show-span-active');
                    $(".onMouseOver tbody tr td").find('.mui-ellipsis-multipart').addClass('show-span-active');
                    if($("#objLists tbody tr").hasClass('selected-tr-active')){

                        disabledBtn($("#downloadbtn,#btnDeleteObjects"));
                        var arr_tr = $("#objLists tbody tr.selected-tr-active");
                        var currFileName = '';
                        arr_tr.each(function(i,obj){
                            var fileName = '';
                            if($(obj).find('td').eq(0).find('span i').hasClass("mui-icon-object-folder"))
                            {
                                fileName = JSON.parse($(obj).find('.hiddenObjData').text()).name;
                            }else
                            {
                                fileName = JSON.parse($(obj).find('.hiddenObjData').text()).name;
                            }
                            if(currFileName.indexOf(fileName)===-1)
                            {//判断被选择文件是否已经存在于已选文件
                                currFileName = currFileName+fileName+"|";
                            }
                        });
                        $("#downloadFileName").val(currFileName);
                        //全选下载按钮是否置灰
                        var restore_state = $("#objLists tr.selected-tr-active").find('.restore_stat');
                        var no_restore_objNum=false;
                        for(var j = 0; j < restore_state.length; j++) {
                            if(_.isEqual($(restore_state[j]).text(), languageJson.obs_term_notRestored_lable)){
                                no_restore_objNum=true;
                                break;
                            }
                            if(_.isEqual($(restore_state[j]).text(), languageJson.obs_term_restoring_lable)){
                                no_restore_objNum=true;
                                break;
                            }
                        }
                        //如果有未恢复对象，置灰下载按钮
                        if(no_restore_objNum){
                            $("#downloadbtn").addClass('mui-disabled');
                        }else{
                            disabledBtn($("#downloadbtn"));
                        }
                    }

                    //属性按钮置灰
                    if($("#objLists tr.selected-tr-active").length == 1 && $("#objLists tr.selected-tr-active").attr("data-type") == "file") {
                        //判断对象是否已经恢复
                        var path = getCurrPath();
                        checkObjectRestore(path + JSON.parse($(this).find('.hiddenObjData').text()).name);
                    } else {
                        disabledBtn($("#recoverBtn"));
                    }
                    //全选后，当选中对象中存在不符合恢复条件对象时，禁用恢复按钮
                    var category=$("#objLists tr.selected-tr-active").find('.hiddenObjData');
                    for(var i=0;i<category.length;i++){
                        var hiddenObjData = JSON.parse($(category[i]).text());
                        var storage = hiddenObjData.StorageClass;
                        if(storage === "STANDARD" || storage === "STANDARD_IA"){
                            $("#recoverBtn").addClass("mui-disabled");
                            $("#recoverBtn").attr("disabled",true);
                            $("#recoverBtn").attr("title",languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
                            break;
                        }
                    };
                }else if (keyCode === 'Ctrl+A') {
                    return false;
                }
            },
            failed: function (msg) {

            }

        };

        //Ctrl+F5----->刷新桶
        //Ctrl+F6----->刷新桶列表
        //Delete 删除选中对象
        //Ctrl+Delete 删除当前桶
        //Ctrl + A
        var keys = ['Ctrl+A','Ctrl+Z'];
        var cuts=[];
        for (var k in keys) {
            option.key = keys[k];
            var shortcut = new gui.Shortcut(option);
            cuts.push(shortcut);
        }

        gui.Window.get().on("focus",function(){
            for(var c in cuts){
                gui.App.registerGlobalHotKey(cuts[c]);
            }
        });

        gui.Window.get().on("blur",function(){
            for(var c in cuts){
                gui.App.unregisterGlobalHotKey(cuts[c]);
            }
        });


        // Give it a menu
        checkColdline(pkg.coldline);
        checkObjectColdline(pkg.objectColdline);
        setTimeout(function () {
            //获取用户信息列表
            accountService.getAccountList(function (err, lsAccount) {
                global.accountObj = lsAccount;
                if(UCDVersion !== 'HEC'&& UCDVersion !== 'OCB'&& UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'FCS'){
                    $("#zhLanguage").remove();
                }
                for(var i = 0;i<langaugeArr.length;i++){
                    $("#language").append("<option style='width:200px;' value='" + encoderForHtml(langaugeArr[i].key) + "'> <span style='max-width: 200px;'>" + encoderForHtml(langaugeArr[i].value) + "</span> </option>");
                }
                indexAction.loadingBasicSetting(pkg,function (err,data) {
                    if(data){
                        global.logger.info("setting in package configuration...", data);
                        var setObj = JSON.parse(data);
                        logger.setLevel(setObj.loggerLevel);
                        global.dbLogger.setLevel(setObj.loggerLevel);//设置mongodb数据库日志级别
                        global.logger=logger;
                        if(setObj.rubbishDays){
                            rubbishDays = parseFloat(setObj.rubbishDays);
                        }
                        isShowServerEncryption = setObj.isShowServerEncryption;
                        if(setObj.isShowServerEncryption){
                            signatureVersion = 'v4';
                        } else {
                            $("#serverEncryptionDiv").hide();
                        }
                    }else{
                        global.logger.error('loadingBasicSetting error:',err);
                    }
                });
                if (lsAccount) {
                    var htmlStr = "";
                    var userStr = '<ul style="max-height: 500px;overflow-y: scroll">';
                    var arr = lsAccount.Accounts.Account;
                    var currentId = lsAccount.Accounts.$.current.toString();
                    if(arr.length>0){
                        $(".btnUserInfo").css("max-width","221px");
                    }else{
                        $(".btnUserInfo").css("max-width","46px");
                    }
                    setTimeout(function(){
                        for (var i = 0; i < arr.length; i++) {
                            if(currentId===arr[i].ID[0]){
                                var showName = encoderForHtml(arr[i].Name).length>20?encoderForHtml(arr[i].Name).substring(0,20)+"...":encoderForHtml(arr[i].Name);
                                var str = '<span title="'+ encoderForHtml(arr[i].Name) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                                $(".btnUserInfo").html(str);
                            }
                            //在账号管理列表里面，如果账号字符大于30，则添加title
                            var accountDomTitle = encoderForHtml(arr[i].Name).length> 27 ? "title='" + encoderForHtml(arr[i].Name) +"'" : "";
                            htmlStr =
                                "<tr>" +
                                    "<td style='padding-left: 20px;width: 340px'>" +
                                        "<span " + accountDomTitle + " class='mui-ellipsis-prototype'>" + encoderForHtml(arr[i].Name) + "</span>" +
                                    "</td>" +
                                    "<td style='width: 120px;'>" +
                                        "<a href='#' data-href='createAccount' data-id='" + arr[i].ID + "' class='mui-icon-account-edit'>"+languageJson.edit+"</a>" +
                                        "<a href='#' style='margin-left: 20px;' data-href='accountList' data-id='" + arr[i].ID + "' class='mui-icon-account-del'>"+languageJson.delete+"</a>" +
                                    "</td>" +
                                "</tr>";
                            $("#accountTab tr:last").after(htmlStr);
                            var accountDomTitleDownList = encoderForHtml(arr[i].Name).length > 11 ? "title='" + encoderForHtml(arr[i].Name) +"'" : "";
                            userStr +=
                                "<li>" +
                                    "<a href='#' class='user' data-id='"+arr[i].ID+"' data-href='"+encoderForHtml(arr[i].Name)+"'>" +
                                        "<span " + accountDomTitleDownList + " class='mui-ellipsis-prototype mui-icon-account1'>"+ encoderForHtml(arr[i].Name) +"</span>" +
                                    "</a>" +
                                "</li>";
                        }
                        if(arr.length>0){
                            userStr +='</ul>'+'<li class="mui-border-before"><a href="#" id="accountManager" class="manager" style="padding: 4px 8px"><span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span></a></li>';
                        }else{
                            userStr +='</ul>'+'<li><a href="#" id="accountManager" class="manager" style="padding: 4px 8px"><span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span></a></li>';
                        }
                        $("#userList").html(userStr);
                    },2000);
                    if (gui.App.argv.length < 2) {
                        setTimeout(function () {
                            curWin.show();
                            var tray = false;
                            if(UCDVersion === 'DT'){//DT版本
                                tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/dt_images/OTC32.png'});
                            } else if(UCDVersion === 'OCB'){//FT版本
                                tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/ft_images/OCB32.png'});
                            } else{
                                tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/icons/OBS32.png'});
                            }
                            tray.on('click', function () {
                                curWin.focus();
                            });
                        }, 200);
                    }
                    winType = os.platform();
                    indexAction.loadSetting(function (obj) {
                        initSysConfig(obj);
                        if(pkg){
                            var version = pkg.version;
                            var lastUpdateDate = pkg.LastUpdateDate;
                            global.appVersion = version;
                            var showVersion = pkg.showVersion;
                            if(showVersion){
                                version  = showVersion;
                            }
                            if(pkg.UCDVersion == "OCB" && obj.language == "zh"){//法电中文更新时间
                                lastUpdateDate = pkg.LastUpdateDatezh;
                            }
                            $("#helpVersion").html(version);
                            $("#helpDtVersion").html(version);
                            $("#lastUpdateTime").html(lastUpdateDate);
                            if(UCDVersion !== 'HEC'&&UCDVersion !== 'CTC'&&UCDVersion !== 'CMCC'&&UCDVersion !== 'FCS'){
                                $("#websiteTr").addClass('mui-hide');
                                $(".more-user-btns").css('right','68px');
                                $("#selType").find('option:selected').html("<span style='font-size: 0.8em;'>"+languageJson.DTStorage+"</span>");
                                $("#btnUserSurveyLi").addClass('mui-hide');
                                $("#userExperienceDiv").addClass('mui-hide');
                                $("#aboutLi").addClass('mui-hide');
                                $("#otherSetting").addClass('mui-hide');
                                $("#isAutoUpdate").get(0).checked = true;
                                if(UCDVersion!=='DT'){//不是DT版本
                                    $("#DtProductMsg").addClass('mui-hide');
                                    $("#CopyrightOwner").html(languageJson[commonUtils.getDiffVersionLang(UCDVersion,"copyright")]);
                                }
                            }else{
                                $("#hwcloudsWeb").removeClass('mui-hide');
                                $("#dtloudsWeb").addClass('mui-hide');
                                $("#aboutDtLi").addClass('mui-hide');
                                $("#selType").find('option:selected').html("<span style='font-size: 0.8em;'>"+languageJson.MOSStorage+"</span>");
                                $("#btnUserSurveyLi").removeClass('mui-hide');
                                $("#isAutoUpdate").get(0).checked = true;
                            }
                        }
                        errorConfig = indexAction.initErrorConfig(errorConfig,languageJson);
                        indexAction.loadExtBucket(function (data) {
                            ExtBucket = data;
                            if(obj && obj.mongoAuthPwd){
                                global.newMongoPwd = obj.mongoAuthPwd;
                                loaderUser();
                            }else{
                                var crypto = require('crypto');
                                async.waterfall([
                                    function(callback){
                                        crypto.randomBytes(64/8, function(err, saltBuf) {
                                            if(err)callback(err);
                                            else callback(null,saltBuf);
                                        });
                                    },
                                    function (data,callback) {
                                        var pwd = data.toString('hex');
                                        global.Tools.encode('mongoPwd',pwd, function (err,text) {
                                            callback(err,text)
                                        })
                                    }
                                ], function (err, result) {
                                    global.newMongoPwd = result;
                                    var configObj = {};
                                    if(obj){
                                        configObj = obj;
                                    }else{
                                        configObj = { isAutoUpdate: 'Y',
                                            userExperience: 'N',
                                            isMultiUpload: true,
                                            multiUploadNum:5,
                                            language: 'zh',
                                            isMultiDownload: true,
                                            isHttps: 'Y' };
                                        if(UCDVersion !== 'HEC'&& UCDVersion !== 'CTC'&&UCDVersion !== 'CMCC'&&UCDVersion !== 'FCS'){
                                            configObj.language="en";
                                        }
                                    }
                                    configObj.mongoAuthPwd = result;
                                    indexAction.writeSysConfig(JSON.parse(JSON.stringify(configObj)),userPath);
                                    loaderUser();
                                });
                            }
                        })
                    });
                } else {
                    var trs = $("#accountTab tbody").find('tr').length;
                    if (gui.App.argv.length < 2) {
                        allButtonChange('1');
                        setTimeout(function () {
                            //读取本地region配置文件信息
                            indexAction.getBucketRegion(pkg, function (err,data) {
                                if(!err){
                                    var configObj = JSON.parse(data);
                                    var arr = configObj.options;
                                    var htmlStr = "";
                                    var selBody = $("#regionSelect");
                                    selBody.html('');
                                    for (var index in arr) {
                                        if(language!='zh'){
                                            if(UCDVersion !== 'HEC'&&UCDVersion !== 'CTC'&&UCDVersion !== 'CMCC'&&UCDVersion !== 'FCS'){
                                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                                                if(arr.length === 1){
                                                    $("#regionSelect").addClass('mui-hide');
                                                    $("#regionStr1").removeClass('mui-hide');
                                                    $("#regionStr1").html(encoderForHtml(arr[index].value));
                                                }
                                            }else{
                                                if(arr[index].value=='cn-north-1'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN North-Beijing1</option>";
                                                }else if(arr[index].value=='cn-east-2'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN East-Shanghai2</option>";
                                                }else if(arr[index].value=='cn-south-1'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN South-Guangzhou</option>";
                                                }else if(arr[index].value=='ap-southeast-1'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>AP-Hong Kong</option>";
                                                }else{
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                                                }
                                            }
                                        }else{
                                            htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                                        }
                                        selBody.append(htmlStr);
                                    }
                                    domainName = configObj.domainName;
                                    global.domainName = configObj.domainName;
                                    defaultRegion = configObj.defaultRegion;
                                    updateServer = configObj.updateServer;
                                }else{
                                    logger.error(err);
                                }
                                indexAction.loadSetting(function (obj) {
                                    initSysConfig(obj);
                                    if ('Y' === isAutoUpdate) {
                                        mosUpdate();
                                    }
                                    if(pkg){
                                        var version = pkg.version;
                                        var lastUpdateDate = pkg.LastUpdateDate;
                                        global.appVersion = version;
                                        var showVersion = pkg.showVersion;
                                        if(showVersion){
                                            version  = showVersion;
                                        }
                                        $("#helpVersion").html(version);
                                        $("#helpDtVersion").html(version);
                                        $("#lastUpdateTime").html(lastUpdateDate);
                                        if(UCDVersion !== 'HEC'&&UCDVersion !== 'CTC'&&UCDVersion !== 'CMCC'&&UCDVersion !== 'FCS'){
                                            $("#websiteTr").addClass('mui-hide');
                                            $(".more-user-btns").css('right','68px');
                                            $("#selType").find('option:selected').html("<span style='font-size: 0.8em;'>"+languageJson.DTStorage+"</span>");
                                            $("#btnUserSurveyLi").addClass('mui-hide');
                                            $("#userExperienceDiv").addClass('mui-hide');
                                            $("#aboutLi").addClass('mui-hide');
                                            $("#otherSetting").addClass('mui-hide');
                                            $("#isAutoUpdate").get(0).checked = true;
                                            if(UCDVersion!=='DT'){//不是DT版本
                                                $("#DtProductMsg").addClass('mui-hide');
                                                $("#CopyrightOwner").html(languageJson[commonUtils.getDiffVersionLang(UCDVersion,"copyright")]);
                                            }
                                        }else{
                                            $("#hwcloudsWeb").removeClass('mui-hide');
                                            $("#dtloudsWeb").addClass('mui-hide');
                                            $("#aboutDtLi").addClass('mui-hide');
                                            $("#selType").find('option:selected').html("<span style='font-size: 0.8em;'>"+languageJson.MOSStorage+"</span>");
                                            $("#btnUserSurveyLi").removeClass('mui-hide');
                                            $("#isAutoUpdate").get(0).checked = true;
                                        }
                                    }
                                    errorConfig = indexAction.initErrorConfig(errorConfig,languageJson);
                                });
                            });
                            $(".btnUserInfo").css("max-width","46px");
                            var str = '<span class="mui-ellipsis-2" style="color: #ffffff;"></span><i class="btn-account"></i>';
                            $(".btnUserInfo").html(str);
                            setTimeout(function(){
                                var userStr ='<li><a href="#" id="accountManager" class="manager"><span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span></a></li>';
                                $("#userList").html(userStr);
                            },2000);
                            if (gui.App.argv.length < 2) {
                                setTimeout(function () {
                                    curWin.show();
                                    var tray = false;
                                    if(UCDVersion === 'DT'){//DT版本
                                        tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/dt_images/OTC32.png'});
                                    } else if(UCDVersion === 'OCB'){//FT版本
                                        tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/ft_images/OCB32.png'});
                                    } else{
                                        tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/icons/OBS32.png'});
                                    }
                                    tray.on('click', function () {
                                        curWin.focus();
                                    });
                                }, 200);
                            }
                            showOverlay();
                            indexAction.loadSetting(function (obj) {
                                if (obj && obj.mongoAuthPwd) {
                                    global.newMongoPwd = obj.mongoAuthPwd;
                                    $("#createAccount").addClass('shown');
                                    if(_.isEqual(UCDVersion,"FCS")){
                                        $("#FCS").parent().addClass('mui-hide');
                                    }
                                    $("#createAccountTab").removeClass("mui-hide");
                                    $("#saveAccountBtn").attr('data-init', 'true');
                                    $(".btnUserInfo").addClass('userNoLogin');
                                }else{
                                    $(".btnUserInfo").addClass('userNoLogin');
                                    var crypto = require('crypto');
                                    async.waterfall([
                                        function (callback) {
                                            crypto.randomBytes(64 / 8, function (err, saltBuf) {
                                                if (err)callback(err);
                                                else callback(null, saltBuf);
                                            });
                                        },
                                        function (data, callback) {
                                            var pwd = data.toString('hex');
                                            global.Tools.encode('mongoPwd', pwd, function (err, text) {
                                                callback(err, text)
                                            })
                                        }
                                    ], function (err, result) {
                                        global.newMongoPwd = result;
                                        var configObj = {};
                                        if (obj) {
                                            configObj = obj;
                                        } else {
                                            configObj = {
                                                isAutoUpdate: 'Y',
                                                userExperience: 'N',
                                                isMultiUpload: true,
                                                multiUploadNum: 5,
                                                language: 'zh',
                                                isMultiDownload: true,
                                                isHttps: 'Y'
                                            };
                                            if (UCDVersion !== 'HEC'&&UCDVersion !== 'CTC'&&UCDVersion !== 'CMCC'&&UCDVersion !== 'FCS') {
                                                configObj.language = "en";
                                            }
                                        }
                                        configObj.mongoAuthPwd = result;
                                        indexAction.writeSysConfig(JSON.parse(JSON.stringify(configObj)),userPath);
                                        $("#createAccount").addClass('shown');
                                        if(_.isEqual(UCDVersion,"FCS")){
                                            $("#FCS").parent().addClass('mui-hide');
                                        }
                                        $("#createAccountTab").removeClass("mui-hide");
                                        $("#saveAccountBtn").attr('data-init', 'true');
                                    });
                                }
                                divDragFunc('createAccountDrag','createAccount');
                            });
                        }, 50);
                    }
                }
            });
        }, 300);
    }
});



function initSysConfig(obj){
    if (obj && obj.isAutoUpdate) {
        isAutoUpdate = obj.isAutoUpdate;
    }else{
        isAutoUpdate = 'N';
    }
    if (obj && obj.isOverwritePower) {
        isOverwritePower = obj.isOverwritePower;
    }
    if (obj && obj.language) {
        language = obj.language;
        if(UCDVersion==='DT'){
            language = 'en';
        }
        loadLanguge();
    }else if(UCDVersion !== 'HEC'&& UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'FCS'){
        language = 'en';
        loadLanguge();
    }else{
        language = 'zh';
        loadLanguge();
    }
    if (obj && obj.isHttps) {
        isHttps = obj.isHttps;
    }
    if(obj && obj.isSSL){
        isSSL = obj.isSSL;
    }
    if(obj && obj.isMD5check){
        global.isMD5check = obj.isMD5check;
    }
    if (obj && obj.downloadTaskNum) {
        downloadTaskNum = obj.downloadTaskNum;
        downloadConfig.maxTaskNum = downloadTaskNum;
    }
    if (obj && obj.uploadTaskNum) {
        uploadTaskNum = obj.uploadTaskNum;
        uploadConfig.maxUploadTasks = uploadTaskNum;
        global.maxUploadTasks = uploadTaskNum;
    }
    if (obj && obj.multiUploadNum) {
        uploadConfig.multiUploadNum = obj.multiUploadNum;
    }
    if (obj && obj.isMultiDownload) {
        downloadConfig.isMultiDownload = obj.isMultiDownload;
    }
    if (obj && obj.proxy) {
        proxy = obj.proxy;
        initProxy();
    }
    if(obj && obj.isServerEncryption && isShowServerEncryption)
    {
        global.serverEncryption = obj.isServerEncryption;
    }

    if(obj && obj.objPerPageSize) {
        global.objPerPageSize = obj.objPerPageSize;
    }

    initTinyCompnents();
    initDepondLang();
}

function  loadLanguge(){
    languageJson=languageData;
    if(UCDVersion === 'TLF'){//如果是TLF版本,修改账户欠费词条
        var data = {
            "en":"Your account is frozen.",
            "Portuguese":"A sua conta está congelada.",
            "Spanish":"Su cuenta está congelada."
        }
        languageJson.InArrearOrInsufficientBalance = data[language];
    }
    global.langData = languageJson;
};


function loaderUser(currentId,isShowMsg,accObject) {
    //每次切换用户需要清理copy/move剪切板
    global.glbClipboard.clean();
    var isShowerr = false;
    if(isShowMsg){
        isShowerr = isShowMsg;
    }
    accountService.getAccountInfo(currentId, function (result) {
        if(accObject){
            result.secretKey = accObject.secretKey;
        }
        if(!result){
            if(isShowerr){
                $('.mui-model').showErrorMessage({
                    message: languageJson.getConfigInfoErr,
                    obsError: obsError("getConfigInfoErr")
                });
            }
            allButtonChange('1');
            return false;
        }else{
            global.currentUserName = result.name.toString();
        }
        require("./js/access/iam/IAMConnector").loadUserInfo(result);
        indexAction.loadingBasicSetting(pkg,function (err,data) {
            if(data){
                var setObj = JSON.parse(data);
                logger.setLevel(setObj.loggerLevel);
                global.logger=logger;
                global.dbLogger.setLevel(setObj.loggerLevel);//设置mongodb数据库日志级别
                if(setObj.rubbishDays){
                    rubbishDays = parseFloat(setObj.rubbishDays);
                }
                isShowServerEncryption = setObj.isShowServerEncryption;
                if(setObj.isShowServerEncryption){
                    signatureVersion = 'v4';
                } else {
                    $("#serverEncryptionDiv").hide();
                }
            }else{
                global.logger.error('loadingBasicSetting error');
            }
        });
        indexAction.getBucketRegion(pkg, function (err, data) {
            if(!err){
                var configObj = JSON.parse(data);
                var arr = configObj.options;
                var htmlStr = "";
                var selBody = $("#regionSelect");
                selBody.html('');
                for (var index in arr) {
                    if(language!='zh'){
                        if(UCDVersion !== 'HEC'&& UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'FCS'){
                            htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                            if(arr.length === 1){
                                $("#regionSelect").addClass("mui-hide");
                                $("#regionStr1").removeClass("mui-hide");
                                $("#regionStr1").html(arr[index].value);
                            }
                        }else{
                            if(arr[index].value=='cn-north-1'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN North-Beijing1</option>";
                            }else if(arr[index].value=='cn-east-2'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN East-Shanghai2</option>";
                            }else if(arr[index].value=='cn-south-1'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN South-Guangzhou</option>";
                            }else if(arr[index].value=='ap-southeast-1'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>AP-Hong Kong</option>";
                            }else{
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                            }
                        }
                    }else{
                        htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                    }
                    selBody.append(htmlStr);
                }
                if(!$('#regionSelect').hasClass('mui-hide')){
                    $('#regionSelect').selectmenu().selectmenu( "menuWidget" ).addClass("obs-connect-type");
                }
                domainName = configObj.domainName;
                global.domainName = configObj.domainName;
                defaultRegion = configObj.defaultRegion;
                updateServer = configObj.updateServer;
            }else{
                logger.error(err);
            }
            if ('Y' === isAutoUpdate) {
                mosUpdate();
            }
            //保存https协议信息，301重定向时需要
            global.isHttps = isHttps;
            var option = {};
                if(result.secretKey){
                    option = {
                        accessKey: result.accessKey,
                        secretKey: result.secretKey,
                        endpoint: result.endpoint,
                        isHttps: isHttps,
                        proxy:proxy,
                        isSSL:isSSL,
                        isMD5check:global.isMD5check
                    };
                }else{
                    allButtonChange('1');
                    $("#createAccount .mui-page-full-title").html(languageJson.editAccount);
                    $("#name").val(result.name);
                    $("#accessKey").val(result.accessKey);
                    $("#selType").val(result.type);
                    $("#selType").selectmenu('refresh', true);
                    if(result.type.toString().trim()==='1'){
                        $("#endpointDiv").addClass('mui-hide');
                    }else{
                        $("#endpointDiv").removeClass('mui-hide');
                        $("#endpoint").val(result.endpoint);
                    }
                    $("#isSaveSK").get(0).checked = false;
                    $("#userId").val(result.userID);
                    $("#createAccount").addClass('shown');
                    $("#createAccountTab").removeClass("mui-hide");
                    $("#saveAccountBtn").attr('data-edit', 'true');
                    divDragFunc('createAccountDrag','createAccount');
                    return false;
                }


                //加载region信息，V4鉴权必须
                if (defaultRegion)
                {
                    option.defaultRegion = defaultRegion;
                }
                //加载鉴权版本
                if (signatureVersion)
                {
                    option.signatureVersion = signatureVersion;
                }
                s3 = indexAction.initS3(option);
            global.s3 = s3;
            bucketAndObjectAction = new BucketAndObjectAction(s3,0);
            bucketAttributeAction = new BucketAttributeAction(s3);
            var userPath = global.appDataPath;
            currentUserId = result.userID[0];

            endpoint=result.endpoint;
            userType = result.type[0];
            if (objectShowWay === "list") {
                $("#listObjBodyDiv").removeClass("mui-hide");
                $("#objContainer").addClass("mui-hide");
            } else {
                $("#listObjBodyDiv").addClass("mui-hide");
                $("#objContainer").removeClass("mui-hide");
            }
            lastBucket = result.lastBucket ? result.lastBucket.toString() : "";
            var loading = loadingShow();
            bucketAndObjectAction.listBucket(function (err, data) {
                if (!err || err.code === "AccessDenied") {
                    if(taskManager){
                        taskManager = null;
                        delete taskManager;
                    }
                    if(taskControlAction){
                        taskControlAction = null;
                        delete taskControlAction;
                    }
                    if(data) {
                        global.curOnwerId = data.Owner.ID;
                        global.curDisplayName = data.Owner.DisplayName;
                    }
                    taskManager = new TaskManager(currentUserId,s3,'',uploadConfig,downloadConfig);
                    taskControlAction = new TaskControlAction(s3, taskManager);
                    taskManager.on("dbconn", function (task) {
                        reloadTasks(true);//强制重新加载任务
                        refreshTaskNum();//查询已有任务数量
                        taskManager.pauseAll = true;
                        var t = setInterval(function () {
                            if(isLoaded){
                                clearInterval(t);
                                taskControlAction.resumeIterators();
                            }
                        },1000);
                        if(!checkRecoverInterval) {
                            global.logger.info("NUM_RECOVER_QUERY_TIMES:" + Const("NUM_RECOVER_QUERY_TIMES"));
                            checkRecoverInterval = setInterval(function () {
                                checkRecoverStatus()
                            }, Const("NUM_RECOVER_QUERY_TIMES"));
                        }
                    })
                        .on("onStart", function (task) {

                            if (nowstat === "WAIT") {
                                removeTask(task);
                            }
                            else if (nowstat === "") {
                                refrchStat(task);
                            }

                        }).
                        on("progress", function (task, evt) {
                            refresh(task, evt);
                        }).
                        on("onWait", function (task) {
                            if (!isLoaded) {
                                return false;
                            }
                            if (nowstat === "PAUSE" || nowstat === "FAILED") {
                                removeTask(task);
                            }
                            else if (nowstat === "WAIT") {
                                addToTask(task);
                            }
                            else if (nowstat === "") {
                                refrchStat(task);
                            }
                        }).
                        on("onPause", function (task) {
                            if (!isLoaded) {
                                return false;
                            }
                            if (nowstat === "WAIT") {
                                removeTask(task);
                            } else if (nowstat === "PAUSE") {
                                addToTask(task);
                            } else if (nowstat === "") {
                                refrchStat(task);
                            }
                        }).
                        on("failed", function (task) {
                            if (!isLoaded) {
                                return false;
                            }
                            if (nowstat === "FAILED") {
                                addToTask(task);
                            } else if (nowstat === "") {
                                refrchStat(task);
                            }
                        }).
                        on("onAbort", function (task) {
                            if (!isLoaded) {
                                return false;
                            }
                            removeTask(task);
                        }).
                        on("end", function (task) {
                            if (!isLoaded) {
                                return false;
                            }
                            if($(".obs-tab-navi .obs-tab-active").attr('tab-for') === 'processingTaskPanel'){
                                removeTask(task);
                            }
                            invokeTool.invokeWithInterval(refreshUI,task,1003,"refreshUI");
                        });
                    //登录成功后,记录用户登录
                    if(UCDVersion === 'HEC'|| UCDVersion === 'CTC'|| UCDVersion === 'CMCC'|| UCDVersion === 'FCS'){
                        userCommentLogin(result.accessKey, result.secretKey);
                    }
                }
                listBucketUI(err, data, loading);
            });

            $("#taskConcole .body tbody").html('');
        });
    });
}


function cleanObjectList() {
    $("#objLists tbody").find('tr').each(function () {
        $(this).remove();
    });
    $("#objLists tbody").html('');
}
/**
 *
 * @param err 调用S3返回的错误对象
 * @param data S3接口返回是数据对象
 * @param bucketName 桶名称
 * @param autoRefresh 如果是自动刷新，出现错误时则不弹出对话框
 * @param isLastPage 是否是最后一页
 * @returns {boolean}
 */
function listObjectUI(err,data,bucketName,autoRefresh,isLastPage){
    $("#path a").each(function(){
        var pathNodeName = $(this).attr("folderName");
        if(pathNodeName.length > 12) {
            $(this).attr("title", pathNodeName);
        }
    })
    $("#lastUpdateTh").removeClass("lastUpdateTh");
    objSort = false;
    getBucketStorageInfo(bucketName);
    $("#downloadbtn,#btnDeleteObjects,#recoverBtn").addClass('mui-disabled');
    $("#downloadbtn").attr('data-title',languageJson.selectFileOrFolder);
    if (global.UCDVersion === "HEC") {
        $("#recoverBtn").attr('data-title',languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
    }else {
        $("#recoverBtn").attr('data-title',languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
    }
    if (err) {
        logger.error("list Object UI ERR", err);
        if(!autoRefresh){
            if(errorConfig[err.code]){
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message),
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        if(err.code == 'NoSuchBucket'|| err.code ==="AccessDenied") {
                            $("#bread-path-box-bucket").click();
                        }
                        return false;
                    }
                });
                showOverlay();
            }
        }
    } else {
        lastBucket = bucketName;
        var path = getCurrPath();
        var isSearch = $("#isSearch").val();
        if(!isSearch){
            if(data.Name!==$('#curBucketName').html()||data.Prefix!==path){
                return false;
            }
        }
        // 如果当前页没有对象且不是第一页，会返回到上一页
        if(data.Contents.length == 0 && data.CommonPrefixes.length == 0 && pageContext.nowPage > 1){
            $('#objLists-previous').click();
        }
        // 判断分页按钮是否显示隐藏
        if (data.IsTruncated) {
            pageContext["page" + (pageContext.nowPage + 1)] = data.NextMarker;
            $('#objLists-table-section').removeClass('mui-hide');
            if(pageContext.nowPage == 1){ // 有多页且在第一页的情况
                $('#objLists-previous').addClass('mui-disabled');
                $('#objLists-previous').attr('title',languageJson.common_term_previous_tip);
            }else{
                disabledBtn($('#objLists-previous'));
            }
            disabledBtn($('#objLists-next'));
        }else if(pageContext.nowPage == 1){ // 只有一页的情况
            $('#objLists-table-section').addClass('mui-hide');
        }else { // 在最后一页的情况
            disabledBtn($('#objLists-previous'));
            $('#objLists-next').addClass('mui-disabled');
            $('#objLists-next').attr('title',languageJson.common_term_next_tip);
        }
        if(isLoaded) {
            cleanObjectList();
            $("#objLists").css("width",$("#objListsHead").css("width"));
            var object;
            var key = data.Prefix;
            var fileAttr = {};
            var tbody = $("#objLists tbody");
            var flo;
            setLocalFolders(data.CommonPrefixes);
            try {
                var folderList = [];
                var isGLACIER = false;
                $("#objHeaderRestoreStatus").hide();
                if (pkg.objectColdline || currBucketStorage == 'Coldline') {
                    isGLACIER = true;
                }
                if(pkg.objectColdline){
                    $("#objHeaderRestoreStatus").show();
                }

                for (var i in data.CommonPrefixes) {
                    flo = data.CommonPrefixes[i];
                    fileAttr.name = encoderForHtml(flo.Prefix);

                    var prefixName = encoderForHtml(indexAction.handlePath(key, flo.Prefix, 1))
                    folderList.push({
                        //处理多个连续空格显示问题
                        showKey: prefixName.replace(new RegExp(' ', 'gm'), '&nbsp;'),
                        fileType: languageJson.folder,
                        storageClass: currBucketStorage,
                        prefixName: prefixName,
                        hidenData: JSON.stringify(fileAttr),
                        aclConfig: languageJson.download,
                        isGLACIER: isGLACIER,
                        delete: languageJson.delete,
                        coldline : pkg.objectColdline
                    })
                }

                tbody.append(renderSync("listObjectsTemplate", folderList));

                var contentList = [];
                for (var index in data.Contents) {
                    object = data.Contents[index];
                    fileAttr.name = encoderForHtml(indexAction.handlePath(key, object.Key, 0));
                    fileAttr.size = indexAction.getFileSize(object.Size);
                    fileAttr.dataSize = object.Size;
                    fileAttr.etag = object.Etag;
                    fileAttr.modifyTime = indexAction.gmtDate2LocaleDate(object.LastModified,language);
                    fileAttr.StorageClass = object.StorageClass;
                    if (object.Key[object.Key.length - 1] != '/') {
                        var isRestored = false;
                        if(object.StorageClass == 'GLACIER' || object.StorageClass == 'Coldline'){
                            isRestored = true;
                        }
                        var fileName = indexAction.handlePath(key, object.Key, 0);
                        fileName = fileName.toLowerCase();
                        contentList.push({
                            showKey: indexAction.getFileType(fileName) + " " + fileAttr.name.replace(new RegExp(' ','gm'),'&nbsp;'),
                            size: indexAction.getFileSize(object.Size,"",language),
                            fileType: languageJson.file,
                            storageClass: commonUtils.termStorageClass(object.StorageClass),
                            modifyDate: fileAttr.modifyTime,
                            encodedFileName: fileAttr.name,
                            hidenData: JSON.stringify(fileAttr),
                            property: languageJson.property,
                            aclConfig: languageJson.download,
                            isGLACIER: isGLACIER,
                            isRestored: isRestored,
                            delete: languageJson.delete,
                            more: languageJson.more,
                            etag: fileAttr.ETag?fileAttr.ETag:"none",
                            recover: languageJson.obs_term_restore_button,
                            unique: AWS.util.crypto.sha256(object.Key,'hex'),
                            coldline : pkg.objectColdline
                        })
                    }
                }
                tbody.append(renderSync("listObjectsItemTemplate", contentList));
                if(pkg.objectColdline && isGLACIER) {
                    //如果需要更新，则批量查询当前页面中的对象恢复状态，并且更所有缓存
                    if (global.restoreCache.isUpdate(bucketName, path)) {
                        global.logger.info("Start update restore status.", global.restoreCache)
                        async.eachLimit(data.Contents, 5,function(item, callback) {
                            var object = item;
                            var objId = AWS.util.crypto.sha256(object.Key, 'hex');
                            bucketAndObjectAction.headObjectWithMD5(bucketName, object.Key, objId, function (err, data, objKey, unique) {
                                var dataKey = unique + Const("RESTORE_STATUS_SUFFIX");
                                var test = unique + Const("RECOVER_READY");
                                if (err) {
                                    global.logger.error("head object failed. object=" + objKey, err);
                                    $("#" + dataKey).html("--");
                                } else {
                                    var restoreStat = global.restoreCache.putCache(data,dataKey);
                                    var storageJson = JSON.parse($("#" + dataKey).parent().parent().find(".hiddenObjData").text());
                                    var storageType = storageJson.StorageClass;
                                    if(storageType != "GLACIER"){
                                        restoreStat = "--";
                                        global.restoreCache.data[dataKey] = restoreStat;
                                    }
                                    if(restoreStat == languageJson.obs_term_restored_lable && storageType === "GLACIER"){
                                        $("#" + unique + "_property").addClass("mui-hide");
                                        $("#"+ unique + "_download").removeClass("mui-hide");
                                    }
                                    $("#" + dataKey).html(restoreStat);
                                }
                                callback()
                            })
                        }, function(err) {
                            if(err) {
                                global.logger.error('Head object eachSeries error.', err);
                            } else {
                                global.logger.info('Head object eachSeries done.');
                            }
                        })
                    } else {
                        //不需要更新，则去缓存中取出每个对象的恢复状态
                        global.logger.info("Use cache restore status.", global.restoreCache)
                        for (var index in data.Contents) {
                            var object = data.Contents[index];
                            var objId = AWS.util.crypto.sha256(object.Key, 'hex');
                            var loopDataKey = objId + Const("RESTORE_STATUS_SUFFIX");
                            if (!global.restoreCache.data[loopDataKey]) {
                                //如果对象列表中的对象，在缓存中找不到value，则发起head请求去查询，并更新缓存
                                bucketAndObjectAction.headObjectWithMD5(bucketName, object.Key, objId, function (err, data, objKey, unique) {
                                    var dataKey = unique + Const("RESTORE_STATUS_SUFFIX");
                                    if (err) {
                                        global.logger.error("head object failed. object=" + objKey, err);
                                        $("#" + dataKey).html("--");
                                    } else {
                                        var restoreStat = global.restoreCache.putCache(data,dataKey);
                                        var storageType = JSON.parse($("#" + dataKey).parent().parent().find(".hiddenObjData").text()).StorageClass;
                                        if(storageType != "GLACIER"){
                                            restoreStat = "--";
                                            global.restoreCache.data[dataKey] = restoreStat;
                                        }
                                        if(restoreStat == languageJson.obs_term_restored_lable && storageType === "GLACIER"){
                                            $("#" + unique + "_property").addClass("mui-hide");
                                            $("#"+ unique + "_download").removeClass("mui-hide");
                                        }
                                        $("#" + dataKey).html(restoreStat);
                                    }
                                })
                            } else {
                                $("#" + loopDataKey).html(global.restoreCache.data[loopDataKey]);
                                if(global.restoreCache.data[loopDataKey] == languageJson.obs_term_restored_lable){
                                    $("#" + objId + "_property").addClass("mui-hide");
                                    $("#" + objId + "_download").removeClass("mui-hide");
                                }
                            }
                        }
                    }
                }
                //按照时间顺序排序
                var $trs = $('#objLists tbody tr[data-type="file"]');
                $trs.sort(function(a,b){
                    var t1 = $(a).find('td:eq(5)').text();
                    var t2 = $(b).find('td:eq(5)').text();
                    var x = new Date(Date.parse(t1.replace(/-/g, "/")));
                    var y = new Date(Date.parse(t2.replace(/-/g, "/")));
                    if(parseInt(x.getTime()) < parseInt(y.getTime())) return 1;
                    else return -1;
                });
                $trs.detach().appendTo('#objLists tbody');
            } catch(err) {
                global.logger.error("err", err.stack)
            }
            if(data.IsTruncated){
                pageContext.refresh = true;
            }else{
                pageContext.refresh = false;
            }
            if (pageContext.nowPage > 1) {
                setTimeout(function () {
                    pageContext.upRefresh = true;
                },500);
            }else{
                pageContext.upRefresh = false;
            }
            if (document.getElementById("listObjBodyDiv").offsetHeight < document.getElementById("listObjBodyDiv").scrollHeight) {
                $("#lastUpdateTh").css('width', '200px');
            } else {
                $("#lastUpdateTh").css('width', '200px');
            }
            if($("#objLists tbody tr").length===0){
                var showEmpty = languageJson.noData;
                var serachKey = $("#prefixSearch").val();
                $("#lastUpdateTh").addClass("lastUpdateThNodata");
                if(serachKey && serachKey.length > 0) {
                    showEmpty = global.langData.noRecords
                }
                global.logger.info("serachKey=", serachKey)
                tbody.append('<div class="table-nodata"><span>' + showEmpty + '</span></div>');
            }else{
                $("#lastUpdateTh").removeClass("lastUpdateThNodata");
            }
        }
    }
}

function encoderForHtml(input){
    var div = document.createElement('div');
    $(div).text(input);
    return $(div).html();
}
function firstWordUpperCase(str){
    return str.toLowerCase().replace(/(\s|^)[a-z]/g, function(char){
        return char.toUpperCase();
    });
}
function encoderForText(input){
    var div = document.createElement('div');
    $(div).html(input);
    return $(div).text();
}

function calculateTime(byteLen, speed) {
    var time = Math.round(byteLen / speed);
    var min = 0;
    var hour = 0;
    var second = time;
    if (time > 59) {
        min = Math.round(time / 60);
        second = time % 60;
    }
    if (min > 59) {
        hour = Math.round(min / 60);
        var min = min % 60
    }
    if (second < 10 < 0) {
        second = '0' + second;
    }
    var spTime = second +languageJson.second;
    if(min>0){
        if (min < 10 < 0) {
            min = '0' + min;
        }
        spTime = min + languageJson.minute +spTime;
    }
    if (hour > 0) {
        if (hour < 10 < 0) {
            hour = '0' + hour;
        }
        spTime = hour + languageJson.hour + spTime;
    }
    return spTime;
}

function getTaskKey(task){
    if (task.action === 'downloadDir'||task.action === 'downloadFile') {
        task.key = task.path+task.prefix;
    }else if (task.action === 'deleteDir'){
        task.key = task.prefix;
    }
    return task;
}


function deleteTaskConsole(action){
    if($.inArray(action.id, taskArr)!==-1){
        $("#"+action.id).remove();
        refreshUI(action);
    }
}


function addToTaskConsole(id,task) {
    var taskBody = '';
    var trHtml = renderTaskConsoleItem(id,task);
    if(task.action==='uploadFile'||task.action==='uploadDir'){
        taskBody = $("#uploadTaskTab tbody");
    }else if(task.action==='downloadFile'||task.action==='downloadDir'){
        taskBody = $("#downloadTaskTab tbody");
    }else if(task.action==='deleteFile'||task.action==='deleteDir'){
        taskBody = $("#deleteTaskTab tbody");
    }
    taskBody.append(trHtml);
}

function taskUpOrDown(type) {
    if(type){
        if (type.trim() === 'uploadDir'||type.trim() === 'uploadFile') {
            type =languageJson.upload;
        } else if (type.trim() === 'downloadDir'||type.trim() === 'downloadFile') {
            type = languageJson.down;
        }else if (type.trim() === 'create'){
            type = languageJson.upload;
        }else if (type.trim() === 'deleteFile'||type.trim() === 'deleteDir'){
            type = languageJson["delete"];
        }
    }
    return type;
}



function refreshUI(task) {
    if (!isLoaded) {
        return false;
    }
    var $curBucketName = $('#curBucketName');
    var parentPath = getCurrPath();
    if (task.type.trim() === "putObj" || task.type.trim() === TaskEnum.TASK_TYPE.copy.value || task.type.trim() === TaskEnum.TASK_TYPE.move.value) {
        var file = task.key;

        if (file.substring(file.length - 1, file.length) === "/") {
            file = file.substring(0, file.length - 1);
            if (file.lastIndexOf("/") === -1) {
                file = "";
            } else {
                file = file.substring(0, file.lastIndexOf("/") + 1);
            }
        } else {
            file = file.substring(0, file.lastIndexOf("/") + 1);
        }
        var bucket = task.bucket;
        //刷新当前目录的对象列表操作
        var currBucket = $curBucketName.html();
        if(bucket === currBucket){
            if (isRefreshUI(task.key)|| parentPath === file) {
                pageContext = {};//重置分页对象
                pageContext.nowPage = 1;

                if ($("#isSearch").val()) {
                    var prefix = $("#prefixSearch").val();
                    prefix = parentPath + prefix;
                    bucketAndObjectAction.listObject(bucket, 'true', prefix, function (err, data) {
                        listObjectUI(err, data, bucket, true);
                    });
                } else {
                    bucketAndObjectAction.listObject(bucket, 'true', parentPath, function (err, data) {
                        listObjectUI(err, data, bucket, true);
                    });
                }
            }
        }
    }
    else if (task.type === "delete") {
        var file = task.key;
        if (file.substring(file.length - 1, file.length) === "/") {
            file = file.substring(0, file.length - 1);
            if (file.lastIndexOf("/") === -1) {
                file = "";
            } else {
                file = file.substring(0, file.lastIndexOf("/") + 1);
            }
        } else {
            file = file.substring(0, file.lastIndexOf("/") + 1);
        }
        var bucket = task.bucket;
        //刷新当前目录的对象列表操作
        var currBucket = $curBucketName.html();
        //判断界面是否还停留在上传对象的桶
        if (bucket === currBucket && parentPath === file) {
            if ($("#isSearch").val()) {
                var prefix = $("#prefixSearch").val();
                prefix = parentPath + prefix;
                bucketAndObjectAction.listObject(bucket, 'true', prefix, function (err, data) {
                    listObjectUI(err, data, bucket, true);
                },pageContext['page'+pageContext.nowPage]);
            } else {
                $("#prefixSearch").val('');
                $("#clearPrefixSearchInput").addClass("mui-hide");
                bucketAndObjectAction.listObject(bucket, 'true', parentPath, function (err, data) {
                    listObjectUI(err, data, bucket, true);
                },pageContext['page'+pageContext.nowPage]);
            }
        }
    }
}

function tabFocus(id) {
    //设置页面焦点事件
    $("#" + id).focus();
}


//获取账户列表信息
function getAccountListInfo(callback,isShowMsg) {
    if (!accountService) {
        return;
    }
    accountService.getAccountList(function (err,lsAccount) {
        if (lsAccount) {
            var htmlStr = "";
            var userStr = '<ul style="max-height: 500px;overflow-y: scroll">';
            var arr = lsAccount.Accounts.Account;
            var currentId = lsAccount.Accounts.$.current.toString();
            if(arr.length>0){
                $(".btnUserInfo").css("max-width","221px");
            }else{
                $(".btnUserInfo").css("max-width","46px");
            }
            $("#accountTab tr:not(:first)").remove();
            var temp = true;
            for (var i = 0; i < arr.length; i++) {
                var showName = encoderForHtml(arr[i].Name).length>20?encoderForHtml(arr[i].Name).substring(0,20)+"...":encoderForHtml(arr[i].Name);
                if(currentUserId){
                    if(currentUserId===arr[i].ID[0]){
                        var str = '<span title="'+ encoderForHtml(arr[i].Name) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                        $(".btnUserInfo").html(str);
                        //优先以currentUserId作为判断当前用户的依据
                        temp = false;
                    }else if(temp&&currentId==arr[i].ID[0]){
                        var str = '<span title="'+ encoderForHtml(arr[i].Name) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                        $(".btnUserInfo").html(str);
                    }
                }else if(currentId==arr[i].ID[0]){
                    var str = '<span title="'+ encoderForHtml(arr[i].Name) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                    $(".btnUserInfo").html(str);
                }
                //账号列表如果都是最宽的字符，大于27则会被hiden
                var accountDomTitle = encoderForHtml(arr[i].Name).length > 27 ? "title='" + encoderForHtml(arr[i].Name) +"'" : "";
                htmlStr =
                    "<tr>" +
                        "<td style='padding-left: 20px;width: 340px'>" +
                            "<span "+accountDomTitle+" class='mui-ellipsis-prototype'>" + encoderForHtml(arr[i].Name) + "</span>" +
                        "</td>" +
                        "<td style='width: 120px;'>" +
                            "<a ng-click='createAccount.cleanInvalidate()' href='#' data-href='createAccount' data-id='" + arr[i].ID + "' class='mui-icon-account-edit'>"+languageJson.edit+"</a>" +
                            "<a href='#' style='margin-left: 20px;' data-href='accountList' data-id='" + arr[i].ID + "' class='mui-icon-account-del'>"+languageJson.delete+"</a>" +
                        "</td>" +
                    "</tr>";
                $("#accountTab tr:last").after(htmlStr);
                //账号列表下拉框如果都是最宽的字符，大于11则会被hiden
                var accountDomTitleDownList = encoderForHtml(arr[i].Name).length > 11 ? "title='" + encoderForHtml(arr[i].Name) +"'" : "";
                userStr +=
                    "<li>" +
                        "<a href='#' class='user mui-ellipsis-prototype' data-id='"+arr[i].ID+"' data-href='"+encoderForHtml(arr[i].Name)+"'>" +
                            "<span "+accountDomTitleDownList+" class='mui-ellipsis-prototype mui-icon-account1'>"+ encoderForHtml(arr[i].Name) +"</span>" +
                        "</a>" +
                    "</li>";
            }
            if(arr.length>0){
                userStr +='</ul>'+
                    '<li class="mui-border-before">' +
                        '<a href="#" id="accountManager" class="manager" style="padding: 4px 8px">' +
                            '<span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span>' +
                        '</a>' +
                    '</li>';
            }else{
                userStr +='</ul>'+
                    '<li>' +
                        '<a href="#" id="accountManager" class="manager" style="padding: 4px 8px">' +
                            '<span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span>' +
                        '</a>' +
                    '</li>';
            }
            $("#userList").html(userStr);
            if (callback) {
                callback(currentId);
            }
        } else {
            if(isShowMsg){
                isShowMsg=false;
                $('.mui-model').showErrorMessage({
                    message: languageJson.getConfigInfoErr,
                    obsError: obsError("getConfigInfoErr")
                });
            }
            var trs = $("#accountTab tbody").find('tr').length;
            if (trs === 1) {
                $("#changeAccount").addClass('mui-disabled');
            }
            $("#objAttr").addClass("mui-hide");//隐藏对象属性栏
            $("#path").html('');
            $("#accountTab tr:not(:first)").remove();
            var str = '<span class="mui-ellipsis-2" style="color: #ffffff;"></span><i class="btn-account"></i>';
            $(".btnUserInfo").html(str);
            $(".btnUserInfo").css("max-width","46px");
            var userStr ='<li><a href="#" id="accountManager" class="manager"><span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span></a></li>';
            $("#userList").html(userStr);
            $("#downloadFileName").val("");
            pageContext = {};//重置分页对象
            pageContext.nowPage = 1;
            $("#isSearch").val("");
            $("#objContainer").html("");
            $("#objLists tbody").find('tr').each(function () {
                $(this).remove();
            });
            $("#lsBuckets").html('');
            if (callback) {
                callback();
            }
        }

    });
}


//切换账户界面变更
function changeUserUI(id){
    var bucket = $('#curBucketName').html();
    $("#objAttr").addClass("mui-hide");//隐藏对象属性栏
    $("#path").html('');
    $("#downloadFileName").val("");
    pageContext = {};//重置分页对象
    pageContext.nowPage = 1;
    $("#isSearch").val("");
    $("#prefixSearch").val('');
    $("#bucketSearch").val('');
    $("#clearPrefixSearchInput").addClass("mui-hide");
    $('#curBucketName').html("");
    $('#curBucketName').attr("isExt","false");
    $("#objectNum").html('');
    $("#taskNum").html('0');
    $("#storageSize").html('');
    $("#lsBuckets").html('');//清空桶列表
    $("#objContainer").html('');//清空对象列表
    $("#pauseQueue tbody").html('');//清空任务列表
    $("#objLists tbody").find('tr').each(function () {
        $(this).remove();
    });
    $("#bucketLists tbody").find('tr').each(function () {
        $(this).remove();
    });
    $(".bucket-delete,.mui-icon-property,.mui-icon-aclConfig,.mui-icon-more").addClass('mui-disabled');
    $("#objDiv").addClass('current');
    $("#objPanel").addClass('current');
    $("#taskDiv").removeClass('current');
    $("#taskPanel").removeClass('current');
    $("#taskNumberShowDiv").removeClass('taskNumShow');
    if($("#bucketArea").hasClass('mui-hide')){
        $("#bucketArea").removeClass('mui-hide');//桶列表和对象列表切换
        $("#objectArea").addClass('mui-hide');
        $("#objectBtnDiv").addClass('mui-hide');
        $("#bucketBtnDiv").removeClass('mui-hide');
        $("#all-back-div").addClass('all-back-btn-disabled');//后退按钮样式修改
        $("#all-back-div").removeClass('all-back-btn');
        $("#objectProDiv").addClass('mui-hide');//隐藏对象属性栏
        $("#bucketProDiv").removeClass('mui-hide');//显示桶属性栏
    }
    loaderUser(id);
}



function listMultiparUploadsUI(err,data,bucket){
    if(err){
        logger.error(err);
        if(errorConfig[err.code]){
            $('.mui-model').showErrorMessage({
                message: errorConfig[err.code],
                obsError: obsError(err.code,err.message),
                ok: function(){
                    $(".refreshCtx").click();
                    return false;
                }
            });
        }
    }else{
        var  objs = data.arr;
        pageMultipartContext = data.pageMultipartContext;
        $("#multipartTab").css("width",$("#multipartPageTab").css("width"));
        var htmlBody = "";
        var num = $("#multipartTab tbody tr").length+1;
        for (var index in objs) {
            var obj = objs[index];
            htmlBody += "<tr><td style='width: 40px;'>"+num+"</td>";
            htmlBody += "<td><span class='mui-ellipsis-multipart'>"+encoderForHtml(obj.Key)+"</span></td>";
            htmlBody += "<td style='width: 100px;text-align: right;'><span>--</span></td>";
            htmlBody += "<td style='width: 110px;'><span>--</span></td>";
            htmlBody += "<td style='width: 110px;'><span class='mui-ellipsis-multipart'>"+indexAction.gmtDate2LocaleDate(encoderForHtml(obj.Initiated),language)+"</span></td>";
            htmlBody += "<td style='width: 140px'><span class='mui-ellipsis-multipart'>"+encoderForHtml(obj.UploadId)+"</span></td>";
            htmlBody += "<td style='width: 75px;'><i data-id='"+encoderForHtml(obj.UploadId)+"' data-key='"+encoderForHtml(obj.Key)+"' class='mui-icon-account-clear' title='"+languageJson.delete+"'></i></td></tr> ";
            $("#multipartTab tbody").append(htmlBody);
            num++;
            htmlBody = "";
        }
        multipartNum = num - 1;
        if (document.getElementById("multipartDiv").offsetHeight < document.getElementById("multipartDiv").scrollHeight) {
            $("#operationBtn").css('width', '60px');
        } else {
            $("#operationBtn").css('width', '50px');
        }
        $("#multipartTab tbody").find('tr').each(function () {
            var self = this;
            if($(this).index()<(pageMultipartContext.nowPage-2)*20){
                return;
            }
            var uploadId = $(self).find('td').eq(5).find('span').text();
            var key = $(self).find('td').eq(1).find('span').text();
            bucketAndObjectAction.listParts(bucket,uploadId,key,0,0,0, function (err,data) {
                if(err){

                }else{
                    $(self).find('td').eq(2).find('span').text(data.count===0?1:indexAction.formatNumber(data.count,language,true));
                    $(self).find('td').eq(3).find('span').text(data.size===0?"--":indexAction.getFileSize(data.size,"",language));
                }
            });
        });
        if($("#multipartTab tbody").find('tr').length === 0){
            $("#deleteMultipart").addClass('mui-hide');
            $("#multipartTab tbody").html('<div class="dialog-table-nodata"><span>' + languageJson.noData + '</span></div>');
        }else{
            $("#deleteMultipart").removeClass('mui-hide');
        }
    }
}

function allButtonChange(type) {
    if (type === '1') {
        $("#overlay").removeClass('mui-hide');
        $("#lsBuckets").html('');//清空桶列表
        $("#isSearch").val("");
        $("#prefixSearch").val('');
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#objectNum").html('');
        $("#storageSize").html('');
        $('#taskNum').html(0);
        selectedTable.find('tbody').html('');
        $("#objLists tbody").find('tr').each(function () {
            $(this).remove();
        });
    } else {
        $("#overlay").addClass('mui-hide');
    }
}

// 删除用户清空当前用户的桶列表
function clearBucketLists() {
    //主区域桶列表
    $("#bucketLists tbody").find('tr').each(function () {//清空桶列表（列表方式）
        $(this).remove();
    });
    //左侧桶列表
    $("#lsBuckets").html('');
    $("#bucketCreateNum").html('');
    $("#extBucketNum").html('');
    //如果页面在对象列表，则跳转到桶列表
    if($("#bucketArea").hasClass('mui-hide')){
        $("#bucketArea").removeClass('mui-hide');//桶列表和对象列表切换
        $("#objectArea").addClass('mui-hide');
        $("#objectBtnDiv").addClass('mui-hide');
        $("#bucketBtnDiv").removeClass('mui-hide');
        $("#all-back-div").addClass('all-back-btn-disabled');//后退按钮样式修改
        $("#all-back-div").removeClass('all-back-btn');
        $("#objectProDiv").addClass('mui-hide');//隐藏对象属性栏
        $("#bucketProDiv").removeClass('mui-hide');//显示桶属性栏
        $("#prefixSearch").attr('placeholder',languageJson.bucketSearchInfo);
    }
}

function getBucketStorageInfo(bucket){
    //外部桶隐藏桶存量信息
    if($('#lsBuckets .current').hasClass('ext')){
        $("#objectProDiv").addClass('mui-hide');
    }else{
        $("#objectProDiv").removeClass('mui-hide');
    }
    $("#bucketProDiv").addClass('mui-hide');//隐藏桶属性栏
    bucketAttributeAction.getBucketStorageInfo(bucket,function(err,data){
        if(!err){
            if(data && data.ObjectNumber){
                $("#objectNum").html(indexAction.formatNumber(data.ObjectNumber,language,true));
            }else{
                $("#objectNum").html(indexAction.formatNumber(0,language,true));
            }
            if(data && data.Size){
                $("#storageSize").html(indexAction.getFileSize(data.Size,"",language));
            }else{
                $("#storageSize").html(indexAction.getFileSize(0,"",language));
            }
        }
    });
}

function getTaskNum(){
    if(nowstat==='RUNNING'){
        var trs = $("#"+selected+" tbody tr").length;
        $('#taskNum').html(trs);
    }else{
        var query={};
        if("uploadTaskDiv"===selected){
            //加载上传任务
            query={type:"putObj",stat:nowstat};
        }else if("downloadTaskDiv"===selected){
            //加载下载传任务
            query={type:"getObj",stat:nowstat};
        }else if("deleteTaskDiv"===selected){
            //加载删除任务
            query={type:"delete",stat:nowstat};
        }else if("recoverTaskDiv"===selected){
            //加载删除任务
            query={type:"recover",stat:nowstat};
        }
        if(nowstat===""){
            query.stat={"$ne":"SUCCESS"};
        }
        taskManager.countTasks(query,function(err,data){
            if(data){
                $('#taskNum').html(indexAction.formatNumber(data,language,true));
                if(nowstat==="" && $("#uploadAction").parent().hasClass('current')){
                    $("#uploadAction").html(languageJson.upload+" ("+indexAction.formatNumber(data,language,true)+")");
                }else if(nowstat==="" && $("#downloadAction").parent().hasClass('current')){
                    $("#downloadAction").html(languageJson.down+" ("+indexAction.formatNumber(data,language,true)+")");
                }else if(nowstat==="" && $("#delAction").parent().hasClass('current')){
                    $("#delAction").html(languageJson.delete+" ("+indexAction.formatNumber(data,language,true)+")");
                }else if(nowstat==="" && $("#recoverAction").parent().hasClass('current')){
                    $("#recoverAction").html(languageJson.recover+" ("+indexAction.formatNumber(data,language,true)+")");
                }
            }else{
                $('#taskNum').html(0);
            }
        });
    }
}

//=========================================老版本任务控制==============================


var i= 0;

function removeTask(task) {
    if($("#taskPanel").hasClass('mui-active')&&isReloadTask(task.type)) {
        var tr = selectedTable.find("tr[id='" + task.id + "']");
        if (tr.hasClass('task')) {
            tr.remove();
        } else {
            reloadTasks();
        }
        if ("" === nowstat || "WAIT" === nowstat) {
            var showAllSize = selectedTable.find('tr').length;//界面显示任务列表
            var html = "";
            if (showAllSize < 20) {
                reloadTasks();
            }
        }
    }
}

function isReloadTask(type){
    if((type==='putObj'&&selected==='uploadTaskDiv')||(type==='getObj'&&selected==='downloadTaskDiv')
        ||(type==='delete'&&selected==='deleteTaskDiv')||(type==='recover'&&selected==='recoverTaskDiv')){
        return true;
    }else{
        return false;
    }
}

function renderTaskConsoleItemBody(task) {

}

function renderTaskConsoleItem(task,stat) {

}

function isShowRunningTask(type){
    if(selected==='uploadTaskDiv'&& type === 'putObj'){
        return true;
    }else if(selected==='downloadTaskDiv'&& type === 'getObj'){
        return true;
    }else if(selected==='deleteTaskDiv'&& type === 'delete'){
        return true;
    }else if(selected==='recoverTaskDiv'&& type === 'recover'){
        return true;
    }else{
        return false;
    }
}

function addToTask(task) {
    if(selectedTable.find('tr').length<51){
        var tr = selectedTable.find("tr[id='" + task.id + "']");
        if (tr.hasClass('task')) {
            tr.remove();
        }
        selectedTable.css("width",$("#taskTabHead").css("width"));
        var trHtml = renderTaskConsoleItem(task);
        selectedTable.find('tbody').append(trHtml);
    }
}


function refresh(task, evt) {
    var tm = new Date();
    if (!task.tickTime) {
        task.tickTime = tm.getTime();
        task.tickLoaded = evt.loaded;
        task.speeds = [];
        task.tickCount = 0;
    }
    else if ((tm.getTime() - task.tickTime) > 1000) {
        var tickTotal = evt.loaded - task.tickLoaded;
        var send = (tm.getTime() - task.tickTime) / 1000;
        var speed = Math.floor(tickTotal / send);//每秒 向下取整
        //去抖动算法
        task.tickCount++;
        if (task.tickCount > 9) {
            task.tickCount = 0;
        }
        task.speeds[task.tickCount] = speed;
        if (task.speeds.length > 8) {
            var tSp = 0;
            for (var i = 0; i < task.speeds.length; i++) {
                tSp += task.speeds[i];
            }
            //平均速度
            speed = tSp / task.speeds.length;
        }
        var spTime = calculateTime(Math.abs(evt.total - evt.loaded), speed);
        var u = 'byte/s';
        if (speed > 1024) {
            speed = speed / 1024.0;//kb每秒
            u = 'KB/s';
        }
        if (speed > 1024) {
            speed = speed / 1024.0;//mb每秒
            u = 'MB/s';
        }

        speed = Math.round(speed * 100) / 100;

        if (speed > 0) {
            task.speed = indexAction.formatNumber(speed,language) + u;
            task.spTime = spTime;
        }
        task.tickTime = tm.getTime();
        task.tickLoaded = evt.loaded;
    }
    var per = 0;
    if (task.position) {
        var position = task.position;

        var loaded = evt.loaded + position;
        var total = Number(evt.total) + position;

        per = Math.round((loaded / total * 10000)) / 100.00;
    } else {
        per = Math.round((evt.loaded / evt.total * 10000)) / 100.00;
    }
    if(!per || per<0){
        per=0;
    }
    //处理进度异常情况
    per = commonUtils.handlePer(per,task.progress);
    task.progress = per + "%";
}

var lastReload=0;


/**
 *重新加载任务列表
 * @param isCompel bool:是否忽略上次刷新时间，强制刷新
 */
function reloadTasks(isCompel){
    if(!isCompel && ((new Date().getTime() - lastReload) < 1000)){
        //加载太频繁，退出
        return;
    }
    if(!isLoaded){
        return false;
    }
    lastReload=(new Date()).getTime();
    var query={};
    if("uploadTaskDiv"===selected){
        //加载上传任务
        query={type:"putObj",stat:nowstat};
    }else if("downloadTaskDiv"===selected){
        //加载下载传任务
        query={type:"getObj",stat:nowstat};
    }else if("deleteTaskDiv"===selected){
        //加载删除任务
        query={type:"delete",stat:nowstat};
    }else if("recoverTaskDiv"===selected){
        //加载恢复冷对象任务
        query={type:"recover",stat:nowstat};
    }
    if(nowstat===""){
        query.stat={$and:[{"$ne":"SUCCESS"},{"$ne":"MD5SUCCESS"}]};
    }
    var html="";
    if("RUNNING"===nowstat){
        var map = taskManager.runningMap;
        for (var id in map) {
            var task = map[id];
            if(task && query.type===task.type){

                var trHtml = renderTaskConsoleItem(task);
                html += trHtml;
            }
        }
        selectedTable.css("width",$("#taskTabHead").css("width"));
        selectedTable.find('tbody').html(html);
    }else{
        taskManager.listTasks(query, parseInt(global.taskShowSize),1,function(err,data){
            if(data){
                var runningMap = taskManager.runningMap;
                for(var i=0;i<data.length;i++) {
                    var runningTask = runningMap[data[i].id];
                    if(runningTask){
                        //正在运行的任务使用内存中的task
                        html+=renderTaskConsoleItem(runningTask);
                    }else{
                        html+=renderTaskConsoleItem(data[i]);
                    }
                }
                selectedTable.css("width",$("#taskTabHead").css("width"));
                selectedTable.find('tbody').html(html);
            }
        });
    }
}

function taskStatChinese(stat,task) {
    if(stat){
        if (stat.trim() === 'RUNNING') {
            stat = languageJson.running;
        } else if (stat.trim() === 'WAIT') {
            stat =languageJson.wait;
        } else if (stat.trim() === 'PAUSE') {
            stat = languageJson.paused;
        }else if (stat.trim() === 'RESTORING') {
            stat = languageJson.obs_term_restoring_lable;
        }else if (stat.trim() === 'SUCCESS') {
            stat = languageJson.obs_term_success_label;
        }else if (stat.trim() === 'FAILED') {
            if(task && nowstat===''){
                var errmsg = '';
                if(errorConfig[task.errMessage]){
                    errmsg = errorConfig[task.errMessage].lastIndexOf("。")>0||errorConfig[task.errMessage].lastIndexOf(".")>0
                        ? errorConfig[task.errMessage].substring(0,errorConfig[task.errMessage].length-1)
                        : errorConfig[task.errMessage];
                    var obsErrorObj = obsError(task.errMessage,"");
                    errmsg = obsErrorObj ? obsErrorObj.description : errmsg;
                }else if(task.errMessage){
                    errmsg = task.errMessage
                }else{
                    errmsg = languageJson.undefinedError;
                }

                //失败状态后追加失败原因的tips显示图标
                stat = languageJson.failed+"<i class='mui-icon-task-failed' title='"+errmsg+"'></i>";
            }else{
                stat = languageJson.failed;
            }
        }
    }
    return stat;
}

/*
 刷新任务控制台"所有table"列表的状态
 */
function refrchStat(task){
    var trHtml = renderTaskConsoleItemBody(task);
    var tr = selectedTable.find("tr[id='"+task.id+"']");
    if(tr.hasClass("task")) {
        tr.html(trHtml);
    }else{
        addToTask(task);
    }
}

//判断上传子文件夹内对象成功时是否刷新对象列表
function isRefreshUI(key){
    if(!key){
        return false;
    }
    if(pageContext.nowPage != 1){
        return false;
    }

    var path = getCurrPath();
    var newFolder = key;
    if(path.length>0) {
        if(key.indexOf(path) === 0){
            newFolder = key.substr(path.length,key.length);//去头
        }else{
            return false;
        }
    }
    if(newFolder.indexOf("/")===-1){
        return false;//不是文件夹或者不是子目录下的文件
    }
    newFolder = newFolder.substr(0,newFolder.indexOf("/")+1);//去尾


    for(var i in folderList){
        if(newFolder===folderList[i]){
            return false;//已经存在
        }
    }

    if(folderList.length===50){
        //用最后一个比较ascII顺序
        if(comp(folderList[49],newFolder)<0){
            return false;
        }
    }
    return true;
}

/**
 * 保存当前所有目录
 * @param data
 */
function setLocalFolders(data){
    folderList = [];
    var path = getCurrPath();
    if(path==="") {
        for (var i in data) {
            folderList.push(data[i].Prefix);
        }
    }else{
        for (var i in data) {
            folderList.push(data[i].Prefix.substr(path.length,data[i].Prefix.length));
        }
    }
}


/**
 *ascII序比较
 *  a=b 0
 * a<b -1
 * a>b 1
 */
function comp(a,b) {
    if (a === b) {
        return 0;
    } else {
        var length = a.length < b.length ? a.length : b.length;
        for (var i = 0; i < length; i++) {
            if (a[i].charCodeAt() < b[i].charCodeAt()) {
                return -1;
            }
            else if (a[i].charCodeAt() > b[i].charCodeAt()) {
                return 1;
            }
        }
        return a.length < b.length ? -1 : 1;
    }
}

/**
 * 是否有运行的任务
 * @returns {boolean}
 */
function hasRunning(){
    var hasRunning = false;
    if(taskManager && taskManager.runningMap){
        for(var id in taskManager.runningMap){
            if(id){
                hasRunning = true;
                break;
            }
        }
    }
    return hasRunning;
}
function hasMovingTask(callback) {
    if(self.taskManager) {
        self.taskManager.countTasks({type: "move", stat: "RUNNING"}, function (err, data) {
            callback(err, data);
        });
    } else {
        callback("", 0);
    }
}

function isTaskDiv(){
    if($("#taskPanel").hasClass('mui-active')){
        return true;
    }
    return false;
}

function deleteRubbishBucket(bName,stat){
    if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
        showOverlay();
    }
    if ($("#mui-overlay").size() > 0) {
        mui.overlay('off');
    }
    var option = {};
    option.timeout = 300000;
    var loading = loadingShow(option);
    bucketAndObjectAction.deleteAllMultipartUploads($('#curBucketName').html(), '', '', '', function (err,data) {
        if(err){
            loading.close();
            if(errorConfig[err.code]){
                var msg = languageJson.deleteAllMultipartErr + errorConfig[err.code];
                $('.mui-model').showErrorMessage({
                    message: languageJson.deleteAllMultipartErr + (obsError(err.code) ? obsError(err.code).description :  errorConfig[err.code]),
                });
            }
        }else{
            bucketAndObjectAction.deleteBucket(
                bName,
                function (err,data) {
                    if(err){
                        if (errorConfig[err.code]) {
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code,err.message)
                            });
                        }
                        loading.close();
                    }else{
                        $('.mui-model').showMessage({
                            message: CommonUtils.format(languageJson.deleteBucketSuccess, CommonUtils.encodeForHTML(CommonUtils.substr32(bName))),
                            ok: function () {
                                return false;
                            },
                            title: languageJson.info
                        });
                        //刷新桶列表
                        lastBucket = '';
                        $("#curBucketName").html('');
                        $("#objectNum").html('');
                        $("#storageSize").html('');
                        bucketAndObjectAction.listBucket(function (err, data) {
                            $("#path p").children().each(function () {
                                $(this).remove();
                            });
                            listBucketUI(err,data,loading);
                        });
                        loading.close();
                    }
                }
            );
        }
    },'',-1);
}

function deleteBucket(bName,stat){
    if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
        showOverlay();
    }
    $('.mui-model').showMessage(
        {
            type: "warning",
            message: languageJson.isSureDeleteBucket,
            ok: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                if($('#lsBuckets .bucket-item.current').hasClass('ext')){
                    bucketAndObjectAction.deleteExtBucket(bName,ExtBucket,currentUserId, function (data) {
                        indexAction.writeExBucket(data);
                        setTimeout(function () {
                            $('.mui-model').showMessage({
                                message: CommonUtils.format(languageJson.deleteBucketSuccess, CommonUtils.encodeForHTML(CommonUtils.substr32(bName))),
                                ok: function () {
                                    return false;
                                },
                                title: languageJson.info
                            });
                        },100);
                        //刷新桶列表
                        var loading = loadingShow();
                        lastBucket = '';
                        $("#curBucketName").html('');
                        $("#objectNum").html('');
                        $("#storageSize").html('');
                        bucketAndObjectAction.listBucket(function (err, data) {
                            $("#path p").children().each(function () {
                                $(this).remove();
                            });
                            listBucketUI(err,data,loading);
                        });
                    });
                }else{
                    var loading = loadingShow();
                    bucketAndObjectAction.deleteBucket(
                        bName,
                        function (err,data) {
                            if(err){
                                loading.close();
                                if (errorConfig[err.code]) {
                                    if (err.code === 'BucketNotEmpty' && stat) {
                                        $('.mui-model').showErrorMessage({
                                            message: CommonUtils.format(languageJson.deleteBucketErrMsg, CommonUtils.encodeForHTML(CommonUtils.substr32(bName)))
                                        });
                                    } else {
                                        $('.mui-model').showErrorMessage({
                                            message: errorConfig[err.code],
                                            obsError: obsError(err.code,err.message)
                                        });
                                    }
                                }
                            }else{
                                $('.mui-model').showMessage({
                                    message: CommonUtils.format(languageJson.deleteBucketSuccess, CommonUtils.encodeForHTML(CommonUtils.substr32(bName))),
                                    ok: function () {
                                        return false;
                                    },
                                    title: languageJson.info
                                });
                                //刷新桶列表
                                lastBucket = '';
                                $("#curBucketName").html('');
                                $("#objectNum").html('');
                                $("#storageSize").html('');
                                bucketAndObjectAction.listBucket(function (err, data) {
                                    $("#path p").children().each(function () {
                                        $(this).remove();
                                    });
                                    listBucketUI(err,data,loading);
                                });
                                loading.close();
                            }
                        }
                    );
                }
            },
            cancel: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                return false;
            },
            title: languageJson.deleteBucket
        }
    );
}


function initProxy(){
    var point = false;
    if(proxy&&proxy.isProxy){
        point = 'http://';
        if(proxy.isAuthentication){
            point = point+proxy.proxyUserName+':'+proxy.proxyPwd+'@';
        }
        if(proxy.isProxy){
            if(proxy.proxyPort){
                point = point+proxy.proxyIP+':'+proxy.proxyPort;
            }else{
                point = point+proxy.proxyIP+':8080';
            }
        }
        global.agentOption = point;
    }
}

function updatePwd(callback){
    temp = {};
    async.parallel([
        function(call) {
            accountService.getAccountList(function (err,accObject) {
                if(err){
                    call(err,accObject);
                }else{
                    if(accObject && accObject.Accounts && accObject.Accounts.Account){
                        async.eachSeries(accObject.Accounts.Account, function(item, cb) {
                            global.Tools.decode(item.ID.toString(),item.SecretKey.toString(),function(err,encryptText){
                                if(err){
                                    call(err,accObject);
                                }else{
                                    global.Tools.changePwd('',encryptText,function(err,decodeText,domain){
                                        if(domain){
                                            temp[item.ID.toString()] = domain;
                                        }
                                        item.SecretKey = decodeText;
                                        cb(err);
                                    });
                                }
                            });
                        }, function(err) {
                            call(err,accObject);
                        });
                    }else{
                        call();
                    }
                }
            });
        },
        function(call) {
            indexAction.loadSetting(function (configObj) {
                if(configObj && configObj.proxy && configObj.proxy.proxyPwd){
                    global.Tools.changePwd(temp.proxyPwd,configObj.proxy.proxyPwd,function(err,encryptText,domain){
                        if(domain){
                            temp.proxyPwd = domain;
                        }
                        configObj.proxy.proxyPwd = encryptText;
                        call(err,configObj);
                    });
                }else{
                    call(null,configObj);
                }
            });
        },
        function(call) {
            if(global.newMongoPwd){
                global.Tools.decode('mongoPwd',global.newMongoPwd, function (err,encrypted) {//sk解密
                    if(err){
                        call(err);
                    }else{
                        global.Tools.changePwd(temp.mongoPwd,encrypted,function(err,encryptText,domain){
                            if(domain){
                                temp.mongoPwd = domain;
                            }
                            call(err,encryptText);
                        });
                    }
                });
            }else{
                call(null);
            }
        }
    ], function (err, results) {
        if(err){
            global.logger.info('update the key failed!');
            callback();
        }else{
            var accObject = results[0];
            var sysObject = results[1];
            if(sysObject && results[2]){
                sysObject.mongoAuthPwd = results[2];
            }
            temp.createTime = new Date().getTime();
            try{
                var xml2js = require('./node_modules/xml2js');
                var builder = new xml2js.Builder();
                var xml = builder.buildObject(accObject);//json对象转成xml文件
                fs.writeFileSync(lanpath + 'accounts.xml', xml);
                var b = new Base64();
                var base64Str = b.encode(JSON.stringify(sysObject));
                fs.writeFileSync(lanpath + 'setting', base64Str);
                fs.writeFileSync(lanpath + 'temp', JSON.stringify(self.temp));
                global.logger.debug('update the key success!');
                callback();
            }catch(err){
                callback();
            }
        }
    });
}

//创建本地文件系统文件夹
function createLocalFolder(path,callback){
    var fatherPath=path.substring(0,path.lastIndexOf("/",path.length-2)+1);
    if(fs.existsSync(fatherPath)){
        fs.mkdirSync(path);
    }else{
        createLocalFolder(fatherPath);
    }
};

//创建任务时显示动画效果
function showCreateTasksAnimation(){
    var pd = {left: $(window).width()/2, top: $(window).height()/2};//起点位置
    var location = getNodeLocation("btnTaskManage");
    var pb = {left: location.popX, top: location.popY};//终点位置
    $("#taskCreate").css({left: pd.left, top: pd.top});//从起点位置开始
    $("#taskCreate").fadeIn().animate({
        left: pb.left,
        top: pb.top
    }, 500,function(){//1秒内完成动画，可以设置动画速度,完了隐藏
        $("#taskCreate").fadeOut();
        refreshTaskNum();//刷新任务数量
    });
}
$("#hasFailedTasks").hide();
setInterval(function () {
    refreshTaskNum();
},1000);

function refreshTaskNum(){
    var self = this;
    if(!self.taskManager){
        return false;
    }
    async.parallel([
            function (cb) {
                self.taskManager.countTasks({$and:[{stat: {"$ne": "SUCCESS"}},{stat: {"$ne": "MD5SUCCESS"}}]}, function (err,data) {
                    cb(err,data);
                });
            },
            function (cb) {
                self.taskManager.countTasks({$or:[{stat: "SUCCESS"},{stat: "MD5SUCCESS"}]}, function (err, data) {
                    cb(err, data);
                });
            },
            function (cb) {
                self.taskManager.countTasks({}, function (err, data) {
                    cb(err, data);
                });
            },
            function (cb) {
                self.taskManager.countTasks({stat: "FAILED"}, function (err, data) {
                    cb(err, data);
                });
            },
            function (cb) {
                self.taskManager.countTasks({$or:[{stat:'RUNNING'},{stat:'WAIT'},{stat:'RESTORING'}]}, function (err, data) {
                    cb(err, data);
                });
            }],
        function (err,results) {
            if(err){
                global.logger.error('refreshTaskNum error:',err);
                return false;
            }
            if(results){
                var runningNum = results[0];
                var completeNum = results[1];
                var allTaskNum = results[2];
                var failedTaskNum = results[3];
                var transportTaskNum = results[4];

                $("#runingTaskCount").text(indexAction.formatNumber(encoderForHtml(runningNum),language,true));
                $("#completeTaskCount").text(indexAction.formatNumber(encoderForHtml(completeNum),language,true));
                $("#totalTaskCount").text(indexAction.formatNumber(encoderForHtml(allTaskNum),language,true));
                //runningNum是所有不为SUCCESS的任务，包含failed、runnning、waiting、restoring、suspended

                if(hasRunning() || transportTaskNum > 0){//判断是否有任务正在运行
                    $(".btnTaskManage").addClass('running');
                    isTaskDone = true;
                }else{
                    $(".btnTaskManage").removeClass('running');
                    if(isTaskDone) {
                        $("#all-refresh-div").click();
                    }
                    isTaskDone = false;
                }

                if(failedTaskNum > 0) {
                    $("#hasFailedTasks").show();
                } else {
                    $("#hasFailedTasks").hide();
                }
            }
        }
    )
}

function deletedCheck(data,bucket,cb){
    var arr = data.split("|");
    arr.pop();//删除最后一个为空的元素
    var queryObj = {};
    queryObj["bucket"] = bucket;
    queryObj.stat={$and:[{"$ne":"SUCCESS"},{"$ne":"MD5SUCCESS"}]};
    queryObj.type={"$ne":"recover"};
    global.logger.info("delete target:", arr);
    async.eachSeries(arr, function(item, callback) {
        try{
            item = item.replace(/\$/g,'\\$').replace(/\&/g,'\\&').replace(/\^/g,'\\^').replace(/\+/g,'\\+');
            item = item.replace(/\?/g,'\\?').replace(/\*/g,'\\*').replace(/\%/g,'\\%').replace(/\@/g,'\\@');
            item = item.replace(/\#/g,'\\#').replace(/\!/g,'\\!').replace(/\_/g,'\\_').replace(/\(/g,'\\(').replace(/\)/g,'\\)');
            queryObj["key"] = new RegExp('^'+item);//前缀查询条件
            global.logger.info("delete check query:", queryObj);
            taskManager.deletedCheckQuery(queryObj, function (err,data) {
                if(!err && data){//如果查询出数据，则表示当前文件夹下存在未完成的任务，不能删除
                    callback('return true');
                }else{
                    callback();
                }
            })
        }catch(e){//如果出现异常，则不校验文件夹下是否有任务，判定可以删除。
            callback();
        }
    }, function(err) {
        if(err){
            cb(true);
        }else{
            cb();
        }
    });
}

function showOverlay(){
    mui.overlay('on', {static: true,keyboard:false});
}

process.on('uncaughtException', function (err) {
    logger.error('Uncaught exception: ', err.stack);
});

/**
 * 初始化tiny相应的组件
 */
function initTinyCompnents(){
    requirejs(['./tinyui/i18n/de-de/tiny2Language.js',
        './tinyui/i18n/en-us/tiny2Language.js',
        './tinyui/i18n/es-es/tiny2Language.js',
        './tinyui/i18n/fr-fr/tiny2Language.js',
        './tinyui/i18n/pt-br/tiny2Language.js',
        './tinyui/i18n/zh-cn/tiny2Language.js',], function(de_de, en_us, es_es, fr_fr, pt_br, zh_cn){
        switch(language){
            case "en":
                tiny.language = en_us;
                break;
            case "zh":
                tiny.language = zh_cn;
                break;
            case "French":
                tiny.language = fr_fr;
                break;
            case "German":
                tiny.language = de_de;
                break;
            case "Portuguese":
                tiny.language = pt_br;
                break;
            case "Spanish":
                tiny.language = es_es;
                break;
        }
        setTimeout(taskPanelCtrl(), 2000);
    });
    objButtonCtrl();
    createAccountCtrl();
    createBucketCtrl();
    changeStorageCtrl();
    changeObjectStorageCtrl();
    DateCtrl();
    recoverObjectCtrl();
    ctxMenuCtrl();
    createFloderCtrl();
}

function initDepondLang(){
    $("input[type='number']").each(function(){
        var min = $(this).attr('min');
        var max = $(this).attr('max');
        if(min && max){
            $(this).attr("title", languageJson.obs_term_integerRange_tip.format(min));
        }
    })
    $("input[type='number']").on('mouseenter',function(){
        var min = $(this).attr('min');
        var max = $(this).attr('max');
        if($(this).val() === max){
            $(this).attr("title", languageJson.obs_term_bucketLifecycle_ruleMaxDays_tip.format(max));
            return;
        }
        if(min && max){
            $(this).attr("title", languageJson.obs_term_integerRange_tip.format(min));
        }
    })
}

function checkColdline(coldline){
    if(coldline){
        $("#bucketHeadStorage").removeClass('mui-hide');
    }
}
function checkObjectColdline(coldline){
    if(coldline){
        $("#objHeadStorage").removeClass('mui-hide');
    }
}